/* Photo.c generated by valac 0.34.9, the Vala compiler
 * generated from Photo.vala, do not modify */

/*
* Copyright (c) 2009-2013 Yorba Foundation
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable.*/
/* UNMODIFIED represents the photo with no edits, i.e. the head of the pipeline.*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <time.h>
#include <glib/gstdio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "config.h"
#include <cairo.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
#define _photo_row_unref0(var) ((var == NULL) ? NULL : (var = (photo_row_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;

#define TYPE_ROTATION (rotation_get_type ())

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())
#define PHOTO_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders))
#define PHOTO_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))
#define PHOTO_IS_BACKING_READERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_IS_BACKING_READERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_BACKING_READERS))
#define PHOTO_BACKING_READERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_BACKING_READERS, PhotoBackingReadersClass))

typedef struct _PhotoBackingReaders PhotoBackingReaders;
typedef struct _PhotoBackingReadersClass PhotoBackingReadersClass;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION_BUNDLE (pixel_transformation_bundle_get_type ())
#define PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle))
#define PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))
#define IS_PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define IS_PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))

typedef struct _PixelTransformationBundle PixelTransformationBundle;
typedef struct _PixelTransformationBundleClass PixelTransformationBundleClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))
#define _photo_backing_readers_unref0(var) ((var == NULL) ? NULL : (var = (photo_backing_readers_unref (var), NULL)))
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _PhotoRowPrivate PhotoRowPrivate;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReadersPrivate PhotoBackingReadersPrivate;
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
#define _photo_preview_unref0(var) ((var == NULL) ? NULL : (var = (photo_preview_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE (photo_reimport_raw_development_state_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentStateClass))

typedef struct _PhotoReimportRawDevelopmentState PhotoReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateClass PhotoReimportRawDevelopmentStateClass;
#define _photo_reimport_raw_development_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL (photo_reimport_raw_development_state_impl_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_IS_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImplClass))

typedef struct _PhotoReimportRawDevelopmentStateImpl PhotoReimportRawDevelopmentStateImpl;
typedef struct _PhotoReimportRawDevelopmentStateImplClass PhotoReimportRawDevelopmentStateImplClass;

#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT (photo_reimport_raw_development_state_impl_dev_to_reimport_get_type ())
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_IS_DEV_TO_REIMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT))
#define PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimportClass))

typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimport PhotoReimportRawDevelopmentStateImplDevToReimport;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass PhotoReimportRawDevelopmentStateImplDevToReimportClass;
typedef struct _PhotoReimportRawDevelopmentStatePrivate PhotoReimportRawDevelopmentStatePrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplPrivate PhotoReimportRawDevelopmentStateImplPrivate;
typedef struct _PhotoReimportRawDevelopmentStateImplDevToReimportPrivate PhotoReimportRawDevelopmentStateImplDevToReimportPrivate;
#define _photo_reimport_raw_development_state_impl_dev_to_reimport_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_raw_development_state_impl_dev_to_reimport_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))

#define TYPE_PIXEL_TRANSFORMATION_TYPE (pixel_transformation_type_get_type ())

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
typedef struct _PhotoParamSpecBackingReaders PhotoParamSpecBackingReaders;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _PhotoParamSpecReimportRawDevelopmentState PhotoParamSpecReimportRawDevelopmentState;
typedef struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK (library_photo_source_holding_tank_get_type ())
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define IS_LIBRARY_PHOTO_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK))
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankClass))

typedef struct _LibraryPhotoSourceHoldingTank LibraryPhotoSourceHoldingTank;
typedef struct _LibraryPhotoSourceHoldingTankClass LibraryPhotoSourceHoldingTankClass;

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_HIERARCHICAL_TAG_INDEX (hierarchical_tag_index_get_type ())
#define HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndex))
#define HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))
#define IS_HIERARCHICAL_TAG_INDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HIERARCHICAL_TAG_INDEX))
#define IS_HIERARCHICAL_TAG_INDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HIERARCHICAL_TAG_INDEX))
#define HIERARCHICAL_TAG_INDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HIERARCHICAL_TAG_INDEX, HierarchicalTagIndexClass))

typedef struct _HierarchicalTagIndex HierarchicalTagIndex;
typedef struct _HierarchicalTagIndexClass HierarchicalTagIndexClass;
#define _hierarchical_tag_index_unref0(var) ((var == NULL) ? NULL : (var = (hierarchical_tag_index_unref (var), NULL)))

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
typedef struct _SourceHoldingTankPrivate SourceHoldingTankPrivate;
typedef struct _DatabaseSourceHoldingTankPrivate DatabaseSourceHoldingTankPrivate;
typedef struct _MediaSourceHoldingTankPrivate MediaSourceHoldingTankPrivate;
typedef struct _LibraryPhotoSourceHoldingTankPrivate LibraryPhotoSourceHoldingTankPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

struct _ImportID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	gchar* (*get_comment) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	gboolean (*set_comment) (MediaSource* self, const gchar* comment);
	void (*get_dimensions) (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
	PhotoRow* row;
	gboolean can_rotate_now;
	BackingPhotoRow* backing_photo_row;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_raw_development_modified) (Photo* self);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*raw_development_modified) (Photo* self);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

struct _PhotoPrivate {
	time_t cached_exposure_time;
	GRecMutex __lock_row;
	BackingPhotoRow* editable;
	PhotoBackingReaders* readers;
	GRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	GdkPixbuf* unmodified_precached;
	GRecMutex __lock_unmodified_precached;
	GTimer* secs_since_access;
	GeeHashMap* developments;
	GRecMutex __lock_developments;
};

struct _PhotoID {
	gint64 id;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoRowPrivate * priv;
	PhotoID photo_id;
	BackingPhotoRow* master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	gchar* title;
	gchar* comment;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
	gboolean enhanced;
	GeeHashMap* original_transforms;
	RawDeveloper developer;
	BackingPhotoID* development_ids;
	gint development_ids_length1;
};

struct _PhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoRow *self);
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	time_t time_created;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _PhotoBackingReaders {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoBackingReadersPrivate * priv;
	PhotoFileReader* master;
	PhotoFileReader* developer;
	PhotoFileReader* editable;
};

struct _PhotoBackingReadersClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoBackingReaders *self);
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
	gboolean export_metadata;
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow* row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoRow* backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStatePrivate * priv;
};

struct _PhotoReimportRawDevelopmentStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentState *self);
};

struct _PhotoReimportRawDevelopmentStateImpl {
	PhotoReimportRawDevelopmentState parent_instance;
	PhotoReimportRawDevelopmentStateImplPrivate * priv;
	GeeCollection* list;
	gboolean metadata_only;
};

struct _PhotoReimportRawDevelopmentStateImplClass {
	PhotoReimportRawDevelopmentStateClass parent_class;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportRawDevelopmentStateImplDevToReimportPrivate * priv;
	BackingPhotoRow* backing;
	PhotoMetadata* metadata;
};

struct _PhotoReimportRawDevelopmentStateImplDevToReimportClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportRawDevelopmentStateImplDevToReimport *self);
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

typedef enum  {
	PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION,
	PIXEL_TRANSFORMATION_TYPE_SHADOWS,
	PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS,
	PIXEL_TRANSFORMATION_TYPE_TEMPERATURE,
	PIXEL_TRANSFORMATION_TYPE_TINT,
	PIXEL_TRANSFORMATION_TYPE_SATURATION,
	PIXEL_TRANSFORMATION_TYPE_EXPOSURE
} PixelTransformationType;

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

typedef void (*OneShotCallback) (void* user_data);
struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	GeeHashMap* original_transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gboolean enhanced;
};

struct _PhotoParamSpecBackingReaders {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportRawDevelopmentState {
	GParamSpec parent_instance;
};

struct _PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport {
	GParamSpec parent_instance;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeHashMap* by_raw_development_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
	GeeMultiMap* photo_to_raw_development_filesize;
};

typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

struct _SourceHoldingTank {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SourceHoldingTankPrivate * priv;
};

struct _SourceHoldingTankClass {
	GTypeClass parent_class;
	void (*finalize) (SourceHoldingTank *self);
	void (*notify_contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
	void (*contents_altered) (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
};

struct _DatabaseSourceHoldingTank {
	SourceHoldingTank parent_instance;
	DatabaseSourceHoldingTankPrivate * priv;
};

struct _DatabaseSourceHoldingTankClass {
	SourceHoldingTankClass parent_class;
};

struct _MediaSourceHoldingTank {
	DatabaseSourceHoldingTank parent_instance;
	MediaSourceHoldingTankPrivate * priv;
};

struct _MediaSourceHoldingTankClass {
	DatabaseSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTank {
	MediaSourceHoldingTank parent_instance;
	LibraryPhotoSourceHoldingTankPrivate * priv;
};

struct _LibraryPhotoSourceHoldingTankClass {
	MediaSourceHoldingTankClass parent_class;
};

struct _LibraryPhotoSourceHoldingTankPrivate {
	GeeHashMap* editable_file_map;
	GeeHashMap* development_file_map;
	GeeMultiMap* reverse_editable_file_map;
	GeeMultiMap* reverse_development_file_map;
};


static gpointer photo_import_params_parent_class = NULL;
static gpointer photo_transformation_state_parent_class = NULL;
static gpointer photo_parent_class = NULL;
static gboolean photo__develop_raw_photos_to_files;
static gboolean photo__develop_raw_photos_to_files = FALSE;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_backing_readers_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_parent_class = NULL;
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = NULL;
static DateableIface* photo_dateable_parent_iface = NULL;
static gpointer library_photo_source_collection_parent_class = NULL;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface* library_photo_flaggable_parent_iface = NULL;
static MonitorableIface* library_photo_monitorable_parent_iface = NULL;
static gpointer library_photo_source_holding_tank_parent_class = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_import_params (GValue* value, gpointer v_object);
void value_take_photo_import_params (GValue* value, gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_thumbnails (GValue* value, gpointer v_object);
void value_take_thumbnails (GValue* value, gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
gpointer photo_row_ref (gpointer instance);
void photo_row_unref (gpointer instance);
GParamSpec* param_spec_photo_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_row (GValue* value, gpointer v_object);
void value_take_photo_row (GValue* value, gpointer v_object);
gpointer value_get_photo_row (const GValue* value);
GType photo_row_get_type (void) G_GNUC_CONST;
enum  {
	PHOTO_IMPORT_PARAMS_DUMMY_PROPERTY
};
PhotoRow* photo_row_new (void);
PhotoRow* photo_row_construct (GType object_type);
PhotoImportParams* photo_import_params_new (GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams* obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
#define PHOTO_TRANSFORMATION_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStatePrivate))
enum  {
	PHOTO_TRANSFORMATION_STATE_DUMMY_PROPERTY
};
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject* obj);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_file_state (GValue* value, gpointer v_object);
void value_take_backing_file_state (GValue* value, gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType photo_exception_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
gpointer backing_photo_row_ref (gpointer instance);
void backing_photo_row_unref (gpointer instance);
GParamSpec* param_spec_backing_photo_row (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_photo_row (GValue* value, gpointer v_object);
void value_take_backing_photo_row (GValue* value, gpointer v_object);
gpointer value_get_backing_photo_row (const GValue* value);
GType backing_photo_row_get_type (void) G_GNUC_CONST;
static gpointer photo_backing_readers_ref (gpointer instance);
static void photo_backing_readers_unref (gpointer instance);
static GParamSpec* photo_param_spec_backing_readers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void photo_value_set_backing_readers (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void photo_value_take_backing_readers (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_value_get_backing_readers (const GValue* value) G_GNUC_UNUSED;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformer (GValue* value, gpointer v_object);
void value_take_pixel_transformer (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_bundle_ref (gpointer instance);
void pixel_transformation_bundle_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation_bundle (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation_bundle (GValue* value, gpointer v_object);
void value_take_pixel_transformation_bundle (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation_bundle (const GValue* value);
GType pixel_transformation_bundle_get_type (void) G_GNUC_CONST;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value, gpointer v_object);
void value_take_one_shot_scheduler (GValue* value, gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
GType raw_developer_get_type (void) G_GNUC_CONST;
#define PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO, PhotoPrivate))
enum  {
	PHOTO_DUMMY_PROPERTY
};
gboolean photo_exception_prohibits (PhotoException self, PhotoException exception);
gboolean photo_exception_allows (PhotoException self, PhotoException exception);
BackingPhotoRow* backing_photo_row_new (void);
BackingPhotoRow* backing_photo_row_construct (GType object_type);
static PhotoBackingReaders* photo_backing_readers_new (void);
static PhotoBackingReaders* photo_backing_readers_construct (GType object_type);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
#define PHOTO_PRECACHE_TIME_TO_LIVE 180
#define PHOTO_MIN_EMBEDDED_SIZE 1024
Photo* photo_construct (GType object_type, PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) -1)
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType orientation_get_type (void) G_GNUC_CONST;
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_key_value_map (GValue* value, gpointer v_object);
void value_take_key_value_map (GValue* value, gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
gchar* media_source_prep_comment (const gchar* comment);
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_adapter (GValue* value, gpointer v_object);
void value_take_photo_file_adapter (GValue* value, gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self, const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack, gunichar ch, gint start_index);
gchar* string_sliced_at (const gchar* str, gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) -1)
static BackingPhotoRow* photo_get_backing_row (Photo* self, BackingPhotoID* id);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
GQuark database_error_quark (void);
void photo_table_detach_editable (PhotoTable* self, PhotoRow* row, GError** error);
static void photo_internal_remove_all_transformations (Photo* self, gboolean notify);
RawDeveloper* raw_developer_as_array (int* result_length1);
void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
void photo_notify_raw_development_modified (Photo* self);
static void photo_real_notify_raw_development_modified (Photo* self);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations, gboolean notify);
PhotoFileFormat photo_get_master_file_format (Photo* self);
static gboolean photo_delete_raw_development (Photo* self, RawDeveloper d);
gboolean media_source_delete_original_file (MediaSource* self);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self, BackingPhotoID* id, GError** error);
gchar* data_object_to_string (DataObject* self);
void backing_photo_table_remove (BackingPhotoTable* self, BackingPhotoID* backing_id, GError** error);
gboolean photo_is_raw_developer_complete (Photo* self, RawDeveloper d);
gboolean photo_is_raw_developer_available (Photo* self, RawDeveloper d);
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
void photo_add_backing_photo_for_development (Photo* self, RawDeveloper d, BackingPhotoRow* bpr, GError** error);
void photo_import_developed_backing_photo (PhotoRow* row, RawDeveloper d, BackingPhotoRow* bpr, GError** error);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
Alteration* alteration_new (const gchar* subject, const gchar* detail);
Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value, gpointer v_object);
void value_take_photo_file_interrogator (GValue* value, gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file, PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type, GFile* file, PhotoFileSnifferOptions options);
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self, GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_detected_photo_information (GValue* value, gpointer v_object);
void value_take_detected_photo_information (GValue* value, gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void backing_photo_table_add (BackingPhotoTable* self, BackingPhotoRow* state, GError** error);
void photo_table_update_raw_development (PhotoTable* self, PhotoRow* row, RawDeveloper rd, BackingPhotoID* backing_photo_id, GError** error);
static void photo_develop_photo (Photo* self, RawDeveloper d);
BackingPhotoRow* raw_developer_create_backing_row_for_development (RawDeveloper self, const gchar* raw_filepath, const gchar* camera_development_filename, GError** error);
GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
void scaling_for_original (Scaling* result);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
GType jpeg_quality_get_type (void) G_GNUC_CONST;
void photo_file_writer_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
void photo_set_default_raw_developer (Photo* self, RawDeveloper d);
void photo_set_raw_developer (Photo* self, RawDeveloper d);
void photo_populate_prefetched (Photo* self, GError** error);
void photo_revert_to_master (Photo* self, gboolean notify);
gboolean photo_set_orientation (Photo* self, Orientation orientation);
gboolean photo_discard_prefetched (Photo* self, gboolean immed);
RawDeveloper photo_get_raw_developer (Photo* self);
gchar* raw_developer_to_string (RawDeveloper self);
void photo_table_remove_development (PhotoTable* self, PhotoRow* row, RawDeveloper rd, GError** error);
void photo_redevelop_raw (Photo* self, RawDeveloper d);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1);
BackingFileState* backing_file_state_new_from_photo_row (BackingPhotoRow* photo_row, const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_row (GType object_type, BackingPhotoRow* photo_row, const gchar* md5);
static void _vala_array_add91 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add92 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_is_developed (Photo* self);
GeeCollection* photo_get_raw_development_photo_rows (Photo* self);
static void _vala_array_add93 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
static PhotoFileReader* photo_get_raw_developer_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
BackingPhotoRow* photo_get_master_photo_row (Photo* self);
BackingPhotoRow* photo_get_editable_photo_row (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self, RawDeveloper d);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareDataFunc compare_func, void* compare_func_target, GDestroyNotify compare_func_target_destroy_notify);
#define PHOTO_ID_INVALID ((gint64) -1)
void photo_id_init (PhotoID *self, gint64 id);
#define EVENT_ID_INVALID ((gint64) -1)
void event_id_init (EventID *self, gint64 id);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails, PhotoFileReader* reader, Orientation orientation, Dimensions* original_dim, GError** error);
ImportResult import_result_convert_error (GError* err, ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self, gint width, gint height);
BackingPhotoRow* photo_query_backing_photo_row (Photo* self, GFile* file, PhotoFileSnifferOptions options, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error);
static void _vala_array_add94 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add95 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add96 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add97 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add98 (gchar*** array, int* length, int* size, gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_table_reimport (PhotoTable* self, PhotoRow* row, GError** error);
void backing_photo_row_copy_from (BackingPhotoRow* self, BackingPhotoRow* from);
static void _vala_array_add99 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add100 (gchar*** array, int* length, int* size, gchar* value);
Alteration* alteration_new_from_array (gchar** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1);
static gboolean photo_verify_file_for_reimport (Photo* self, GFile* file, BackingPhotoRow** backing, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state, PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoRow* backing_state, PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error);
void photo_get_editable_id (Photo* self, BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self, BackingPhotoRow* row, GError** error);
void media_source_set_title (MediaSource* self, const gchar* title);
gboolean media_source_set_comment (MediaSource* self, const gchar* comment);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type, const gchar* list);
gpointer photo_reimport_raw_development_state_ref (gpointer instance);
void photo_reimport_raw_development_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_raw_development_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_raw_development_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_raw_development_state (const GValue* value);
GType photo_reimport_raw_development_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState** state, GError** error);
GeeCollection* photo_get_raw_developer_files (Photo* self);
static GType photo_reimport_raw_development_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void);
static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type);
static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self, BackingPhotoRow* backing, PhotoMetadata* metadata);
static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self);
void photo_finish_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState* state, GError** error);
static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance);
static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance);
static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) G_GNUC_UNUSED;
GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) G_GNUC_CONST;
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self, PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self, GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self, PhotoID* photo_id, time_t timestamp, GError** error);
void app_window_database_error (GError* err);
void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, GError** error);
void photo_update_many_editable_timestamps (GeeMap* map, GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1);
gboolean photo_can_write_file (Photo* self);
void disassemble_filename (const gchar* basename, gchar** name, gchar** ext);
gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format, int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self, GFile* file);
void photo_table_set_filepath (PhotoTable* self, PhotoID* photo_id, const gchar* filepath, GError** error);
void media_source_notify_master_replaced (MediaSource* self, GFile* old_file, GFile* new_file);
static void _vala_array_add101 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add102 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add103 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add104 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_editable_file (Photo* self, GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self, BackingPhotoID* id, const gchar* filepath, GError** error);
static void _vala_array_add105 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add106 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add107 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_many_editable_file (GeeMap* map, GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base, EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base, ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self, Alteration* other);
guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self, PhotoID* photo_id, guint64 flags);
gboolean photo_is_flag_set (Photo* self, guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags, guint64 selector);
guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags, guint64 selector);
guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags, guint64 selector);
guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error);
guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self, PhotoID* photo_id, gboolean dirty, GError** error);
gboolean photo_is_enhanced (Photo* self);
void photo_set_enhanced (Photo* self, gboolean enhanced);
gboolean photo_table_set_enhanced (PhotoTable* self, PhotoID* photo_id, gboolean enhanced);
static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self, PhotoID* photo_id, const gchar* backlinks, GError** error);
static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self, PhotoID* photo_id, EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base, DataSource* source);
gboolean data_source_equals (DataSource* self, DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self, PhotoID* photoID, gint64 filesize, glong timestamp, const gchar* md5, const gchar* exif_md5, const gchar* thumbnail_md5, PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static gchar* photo_real_get_comment (MediaSource* base);
static void photo_real_set_title (MediaSource* base, const gchar* title);
gboolean photo_table_set_title (PhotoTable* self, PhotoID* photo_id, const gchar* new_title);
static gboolean photo_real_set_comment (MediaSource* base, const gchar* comment);
gboolean photo_table_set_comment (PhotoTable* self, PhotoID* photo_id, const gchar* new_comment);
void photo_set_import_id (Photo* self, ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self, PhotoID* photo_id, ImportID* import_id, GError** error);
void photo_set_title_persistent (Photo* self, const gchar* title, GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self, GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self, GError** error);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
void library_monitor_unblacklist_file (GFile* file);
void photo_set_comment_persistent (Photo* self, const gchar* comment, GError** error);
void photo_metadata_set_comment (PhotoMetadata* self, const gchar* comment);
static void photo_real_set_exposure_time (Dateable* base, time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self, PhotoID* photo_id, time_t time);
void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error);
void dateable_set_exposure_time (Dateable* self, time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base, PhotoException disallowed_steps, Dimensions* result);
void photo_get_raw_dimensions (Photo* self, Dimensions* result);
Orientation photo_get_orientation (Photo* self);
gboolean photo_get_straighten (Photo* self, gdouble* theta);
void compute_arb_rotated_size (gdouble src_width, gdouble src_height, gdouble angle, gdouble* dest_width, gdouble* dest_height);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self, Box* crop, PhotoException exceptions);
void box_get_dimensions (Box *self, Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_new (void);
PixelTransformationBundle* pixel_transformation_bundle_construct (GType object_type);
static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name);
void pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self);
void pixel_transformation_bundle_load (PixelTransformationBundle* self, KeyValueMap* store);
PixelTransformer* pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_copy (PixelTransformationBundle* self);
static PixelTransformationBundle* photo_locked_original_color_adjustments (Photo* self);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type, const gchar* group);
static KeyValueMap* photo_get_color_adjustments_map (Photo* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
PixelTransformer* pixel_transformer_copy (PixelTransformer* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self, const gchar* name);
GType pixel_transformation_type_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation (GValue* value, gpointer v_object);
void value_take_pixel_transformation (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type);
PixelTransformation* pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self, PixelTransformationType type);
void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments);
gboolean pixel_transformation_bundle_is_identity (PixelTransformationBundle* self);
static gboolean photo_remove_transformation (Photo* self, const gchar* name);
KeyValueMap* pixel_transformation_bundle_save (PixelTransformationBundle* self, const gchar* group);
GeeIterable* pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self);
void pixel_transformer_replace_transformation (PixelTransformer* self, PixelTransformation* old_trans, PixelTransformation* new_trans);
PixelTransformationType pixel_transformation_get_transformation_type (PixelTransformation* self);
static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_comment (MediaSource* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments, GeeHashMap* original_transformations, gboolean enhanced);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments, GeeHashMap* original_transformations, gboolean enhanced);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static gboolean photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self, PhotoID* photo_id, Orientation orientation, GeeHashMap* transformations, GeeHashMap* original_transforms, gboolean enhanced);
void photo_remove_all_transformations (Photo* self);
gboolean photo_table_remove_all_transformations (PhotoTable* self, PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self, PhotoID* photo_id, Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
gboolean photo_check_can_rotate (Photo* self);
void photo_rotate (Photo* self, Rotation rotation);
static void photo_real_rotate (Photo* self, Rotation rotation);
Orientation orientation_perform (Orientation self, Rotation rotation);
gchar* key_value_map_get_group (KeyValueMap* self);
gboolean photo_table_set_transformation (PhotoTable* self, PhotoID* photo_id, KeyValueMap* map);
static gboolean photo_set_original_transforms (Photo* self, KeyValueMap* trans);
gboolean photo_table_set_original_transforms (PhotoTable* self, PhotoID* photo_id, KeyValueMap* map);
static gboolean photo_clear_original_transforms (Photo* self);
gboolean photo_table_remove_transformation (PhotoTable* self, PhotoID* photo_id, const gchar* object);
gboolean photo_has_crop (Photo* self);
gboolean photo_get_raw_crop (Photo* self, Box* crop);
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
gint key_value_map_get_int (KeyValueMap* self, const gchar* key, gint def);
static void photo_set_raw_crop (Photo* self, Box* crop);
void key_value_map_set_int (KeyValueMap* self, const gchar* key, gint value);
static gboolean photo_get_raw_straighten (Photo* self, gdouble* angle);
gdouble key_value_map_get_double (KeyValueMap* self, const gchar* key, gdouble def);
static void photo_set_raw_straighten (Photo* self, gdouble theta);
void key_value_map_set_double (KeyValueMap* self, const gchar* key, gdouble value);
GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST;
EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1);
void key_value_map_get_point (KeyValueMap* self, const gchar* key, GdkPoint* def, GdkPoint* result);
gboolean photo_has_redeye_transformations (Photo* self);
void photo_add_redeye_instance (Photo* self, EditingToolsRedeyeInstance* redeye);
void key_value_map_set_point (KeyValueMap* self, const gchar* key, GdkPoint* point);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self, GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_get_prefetched_copy (Photo* self);
gboolean photo_get_develop_raw_photos_to_files (void);
void media_source_get_dimensions (MediaSource* self, PhotoException disallowed_steps, Dimensions* result);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, EditingToolsRedeyeInstance* inst);
GdkPixbuf* rotate_arb (GdkPixbuf* source_pixbuf, gdouble angle);
void pixel_transformer_transform_pixbuf (PixelTransformer* self, GdkPixbuf* pixbuf, GCancellable* cancellable);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value, gpointer v_object);
void value_take_photo_file_format_properties (GValue* value, gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self, GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, gboolean export_metadata, GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
#define RESOURCES_APP_TITLE _ ("Photos")
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_clear (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format);
void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, gboolean export_metadata, GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self, const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error);
static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, const gchar* commandline, GError** error);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_with_raw_external_editor (Photo* self, const gchar* external_editor, GError** error);
GType configuration_facade_get_type (void) G_GNUC_CONST;
GType config_facade_get_type (void) G_GNUC_CONST;
ConfigFacade* config_facade_get_instance (void);
void configuration_facade_set_external_raw_app (ConfigurationFacade* self, const gchar* external_raw_app);
void photo_open_with_external_editor (Photo* self, const gchar* external_editor, GError** error);
GFile* photo_get_modified_file (Photo* self, GError** error);
void configuration_facade_set_external_photo_app (ConfigurationFacade* self, const gchar* external_photo_app);
static void photo_halt_monitoring_editable (Photo* self);
static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error);
static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error);
static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error);
static void photo_update_editable_attributes (Photo* self, GError** error);
void photo_reimport_editable (Photo* self, GError** error);
void photo_table_attach_editable (PhotoTable* self, PhotoRow* row, BackingPhotoID* editable_id, GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, gint64 filesize, GError** error);
static void _vala_array_add108 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add109 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add110 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add111 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add112 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add113 (gchar*** array, int* length, int* size, gchar* value);
void backing_photo_id_init (BackingPhotoID *self, gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name, OneShotCallback callback, void* callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type, const gchar* name, OneShotCallback callback, void* callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self, guint msec, gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_original_dimensions (Photo* self, Dimensions* result);
void photo_get_master_dimensions (Photo* self, Dimensions* result);
void photo_set_crop (Photo* self, Box* crop);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void photo_set_straighten (Photo* self, gdouble theta);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y);
void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
PixelTransformationBundle* auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf);
gboolean photo_enhance (Photo* self);
gboolean photo_unenhance (Photo* self);
void photo_set_develop_raw_photos_to_files (gboolean value);
static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_raw_development_modified (Photo* self);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata);
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplPrivate))
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject* obj);
enum  {
	PHOTO_BACKING_READERS_DUMMY_PROPERTY
};
static void photo_backing_readers_finalize (PhotoBackingReaders* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_DUMMY_PROPERTY
};
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_IMPL_DUMMY_PROPERTY
};
static gchar** _vala_array_dup6 (gchar** self, int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_DUMMY_PROPERTY
};
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_DUMMY_PROPERTY
};
PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type);
static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState* obj);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DUMMY_PROPERTY
};
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing, PhotoMetadata* metadata);
static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type, BackingPhotoRow* backing, PhotoMetadata* metadata);
enum  {
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_DUMMY_PROPERTY
};
static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport* obj);
static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState* obj);
static void photo_finalize (GObject* obj);
static void _vala_photo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_photo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_DUMMY_PROPERTY
};
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v, gpointer self);
gboolean file_equal (GFile* a, GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self);
gint int64_compare (gint64* a, gint64* b);
static gint _int64_compare_gcompare_data_func (gconstpointer a, gconstpointer b, gpointer self);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (gint64* a, gint64* b);
static gboolean _int64_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type, LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
GType library_photo_source_holding_tank_get_type (void) G_GNUC_CONST;
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type, Workers* workers, GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self, Photo* _photo);
static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
gpointer hierarchical_tag_index_ref (gpointer instance);
void hierarchical_tag_index_unref (gpointer instance);
GParamSpec* param_spec_hierarchical_tag_index (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_hierarchical_tag_index (GValue* value, gpointer v_object);
void value_take_hierarchical_tag_index (GValue* value, gpointer v_object);
gpointer value_get_hierarchical_tag_index (const GValue* value);
GType hierarchical_tag_index_get_type (void) G_GNUC_CONST;
HierarchicalTagIndex* hierarchical_tag_index_get_global_index (void);
gboolean photo_metadata_has_hierarchical_keywords (PhotoMetadata* self);
HierarchicalTagIndex* hierarchical_tag_utilities_process_hierarchical_import_keywords (GeeCollection* h_keywords);
GeeSet* photo_metadata_get_hierarchical_keywords (PhotoMetadata* self);
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gboolean hierarchical_tag_index_is_tag_in_index (HierarchicalTagIndex* self, const gchar* tag);
gchar* tag_prep_tag_name (const gchar* name);
gchar* hierarchical_tag_index_get_path_for_name (HierarchicalTagIndex* self, const gchar* name);
Tag* tag_for_path (const gchar* name);
GeeCollection* hierarchical_tag_index_get_all_paths (HierarchicalTagIndex* self);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self, GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self, GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self, gint64 numeric_id);
gint64 parse_int64 (const gchar* str, gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self, EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self, GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matches_development);
gboolean backing_photo_row_matches_file_info (BackingPhotoRow* self, GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matched_development);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize, PhotoID* result);
gint utf8_ci_compare (void* a, void* b);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize);
gboolean photo_id_is_valid (PhotoID *self);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self, const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self, GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type, MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection* obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO, LibraryPhotoPrivate))
enum  {
	LIBRARY_PHOTO_DUMMY_PROPERTY
};
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row);
static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const gchar* dehydrated);
static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params);
static LibraryPhoto* library_photo_construct_from_import_params (GType object_type, PhotoImportParams* import_params);
void library_photo_init (ProgressMonitor monitor, void* monitor_target);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self, GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self, GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo);
void photo_table_add (PhotoTable* self, PhotoRow* photo_row, PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self, PhotoID* photo_id, GError** error);
static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source, gboolean force, GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration);
gboolean alteration_has_subject (Alteration* self, const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self, gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
static void library_photo_real_rotate (Photo* base, Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source, Rotation rotation, GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source, gint scale, GError** error);
static void library_photo_duplicate_backing_photo (LibraryPhoto* self, BackingPhotoRow* backing, BackingPhotoID* result, GError** error);
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, gboolean blacklist, GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error);
void photo_table_duplicate (PhotoTable* self, PhotoID* photo_id, const gchar* new_filename, BackingPhotoID* editable_id, BackingPhotoID* develop_shotwell, BackingPhotoID* develop_camera_id, BackingPhotoID* develop_embedded_id, PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self, PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source, ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self, DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self, MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
void tag_attach (Tag* self, MediaSource* source);
void spin_event_loop (void);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
void library_photo_get_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, PhotoID* result);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata);
gchar* hierarchical_tag_utilities_make_flat_tag_safe (const gchar* in_tag);
gchar* hierarchical_tag_utilities_flat_to_hierarchical (const gchar* name);
gboolean tag_source_collection_exists (TagSourceCollection* self, const gchar* name, gboolean treat_htags_as_root);
static void library_photo_finalize (GObject* obj);
#define LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTankPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_HOLDING_TANK_DUMMY_PROPERTY
};
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type, MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed);
static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self, Photo* _photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self, Photo* _photo);
static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self);
void source_holding_tank_notify_contents_altered (SourceHoldingTank* self, GeeCollection* added, GeeCollection* removed);
static void library_photo_source_holding_tank_finalize (SourceHoldingTank* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType backing_fetch_mode_get_type (void) {
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {BACKING_FETCH_MODE_UNMODIFIED, "BACKING_FETCH_MODE_UNMODIFIED", "unmodified"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 2820 "Photo.c"
}


static gpointer _thumbnails_ref0 (gpointer self) {
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 2827 "Photo.c"
}


PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	ImportID _tmp4_ = {0};
	PhotoFileSnifferOptions _tmp5_ = 0;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	Thumbnails* _tmp12_ = NULL;
	Thumbnails* _tmp13_ = NULL;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 54 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->file = _tmp1_;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = final_associated_file;
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 55 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->final_associated_file = _tmp3_;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = *import_id;
#line 56 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->import_id = _tmp4_;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = sniffer_options;
#line 57 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->sniffer_options = _tmp5_;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = exif_md5;
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 58 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->exif_md5 = _tmp7_;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = thumbnail_md5;
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 59 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->thumbnail_md5 = _tmp9_;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = full_md5;
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 60 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->full_md5 = _tmp11_;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = thumbnails;
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _thumbnails_ref0 (_tmp12_);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 61 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->thumbnails = _tmp13_;
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 2911 "Photo.c"
}


PhotoImportParams* photo_import_params_new (GFile* file, GFile* final_associated_file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
#line 51 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, final_associated_file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 2918 "Photo.c"
}


PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	ImportID _tmp2_ = {0};
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 66 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->file = _tmp1_;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *import_id;
#line 67 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->import_id = _tmp2_;
#line 68 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 69 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->exif_md5 = NULL;
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 70 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 71 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->full_md5 = NULL;
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 72 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->thumbnails = NULL;
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 2965 "Photo.c"
}


PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id) {
#line 65 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 2972 "Photo.c"
}


static void value_photo_import_params_init (GValue* value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 2979 "Photo.c"
}


static void value_photo_import_params_free_value (GValue* value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 2988 "Photo.c"
	}
}


static void value_photo_import_params_copy_value (const GValue* src_value, GValue* dest_value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 2998 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3002 "Photo.c"
	}
}


static gpointer value_photo_import_params_peek_pointer (const GValue* value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 3010 "Photo.c"
}


static gchar* value_photo_import_params_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 3017 "Photo.c"
		PhotoImportParams* object;
		object = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3024 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3028 "Photo.c"
		}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 3032 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3036 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 3040 "Photo.c"
}


static gchar* value_photo_import_params_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoImportParams** object_p;
	object_p = collect_values[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3051 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 3057 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 3061 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 3065 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 3069 "Photo.c"
}


GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoImportParams* spec;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 3083 "Photo.c"
}


gpointer value_get_photo_import_params (const GValue* value) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 3092 "Photo.c"
}


void value_set_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 3112 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3116 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_import_params_unref (old);
#line 3122 "Photo.c"
	}
}


void value_take_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 3141 "Photo.c"
	} else {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 3145 "Photo.c"
	}
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_import_params_unref (old);
#line 3151 "Photo.c"
	}
}


static void photo_import_params_class_init (PhotoImportParamsClass * klass) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoImportParamsClass *) klass)->finalize = photo_import_params_finalize;
#line 3161 "Photo.c"
}


static void photo_import_params_instance_init (PhotoImportParams * self) {
	PhotoRow* _tmp0_ = NULL;
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->final_associated_file = NULL;
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->row = _tmp0_;
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->keywords = NULL;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 3177 "Photo.c"
}


static void photo_import_params_finalize (PhotoImportParams* obj) {
	PhotoImportParams * self;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 36 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 37 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->final_associated_file);
#line 40 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 41 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 42 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 45 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 48 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 49 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 3203 "Photo.c"
}


GType photo_import_params_get_type (void) {
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer photo_import_params_ref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 3228 "Photo.c"
}


void photo_import_params_unref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 34 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3241 "Photo.c"
	}
}


PhotoTransformationState* photo_transformation_state_construct (GType object_type) {
	PhotoTransformationState * self = NULL;
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 85 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 3252 "Photo.c"
}


gboolean photo_transformation_state_is_broken (PhotoTransformationState* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 88 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->is_broke;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 89 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 3267 "Photo.c"
}


static void photo_transformation_state_real_broken (PhotoTransformationState* self) {
#line 82 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 3274 "Photo.c"
}


static void photo_transformation_state_class_init (PhotoTransformationStateClass * klass) {
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoTransformationStatePrivate));
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoTransformationStateClass *) klass)->broken = photo_transformation_state_real_broken;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3289 "Photo.c"
}


static void photo_transformation_state_instance_init (PhotoTransformationState * self) {
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = PHOTO_TRANSFORMATION_STATE_GET_PRIVATE (self);
#line 77 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 3298 "Photo.c"
}


static void photo_transformation_state_finalize (GObject* obj) {
	PhotoTransformationState * self;
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState);
#line 76 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 3308 "Photo.c"
}


GType photo_transformation_state_get_type (void) {
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean photo_exception_prohibits (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_ = 0;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = exception;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (self & _tmp0_) != 0;
#line 160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 3333 "Photo.c"
}


gboolean photo_exception_allows (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_ = 0;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = exception;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (self & _tmp0_) == 0;
#line 164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 3346 "Photo.c"
}


GType photo_exception_get_type (void) {
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_STRAIGHTEN, "PHOTO_EXCEPTION_STRAIGHTEN", "straighten"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


static gpointer _photo_row_ref0 (gpointer self) {
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_row_ref (self) : NULL;
#line 3365 "Photo.c"
}


static gpointer _backing_photo_row_ref0 (gpointer self) {
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? backing_photo_row_ref (self) : NULL;
#line 3372 "Photo.c"
}


Photo* photo_construct (GType object_type, PhotoRow* row) {
	Photo * self = NULL;
	PhotoRow* _tmp0_ = NULL;
	PhotoRow* _tmp1_ = NULL;
	PhotoRow* _tmp2_ = NULL;
	PhotoRow* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	PhotoRow* _tmp6_ = NULL;
	PhotoRow* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	PhotoBackingReaders* _tmp10_ = NULL;
	PhotoRow* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_ = NULL;
	PhotoFileFormat _tmp13_ = 0;
	PhotoRow* _tmp14_ = NULL;
	BackingPhotoRow* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	PhotoFileReader* _tmp17_ = NULL;
	gchar* basename = NULL;
	PhotoRow* _tmp18_ = NULL;
	BackingPhotoRow* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	const gchar* _tmp22_ = NULL;
	const gchar* _tmp25_ = NULL;
	gboolean _tmp26_ = FALSE;
	PhotoRow* _tmp31_ = NULL;
	BackingPhotoID _tmp32_ = {0};
	gint64 _tmp33_ = 0LL;
	PhotoRow* _tmp49_ = NULL;
	BackingPhotoRow* _tmp50_ = NULL;
	PhotoFileFormat _tmp51_ = 0;
	gboolean _tmp67_ = FALSE;
	PhotoRow* _tmp68_ = NULL;
	BackingPhotoRow* _tmp69_ = NULL;
	PhotoFileFormat _tmp70_ = 0;
	PhotoBackingReaders* _tmp85_ = NULL;
	PhotoFileReader* _tmp86_ = NULL;
	PhotoRow* _tmp106_ = NULL;
	time_t _tmp107_ = 0;
	GError * _inner_error_ = NULL;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = row;
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _photo_row_ref0 (_tmp0_);
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->row = _tmp1_;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = self->row;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = self->row;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_->title;
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = media_source_prep_title (_tmp4_);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp2_->title);
#line 338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_->title = _tmp5_;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = self->row;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = self->row;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp7_->comment;
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = media_source_prep_comment (_tmp8_);
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp6_->comment);
#line 339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_->comment = _tmp9_;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = self->priv->readers;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = row;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _tmp11_->master;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_->file_format;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = row;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_->master;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _tmp15_->filepath;
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = photo_file_format_create_reader (_tmp13_, _tmp16_);
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp10_->master);
#line 343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_->master = _tmp17_;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = row;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_->master;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = _tmp19_->filepath;
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = string_sliced_at_last_char (_tmp20_, (gunichar) G_DIR_SEPARATOR, 0);
#line 346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	basename = _tmp21_;
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = basename;
#line 347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 3489 "Photo.c"
		const gchar* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = basename;
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = string_sliced_at (_tmp23_, 1);
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->priv->file_title = _tmp24_;
#line 3500 "Photo.c"
	}
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = self->priv->file_title;
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = is_string_empty (_tmp25_);
#line 350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp26_) {
#line 3508 "Photo.c"
		PhotoRow* _tmp27_ = NULL;
		BackingPhotoRow* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = row;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = _tmp27_->master;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = _tmp28_->filepath;
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = g_strdup (_tmp29_);
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->priv->file_title = _tmp30_;
#line 3525 "Photo.c"
	}
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = row;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp31_->editable_id;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = _tmp32_.id;
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp33_ != BACKING_PHOTO_ID_INVALID) {
#line 3535 "Photo.c"
		BackingPhotoRow* e = NULL;
		PhotoRow* _tmp34_ = NULL;
		BackingPhotoID _tmp35_ = {0};
		BackingPhotoRow* _tmp36_ = NULL;
		BackingPhotoRow* _tmp37_ = NULL;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = row;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = _tmp34_->editable_id;
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = photo_get_backing_row (self, &_tmp35_);
#line 354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		e = _tmp36_;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = e;
#line 355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp37_ != NULL) {
#line 3553 "Photo.c"
			BackingPhotoRow* _tmp38_ = NULL;
			BackingPhotoRow* _tmp39_ = NULL;
			PhotoBackingReaders* _tmp40_ = NULL;
			BackingPhotoRow* _tmp41_ = NULL;
			PhotoFileFormat _tmp42_ = 0;
			BackingPhotoRow* _tmp43_ = NULL;
			const gchar* _tmp44_ = NULL;
			PhotoFileReader* _tmp45_ = NULL;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp38_ = e;
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = _backing_photo_row_ref0 (_tmp38_);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (self->priv->editable);
#line 356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->priv->editable = _tmp39_;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = self->priv->readers;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = self->priv->editable;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = _tmp41_->file_format;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43_ = self->priv->editable;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp44_ = _tmp43_->filepath;
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp45_ = photo_file_format_create_reader (_tmp42_, _tmp44_);
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp40_->editable);
#line 357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_->editable = _tmp45_;
#line 3586 "Photo.c"
		} else {
			{
				PhotoTable* _tmp46_ = NULL;
				PhotoTable* _tmp47_ = NULL;
				PhotoRow* _tmp48_ = NULL;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp46_ = photo_table_get_instance ();
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp47_ = _tmp46_;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp48_ = self->row;
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_detach_editable (_tmp47_, _tmp48_, &_inner_error_);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp47_);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3606 "Photo.c"
						goto __catch112_database_error;
					}
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (e);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (basename);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return NULL;
#line 3619 "Photo.c"
				}
			}
			goto __finally112;
			__catch112_database_error:
			{
				GError* err = NULL;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				err = _inner_error_;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 3632 "Photo.c"
			}
			__finally112:
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (e);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (basename);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return NULL;
#line 3647 "Photo.c"
			}
#line 367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_internal_remove_all_transformations (self, FALSE);
#line 3651 "Photo.c"
		}
#line 353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (e);
#line 3655 "Photo.c"
	}
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp49_ = row;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp50_ = _tmp49_->master;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp51_ = _tmp50_->file_format;
#line 371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp51_ == PHOTO_FILE_FORMAT_RAW) {
#line 3665 "Photo.c"
		GeeHashMap* _tmp52_ = NULL;
		gint _tmp53_ = 0;
		RawDeveloper* _tmp54_ = NULL;
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp52_ = gee_hash_map_new (TYPE_RAW_DEVELOPER, NULL, NULL, TYPE_BACKING_PHOTO_ROW, (GBoxedCopyFunc) backing_photo_row_ref, (GDestroyNotify) backing_photo_row_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (self->priv->developments);
#line 373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->priv->developments = _tmp52_;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp54_ = raw_developer_as_array (&_tmp53_);
#line 3677 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection = _tmp54_;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection_length1 = _tmp53_;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			for (d_it = 0; d_it < _tmp53_; d_it = d_it + 1) {
#line 3689 "Photo.c"
				RawDeveloper d = 0;
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				d = d_collection[d_it];
#line 3693 "Photo.c"
				{
					BackingPhotoID id = {0};
					PhotoRow* _tmp55_ = NULL;
					BackingPhotoID* _tmp56_ = NULL;
					gint _tmp56__length1 = 0;
					RawDeveloper _tmp57_ = 0;
					BackingPhotoID _tmp58_ = {0};
					BackingPhotoID _tmp59_ = {0};
					gint64 _tmp60_ = 0LL;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp55_ = row;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp56_ = _tmp55_->development_ids;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp56__length1 = _tmp55_->development_ids_length1;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp57_ = d;
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp58_ = _tmp56_[_tmp57_];
#line 375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					id = _tmp58_;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp59_ = id;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp60_ = _tmp59_.id;
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp60_ != BACKING_PHOTO_ID_INVALID) {
#line 3721 "Photo.c"
						BackingPhotoRow* bpr = NULL;
						BackingPhotoID _tmp61_ = {0};
						BackingPhotoRow* _tmp62_ = NULL;
						BackingPhotoRow* _tmp63_ = NULL;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp61_ = id;
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp62_ = photo_get_backing_row (self, &_tmp61_);
#line 377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						bpr = _tmp62_;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp63_ = bpr;
#line 378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp63_ != NULL) {
#line 3736 "Photo.c"
							GeeHashMap* _tmp64_ = NULL;
							RawDeveloper _tmp65_ = 0;
							BackingPhotoRow* _tmp66_ = NULL;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp64_ = self->priv->developments;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp65_ = d;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp66_ = bpr;
#line 379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp64_, (gpointer) ((gintptr) _tmp65_), _tmp66_);
#line 3748 "Photo.c"
						}
#line 376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_backing_photo_row_unref0 (bpr);
#line 3752 "Photo.c"
					}
				}
			}
#line 374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 3758 "Photo.c"
		}
	}
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp68_ = row;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp69_ = _tmp68_->master;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp70_ = _tmp69_->file_format;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp70_ == PHOTO_FILE_FORMAT_RAW) {
#line 3769 "Photo.c"
		GeeHashMap* _tmp71_ = NULL;
		PhotoRow* _tmp72_ = NULL;
		RawDeveloper _tmp73_ = 0;
		gboolean _tmp74_ = FALSE;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = self->priv->developments;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = row;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = _tmp72_->developer;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp71_, (gpointer) ((gintptr) _tmp73_));
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp67_ = _tmp74_;
#line 3784 "Photo.c"
	} else {
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp67_ = FALSE;
#line 3788 "Photo.c"
	}
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp67_) {
#line 3792 "Photo.c"
		BackingPhotoRow* r = NULL;
		GeeHashMap* _tmp75_ = NULL;
		PhotoRow* _tmp76_ = NULL;
		RawDeveloper _tmp77_ = 0;
		gpointer _tmp78_ = NULL;
		PhotoBackingReaders* _tmp79_ = NULL;
		BackingPhotoRow* _tmp80_ = NULL;
		PhotoFileFormat _tmp81_ = 0;
		BackingPhotoRow* _tmp82_ = NULL;
		const gchar* _tmp83_ = NULL;
		PhotoFileReader* _tmp84_ = NULL;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = self->priv->developments;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp76_ = row;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp77_ = _tmp76_->developer;
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp78_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp75_, (gpointer) ((gintptr) _tmp77_));
#line 386 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		r = (BackingPhotoRow*) _tmp78_;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp79_ = self->priv->readers;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp80_ = r;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp81_ = _tmp80_->file_format;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp82_ = r;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp83_ = _tmp82_->filepath;
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp84_ = photo_file_format_create_reader (_tmp81_, _tmp83_);
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp79_->developer);
#line 387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp79_->developer = _tmp84_;
#line 385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (r);
#line 3832 "Photo.c"
	}
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp85_ = self->priv->readers;
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp86_ = _tmp85_->editable;
#line 391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp86_ != NULL) {
#line 3840 "Photo.c"
		BackingPhotoRow* _tmp87_ = NULL;
		BackingPhotoRow* _tmp88_ = NULL;
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp87_ = self->priv->editable;
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp88_ = _backing_photo_row_ref0 (_tmp87_);
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (self->backing_photo_row);
#line 392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->backing_photo_row = _tmp88_;
#line 3851 "Photo.c"
	} else {
		PhotoRow* _tmp89_ = NULL;
		BackingPhotoRow* _tmp90_ = NULL;
		PhotoFileFormat _tmp91_ = 0;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp89_ = row;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp90_ = _tmp89_->master;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp91_ = _tmp90_->file_format;
#line 393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp91_ != PHOTO_FILE_FORMAT_RAW) {
#line 3864 "Photo.c"
			PhotoRow* _tmp92_ = NULL;
			BackingPhotoRow* _tmp93_ = NULL;
			BackingPhotoRow* _tmp94_ = NULL;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp92_ = self->row;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp93_ = _tmp92_->master;
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp94_ = _backing_photo_row_ref0 (_tmp93_);
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->backing_photo_row = _tmp94_;
#line 3878 "Photo.c"
		} else {
			GeeHashMap* _tmp95_ = NULL;
			PhotoRow* _tmp96_ = NULL;
			RawDeveloper _tmp97_ = 0;
			gboolean _tmp98_ = FALSE;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp95_ = self->priv->developments;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp96_ = row;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp97_ = _tmp96_->developer;
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp98_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp95_, (gpointer) ((gintptr) _tmp97_));
#line 398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp98_) {
#line 3894 "Photo.c"
				GeeHashMap* _tmp99_ = NULL;
				PhotoRow* _tmp100_ = NULL;
				RawDeveloper _tmp101_ = 0;
				gpointer _tmp102_ = NULL;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp99_ = self->priv->developments;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp100_ = row;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp101_ = _tmp100_->developer;
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp102_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp99_, (gpointer) ((gintptr) _tmp101_));
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->backing_photo_row = (BackingPhotoRow*) _tmp102_;
#line 3911 "Photo.c"
			} else {
				PhotoRow* _tmp103_ = NULL;
				BackingPhotoRow* _tmp104_ = NULL;
				BackingPhotoRow* _tmp105_ = NULL;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp103_ = self->row;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp104_ = _tmp103_->master;
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp105_ = _backing_photo_row_ref0 (_tmp104_);
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (self->backing_photo_row);
#line 402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->backing_photo_row = _tmp105_;
#line 3926 "Photo.c"
			}
		}
	}
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp106_ = self->row;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp107_ = _tmp106_->exposure_time;
#line 406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->cached_exposure_time = _tmp107_;
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (basename);
#line 334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 3940 "Photo.c"
}


static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = old_file;
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = new_file;
#line 410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-replaced", _tmp0_, _tmp1_);
#line 3953 "Photo.c"
}


void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 3962 "Photo.c"
}


static void photo_real_notify_raw_development_modified (Photo* self) {
#line 414 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "raw-development-modified");
#line 3969 "Photo.c"
}


void photo_notify_raw_development_modified (Photo* self) {
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_raw_development_modified (self);
#line 3978 "Photo.c"
}


static void photo_real_notify_baseline_replaced (Photo* self) {
#line 418 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-replaced");
#line 3985 "Photo.c"
}


void photo_notify_baseline_replaced (Photo* self) {
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 417 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 3994 "Photo.c"
}


static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_ = NULL;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_);
#line 4004 "Photo.c"
}


void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
#line 421 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 421 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 4013 "Photo.c"
}


static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_ = NULL;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 426 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_);
#line 4023 "Photo.c"
}


void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 4032 "Photo.c"
}


static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_ = NULL;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_);
#line 4042 "Photo.c"
}


void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 429 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 4051 "Photo.c"
}


static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_ = NULL;
#line 434 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 434 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_);
#line 4061 "Photo.c"
}


void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 4070 "Photo.c"
}


static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error) {
	Photo * self;
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GFile* file = NULL;
	PhotoFileFormat _tmp8_ = 0;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	GError * _inner_error_ = NULL;
#line 437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 438 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = TRUE;
#line 439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = NULL;
#line 4090 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 4097 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 4107 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				GFile* _tmp5_ = NULL;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				file = _tmp5_;
#line 4121 "Photo.c"
			}
		}
		__finally113:
		{
			PhotoBackingReaders* _tmp6_ = NULL;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4131 "Photo.c"
		}
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4135 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp7_;
#line 4143 "Photo.c"
		}
	}
#line 445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE, TRUE);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo_get_master_file_format (self);
#line 447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ == PHOTO_FILE_FORMAT_RAW) {
#line 4152 "Photo.c"
		gint _tmp9_ = 0;
		RawDeveloper* _tmp10_ = NULL;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = raw_developer_as_array (&_tmp9_);
#line 4157 "Photo.c"
		{
			RawDeveloper* d_collection = NULL;
			gint d_collection_length1 = 0;
			gint _d_collection_size_ = 0;
			gint d_it = 0;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection = _tmp10_;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection_length1 = _tmp9_;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			for (d_it = 0; d_it < _tmp9_; d_it = d_it + 1) {
#line 4169 "Photo.c"
				RawDeveloper d = 0;
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				d = d_collection[d_it];
#line 4173 "Photo.c"
				{
					RawDeveloper _tmp11_ = 0;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = d;
#line 449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_delete_raw_development (self, _tmp11_);
#line 4180 "Photo.c"
				}
			}
#line 448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			d_collection = (g_free (d_collection), NULL);
#line 4185 "Photo.c"
		}
	}
#line 453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_delete_original_file ((MediaSource*) self);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), &_inner_error_);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp14_;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4196 "Photo.c"
		gboolean _tmp15_ = FALSE;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp15_;
#line 4204 "Photo.c"
	}
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_) {
#line 4208 "Photo.c"
		gboolean _tmp16_ = FALSE;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = ret;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp16_;
#line 4214 "Photo.c"
	} else {
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = FALSE;
#line 4218 "Photo.c"
	}
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp12_;
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 4226 "Photo.c"
}


static BackingPhotoRow* photo_get_backing_row (Photo* self, BackingPhotoID* id) {
	BackingPhotoRow* result = NULL;
	BackingPhotoID _tmp0_ = {0};
	gint64 _tmp1_ = 0LL;
	BackingPhotoRow* backing_row = NULL;
	BackingPhotoRow* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *id;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == BACKING_PHOTO_ID_INVALID) {
#line 463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 4251 "Photo.c"
	}
#line 465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing_row = NULL;
#line 4255 "Photo.c"
	{
		BackingPhotoRow* _tmp2_ = NULL;
		BackingPhotoTable* _tmp3_ = NULL;
		BackingPhotoTable* _tmp4_ = NULL;
		BackingPhotoID _tmp5_ = {0};
		BackingPhotoRow* _tmp6_ = NULL;
		BackingPhotoRow* _tmp7_ = NULL;
		BackingPhotoRow* _tmp8_ = NULL;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = backing_photo_table_get_instance ();
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = *id;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = backing_photo_table_fetch (_tmp4_, &_tmp5_, &_inner_error_);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp4_);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp7_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 4282 "Photo.c"
				goto __catch114_database_error;
			}
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 4293 "Photo.c"
		}
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = _tmp2_;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = NULL;
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		backing_row = _tmp8_;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp2_);
#line 4305 "Photo.c"
	}
	goto __finally114;
	__catch114_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = data_object_to_string ((DataObject*) self);
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = err;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:469: Unable to fetch backing state for %s: %s", _tmp10_, _tmp12_);
#line 469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 4333 "Photo.c"
	}
	__finally114:
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 4346 "Photo.c"
	}
#line 472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = backing_row;
#line 472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 4352 "Photo.c"
		{
			BackingPhotoTable* _tmp14_ = NULL;
			BackingPhotoTable* _tmp15_ = NULL;
			BackingPhotoID _tmp16_ = {0};
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = backing_photo_table_get_instance ();
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = *id;
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_table_remove (_tmp15_, &_tmp16_, &_inner_error_);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp15_);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 4371 "Photo.c"
					goto __catch115_database_error;
				}
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing_row);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return NULL;
#line 4382 "Photo.c"
			}
		}
		goto __finally115;
		__catch115_database_error:
		{
			GError* err = NULL;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 4395 "Photo.c"
		}
		__finally115:
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing_row);
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 473 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 4408 "Photo.c"
		}
#line 478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing_row);
#line 478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 4416 "Photo.c"
	}
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = backing_row;
#line 481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 4422 "Photo.c"
}


gboolean photo_is_raw_developer_complete (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4431 "Photo.c"
	{
		GeeHashMap* _tmp0_ = NULL;
		gboolean _tmp13_ = FALSE;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4439 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			GeeHashMap* _tmp2_ = NULL;
			RawDeveloper _tmp3_ = 0;
			gboolean _tmp4_ = FALSE;
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = d;
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) _tmp3_));
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp4_) {
#line 4453 "Photo.c"
				GeeHashMap* _tmp5_ = NULL;
				RawDeveloper _tmp6_ = 0;
				gpointer _tmp7_ = NULL;
				BackingPhotoRow* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = self->priv->developments;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = d;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) _tmp6_));
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = (BackingPhotoRow*) _tmp7_;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_->filepath;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = g_file_test (_tmp9_, G_FILE_TEST_EXISTS);
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp10_;
#line 489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp8_);
#line 4476 "Photo.c"
			} else {
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 4480 "Photo.c"
			}
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 4484 "Photo.c"
			{
				GeeHashMap* _tmp11_ = NULL;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4491 "Photo.c"
			}
#line 488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 4495 "Photo.c"
		}
		__finally116:
		{
			GeeHashMap* _tmp12_ = NULL;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->priv->developments;
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4504 "Photo.c"
		}
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp13_;
#line 4512 "Photo.c"
	}
}


gboolean photo_is_raw_developer_available (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	RawDeveloper _tmp7_ = 0;
	GError * _inner_error_ = NULL;
#line 494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4523 "Photo.c"
	{
		GeeHashMap* _tmp0_ = NULL;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4530 "Photo.c"
		{
			GeeHashMap* _tmp1_ = NULL;
			RawDeveloper _tmp2_ = 0;
			gboolean _tmp3_ = FALSE;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = d;
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) _tmp2_));
#line 496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_) {
#line 497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = TRUE;
#line 4545 "Photo.c"
				{
					GeeHashMap* _tmp4_ = NULL;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp4_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4552 "Photo.c"
				}
#line 497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 4556 "Photo.c"
			}
		}
		__finally117:
		{
			GeeHashMap* _tmp5_ = NULL;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4566 "Photo.c"
		}
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4570 "Photo.c"
			gboolean _tmp6_ = FALSE;
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp6_;
#line 4578 "Photo.c"
		}
	}
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = d;
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (_tmp7_) {
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 4587 "Photo.c"
		{
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = TRUE;
#line 502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 4593 "Photo.c"
		}
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 4597 "Photo.c"
		{
#line 505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = FALSE;
#line 505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 4603 "Photo.c"
		}
#line 500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 4607 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp8_ = NULL;
				guint num_previews = 0U;
				PhotoMetadata* _tmp9_ = NULL;
				guint _tmp10_ = 0U;
				guint _tmp11_ = 0U;
#line 509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = photo_get_master_metadata (self, &_inner_error_);
#line 509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				meta = _tmp8_;
#line 509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4622 "Photo.c"
					goto __catch118_g_error;
				}
#line 510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = meta;
#line 510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = photo_metadata_get_preview_count (_tmp9_);
#line 510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				num_previews = _tmp10_;
#line 512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = num_previews;
#line 512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp11_ > ((guint) 0)) {
#line 4635 "Photo.c"
					PhotoPreview* prev = NULL;
					PhotoMetadata* _tmp12_ = NULL;
					guint _tmp13_ = 0U;
					PhotoPreview* _tmp14_ = NULL;
					PhotoPreview* _tmp15_ = NULL;
					Dimensions dims = {0};
					PhotoPreview* _tmp16_ = NULL;
					Dimensions _tmp17_ = {0};
					gint _tmp18_ = 0;
					Dimensions _tmp19_ = {0};
					gint _tmp20_ = 0;
					Dimensions _tmp21_ = {0};
					gint _tmp22_ = 0;
					gint preview_major_axis = 0;
					gint _tmp27_ = 0;
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = meta;
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = num_previews;
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = photo_metadata_get_preview (_tmp12_, _tmp13_ - 1);
#line 513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					prev = _tmp14_;
#line 516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = prev;
#line 516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp15_ == NULL) {
#line 517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						result = FALSE;
#line 517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return result;
#line 4671 "Photo.c"
					}
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = prev;
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_preview_get_pixel_dimensions (_tmp16_, &_tmp17_);
#line 519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					dims = _tmp17_;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = dims;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = _tmp19_.width;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp21_ = dims;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = _tmp21_.height;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp20_ > _tmp22_) {
#line 4689 "Photo.c"
						Dimensions _tmp23_ = {0};
						gint _tmp24_ = 0;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp23_ = dims;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp24_ = _tmp23_.width;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp18_ = _tmp24_;
#line 4698 "Photo.c"
					} else {
						Dimensions _tmp25_ = {0};
						gint _tmp26_ = 0;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp25_ = dims;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp26_ = _tmp25_.height;
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp18_ = _tmp26_;
#line 4708 "Photo.c"
					}
#line 522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					preview_major_axis = _tmp18_;
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp27_ = preview_major_axis;
#line 523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp27_ < PHOTO_MIN_EMBEDDED_SIZE) {
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						result = FALSE;
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_preview_unref0 (prev);
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_media_metadata_unref0 (meta);
#line 524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return result;
#line 4724 "Photo.c"
					}
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = TRUE;
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 4734 "Photo.c"
				}
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 4742 "Photo.c"
			}
			goto __finally118;
			__catch118_g_error:
			{
				GError* e = NULL;
				GError* _tmp28_ = NULL;
				const gchar* _tmp29_ = NULL;
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				e = _inner_error_;
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = e;
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = _tmp28_->message;
#line 533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("Photo.vala:533: Error accessing embedded preview. Message: %s", _tmp29_);
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (e);
#line 4762 "Photo.c"
			}
			__finally118:
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4767 "Photo.c"
				gboolean _tmp30_ = FALSE;
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return _tmp30_;
#line 4775 "Photo.c"
			}
#line 535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = FALSE;
#line 535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 4781 "Photo.c"
		}
		default:
		{
#line 538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_assert_not_reached ();
#line 4787 "Photo.c"
		}
	}
}


void photo_add_backing_photo_for_development (Photo* self, RawDeveloper d, BackingPhotoRow* bpr, GError** error) {
	PhotoRow* _tmp0_ = NULL;
	RawDeveloper _tmp1_ = 0;
	BackingPhotoRow* _tmp2_ = NULL;
	Alteration* _tmp8_ = NULL;
	Alteration* _tmp9_ = NULL;
	GError * _inner_error_ = NULL;
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = d;
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = bpr;
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_import_developed_backing_photo (_tmp0_, _tmp1_, _tmp2_, &_inner_error_);
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 4818 "Photo.c"
	}
	{
		GeeHashMap* _tmp3_ = NULL;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = self->priv->developments;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 4826 "Photo.c"
		{
			GeeHashMap* _tmp4_ = NULL;
			RawDeveloper _tmp5_ = 0;
			BackingPhotoRow* _tmp6_ = NULL;
#line 548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->developments;
#line 548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = d;
#line 548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = bpr;
#line 548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) _tmp5_), _tmp6_);
#line 4839 "Photo.c"
		}
		__finally119:
		{
			GeeHashMap* _tmp7_ = NULL;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->developments;
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 4848 "Photo.c"
		}
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 4856 "Photo.c"
		}
	}
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = alteration_new ("image", "developer");
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp9_);
#line 550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp9_);
#line 4867 "Photo.c"
}


void photo_import_developed_backing_photo (PhotoRow* row, RawDeveloper d, BackingPhotoRow* bpr, GError** error) {
	GFile* file = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFileInfo* info = NULL;
	GFile* _tmp3_ = NULL;
	GFileInfo* _tmp4_ = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp5_ = NULL;
	GTimeVal _tmp6_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp7_ = NULL;
	PhotoFileInterrogator* _tmp8_ = NULL;
	PhotoFileInterrogator* _tmp9_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp10_ = NULL;
	DetectedPhotoInformation* _tmp11_ = NULL;
	BackingPhotoRow* _tmp12_ = NULL;
	DetectedPhotoInformation* _tmp13_ = NULL;
	Dimensions _tmp14_ = {0};
	BackingPhotoRow* _tmp15_ = NULL;
	GFileInfo* _tmp16_ = NULL;
	gint64 _tmp17_ = 0LL;
	BackingPhotoRow* _tmp18_ = NULL;
	GTimeVal _tmp19_ = {0};
	glong _tmp20_ = 0L;
	Orientation _tmp21_ = 0;
	DetectedPhotoInformation* _tmp22_ = NULL;
	PhotoMetadata* _tmp23_ = NULL;
	BackingPhotoRow* _tmp27_ = NULL;
	BackingPhotoTable* _tmp28_ = NULL;
	BackingPhotoTable* _tmp29_ = NULL;
	BackingPhotoRow* _tmp30_ = NULL;
	PhotoTable* _tmp31_ = NULL;
	PhotoTable* _tmp32_ = NULL;
	PhotoRow* _tmp33_ = NULL;
	RawDeveloper _tmp34_ = 0;
	BackingPhotoRow* _tmp35_ = NULL;
	BackingPhotoID _tmp36_ = {0};
	GError * _inner_error_ = NULL;
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (row != NULL);
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (bpr != NULL);
#line 555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = bpr;
#line 555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->filepath;
#line 555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = g_file_new_for_path (_tmp1_);
#line 555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp2_;
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = file;
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	info = _tmp4_;
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 4938 "Photo.c"
	}
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = info;
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp5_, &_tmp6_);
#line 558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	timestamp = _tmp6_;
#line 560 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = file;
#line 560 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (_tmp7_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 560 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp8_;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = interrogator;
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp9_, &_inner_error_);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 4968 "Photo.c"
	}
#line 564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = interrogator;
#line 564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_file_interrogator_get_detected_photo_information (_tmp10_);
#line 564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp11_;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = bpr;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = detected;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = _tmp13_->image_dim;
#line 565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_->dim = _tmp14_;
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = bpr;
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = info;
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = g_file_info_get_size (_tmp16_);
#line 566 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_->filesize = _tmp17_;
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = bpr;
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = timestamp;
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = _tmp19_.tv_sec;
#line 567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_->timestamp = (time_t) _tmp20_;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = detected;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = _tmp22_->metadata;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 5006 "Photo.c"
		DetectedPhotoInformation* _tmp24_ = NULL;
		PhotoMetadata* _tmp25_ = NULL;
		Orientation _tmp26_ = 0;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = detected;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = _tmp24_->metadata;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = photo_metadata_get_orientation (_tmp25_);
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = _tmp26_;
#line 5018 "Photo.c"
	} else {
#line 569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = ORIENTATION_TOP_LEFT;
#line 5022 "Photo.c"
	}
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = bpr;
#line 568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_->original_orientation = _tmp21_;
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = backing_photo_table_get_instance ();
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = _tmp28_;
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = bpr;
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing_photo_table_add (_tmp29_, _tmp30_, &_inner_error_);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp29_);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 5052 "Photo.c"
	}
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = photo_table_get_instance ();
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = row;
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = d;
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = bpr;
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = _tmp35_->id;
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_table_update_raw_development (_tmp32_, _tmp33_, _tmp34_, &_tmp36_, &_inner_error_);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp32_);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 5084 "Photo.c"
	}
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (info);
#line 553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 5094 "Photo.c"
}


static void photo_develop_photo (Photo* self, RawDeveloper d) {
	gboolean wrote_img_to_disk = FALSE;
	BackingPhotoRow* bps = NULL;
	RawDeveloper _tmp0_ = 0;
	GError * _inner_error_ = NULL;
#line 578 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	wrote_img_to_disk = FALSE;
#line 580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	bps = NULL;
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = d;
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (_tmp0_) {
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_SHOTWELL:
#line 5115 "Photo.c"
		{
			{
				BackingPhotoRow* _tmp1_ = NULL;
				RawDeveloper _tmp2_ = 0;
				PhotoRow* _tmp3_ = NULL;
				BackingPhotoRow* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				BackingPhotoRow* _tmp6_ = NULL;
				BackingPhotoRow* _tmp7_ = NULL;
				GdkPixbuf* pix = NULL;
				GdkPixbuf* _tmp14_ = NULL;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				PhotoFileWriter* _tmp22_ = NULL;
				PhotoFileWriter* _tmp23_ = NULL;
				GdkPixbuf* _tmp24_ = NULL;
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp25_ = NULL;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp26_ = NULL;
				const gchar* _tmp27_ = NULL;
				PhotoFileMetadataWriter* _tmp28_ = NULL;
				PhotoFileMetadataWriter* _tmp29_ = NULL;
				PhotoMetadata* _tmp30_ = NULL;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = d;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->master;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->filepath;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = raw_developer_create_backing_row_for_development (_tmp2_, _tmp5_, NULL, &_inner_error_);
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5155 "Photo.c"
					goto __catch120_g_error;
				}
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp1_;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = NULL;
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				bps = _tmp7_;
#line 587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				pix = NULL;
#line 5168 "Photo.c"
				{
					PhotoBackingReaders* _tmp8_ = NULL;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = self->priv->readers;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 5175 "Photo.c"
					{
						GdkPixbuf* _tmp9_ = NULL;
						Scaling _tmp10_ = {0};
						GdkPixbuf* _tmp11_ = NULL;
						GdkPixbuf* _tmp12_ = NULL;
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						scaling_for_original (&_tmp10_);
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp11_ = photo_get_master_pixbuf (self, &_tmp10_, FALSE, &_inner_error_);
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp9_ = _tmp11_;
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5189 "Photo.c"
							goto __finally121;
						}
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp12_ = _tmp9_;
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp9_ = NULL;
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (pix);
#line 593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						pix = _tmp12_;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_tmp9_);
#line 5202 "Photo.c"
					}
					__finally121:
					{
						PhotoBackingReaders* _tmp13_ = NULL;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = self->priv->readers;
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5211 "Photo.c"
					}
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (pix);
#line 588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_backing_photo_row_unref0 (_tmp1_);
#line 5219 "Photo.c"
						goto __catch120_g_error;
					}
				}
#line 596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = pix;
#line 596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp14_ == NULL) {
#line 597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_debug ("Photo.vala:597: Could not get preview pixbuf");
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5233 "Photo.c"
					{
						gboolean _tmp15_ = FALSE;
#line 622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp15_ = wrote_img_to_disk;
#line 622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp15_) {
#line 5240 "Photo.c"
							{
								RawDeveloper _tmp16_ = 0;
								BackingPhotoRow* _tmp17_ = NULL;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp16_ = d;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp17_ = bps;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp16_, _tmp17_, &_inner_error_);
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5252 "Photo.c"
									goto __catch122_g_error;
								}
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5257 "Photo.c"
							}
							goto __finally122;
							__catch122_g_error:
							{
								GError* e = NULL;
								GError* _tmp18_ = NULL;
								const gchar* _tmp19_ = NULL;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								e = _inner_error_;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_inner_error_ = NULL;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp18_ = e;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp19_ = _tmp18_->message;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								g_debug ("Photo.vala:629: Error adding backing photo as development. Message: %s", _tmp19_);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_error_free0 (e);
#line 5277 "Photo.c"
							}
							__finally122:
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5282 "Photo.c"
								goto __catch120_g_error;
							}
						}
					}
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 5291 "Photo.c"
				}
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = bps;
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = _tmp20_->filepath;
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp21_, &_inner_error_);
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				writer = _tmp22_;
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5307 "Photo.c"
					goto __catch120_g_error;
				}
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = writer;
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = pix;
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_file_writer_write (_tmp23_, _tmp24_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5324 "Photo.c"
					goto __catch120_g_error;
				}
#line 611 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = photo_get_master_metadata (self, &_inner_error_);
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				meta = _tmp25_;
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 616 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5341 "Photo.c"
					goto __catch120_g_error;
				}
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = bps;
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = _tmp26_->filepath;
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp27_, &_inner_error_);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				mwriter = _tmp28_;
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5362 "Photo.c"
					goto __catch120_g_error;
				}
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = mwriter;
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = meta;
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp29_, _tmp30_, &_inner_error_);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp1_);
#line 5383 "Photo.c"
					goto __catch120_g_error;
				}
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (pix);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 5396 "Photo.c"
			}
			goto __finally120;
			__catch120_g_error:
			{
				GError* err = NULL;
				GError* _tmp31_ = NULL;
				const gchar* _tmp32_ = NULL;
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				err = _inner_error_;
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = err;
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = _tmp31_->message;
#line 620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("Photo.vala:620: Error developing photo: %s", _tmp32_);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 5416 "Photo.c"
			}
			__finally120:
			{
				gboolean _tmp33_ = FALSE;
#line 622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = wrote_img_to_disk;
#line 622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp33_) {
#line 5425 "Photo.c"
					{
						RawDeveloper _tmp34_ = 0;
						BackingPhotoRow* _tmp35_ = NULL;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp34_ = d;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp35_ = bps;
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_add_backing_photo_for_development (self, _tmp34_, _tmp35_, &_inner_error_);
#line 625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5437 "Photo.c"
							goto __catch123_g_error;
						}
#line 627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 5442 "Photo.c"
					}
					goto __finally123;
					__catch123_g_error:
					{
						GError* e = NULL;
						GError* _tmp36_ = NULL;
						const gchar* _tmp37_ = NULL;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						e = _inner_error_;
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_inner_error_ = NULL;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp36_ = e;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp37_ = _tmp36_->message;
#line 629 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_debug ("Photo.vala:629: Error adding backing photo as development. Message: %s", _tmp37_);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_error_free0 (e);
#line 5462 "Photo.c"
					}
					__finally123:
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return;
#line 5475 "Photo.c"
					}
				}
			}
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 5489 "Photo.c"
			}
#line 635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 5493 "Photo.c"
		}
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_CAMERA:
#line 5497 "Photo.c"
		{
#line 639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 5501 "Photo.c"
		}
#line 582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case RAW_DEVELOPER_EMBEDDED:
#line 5505 "Photo.c"
		{
			{
				PhotoMetadata* meta = NULL;
				PhotoMetadata* _tmp38_ = NULL;
				guint c = 0U;
				PhotoMetadata* _tmp39_ = NULL;
				guint _tmp40_ = 0U;
				guint _tmp41_ = 0U;
				PhotoPreview* prev = NULL;
				PhotoMetadata* _tmp47_ = NULL;
				guint _tmp48_ = 0U;
				PhotoPreview* _tmp49_ = NULL;
				PhotoPreview* _tmp50_ = NULL;
				GdkPixbuf* pix = NULL;
				PhotoPreview* _tmp56_ = NULL;
				GdkPixbuf* _tmp57_ = NULL;
				GdkPixbuf* _tmp58_ = NULL;
				BackingPhotoRow* _tmp64_ = NULL;
				RawDeveloper _tmp65_ = 0;
				PhotoRow* _tmp66_ = NULL;
				BackingPhotoRow* _tmp67_ = NULL;
				const gchar* _tmp68_ = NULL;
				BackingPhotoRow* _tmp69_ = NULL;
				BackingPhotoRow* _tmp70_ = NULL;
				PhotoFileWriter* writer = NULL;
				BackingPhotoRow* _tmp71_ = NULL;
				const gchar* _tmp72_ = NULL;
				PhotoFileWriter* _tmp73_ = NULL;
				PhotoFileWriter* _tmp74_ = NULL;
				GdkPixbuf* _tmp75_ = NULL;
				PhotoFileMetadataWriter* mwriter = NULL;
				BackingPhotoRow* _tmp76_ = NULL;
				const gchar* _tmp77_ = NULL;
				PhotoFileMetadataWriter* _tmp78_ = NULL;
				PhotoFileMetadataWriter* _tmp79_ = NULL;
				PhotoMetadata* _tmp80_ = NULL;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = photo_get_master_metadata (self, &_inner_error_);
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				meta = _tmp38_;
#line 644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5548 "Photo.c"
					goto __catch124_g_error;
				}
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = meta;
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = photo_metadata_get_preview_count (_tmp39_);
#line 645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				c = _tmp40_;
#line 646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = c;
#line 646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp41_ <= ((guint) 0)) {
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5563 "Photo.c"
					{
						gboolean _tmp42_ = FALSE;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp42_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp42_) {
#line 5570 "Photo.c"
							{
								RawDeveloper _tmp43_ = 0;
								BackingPhotoRow* _tmp44_ = NULL;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp43_ = d;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp44_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp43_, _tmp44_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5582 "Photo.c"
									goto __catch125_g_error;
								}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5587 "Photo.c"
							}
							goto __finally125;
							__catch125_g_error:
							{
								GError* e = NULL;
								GError* _tmp45_ = NULL;
								const gchar* _tmp46_ = NULL;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp45_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp46_ = _tmp45_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp46_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_error_free0 (e);
#line 5607 "Photo.c"
							}
							__finally125:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5612 "Photo.c"
								goto __catch124_g_error;
							}
						}
					}
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 5621 "Photo.c"
				}
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp47_ = meta;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp48_ = c;
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp49_ = photo_metadata_get_preview (_tmp47_, _tmp48_ - 1);
#line 648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				prev = _tmp49_;
#line 649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp50_ = prev;
#line 649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp50_ == NULL) {
#line 650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_debug ("Photo.vala:650: Could not get preview from metadata");
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5641 "Photo.c"
					{
						gboolean _tmp51_ = FALSE;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp51_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp51_) {
#line 5648 "Photo.c"
							{
								RawDeveloper _tmp52_ = 0;
								BackingPhotoRow* _tmp53_ = NULL;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp52_ = d;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp53_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp52_, _tmp53_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5660 "Photo.c"
									goto __catch126_g_error;
								}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5665 "Photo.c"
							}
							goto __finally126;
							__catch126_g_error:
							{
								GError* e = NULL;
								GError* _tmp54_ = NULL;
								const gchar* _tmp55_ = NULL;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp54_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp55_ = _tmp54_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp55_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_error_free0 (e);
#line 5685 "Photo.c"
							}
							__finally126:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5690 "Photo.c"
								goto __catch124_g_error;
							}
						}
					}
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 5699 "Photo.c"
				}
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = prev;
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = photo_preview_get_pixbuf (_tmp56_, &_inner_error_);
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				pix = _tmp57_;
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5713 "Photo.c"
					goto __catch124_g_error;
				}
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = pix;
#line 655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp58_ == NULL) {
#line 656 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_debug ("Photo.vala:656: Could not get preview pixbuf");
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5728 "Photo.c"
					{
						gboolean _tmp59_ = FALSE;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp59_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp59_) {
#line 5735 "Photo.c"
							{
								RawDeveloper _tmp60_ = 0;
								BackingPhotoRow* _tmp61_ = NULL;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp60_ = d;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp61_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_add_backing_photo_for_development (self, _tmp60_, _tmp61_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5747 "Photo.c"
									goto __catch127_g_error;
								}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								photo_notify_raw_development_modified (self);
#line 5752 "Photo.c"
							}
							goto __finally127;
							__catch127_g_error:
							{
								GError* e = NULL;
								GError* _tmp62_ = NULL;
								const gchar* _tmp63_ = NULL;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp62_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp63_ = _tmp62_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp63_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_error_free0 (e);
#line 5772 "Photo.c"
							}
							__finally127:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5777 "Photo.c"
								goto __catch124_g_error;
							}
						}
					}
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bps);
#line 657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 5786 "Photo.c"
				}
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp65_ = d;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp66_ = self->row;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_ = _tmp66_->master;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp68_ = _tmp67_->filepath;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp69_ = raw_developer_create_backing_row_for_development (_tmp65_, _tmp68_, NULL, &_inner_error_);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp64_ = _tmp69_;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5808 "Photo.c"
					goto __catch124_g_error;
				}
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp70_ = _tmp64_;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp64_ = NULL;
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				bps = _tmp70_;
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp71_ = bps;
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp72_ = _tmp71_->filepath;
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp73_ = photo_file_format_create_writer (PHOTO_FILE_FORMAT_JFIF, _tmp72_, &_inner_error_);
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				writer = _tmp73_;
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp64_);
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5837 "Photo.c"
					goto __catch124_g_error;
				}
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp74_ = writer;
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp75_ = pix;
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_file_writer_write (_tmp74_, _tmp75_, JPEG_QUALITY_HIGH, &_inner_error_);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp64_);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5858 "Photo.c"
					goto __catch124_g_error;
				}
#line 667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				wrote_img_to_disk = TRUE;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp76_ = bps;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp77_ = _tmp76_->filepath;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp78_ = photo_file_format_create_metadata_writer (PHOTO_FILE_FORMAT_JFIF, _tmp77_, &_inner_error_);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				mwriter = _tmp78_;
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp64_);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5883 "Photo.c"
					goto __catch124_g_error;
				}
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp79_ = mwriter;
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp80_ = meta;
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_file_metadata_writer_write_metadata (_tmp79_, _tmp80_, &_inner_error_);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (mwriter);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (writer);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp64_);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pix);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_preview_unref0 (prev);
#line 671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (meta);
#line 5906 "Photo.c"
					goto __catch124_g_error;
				}
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (mwriter);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (writer);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp64_);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (pix);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_preview_unref0 (prev);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_media_metadata_unref0 (meta);
#line 5921 "Photo.c"
			}
			goto __finally124;
			__catch124_g_error:
			{
				GError* e = NULL;
				GError* _tmp81_ = NULL;
				const gchar* _tmp82_ = NULL;
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				e = _inner_error_;
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp81_ = e;
#line 673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp82_ = _tmp81_->message;
#line 673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("Photo.vala:673: Error accessing embedded preview. Message: %s", _tmp82_);
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (e);
#line 5941 "Photo.c"
				{
					gboolean _tmp83_ = FALSE;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp83_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp83_) {
#line 5948 "Photo.c"
						{
							RawDeveloper _tmp84_ = 0;
							BackingPhotoRow* _tmp85_ = NULL;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp84_ = d;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp85_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							photo_add_backing_photo_for_development (self, _tmp84_, _tmp85_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5960 "Photo.c"
								goto __catch128_g_error;
							}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							photo_notify_raw_development_modified (self);
#line 5965 "Photo.c"
						}
						goto __finally128;
						__catch128_g_error:
						{
							GError* e = NULL;
							GError* _tmp86_ = NULL;
							const gchar* _tmp87_ = NULL;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp86_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp87_ = _tmp86_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp87_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_error_free0 (e);
#line 5985 "Photo.c"
						}
						__finally128:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_backing_photo_row_unref0 (bps);
#line 5992 "Photo.c"
						}
					}
				}
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 6000 "Photo.c"
			}
			__finally124:
			{
				gboolean _tmp88_ = FALSE;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp88_ = wrote_img_to_disk;
#line 676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp88_) {
#line 6009 "Photo.c"
					{
						RawDeveloper _tmp89_ = 0;
						BackingPhotoRow* _tmp90_ = NULL;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp89_ = d;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp90_ = bps;
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_add_backing_photo_for_development (self, _tmp89_, _tmp90_, &_inner_error_);
#line 679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6021 "Photo.c"
							goto __catch129_g_error;
						}
#line 681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_notify_raw_development_modified (self);
#line 6026 "Photo.c"
					}
					goto __finally129;
					__catch129_g_error:
					{
						GError* e = NULL;
						GError* _tmp91_ = NULL;
						const gchar* _tmp92_ = NULL;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						e = _inner_error_;
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_inner_error_ = NULL;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp91_ = e;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp92_ = _tmp91_->message;
#line 683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_debug ("Photo.vala:683: Error adding backing photo as development. Message: %s", _tmp92_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_error_free0 (e);
#line 6046 "Photo.c"
					}
					__finally129:
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_backing_photo_row_unref0 (bps);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return;
#line 6059 "Photo.c"
					}
				}
			}
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bps);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 6073 "Photo.c"
			}
#line 688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 6077 "Photo.c"
		}
		default:
		{
#line 691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_assert_not_reached ();
#line 6083 "Photo.c"
		}
	}
#line 578 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (bps);
#line 6088 "Photo.c"
}


void photo_set_default_raw_developer (Photo* self, RawDeveloper d) {
	GError * _inner_error_ = NULL;
#line 696 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 6096 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6103 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			RawDeveloper _tmp2_ = 0;
#line 698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = d;
#line 698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_->developer = _tmp2_;
#line 6113 "Photo.c"
		}
		__finally130:
		{
			PhotoRow* _tmp3_ = NULL;
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 6122 "Photo.c"
		}
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 6132 "Photo.c"
		}
	}
}


void photo_set_raw_developer (Photo* self, RawDeveloper d) {
	PhotoFileFormat _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	Alteration* _tmp46_ = NULL;
	Alteration* _tmp47_ = NULL;
	GError * _inner_error_ = NULL;
#line 703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 704 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 704 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 705 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 6154 "Photo.c"
	}
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_is_raw_developer_available (self, RAW_DEVELOPER_CAMERA);
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 6160 "Photo.c"
		RawDeveloper _tmp3_ = 0;
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = d;
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp3_ == RAW_DEVELOPER_EMBEDDED;
#line 6166 "Photo.c"
	} else {
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = FALSE;
#line 6170 "Photo.c"
	}
#line 710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		d = RAW_DEVELOPER_CAMERA;
#line 6176 "Photo.c"
	}
#line 715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_is_raw_developer_available (self, RAW_DEVELOPER_EMBEDDED);
#line 715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp4_) {
#line 716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		d = RAW_DEVELOPER_SHOTWELL;
#line 6184 "Photo.c"
	}
	{
		GeeHashMap* _tmp5_ = NULL;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6192 "Photo.c"
		{
			RawDeveloper stale_raw_developer = 0;
			PhotoRow* _tmp6_ = NULL;
			RawDeveloper _tmp7_ = 0;
			RawDeveloper _tmp8_ = 0;
			gboolean _tmp9_ = FALSE;
			GeeHashMap* _tmp13_ = NULL;
			RawDeveloper _tmp14_ = 0;
			gboolean _tmp15_ = FALSE;
			PhotoRow* _tmp17_ = NULL;
			RawDeveloper _tmp18_ = 0;
			GeeHashMap* _tmp19_ = NULL;
			RawDeveloper _tmp20_ = 0;
			gpointer _tmp21_ = NULL;
			PhotoBackingReaders* _tmp22_ = NULL;
			BackingPhotoRow* _tmp23_ = NULL;
			PhotoFileFormat _tmp24_ = 0;
			BackingPhotoRow* _tmp25_ = NULL;
			const gchar* _tmp26_ = NULL;
			PhotoFileReader* _tmp27_ = NULL;
			BackingPhotoRow* _tmp28_ = NULL;
			Orientation _tmp29_ = 0;
			gboolean _tmp39_ = FALSE;
			RawDeveloper _tmp40_ = 0;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_->developer;
#line 719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			stale_raw_developer = _tmp7_;
#line 722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = d;
#line 722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo_is_raw_developer_complete (self, _tmp8_);
#line 722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp9_) {
#line 6229 "Photo.c"
				RawDeveloper _tmp10_ = 0;
#line 723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = d;
#line 723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_develop_photo (self, _tmp10_);
#line 6235 "Photo.c"
				{
#line 725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6241 "Photo.c"
						goto __catch132_g_error;
					}
				}
				goto __finally132;
				__catch132_g_error:
				{
					GError* e = NULL;
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					e = _inner_error_;
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_inner_error_ = NULL;
#line 728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_error_free0 (e);
#line 6255 "Photo.c"
					{
						GeeHashMap* _tmp11_ = NULL;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp11_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6262 "Photo.c"
					}
#line 728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 6266 "Photo.c"
				}
				__finally132:
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6271 "Photo.c"
					{
						GeeHashMap* _tmp12_ = NULL;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp12_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6278 "Photo.c"
					}
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 6286 "Photo.c"
				}
			}
#line 731 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->priv->developments;
#line 731 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = d;
#line 731 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp13_, (gpointer) ((gintptr) _tmp14_));
#line 731 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp15_) {
#line 6297 "Photo.c"
				{
					GeeHashMap* _tmp16_ = NULL;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6304 "Photo.c"
				}
#line 732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 6308 "Photo.c"
			}
#line 735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_revert_to_master (self, FALSE);
#line 738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->row;
#line 738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = d;
#line 738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_->developer = _tmp18_;
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->priv->developments;
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = d;
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp19_, (gpointer) ((gintptr) _tmp20_));
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (self->backing_photo_row);
#line 739 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->backing_photo_row = (BackingPhotoRow*) _tmp21_;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = self->priv->readers;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = self->backing_photo_row;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = _tmp23_->file_format;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = self->backing_photo_row;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = _tmp25_->filepath;
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = photo_file_format_create_reader (_tmp24_, _tmp26_);
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp22_->developer);
#line 740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_->developer = _tmp27_;
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = self->backing_photo_row;
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp29_ = _tmp28_->original_orientation;
#line 742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_orientation (self, _tmp29_);
#line 6350 "Photo.c"
			{
				PhotoTable* _tmp30_ = NULL;
				PhotoTable* _tmp31_ = NULL;
				PhotoRow* _tmp32_ = NULL;
				RawDeveloper _tmp33_ = 0;
				BackingPhotoRow* _tmp34_ = NULL;
				BackingPhotoID _tmp35_ = {0};
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = photo_table_get_instance ();
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = self->row;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = d;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = self->backing_photo_row;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = _tmp34_->id;
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_update_raw_development (_tmp31_, _tmp32_, _tmp33_, &_tmp35_, &_inner_error_);
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp31_);
#line 745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6376 "Photo.c"
					goto __catch133_g_error;
				}
			}
			goto __finally133;
			__catch133_g_error:
			{
				GError* e = NULL;
				GError* _tmp36_ = NULL;
				const gchar* _tmp37_ = NULL;
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				e = _inner_error_;
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = e;
#line 747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _tmp36_->message;
#line 747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_warning ("Photo.vala:747: Error updating database: %s", _tmp37_);
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (e);
#line 6398 "Photo.c"
			}
			__finally133:
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6403 "Photo.c"
				{
					GeeHashMap* _tmp38_ = NULL;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp38_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6410 "Photo.c"
				}
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 6418 "Photo.c"
			}
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = stale_raw_developer;
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp40_ != RAW_DEVELOPER_CAMERA) {
#line 6424 "Photo.c"
				RawDeveloper _tmp41_ = 0;
				PhotoRow* _tmp42_ = NULL;
				RawDeveloper _tmp43_ = 0;
#line 755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = stale_raw_developer;
#line 755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = self->row;
#line 755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = _tmp42_->developer;
#line 755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = _tmp41_ != _tmp43_;
#line 6436 "Photo.c"
			} else {
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = FALSE;
#line 6440 "Photo.c"
			}
#line 754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp39_) {
#line 6444 "Photo.c"
				RawDeveloper _tmp44_ = 0;
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = stale_raw_developer;
#line 758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_delete_raw_development (self, _tmp44_);
#line 6450 "Photo.c"
			}
		}
		__finally131:
		{
			GeeHashMap* _tmp45_ = NULL;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp45_ = self->priv->developments;
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6460 "Photo.c"
		}
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 6470 "Photo.c"
		}
	}
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = alteration_new ("image", "developer");
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = _tmp46_;
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp47_);
#line 765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp47_);
#line 766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 6483 "Photo.c"
}


RawDeveloper photo_get_raw_developer (Photo* self) {
	RawDeveloper result = 0;
	PhotoRow* _tmp0_ = NULL;
	RawDeveloper _tmp1_ = 0;
#line 769 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->developer;
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 6501 "Photo.c"
}


static gboolean photo_delete_raw_development (Photo* self, RawDeveloper d) {
	gboolean result = FALSE;
	gboolean ret = FALSE;
	GError * _inner_error_ = NULL;
#line 775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = FALSE;
#line 6513 "Photo.c"
	{
		GeeHashMap* _tmp0_ = NULL;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6520 "Photo.c"
		{
			GeeHashMap* _tmp1_ = NULL;
			RawDeveloper _tmp2_ = 0;
			gboolean _tmp3_ = FALSE;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_ = NULL;
			RawDeveloper _tmp7_ = 0;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			BackingPhotoRow* bpr = NULL;
			GeeHashMap* _tmp10_ = NULL;
			RawDeveloper _tmp11_ = 0;
			gpointer _tmp12_ = NULL;
			BackingPhotoRow* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			GeeHashMap* _tmp39_ = NULL;
			RawDeveloper _tmp40_ = 0;
			gboolean _tmp41_ = FALSE;
#line 779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->developments;
#line 779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = d;
#line 779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, (gpointer) ((gintptr) _tmp2_));
#line 779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp3_) {
#line 780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 6549 "Photo.c"
				{
					GeeHashMap* _tmp4_ = NULL;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp4_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6556 "Photo.c"
				}
#line 780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 6560 "Photo.c"
			}
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = data_object_to_string ((DataObject*) self);
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = d;
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = raw_developer_to_string (_tmp7_);
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_debug ("Photo.vala:784: Delete raw development: %s %s", _tmp6_, _tmp9_);
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp9_);
#line 784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp6_);
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = self->priv->developments;
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = d;
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp10_, (gpointer) ((gintptr) _tmp11_));
#line 785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			bpr = (BackingPhotoRow*) _tmp12_;
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = bpr;
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->filepath;
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp14_ != NULL) {
#line 6592 "Photo.c"
				GFile* f = NULL;
				BackingPhotoRow* _tmp15_ = NULL;
				const gchar* _tmp16_ = NULL;
				GFile* _tmp17_ = NULL;
#line 787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = bpr;
#line 787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = _tmp15_->filepath;
#line 787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = g_file_new_for_path (_tmp16_);
#line 787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				f = _tmp17_;
#line 6605 "Photo.c"
				{
					RawDeveloper _tmp18_ = 0;
#line 789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = d;
#line 789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp18_ == RAW_DEVELOPER_CAMERA) {
#line 6612 "Photo.c"
						GFile* _tmp19_ = NULL;
#line 790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp19_ = f;
#line 790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_file_trash (_tmp19_, NULL, &_inner_error_);
#line 790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6620 "Photo.c"
							goto __catch135_g_error;
						}
					} else {
						GFile* _tmp20_ = NULL;
#line 792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp20_ = f;
#line 792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_file_delete (_tmp20_, NULL, &_inner_error_);
#line 792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6631 "Photo.c"
							goto __catch135_g_error;
						}
					}
				}
				goto __finally135;
				__catch135_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp21_ = NULL;
					const gchar* _tmp22_ = NULL;
					GError* _tmp23_ = NULL;
					const gchar* _tmp24_ = NULL;
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					e = _inner_error_;
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_inner_error_ = NULL;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp21_ = bpr;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = _tmp21_->filepath;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = e;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp24_ = _tmp23_->message;
#line 794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_warning ("Photo.vala:794: Unable to delete RAW development: %s error: %s", _tmp22_, _tmp24_);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_error_free0 (e);
#line 6660 "Photo.c"
				}
				__finally135:
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6665 "Photo.c"
					gboolean _tmp26_ = FALSE;
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (f);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (f);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (bpr);
#line 6675 "Photo.c"
					{
						GeeHashMap* _tmp25_ = NULL;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp25_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6682 "Photo.c"
					}
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return _tmp26_;
#line 6690 "Photo.c"
				}
#line 786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (f);
#line 6694 "Photo.c"
			}
			{
				PhotoTable* _tmp27_ = NULL;
				PhotoTable* _tmp28_ = NULL;
				PhotoRow* _tmp29_ = NULL;
				RawDeveloper _tmp30_ = 0;
				BackingPhotoTable* _tmp31_ = NULL;
				BackingPhotoTable* _tmp32_ = NULL;
				BackingPhotoRow* _tmp33_ = NULL;
				BackingPhotoID _tmp34_ = {0};
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = photo_table_get_instance ();
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = _tmp27_;
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = self->row;
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = d;
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_remove_development (_tmp28_, _tmp29_, _tmp30_, &_inner_error_);
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp28_);
#line 800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6719 "Photo.c"
					goto __catch136_g_error;
				}
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = backing_photo_table_get_instance ();
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = _tmp31_;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = bpr;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = _tmp33_->id;
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				backing_photo_table_remove (_tmp32_, &_tmp34_, &_inner_error_);
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp32_);
#line 801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6736 "Photo.c"
					goto __catch136_g_error;
				}
			}
			goto __finally136;
			__catch136_g_error:
			{
				GError* e = NULL;
				GError* _tmp35_ = NULL;
				const gchar* _tmp36_ = NULL;
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				e = _inner_error_;
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = e;
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = _tmp35_->message;
#line 803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_warning ("Photo.vala:803: Database error while deleting RAW development: %s", _tmp36_);
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (e);
#line 6758 "Photo.c"
			}
			__finally136:
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6763 "Photo.c"
				gboolean _tmp38_ = FALSE;
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (bpr);
#line 6769 "Photo.c"
				{
					GeeHashMap* _tmp37_ = NULL;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp37_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6776 "Photo.c"
				}
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return _tmp38_;
#line 6784 "Photo.c"
			}
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = self->priv->developments;
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = d;
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp39_, (gpointer) ((gintptr) _tmp40_), NULL);
#line 806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			ret = _tmp41_;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (bpr);
#line 6796 "Photo.c"
		}
		__finally134:
		{
			GeeHashMap* _tmp42_ = NULL;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = self->priv->developments;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6805 "Photo.c"
		}
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 6809 "Photo.c"
			gboolean _tmp43_ = FALSE;
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp43_;
#line 6817 "Photo.c"
		}
	}
#line 809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = ret;
#line 810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 6826 "Photo.c"
}


void photo_redevelop_raw (Photo* self, RawDeveloper d) {
	GError * _inner_error_ = NULL;
#line 814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 6834 "Photo.c"
	{
		GeeHashMap* _tmp0_ = NULL;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->developments;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_developments);
#line 6841 "Photo.c"
		{
			RawDeveloper _tmp1_ = 0;
			RawDeveloper dev = 0;
			RawDeveloper _tmp2_ = 0;
			RawDeveloper _tmp3_ = 0;
			RawDeveloper _tmp4_ = 0;
#line 816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = d;
#line 816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_delete_raw_development (self, _tmp1_);
#line 817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = d;
#line 817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			dev = _tmp2_;
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = dev;
#line 818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ == RAW_DEVELOPER_CAMERA) {
#line 819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				dev = RAW_DEVELOPER_EMBEDDED;
#line 6862 "Photo.c"
			}
#line 821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = dev;
#line 821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_raw_developer (self, _tmp4_);
#line 6868 "Photo.c"
		}
		__finally137:
		{
			GeeHashMap* _tmp5_ = NULL;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->developments;
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_developments);
#line 6877 "Photo.c"
		}
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 6887 "Photo.c"
		}
	}
}


static void _vala_array_add91 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6900 "Photo.c"
	}
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6906 "Photo.c"
}


static void _vala_array_add92 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6917 "Photo.c"
	}
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6923 "Photo.c"
}


static void _vala_array_add93 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 6934 "Photo.c"
	}
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6940 "Photo.c"
}


static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1) {
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** backing = NULL;
	BackingFileState** _tmp0_ = NULL;
	gint backing_length1 = 0;
	gint _backing_size_ = 0;
	BackingFileState** _tmp27_ = NULL;
	gint _tmp27__length1 = 0;
	GError * _inner_error_ = NULL;
#line 825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp0_;
#line 826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing_length1 = 0;
#line 826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_size_ = backing_length1;
#line 6964 "Photo.c"
	{
		PhotoRow* _tmp1_ = NULL;
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->row;
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 6971 "Photo.c"
		{
			BackingFileState** _tmp2_ = NULL;
			gint _tmp2__length1 = 0;
			PhotoRow* _tmp3_ = NULL;
			BackingPhotoRow* _tmp4_ = NULL;
			PhotoRow* _tmp5_ = NULL;
			const gchar* _tmp6_ = NULL;
			BackingFileState* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp12_ = FALSE;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = backing;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->master;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->md5;
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_row (_tmp4_, _tmp6_);
#line 828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add91 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = photo_has_editable (self);
#line 829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp8_) {
#line 7002 "Photo.c"
				BackingFileState** _tmp9_ = NULL;
				gint _tmp9__length1 = 0;
				BackingPhotoRow* _tmp10_ = NULL;
				BackingFileState* _tmp11_ = NULL;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = backing;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9__length1 = backing_length1;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->priv->editable;
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = backing_file_state_new_from_photo_row (_tmp10_, NULL);
#line 830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_array_add92 (&backing, &backing_length1, &_backing_size_, _tmp11_);
#line 7017 "Photo.c"
			}
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = photo_is_developed (self);
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp12_) {
#line 7023 "Photo.c"
				GeeCollection* dev_rows = NULL;
				GeeCollection* _tmp13_ = NULL;
				GeeCollection* _tmp14_ = NULL;
#line 833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = photo_get_raw_development_photo_rows (self);
#line 833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				dev_rows = _tmp13_;
#line 834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = dev_rows;
#line 834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp14_ != NULL) {
#line 7035 "Photo.c"
					{
						GeeIterator* _r_it = NULL;
						GeeCollection* _tmp15_ = NULL;
						GeeIterator* _tmp16_ = NULL;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp15_ = dev_rows;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_r_it = _tmp16_;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 7048 "Photo.c"
							GeeIterator* _tmp17_ = NULL;
							gboolean _tmp18_ = FALSE;
							BackingPhotoRow* r = NULL;
							GeeIterator* _tmp19_ = NULL;
							gpointer _tmp20_ = NULL;
							BackingPhotoRow* _tmp21_ = NULL;
							const gchar* _tmp22_ = NULL;
							BackingFileState** _tmp23_ = NULL;
							gint _tmp23__length1 = 0;
							BackingPhotoRow* _tmp24_ = NULL;
							BackingFileState* _tmp25_ = NULL;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp17_ = _r_it;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp18_ = gee_iterator_next (_tmp17_);
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp18_) {
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 7068 "Photo.c"
							}
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp19_ = _r_it;
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20_ = gee_iterator_get (_tmp19_);
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							r = (BackingPhotoRow*) _tmp20_;
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_ = r;
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp22_ = _tmp21_->filepath;
#line 836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_debug ("Photo.vala:836: adding: %s", _tmp22_);
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp23_ = backing;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp23__length1 = backing_length1;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp24_ = r;
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp25_ = backing_file_state_new_from_photo_row (_tmp24_, NULL);
#line 837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_vala_array_add93 (&backing, &backing_length1, &_backing_size_, _tmp25_);
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_backing_photo_row_unref0 (r);
#line 7094 "Photo.c"
						}
#line 835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_r_it);
#line 7098 "Photo.c"
					}
				}
#line 832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (dev_rows);
#line 7103 "Photo.c"
			}
		}
		__finally138:
		{
			PhotoRow* _tmp26_ = NULL;
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = self->row;
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 7113 "Photo.c"
		}
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 7125 "Photo.c"
		}
	}
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = backing;
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27__length1 = backing_length1;
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (result_length1) {
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result_length1 = _tmp27__length1;
#line 7136 "Photo.c"
	}
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp27_;
#line 843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 7142 "Photo.c"
}


static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode) {
	PhotoFileReader* result = NULL;
	BackingFetchMode _tmp0_ = 0;
#line 846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = mode;
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (_tmp0_) {
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 7157 "Photo.c"
		{
			PhotoFileReader* _tmp1_ = NULL;
#line 849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_get_master_reader (self);
#line 849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7166 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 7170 "Photo.c"
		{
			PhotoFileReader* _tmp2_ = NULL;
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = photo_get_baseline_reader (self);
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7179 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 7183 "Photo.c"
		{
			PhotoFileReader* _tmp3_ = NULL;
#line 855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = photo_get_source_reader (self);
#line 855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7192 "Photo.c"
		}
#line 847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case BACKING_FETCH_MODE_UNMODIFIED:
#line 7196 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = photo_get_master_file_format (self);
#line 858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp4_ == PHOTO_FILE_FORMAT_RAW) {
#line 7203 "Photo.c"
				PhotoFileReader* _tmp5_ = NULL;
#line 859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = photo_get_raw_developer_reader (self);
#line 859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp5_;
#line 859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 7211 "Photo.c"
			} else {
				PhotoFileReader* _tmp6_ = NULL;
#line 861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo_get_master_reader (self);
#line 861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp6_;
#line 861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 7220 "Photo.c"
			}
		}
		default:
		{
			BackingFetchMode _tmp7_ = 0;
			GEnumValue* _tmp8_;
#line 864 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = mode;
#line 864 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), _tmp7_);
#line 864 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_error ("Photo.vala:864: Unknown backing fetch mode %s", (_tmp8_ != NULL) ? _tmp8_->value_name : NULL);
#line 7233 "Photo.c"
		}
	}
}


static gpointer _photo_file_adapter_ref0 (gpointer self) {
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 7242 "Photo.c"
}


static PhotoFileReader* photo_get_master_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7251 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7258 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 7271 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_ = NULL;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7278 "Photo.c"
			}
#line 870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7282 "Photo.c"
		}
		__finally139:
		{
			PhotoBackingReaders* _tmp5_ = NULL;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7291 "Photo.c"
		}
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 7299 "Photo.c"
	}
}


PhotoFileReader* photo_get_editable_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7309 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7316 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 7329 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_ = NULL;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7336 "Photo.c"
			}
#line 876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7340 "Photo.c"
		}
		__finally140:
		{
			PhotoBackingReaders* _tmp5_ = NULL;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7349 "Photo.c"
		}
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 875 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 7357 "Photo.c"
	}
}


static PhotoFileReader* photo_get_baseline_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7367 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7374 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoBackingReaders* _tmp7_ = NULL;
			PhotoFileReader* _tmp8_ = NULL;
			PhotoBackingReaders* _tmp13_ = NULL;
			PhotoFileReader* _tmp14_ = NULL;
			PhotoFileReader* _tmp15_ = NULL;
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7389 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				PhotoFileReader* _tmp5_ = NULL;
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp5_;
#line 7401 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_ = NULL;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7408 "Photo.c"
				}
#line 884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 7412 "Photo.c"
			}
#line 886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 7420 "Photo.c"
				PhotoBackingReaders* _tmp9_ = NULL;
				PhotoFileReader* _tmp10_ = NULL;
				PhotoFileReader* _tmp11_ = NULL;
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp11_;
#line 7432 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_ = NULL;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7439 "Photo.c"
				}
#line 887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 7443 "Photo.c"
			}
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp15_;
#line 7453 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_ = NULL;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7460 "Photo.c"
			}
#line 889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7464 "Photo.c"
		}
		__finally141:
		{
			PhotoBackingReaders* _tmp17_ = NULL;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7473 "Photo.c"
		}
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 7481 "Photo.c"
	}
}


static PhotoFileReader* photo_get_source_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7491 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7498 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoBackingReaders* _tmp7_ = NULL;
			PhotoFileReader* _tmp8_ = NULL;
			PhotoBackingReaders* _tmp13_ = NULL;
			PhotoFileReader* _tmp14_ = NULL;
			PhotoFileReader* _tmp15_ = NULL;
#line 896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 7513 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				PhotoFileReader* _tmp5_ = NULL;
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp5_;
#line 7525 "Photo.c"
				{
					PhotoBackingReaders* _tmp6_ = NULL;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7532 "Photo.c"
				}
#line 897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 7536 "Photo.c"
			}
#line 899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_->developer;
#line 899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 7544 "Photo.c"
				PhotoBackingReaders* _tmp9_ = NULL;
				PhotoFileReader* _tmp10_ = NULL;
				PhotoFileReader* _tmp11_ = NULL;
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_->developer;
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp11_;
#line 7556 "Photo.c"
				{
					PhotoBackingReaders* _tmp12_ = NULL;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7563 "Photo.c"
				}
#line 900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 7567 "Photo.c"
			}
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->master;
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp15_;
#line 7577 "Photo.c"
			{
				PhotoBackingReaders* _tmp16_ = NULL;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7584 "Photo.c"
			}
#line 902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7588 "Photo.c"
		}
		__finally142:
		{
			PhotoBackingReaders* _tmp17_ = NULL;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7597 "Photo.c"
		}
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 7605 "Photo.c"
	}
}


static PhotoFileReader* photo_get_raw_developer_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7615 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7622 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 7635 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_ = NULL;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7642 "Photo.c"
			}
#line 909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7646 "Photo.c"
		}
		__finally143:
		{
			PhotoBackingReaders* _tmp5_ = NULL;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7655 "Photo.c"
		}
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 7663 "Photo.c"
	}
}


gboolean photo_is_developed (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7673 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7681 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->developer;
#line 915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 7691 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_ = NULL;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7698 "Photo.c"
			}
#line 915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7702 "Photo.c"
		}
		__finally144:
		{
			PhotoBackingReaders* _tmp4_ = NULL;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7711 "Photo.c"
		}
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 7719 "Photo.c"
	}
}


gboolean photo_has_editable (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 919 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7729 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7737 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 7747 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_ = NULL;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7754 "Photo.c"
			}
#line 921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7758 "Photo.c"
		}
		__finally145:
		{
			PhotoBackingReaders* _tmp4_ = NULL;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7767 "Photo.c"
		}
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 7775 "Photo.c"
	}
}


gboolean photo_does_master_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7785 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7793 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			gboolean _tmp3_ = FALSE;
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp2_);
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 7806 "Photo.c"
			{
				PhotoBackingReaders* _tmp4_ = NULL;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7813 "Photo.c"
			}
#line 927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7817 "Photo.c"
		}
		__finally146:
		{
			PhotoBackingReaders* _tmp5_ = NULL;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7826 "Photo.c"
		}
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp6_;
#line 7834 "Photo.c"
	}
}


gboolean photo_does_editable_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 932 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7844 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
		gboolean _tmp9_ = FALSE;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7852 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 7863 "Photo.c"
				PhotoBackingReaders* _tmp4_ = NULL;
				PhotoFileReader* _tmp5_ = NULL;
				gboolean _tmp6_ = FALSE;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo_file_adapter_file_exists ((PhotoFileAdapter*) _tmp5_);
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 7875 "Photo.c"
			} else {
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 7879 "Photo.c"
			}
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 7883 "Photo.c"
			{
				PhotoBackingReaders* _tmp7_ = NULL;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7890 "Photo.c"
			}
#line 934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7894 "Photo.c"
		}
		__finally147:
		{
			PhotoBackingReaders* _tmp8_ = NULL;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7903 "Photo.c"
		}
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp9_;
#line 7911 "Photo.c"
	}
}


gboolean photo_is_master_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 938 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7921 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 7929 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_ == NULL;
#line 7939 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_ = NULL;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7946 "Photo.c"
			}
#line 940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 7950 "Photo.c"
		}
		__finally148:
		{
			PhotoBackingReaders* _tmp4_ = NULL;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 7959 "Photo.c"
		}
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 7967 "Photo.c"
	}
}


gboolean photo_is_master_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = !_tmp0_;
#line 945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 7983 "Photo.c"
}


gboolean photo_is_editable_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7992 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 8000 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 8010 "Photo.c"
			{
				PhotoBackingReaders* _tmp3_ = NULL;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8017 "Photo.c"
			}
#line 950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8021 "Photo.c"
		}
		__finally149:
		{
			PhotoBackingReaders* _tmp4_ = NULL;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 8030 "Photo.c"
		}
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 8038 "Photo.c"
	}
}


gboolean photo_is_editable_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 8054 "Photo.c"
}


BackingPhotoRow* photo_get_master_photo_row (Photo* self) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8063 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8070 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			BackingPhotoRow* _tmp2_ = NULL;
			BackingPhotoRow* _tmp3_ = NULL;
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _backing_photo_row_ref0 (_tmp2_);
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 8083 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8090 "Photo.c"
			}
#line 960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8094 "Photo.c"
		}
		__finally150:
		{
			PhotoRow* _tmp5_ = NULL;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8103 "Photo.c"
		}
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8111 "Photo.c"
	}
}


BackingPhotoRow* photo_get_editable_photo_row (Photo* self) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8121 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8128 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = backing_photo_id_is_valid (&_tmp1_->editable_id);
#line 967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_) {
#line 8138 "Photo.c"
				BackingPhotoRow* _tmp3_ = NULL;
				BackingPhotoRow* _tmp4_ = NULL;
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->editable;
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _backing_photo_row_ref0 (_tmp3_);
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = _tmp4_;
#line 8147 "Photo.c"
				{
					PhotoRow* _tmp5_ = NULL;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp5_ = self->row;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8154 "Photo.c"
				}
#line 968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 8158 "Photo.c"
			} else {
#line 970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = NULL;
#line 8162 "Photo.c"
				{
					PhotoRow* _tmp6_ = NULL;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->row;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8169 "Photo.c"
				}
#line 970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 8173 "Photo.c"
			}
		}
		__finally151:
		{
			PhotoRow* _tmp7_ = NULL;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8183 "Photo.c"
		}
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8191 "Photo.c"
	}
}


GeeCollection* photo_get_raw_development_photo_rows (Photo* self) {
	GeeCollection* result = NULL;
	GError * _inner_error_ = NULL;
#line 974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8201 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8208 "Photo.c"
		{
			GeeCollection* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8216 "Photo.c"
				GeeHashMap* _tmp3_ = NULL;
				GeeCollection* _tmp4_ = NULL;
				GeeCollection* _tmp5_ = NULL;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp5_;
#line 8230 "Photo.c"
			} else {
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp1_);
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = NULL;
#line 8236 "Photo.c"
			}
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 8240 "Photo.c"
			{
				PhotoRow* _tmp6_ = NULL;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8247 "Photo.c"
			}
#line 976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8251 "Photo.c"
		}
		__finally152:
		{
			PhotoRow* _tmp7_ = NULL;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8260 "Photo.c"
		}
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8268 "Photo.c"
	}
}


BackingPhotoRow* photo_get_raw_development_photo_row (Photo* self, RawDeveloper d) {
	BackingPhotoRow* result = NULL;
	GError * _inner_error_ = NULL;
#line 980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 8278 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 8285 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->developments;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 8293 "Photo.c"
				GeeHashMap* _tmp3_ = NULL;
				RawDeveloper _tmp4_ = 0;
				gpointer _tmp5_ = NULL;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = d;
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) _tmp4_));
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = (BackingPhotoRow*) _tmp5_;
#line 8307 "Photo.c"
			} else {
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp1_);
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = NULL;
#line 8313 "Photo.c"
			}
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 8317 "Photo.c"
			{
				PhotoRow* _tmp6_ = NULL;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8324 "Photo.c"
			}
#line 982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8328 "Photo.c"
		}
		__finally153:
		{
			PhotoRow* _tmp7_ = NULL;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 8337 "Photo.c"
		}
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 8345 "Photo.c"
	}
}


static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self) {
	PhotoFileFormat* dup;
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return dup;
#line 8358 "Photo.c"
}


static gpointer __photo_file_format_dup0 (gpointer self) {
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 8365 "Photo.c"
}


PhotoFileFormat* photo_get_editable_file_format (Photo* self) {
	PhotoFileFormat* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	PhotoFileFormat* _tmp4_ = NULL;
#line 986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp0_;
#line 988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = reader;
#line 988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 8393 "Photo.c"
	}
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reader;
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 8407 "Photo.c"
}


PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _result_ = 0;
	PhotoFileFormat _tmp0_ = 0;
	ExportFormatParameters _tmp1_ = {0};
	ExportFormatMode _tmp2_ = 0;
#line 995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_file_format_get_system_default_format ();
#line 996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_result_ = _tmp0_;
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = *params;
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_.mode;
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (_tmp2_) {
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 8433 "Photo.c"
		{
			PhotoFileFormat _tmp3_ = 0;
#line 1000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = photo_get_master_file_format (self);
#line 1000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_result_ = _tmp3_;
#line 1001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 8442 "Photo.c"
		}
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 8446 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 1004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = photo_get_best_export_file_format (self);
#line 1004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_result_ = _tmp4_;
#line 1005 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 8455 "Photo.c"
		}
#line 998 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 8459 "Photo.c"
		{
			ExportFormatParameters _tmp5_ = {0};
			PhotoFileFormat _tmp6_ = 0;
#line 1008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = *params;
#line 1008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_.specified_format;
#line 1008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_result_ = _tmp6_;
#line 1009 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 8471 "Photo.c"
		}
		default:
		{
#line 1012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_error ("Photo.vala:1012: get_export_format_for_parameters: unsupported export " \
"format mode");
#line 8477 "Photo.c"
		}
	}
#line 1015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _result_;
#line 1015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 8484 "Photo.c"
}


gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	ExportFormatParameters _tmp0_ = {0};
	ExportFormatMode _tmp1_ = 0;
	const gchar* _tmp8_ = NULL;
#line 1018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 1019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_result_ = NULL;
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *params;
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (_tmp1_) {
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 8508 "Photo.c"
		{
			GFile* _tmp2_ = NULL;
			GFile* _tmp3_ = NULL;
			gchar* _tmp4_ = NULL;
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = media_source_get_master_file ((MediaSource*) self);
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_result_);
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_result_ = _tmp4_;
#line 1023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 1024 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 8527 "Photo.c"
		}
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 1021 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 8533 "Photo.c"
		{
			ExportFormatParameters _tmp5_ = {0};
			PhotoFileFormat _tmp6_ = 0;
			gchar* _tmp7_ = NULL;
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = *params;
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp7_;
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_result_);
#line 1028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 8550 "Photo.c"
		}
		default:
		{
#line 1031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_error ("Photo.vala:1031: get_export_basename_for_parameters: unsupported expor" \
"t format mode");
#line 8556 "Photo.c"
		}
	}
#line 1034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _result_;
#line 1034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp8_ != NULL, "result != null");
#line 1035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _result_;
#line 1035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 8567 "Photo.c"
}


ImportResult photo_prepare_for_import (PhotoImportParams* params) {
	ImportResult result = 0;
	GFile* file = NULL;
	PhotoImportParams* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFileInfo* info = NULL;
	GFileInfo* _tmp7_ = NULL;
	GFileType _tmp8_ = 0;
	GFile* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	GFile* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp19_ = NULL;
	GTimeVal _tmp20_ = {0};
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	PhotoImportParams* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp32_ = NULL;
	PhotoImportParams* _tmp33_ = NULL;
	PhotoFileSnifferOptions _tmp34_ = 0;
	PhotoFileInterrogator* _tmp35_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	PhotoFileInterrogator* _tmp42_ = NULL;
	DetectedPhotoInformation* _tmp43_ = NULL;
	DetectedPhotoInformation* _tmp44_ = NULL;
	PhotoImportParams* _tmp45_ = NULL;
	PhotoFileSnifferOptions _tmp46_ = 0;
	Orientation orientation = 0;
	time_t exposure_time = 0;
	gchar* title = NULL;
	gchar* _tmp59_ = NULL;
	gchar* comment = NULL;
	gchar* _tmp60_ = NULL;
	DetectedPhotoInformation* _tmp61_ = NULL;
	PhotoMetadata* _tmp62_ = NULL;
	gboolean _tmp82_ = FALSE;
	gboolean _tmp83_ = FALSE;
	DetectedPhotoInformation* _tmp84_ = NULL;
	GdkColorspace _tmp85_ = 0;
	PhotoImportParams* _tmp93_ = NULL;
	PhotoRow* _tmp94_ = NULL;
	PhotoImportParams* _tmp95_ = NULL;
	PhotoRow* _tmp96_ = NULL;
	BackingPhotoRow* _tmp97_ = NULL;
	GFile* _tmp98_ = NULL;
	gchar* _tmp99_ = NULL;
	PhotoImportParams* _tmp100_ = NULL;
	PhotoRow* _tmp101_ = NULL;
	BackingPhotoRow* _tmp102_ = NULL;
	DetectedPhotoInformation* _tmp103_ = NULL;
	Dimensions _tmp104_ = {0};
	PhotoImportParams* _tmp105_ = NULL;
	PhotoRow* _tmp106_ = NULL;
	BackingPhotoRow* _tmp107_ = NULL;
	GFileInfo* _tmp108_ = NULL;
	gint64 _tmp109_ = 0LL;
	PhotoImportParams* _tmp110_ = NULL;
	PhotoRow* _tmp111_ = NULL;
	BackingPhotoRow* _tmp112_ = NULL;
	GTimeVal _tmp113_ = {0};
	glong _tmp114_ = 0L;
	PhotoImportParams* _tmp115_ = NULL;
	PhotoRow* _tmp116_ = NULL;
	time_t _tmp117_ = 0;
	PhotoImportParams* _tmp118_ = NULL;
	PhotoRow* _tmp119_ = NULL;
	Orientation _tmp120_ = 0;
	PhotoImportParams* _tmp121_ = NULL;
	PhotoRow* _tmp122_ = NULL;
	BackingPhotoRow* _tmp123_ = NULL;
	Orientation _tmp124_ = 0;
	PhotoImportParams* _tmp125_ = NULL;
	PhotoRow* _tmp126_ = NULL;
	PhotoImportParams* _tmp127_ = NULL;
	ImportID _tmp128_ = {0};
	PhotoImportParams* _tmp129_ = NULL;
	PhotoRow* _tmp130_ = NULL;
	PhotoImportParams* _tmp131_ = NULL;
	PhotoRow* _tmp132_ = NULL;
	PhotoImportParams* _tmp133_ = NULL;
	PhotoRow* _tmp134_ = NULL;
	DetectedPhotoInformation* _tmp135_ = NULL;
	const gchar* _tmp136_ = NULL;
	gchar* _tmp137_ = NULL;
	PhotoImportParams* _tmp138_ = NULL;
	PhotoRow* _tmp139_ = NULL;
	DetectedPhotoInformation* _tmp140_ = NULL;
	const gchar* _tmp141_ = NULL;
	gchar* _tmp142_ = NULL;
	PhotoImportParams* _tmp143_ = NULL;
	PhotoRow* _tmp144_ = NULL;
	DetectedPhotoInformation* _tmp145_ = NULL;
	const gchar* _tmp146_ = NULL;
	gchar* _tmp147_ = NULL;
	PhotoImportParams* _tmp148_ = NULL;
	PhotoRow* _tmp149_ = NULL;
	PhotoImportParams* _tmp150_ = NULL;
	PhotoRow* _tmp151_ = NULL;
	PhotoImportParams* _tmp152_ = NULL;
	PhotoRow* _tmp153_ = NULL;
	BackingPhotoRow* _tmp154_ = NULL;
	DetectedPhotoInformation* _tmp155_ = NULL;
	PhotoFileFormat _tmp156_ = 0;
	PhotoImportParams* _tmp157_ = NULL;
	PhotoRow* _tmp158_ = NULL;
	const gchar* _tmp159_ = NULL;
	gchar* _tmp160_ = NULL;
	PhotoImportParams* _tmp161_ = NULL;
	PhotoRow* _tmp162_ = NULL;
	const gchar* _tmp163_ = NULL;
	gchar* _tmp164_ = NULL;
	PhotoImportParams* _tmp165_ = NULL;
	Thumbnails* _tmp166_ = NULL;
	GError * _inner_error_ = NULL;
#line 1050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = params;
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp2_;
#line 1056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	info = NULL;
#line 8701 "Photo.c"
	{
		GFileInfo* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		GFileInfo* _tmp5_ = NULL;
		GFileInfo* _tmp6_ = NULL;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = file;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = g_file_query_info (_tmp4_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp5_;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 8715 "Photo.c"
			goto __catch154_g_error;
		}
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp3_;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = NULL;
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		info = _tmp6_;
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 8728 "Photo.c"
	}
	goto __finally154;
	__catch154_g_error:
	{
		GError* err = NULL;
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1061 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 8748 "Photo.c"
	}
	__finally154:
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 8763 "Photo.c"
	}
#line 1064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = info;
#line 1064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = g_file_info_get_file_type (_tmp7_);
#line 1064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ != G_FILE_TYPE_REGULAR) {
#line 1065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 1065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 8779 "Photo.c"
	}
#line 1067 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = file;
#line 1067 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = photo_is_file_image (_tmp9_);
#line 1067 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp10_) {
#line 8787 "Photo.c"
		GFile* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = file;
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = g_file_get_path (_tmp11_);
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_message ("Photo.vala:1068: Not importing %s: Not an image file", _tmp13_);
#line 1068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp13_);
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 8809 "Photo.c"
	}
#line 1073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = file;
#line 1073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = photo_file_format_is_file_supported (_tmp14_);
#line 1073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp15_) {
#line 8817 "Photo.c"
		GFile* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = file;
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = g_file_get_path (_tmp16_);
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_message ("Photo.vala:1074: Not importing %s: Unsupported extension", _tmp18_);
#line 1074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp18_);
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 8839 "Photo.c"
	}
#line 1079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = info;
#line 1079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp19_, &_tmp20_);
#line 1079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	timestamp = _tmp20_;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = params;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = _tmp23_->exif_md5;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp24_ != NULL) {
#line 8853 "Photo.c"
		PhotoImportParams* _tmp25_ = NULL;
		const gchar* _tmp26_ = NULL;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = params;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = _tmp25_->thumbnail_md5;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = _tmp26_ != NULL;
#line 8862 "Photo.c"
	} else {
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = FALSE;
#line 8866 "Photo.c"
	}
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp22_) {
#line 8870 "Photo.c"
		PhotoImportParams* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = params;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = _tmp27_->full_md5;
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = _tmp28_ != NULL;
#line 8879 "Photo.c"
	} else {
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = FALSE;
#line 8883 "Photo.c"
	}
#line 1082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp21_) {
#line 8887 "Photo.c"
		PhotoImportParams* _tmp29_ = NULL;
		PhotoImportParams* _tmp30_ = NULL;
		PhotoFileSnifferOptions _tmp31_ = 0;
#line 1083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = params;
#line 1083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = params;
#line 1083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = _tmp30_->sniffer_options;
#line 1083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_->sniffer_options = _tmp31_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 8899 "Photo.c"
	}
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = file;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = params;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = _tmp33_->sniffer_options;
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = photo_file_interrogator_new (_tmp32_, _tmp34_);
#line 1086 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp35_;
#line 8911 "Photo.c"
	{
		PhotoFileInterrogator* _tmp36_ = NULL;
#line 1088 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = interrogator;
#line 1088 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp36_, &_inner_error_);
#line 1088 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 8920 "Photo.c"
			goto __catch155_g_error;
		}
	}
	goto __finally155;
	__catch155_g_error:
	{
		GError* err = NULL;
		GFile* _tmp37_ = NULL;
		gchar* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		GError* _tmp40_ = NULL;
		const gchar* _tmp41_ = NULL;
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = file;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = g_file_get_path (_tmp37_);
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = _tmp38_;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = err;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = _tmp40_->message;
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1090: Unable to interrogate photo file %s: %s", _tmp39_, _tmp41_);
#line 1090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp39_);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 8963 "Photo.c"
	}
	__finally155:
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 8980 "Photo.c"
	}
#line 1096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = interrogator;
#line 1096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = photo_file_interrogator_get_detected_photo_information (_tmp42_);
#line 1096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp43_;
#line 1097 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = detected;
#line 1097 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp44_ == NULL) {
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9004 "Photo.c"
	}
#line 1101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = params;
#line 1101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = _tmp45_->sniffer_options;
#line 1101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((_tmp46_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 9012 "Photo.c"
		DetectedPhotoInformation* _tmp47_ = NULL;
		PhotoImportParams* _tmp48_ = NULL;
		const gchar* _tmp49_ = NULL;
		gchar* _tmp50_ = NULL;
		DetectedPhotoInformation* _tmp51_ = NULL;
		PhotoImportParams* _tmp52_ = NULL;
		const gchar* _tmp53_ = NULL;
		gchar* _tmp54_ = NULL;
		DetectedPhotoInformation* _tmp55_ = NULL;
		PhotoImportParams* _tmp56_ = NULL;
		const gchar* _tmp57_ = NULL;
		gchar* _tmp58_ = NULL;
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = detected;
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = params;
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = _tmp48_->exif_md5;
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = g_strdup (_tmp49_);
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp47_->exif_md5);
#line 1102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_->exif_md5 = _tmp50_;
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = detected;
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp52_ = params;
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp53_ = _tmp52_->thumbnail_md5;
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp54_ = g_strdup (_tmp53_);
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp51_->thumbnail_md5);
#line 1103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_->thumbnail_md5 = _tmp54_;
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp55_ = detected;
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp56_ = params;
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = _tmp56_->full_md5;
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp58_ = g_strdup (_tmp57_);
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp55_->md5);
#line 1104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp55_->md5 = _tmp58_;
#line 9061 "Photo.c"
	}
#line 1107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 1108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	exposure_time = (time_t) 0;
#line 1109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp59_ = g_strdup ("");
#line 1109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	title = _tmp59_;
#line 1110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp60_ = g_strdup ("");
#line 1110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	comment = _tmp60_;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp61_ = detected;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp62_ = _tmp61_->metadata;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp62_ != NULL) {
#line 9081 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp63_ = NULL;
		PhotoMetadata* _tmp64_ = NULL;
		MetadataDateTime* _tmp65_ = NULL;
		MetadataDateTime* _tmp66_ = NULL;
		DetectedPhotoInformation* _tmp69_ = NULL;
		PhotoMetadata* _tmp70_ = NULL;
		Orientation _tmp71_ = 0;
		DetectedPhotoInformation* _tmp72_ = NULL;
		PhotoMetadata* _tmp73_ = NULL;
		gchar* _tmp74_ = NULL;
		DetectedPhotoInformation* _tmp75_ = NULL;
		PhotoMetadata* _tmp76_ = NULL;
		gchar* _tmp77_ = NULL;
		PhotoImportParams* _tmp78_ = NULL;
		DetectedPhotoInformation* _tmp79_ = NULL;
		PhotoMetadata* _tmp80_ = NULL;
		GeeSet* _tmp81_ = NULL;
#line 1118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp63_ = detected;
#line 1118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 1118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_ = photo_metadata_get_exposure_date_time (_tmp64_);
#line 1118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp65_;
#line 1119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = date_time;
#line 1119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp66_ != NULL) {
#line 9112 "Photo.c"
			MetadataDateTime* _tmp67_ = NULL;
			time_t _tmp68_ = 0;
#line 1120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp67_ = date_time;
#line 1120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp68_ = metadata_date_time_get_timestamp (_tmp67_);
#line 1120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			exposure_time = _tmp68_;
#line 9121 "Photo.c"
		}
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp69_ = detected;
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = _tmp69_->metadata;
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = photo_metadata_get_orientation (_tmp70_);
#line 1122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		orientation = _tmp71_;
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = detected;
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = media_metadata_get_title ((MediaMetadata*) _tmp73_);
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (title);
#line 1123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		title = _tmp74_;
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = detected;
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp76_ = _tmp75_->metadata;
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp77_ = media_metadata_get_comment ((MediaMetadata*) _tmp76_);
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (comment);
#line 1124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		comment = _tmp77_;
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp78_ = params;
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp79_ = detected;
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp80_ = _tmp79_->metadata;
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp81_ = photo_metadata_get_keywords (_tmp80_, NULL, NULL, NULL);
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp78_->keywords);
#line 1125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp78_->keywords = (GeeCollection*) _tmp81_;
#line 1117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 9165 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp84_ = detected;
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp85_ = _tmp84_->colorspace;
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp85_ != GDK_COLORSPACE_RGB) {
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp83_ = TRUE;
#line 9175 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp86_ = NULL;
		gint _tmp87_ = 0;
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp86_ = detected;
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp87_ = _tmp86_->channels;
#line 1130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp83_ = _tmp87_ < 3;
#line 9185 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp83_) {
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp82_ = TRUE;
#line 9191 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp88_ = NULL;
		gint _tmp89_ = 0;
#line 1131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp88_ = detected;
#line 1131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp89_ = _tmp88_->bits_per_channel;
#line 1131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp82_ = _tmp89_ != 8;
#line 9201 "Photo.c"
	}
#line 1129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp82_) {
#line 9205 "Photo.c"
		GFile* _tmp90_ = NULL;
		gchar* _tmp91_ = NULL;
		gchar* _tmp92_ = NULL;
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp90_ = file;
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp91_ = g_file_get_path (_tmp90_);
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp92_ = _tmp91_;
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_message ("Photo.vala:1132: Not importing %s: Unsupported color format", _tmp92_);
#line 1132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp92_);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (comment);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (title);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 9235 "Photo.c"
	}
#line 1140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp93_ = params;
#line 1140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp94_ = _tmp93_->row;
#line 1140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp94_->photo_id, PHOTO_ID_INVALID);
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp95_ = params;
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp96_ = _tmp95_->row;
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp97_ = _tmp96_->master;
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp98_ = file;
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp99_ = g_file_get_path (_tmp98_);
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp97_->filepath);
#line 1141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp97_->filepath = _tmp99_;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp100_ = params;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp101_ = _tmp100_->row;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp102_ = _tmp101_->master;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp103_ = detected;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp104_ = _tmp103_->image_dim;
#line 1142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp102_->dim = _tmp104_;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp105_ = params;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp106_ = _tmp105_->row;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp107_ = _tmp106_->master;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp108_ = info;
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp109_ = g_file_info_get_size (_tmp108_);
#line 1143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp107_->filesize = _tmp109_;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp110_ = params;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp111_ = _tmp110_->row;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp112_ = _tmp111_->master;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp113_ = timestamp;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp114_ = _tmp113_.tv_sec;
#line 1144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp112_->timestamp = (time_t) _tmp114_;
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp115_ = params;
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp116_ = _tmp115_->row;
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp117_ = exposure_time;
#line 1145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp116_->exposure_time = _tmp117_;
#line 1146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp118_ = params;
#line 1146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp119_ = _tmp118_->row;
#line 1146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp120_ = orientation;
#line 1146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp119_->orientation = _tmp120_;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp121_ = params;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp122_ = _tmp121_->row;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp123_ = _tmp122_->master;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp124_ = orientation;
#line 1147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp123_->original_orientation = _tmp124_;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp125_ = params;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp126_ = _tmp125_->row;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp127_ = params;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp128_ = _tmp127_->import_id;
#line 1148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp126_->import_id = _tmp128_;
#line 1149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp129_ = params;
#line 1149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp130_ = _tmp129_->row;
#line 1149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	event_id_init (&_tmp130_->event_id, EVENT_ID_INVALID);
#line 1150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp131_ = params;
#line 1150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp132_ = _tmp131_->row;
#line 1150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp132_->transformations);
#line 1150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp132_->transformations = NULL;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp133_ = params;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp134_ = _tmp133_->row;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp135_ = detected;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp136_ = _tmp135_->md5;
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp137_ = g_strdup (_tmp136_);
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp134_->md5);
#line 1151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp134_->md5 = _tmp137_;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp138_ = params;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp139_ = _tmp138_->row;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp140_ = detected;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp141_ = _tmp140_->thumbnail_md5;
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp142_ = g_strdup (_tmp141_);
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp139_->thumbnail_md5);
#line 1152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp139_->thumbnail_md5 = _tmp142_;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp143_ = params;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp144_ = _tmp143_->row;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp145_ = detected;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp146_ = _tmp145_->exif_md5;
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp147_ = g_strdup (_tmp146_);
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp144_->exif_md5);
#line 1153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp144_->exif_md5 = _tmp147_;
#line 1154 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp148_ = params;
#line 1154 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp149_ = _tmp148_->row;
#line 1154 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp149_->time_created = (time_t) 0;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp150_ = params;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp151_ = _tmp150_->row;
#line 1155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp151_->flags = (guint64) 0;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp152_ = params;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp153_ = _tmp152_->row;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp154_ = _tmp153_->master;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp155_ = detected;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp156_ = _tmp155_->file_format;
#line 1156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp154_->file_format = _tmp156_;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp157_ = params;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp158_ = _tmp157_->row;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp159_ = title;
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp160_ = g_strdup (_tmp159_);
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp158_->title);
#line 1157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp158_->title = _tmp160_;
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp161_ = params;
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp162_ = _tmp161_->row;
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp163_ = comment;
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp164_ = g_strdup (_tmp163_);
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp162_->comment);
#line 1158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp162_->comment = _tmp164_;
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp165_ = params;
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp166_ = _tmp165_->thumbnails;
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp166_ != NULL) {
#line 9439 "Photo.c"
		PhotoFileReader* reader = NULL;
		PhotoImportParams* _tmp167_ = NULL;
		PhotoRow* _tmp168_ = NULL;
		BackingPhotoRow* _tmp169_ = NULL;
		PhotoFileFormat _tmp170_ = 0;
		PhotoImportParams* _tmp171_ = NULL;
		PhotoRow* _tmp172_ = NULL;
		BackingPhotoRow* _tmp173_ = NULL;
		const gchar* _tmp174_ = NULL;
		PhotoFileReader* _tmp175_ = NULL;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp167_ = params;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp168_ = _tmp167_->row;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp169_ = _tmp168_->master;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp170_ = _tmp169_->file_format;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp171_ = params;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp172_ = _tmp171_->row;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp173_ = _tmp172_->master;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp174_ = _tmp173_->filepath;
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp175_ = photo_file_format_create_reader (_tmp170_, _tmp174_);
#line 1161 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		reader = _tmp175_;
#line 9470 "Photo.c"
		{
			PhotoImportParams* _tmp176_ = NULL;
			Thumbnails* _tmp177_ = NULL;
			PhotoFileReader* _tmp178_ = NULL;
			PhotoImportParams* _tmp179_ = NULL;
			PhotoRow* _tmp180_ = NULL;
			Orientation _tmp181_ = 0;
			PhotoImportParams* _tmp182_ = NULL;
			PhotoRow* _tmp183_ = NULL;
			BackingPhotoRow* _tmp184_ = NULL;
			Dimensions _tmp185_ = {0};
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp176_ = params;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp177_ = _tmp176_->thumbnails;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp178_ = reader;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp179_ = params;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp180_ = _tmp179_->row;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp181_ = _tmp180_->orientation;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp182_ = params;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp183_ = _tmp182_->row;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp184_ = _tmp183_->master;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp185_ = _tmp184_->dim;
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp177_, _tmp178_, _tmp181_, &_tmp185_, &_inner_error_);
#line 1164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 9506 "Photo.c"
				goto __catch156_g_error;
			}
		}
		goto __finally156;
		__catch156_g_error:
		{
			GError* err = NULL;
			GError* _tmp186_ = NULL;
			ImportResult _tmp187_ = 0;
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp186_ = err;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp187_ = import_result_convert_error (_tmp186_, IMPORT_RESULT_FILE_ERROR);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp187_;
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (comment);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (title);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 1167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 9544 "Photo.c"
		}
		__finally156:
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (comment);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (title);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return 0;
#line 9569 "Photo.c"
		}
#line 1160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 9573 "Photo.c"
	}
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (comment);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (title);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (info);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 1174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 9591 "Photo.c"
}


void photo_create_pre_import (PhotoImportParams* params) {
	GFile* file = NULL;
	PhotoImportParams* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	PhotoImportParams* _tmp3_ = NULL;
	PhotoRow* _tmp4_ = NULL;
	PhotoImportParams* _tmp5_ = NULL;
	PhotoRow* _tmp6_ = NULL;
	BackingPhotoRow* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	PhotoImportParams* _tmp9_ = NULL;
	PhotoRow* _tmp10_ = NULL;
	BackingPhotoRow* _tmp11_ = NULL;
	PhotoImportParams* _tmp12_ = NULL;
	PhotoRow* _tmp13_ = NULL;
	BackingPhotoRow* _tmp14_ = NULL;
	PhotoImportParams* _tmp15_ = NULL;
	PhotoRow* _tmp16_ = NULL;
	BackingPhotoRow* _tmp17_ = NULL;
	PhotoImportParams* _tmp18_ = NULL;
	PhotoRow* _tmp19_ = NULL;
	PhotoImportParams* _tmp20_ = NULL;
	PhotoRow* _tmp21_ = NULL;
	PhotoImportParams* _tmp22_ = NULL;
	PhotoRow* _tmp23_ = NULL;
	BackingPhotoRow* _tmp24_ = NULL;
	PhotoImportParams* _tmp25_ = NULL;
	PhotoRow* _tmp26_ = NULL;
	PhotoImportParams* _tmp27_ = NULL;
	ImportID _tmp28_ = {0};
	PhotoImportParams* _tmp29_ = NULL;
	PhotoRow* _tmp30_ = NULL;
	PhotoImportParams* _tmp31_ = NULL;
	PhotoRow* _tmp32_ = NULL;
	PhotoImportParams* _tmp33_ = NULL;
	PhotoRow* _tmp34_ = NULL;
	PhotoImportParams* _tmp35_ = NULL;
	PhotoRow* _tmp36_ = NULL;
	PhotoImportParams* _tmp37_ = NULL;
	PhotoRow* _tmp38_ = NULL;
	PhotoImportParams* _tmp39_ = NULL;
	PhotoRow* _tmp40_ = NULL;
	PhotoImportParams* _tmp41_ = NULL;
	PhotoRow* _tmp42_ = NULL;
	PhotoImportParams* _tmp43_ = NULL;
	PhotoRow* _tmp44_ = NULL;
	BackingPhotoRow* _tmp45_ = NULL;
	PhotoImportParams* _tmp46_ = NULL;
	PhotoRow* _tmp47_ = NULL;
	PhotoImportParams* _tmp48_ = NULL;
	PhotoRow* _tmp49_ = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	PhotoImportParams* _tmp50_ = NULL;
	GFile* _tmp51_ = NULL;
	PhotoImportParams* _tmp52_ = NULL;
	PhotoFileSnifferOptions _tmp53_ = 0;
	PhotoFileInterrogator* _tmp54_ = NULL;
	GError * _inner_error_ = NULL;
#line 1177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (params != NULL);
#line 1178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = params;
#line 1178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 1178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp2_;
#line 1179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = params;
#line 1179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_->row;
#line 1179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp4_->photo_id, PHOTO_ID_INVALID);
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = params;
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = _tmp5_->row;
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_->master;
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = g_file_get_path (file);
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp7_->filepath);
#line 1180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_->filepath = _tmp8_;
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = params;
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _tmp9_->row;
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_->master;
#line 1181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&_tmp11_->dim, 0, 0);
#line 1182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = params;
#line 1182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_->row;
#line 1182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = _tmp13_->master;
#line 1182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_->filesize = (gint64) 0;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = params;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _tmp15_->row;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = _tmp16_->master;
#line 1183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_->timestamp = (time_t) 0;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = params;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_->row;
#line 1184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_->exposure_time = (time_t) 0;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = params;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp20_->row;
#line 1185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_->orientation = ORIENTATION_TOP_LEFT;
#line 1186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = params;
#line 1186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = _tmp22_->row;
#line 1186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = _tmp23_->master;
#line 1186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_->original_orientation = ORIENTATION_TOP_LEFT;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = params;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp25_->row;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = params;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = _tmp27_->import_id;
#line 1187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_->import_id = _tmp28_;
#line 1188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = params;
#line 1188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = _tmp29_->row;
#line 1188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	event_id_init (&_tmp30_->event_id, EVENT_ID_INVALID);
#line 1189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = params;
#line 1189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp31_->row;
#line 1189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp32_->transformations);
#line 1189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_->transformations = NULL;
#line 1190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = params;
#line 1190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = _tmp33_->row;
#line 1190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp34_->md5);
#line 1190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_->md5 = NULL;
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = params;
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = _tmp35_->row;
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp36_->thumbnail_md5);
#line 1191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_->thumbnail_md5 = NULL;
#line 1192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = params;
#line 1192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = _tmp37_->row;
#line 1192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp38_->exif_md5);
#line 1192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_->exif_md5 = NULL;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = params;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = _tmp39_->row;
#line 1193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_->time_created = (time_t) 0;
#line 1194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = params;
#line 1194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = _tmp41_->row;
#line 1194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_->flags = (guint64) 0;
#line 1195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = params;
#line 1195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = _tmp43_->row;
#line 1195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = _tmp44_->master;
#line 1195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = params;
#line 1196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = _tmp46_->row;
#line 1196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp47_->title);
#line 1196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_->title = NULL;
#line 1197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp48_ = params;
#line 1197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp49_ = _tmp48_->row;
#line 1197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp49_->comment);
#line 1197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp49_->comment = NULL;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp50_ = params;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp51_ = _tmp50_->file;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp52_ = params;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp53_ = _tmp52_->sniffer_options;
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp54_ = photo_file_interrogator_new (_tmp51_, _tmp53_);
#line 1199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp54_;
#line 9822 "Photo.c"
	{
		DetectedPhotoInformation* detected = NULL;
		DetectedPhotoInformation* _tmp55_ = NULL;
		DetectedPhotoInformation* _tmp56_ = NULL;
#line 1201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 1201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 9831 "Photo.c"
			goto __catch157_g_error;
		}
#line 1202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp55_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		detected = _tmp55_;
#line 1203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp56_ = detected;
#line 1203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp56_ != NULL) {
#line 9842 "Photo.c"
			PhotoImportParams* _tmp57_ = NULL;
			PhotoRow* _tmp58_ = NULL;
			BackingPhotoRow* _tmp59_ = NULL;
			DetectedPhotoInformation* _tmp60_ = NULL;
			PhotoFileFormat _tmp61_ = 0;
			MetadataDateTime* date_time = NULL;
			DetectedPhotoInformation* _tmp62_ = NULL;
			PhotoMetadata* _tmp63_ = NULL;
			MetadataDateTime* _tmp64_ = NULL;
			MetadataDateTime* _tmp65_ = NULL;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp57_ = params;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp58_ = _tmp57_->row;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp59_ = _tmp58_->master;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp60_ = detected;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp61_ = _tmp60_->file_format;
#line 1204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp59_->file_format = _tmp61_;
#line 1205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp62_ = detected;
#line 1205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp63_ = _tmp62_->metadata;
#line 1205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp64_ = photo_metadata_get_exposure_date_time (_tmp63_);
#line 1205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			date_time = _tmp64_;
#line 1206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp65_ = date_time;
#line 1206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp65_ != NULL) {
#line 9877 "Photo.c"
				PhotoImportParams* _tmp66_ = NULL;
				PhotoRow* _tmp67_ = NULL;
				MetadataDateTime* _tmp68_ = NULL;
				time_t _tmp69_ = 0;
#line 1207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp66_ = params;
#line 1207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_ = _tmp66_->row;
#line 1207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp68_ = date_time;
#line 1207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp69_ = metadata_date_time_get_timestamp (_tmp68_);
#line 1207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_->exposure_time = _tmp69_;
#line 9892 "Photo.c"
			}
#line 1203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 9896 "Photo.c"
		}
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 9900 "Photo.c"
	}
	goto __finally157;
	__catch157_g_error:
	{
		GError* err = NULL;
		gchar* _tmp70_ = NULL;
		gchar* _tmp71_ = NULL;
		GError* _tmp72_ = NULL;
		const gchar* _tmp73_ = NULL;
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = g_file_get_path (file);
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = _tmp70_;
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = err;
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = _tmp72_->message;
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_debug ("Photo.vala:1210: Unable to interrogate photo file %s: %s", _tmp71_, _tmp73_);
#line 1210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp71_);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 9928 "Photo.c"
	}
	__finally157:
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 9943 "Photo.c"
	}
#line 1177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 9949 "Photo.c"
}


BackingPhotoRow* photo_query_backing_photo_row (Photo* self, GFile* file, PhotoFileSnifferOptions options, DetectedPhotoInformation** detected, GError** error) {
	DetectedPhotoInformation* _vala_detected = NULL;
	BackingPhotoRow* result = NULL;
	BackingPhotoRow* backing = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	GFileInfo* info = NULL;
	PhotoFileInterrogator* interrogator = NULL;
	GFile* _tmp10_ = NULL;
	PhotoFileSnifferOptions _tmp11_ = 0;
	PhotoFileInterrogator* _tmp12_ = NULL;
	PhotoFileInterrogator* _tmp13_ = NULL;
	PhotoFileInterrogator* _tmp14_ = NULL;
	DetectedPhotoInformation* _tmp15_ = NULL;
	DetectedPhotoInformation* _tmp16_ = NULL;
	GTimeVal modification_time = {0};
	GFileInfo* _tmp19_ = NULL;
	GTimeVal _tmp20_ = {0};
	BackingPhotoRow* _tmp21_ = NULL;
	GFile* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	BackingPhotoRow* _tmp24_ = NULL;
	GTimeVal _tmp25_ = {0};
	glong _tmp26_ = 0L;
	BackingPhotoRow* _tmp27_ = NULL;
	GFileInfo* _tmp28_ = NULL;
	gint64 _tmp29_ = 0LL;
	BackingPhotoRow* _tmp30_ = NULL;
	DetectedPhotoInformation* _tmp31_ = NULL;
	PhotoFileFormat _tmp32_ = 0;
	BackingPhotoRow* _tmp33_ = NULL;
	DetectedPhotoInformation* _tmp34_ = NULL;
	Dimensions _tmp35_ = {0};
	Orientation _tmp36_ = 0;
	DetectedPhotoInformation* _tmp37_ = NULL;
	PhotoMetadata* _tmp38_ = NULL;
	BackingPhotoRow* _tmp42_ = NULL;
	GError * _inner_error_ = NULL;
#line 1214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 1216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_detected = NULL;
#line 1218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp0_;
#line 1220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	info = NULL;
#line 10004 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		GFileInfo* _tmp3_ = NULL;
		GFileInfo* _tmp4_ = NULL;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = file;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = g_file_query_info (_tmp2_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp3_;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 10018 "Photo.c"
			goto __catch158_g_error;
		}
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp1_;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		info = _tmp4_;
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 10031 "Photo.c"
	}
	goto __finally158;
	__catch158_g_error:
	{
		GError* err = NULL;
		GFile* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = file;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = err;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = _tmp8_->message;
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("Photo.vala:1225: Unable to read file information for %s: %s", _tmp7_, _tmp9_);
#line 1225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (detected) {
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*detected = _vala_detected;
#line 10072 "Photo.c"
		} else {
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10076 "Photo.c"
		}
#line 1227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 10080 "Photo.c"
	}
	__finally158:
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 10093 "Photo.c"
	}
#line 1231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = file;
#line 1231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = options;
#line 1231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = photo_file_interrogator_new (_tmp10_, _tmp11_);
#line 1231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp12_;
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = interrogator;
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp13_, &_inner_error_);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 10119 "Photo.c"
	}
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = interrogator;
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = photo_file_interrogator_get_detected_photo_information (_tmp14_);
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_detected = _tmp15_;
#line 1234 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _vala_detected;
#line 1234 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 10133 "Photo.c"
		gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
#line 1235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = data_object_to_string ((DataObject*) self);
#line 1235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 1235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("Photo.vala:1235: Photo update: %s no longer a recognized image", _tmp18_);
#line 1235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp18_);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (detected) {
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*detected = _vala_detected;
#line 10156 "Photo.c"
		} else {
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 10160 "Photo.c"
		}
#line 1237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 10164 "Photo.c"
	}
#line 1240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = info;
#line 1240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp19_, &_tmp20_);
#line 1240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	modification_time = _tmp20_;
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = backing;
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = file;
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = g_file_get_path (_tmp22_);
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp21_->filepath);
#line 1242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_->filepath = _tmp23_;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = backing;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = modification_time;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp25_.tv_sec;
#line 1243 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_->timestamp = (time_t) _tmp26_;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = backing;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = info;
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = g_file_info_get_size (_tmp28_);
#line 1244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_->filesize = _tmp29_;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = backing;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _vala_detected;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp31_->file_format;
#line 1245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_->file_format = _tmp32_;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = backing;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = _vala_detected;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = _tmp34_->image_dim;
#line 1246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_->dim = _tmp35_;
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = _vala_detected;
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = _tmp37_->metadata;
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp38_ != NULL) {
#line 10220 "Photo.c"
		DetectedPhotoInformation* _tmp39_ = NULL;
		PhotoMetadata* _tmp40_ = NULL;
		Orientation _tmp41_ = 0;
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = _vala_detected;
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = _tmp39_->metadata;
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = photo_metadata_get_orientation (_tmp40_);
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = _tmp41_;
#line 10232 "Photo.c"
	} else {
#line 1248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = ORIENTATION_TOP_LEFT;
#line 10236 "Photo.c"
	}
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = backing;
#line 1247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_->original_orientation = _tmp36_;
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = backing;
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (info);
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (detected) {
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*detected = _vala_detected;
#line 10252 "Photo.c"
	} else {
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 10256 "Photo.c"
	}
#line 1250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 10260 "Photo.c"
}


static void _vala_array_add94 (gchar*** array, int* length, int* size, gchar* value) {
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10271 "Photo.c"
	}
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10277 "Photo.c"
}


static void _vala_array_add95 (gchar*** array, int* length, int* size, gchar* value) {
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10288 "Photo.c"
	}
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10294 "Photo.c"
}


static void _vala_array_add96 (gchar*** array, int* length, int* size, gchar* value) {
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10305 "Photo.c"
	}
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10311 "Photo.c"
}


static void _vala_array_add97 (gchar*** array, int* length, int* size, gchar* value) {
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10322 "Photo.c"
	}
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10328 "Photo.c"
}


static void _vala_array_add98 (gchar*** array, int* length, int* size, gchar* value) {
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 10339 "Photo.c"
	}
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 10345 "Photo.c"
}


static gpointer _media_metadata_ref0 (gpointer self) {
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 10352 "Photo.c"
}


gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error) {
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_ = NULL;
	BackingPhotoRow* _tmp8_ = NULL;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_ = NULL;
	GdkColorspace _tmp15_ = 0;
	PhotoRow* updated_row = NULL;
	PhotoRow* _tmp23_ = NULL;
	gchar** list = NULL;
	gchar** _tmp29_ = NULL;
	gint list_length1 = 0;
	gint _list_size_ = 0;
	PhotoRow* _tmp30_ = NULL;
	const gchar* _tmp31_ = NULL;
	DetectedPhotoInformation* _tmp32_ = NULL;
	const gchar* _tmp33_ = NULL;
	PhotoRow* _tmp36_ = NULL;
	BackingPhotoRow* _tmp37_ = NULL;
	Orientation _tmp38_ = 0;
	BackingPhotoRow* _tmp39_ = NULL;
	Orientation _tmp40_ = 0;
	DetectedPhotoInformation* _tmp47_ = NULL;
	PhotoMetadata* _tmp48_ = NULL;
	PhotoRow* _tmp78_ = NULL;
	BackingPhotoRow* _tmp79_ = NULL;
	BackingPhotoRow* _tmp80_ = NULL;
	PhotoRow* _tmp81_ = NULL;
	DetectedPhotoInformation* _tmp82_ = NULL;
	const gchar* _tmp83_ = NULL;
	gchar* _tmp84_ = NULL;
	PhotoRow* _tmp85_ = NULL;
	DetectedPhotoInformation* _tmp86_ = NULL;
	const gchar* _tmp87_ = NULL;
	gchar* _tmp88_ = NULL;
	PhotoRow* _tmp89_ = NULL;
	DetectedPhotoInformation* _tmp90_ = NULL;
	const gchar* _tmp91_ = NULL;
	gchar* _tmp92_ = NULL;
	PhotoMetadata* metadata = NULL;
	DetectedPhotoInformation* _tmp93_ = NULL;
	PhotoMetadata* _tmp94_ = NULL;
	PhotoRow* _tmp117_ = NULL;
	PhotoMetadata* _tmp118_ = NULL;
	gchar** _tmp119_ = NULL;
	gint _tmp119__length1 = 0;
	PhotoReimportMasterStateImpl* _tmp120_ = NULL;
	GError * _inner_error_ = NULL;
#line 1314 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_reimport_state = NULL;
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp3_;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = file;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_query_backing_photo_row (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_inner_error_);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp5_;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp6_;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 10445 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp7_;
#line 10455 "Photo.c"
	}
#line 1322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = backing;
#line 1322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 10461 "Photo.c"
		GFile* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = file;
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1323: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 1323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp11_);
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (reimport_state) {
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 10487 "Photo.c"
		} else {
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10491 "Photo.c"
		}
#line 1324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 10495 "Photo.c"
	}
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = detected;
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_->colorspace;
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_ != GDK_COLORSPACE_RGB) {
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = TRUE;
#line 10505 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_ = NULL;
		gint _tmp17_ = 0;
#line 1329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = detected;
#line 1329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_->channels;
#line 1329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp17_ < 3;
#line 10515 "Photo.c"
	}
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_) {
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = TRUE;
#line 10521 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp18_ = NULL;
		gint _tmp19_ = 0;
#line 1330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = detected;
#line 1330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp18_->bits_per_channel;
#line 1330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp19_ != 8;
#line 10531 "Photo.c"
	}
#line 1328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_) {
#line 10535 "Photo.c"
		GFile* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = file;
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = g_file_get_path (_tmp20_);
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1331: Not re-importing %s: Unsupported color format", _tmp22_);
#line 1331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp22_);
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (reimport_state) {
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 10561 "Photo.c"
		} else {
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 10565 "Photo.c"
		}
#line 1333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 10569 "Photo.c"
	}
#line 1337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = photo_row_new ();
#line 1337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	updated_row = _tmp23_;
#line 10575 "Photo.c"
	{
		PhotoRow* _tmp24_ = NULL;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = self->row;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 10582 "Photo.c"
		{
			PhotoRow* _tmp25_ = NULL;
			PhotoRow* _tmp26_ = NULL;
#line 1339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = self->row;
#line 1339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = _photo_row_ref0 (_tmp25_);
#line 1339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1339 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			updated_row = _tmp26_;
#line 10594 "Photo.c"
		}
		__finally159:
		{
			PhotoRow* _tmp27_ = NULL;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = self->row;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 10603 "Photo.c"
		}
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 10607 "Photo.c"
			gboolean _tmp28_ = FALSE;
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_row_unref0 (updated_row);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 1338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp28_;
#line 10621 "Photo.c"
		}
	}
#line 1343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 1343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list = _tmp29_;
#line 1343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list_length1 = 0;
#line 1343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_list_size_ = list_length1;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = updated_row;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _tmp30_->md5;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = detected;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = _tmp32_->md5;
#line 1345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_strcmp0 (_tmp31_, _tmp33_) != 0) {
#line 10642 "Photo.c"
		gchar** _tmp34_ = NULL;
		gint _tmp34__length1 = 0;
		gchar* _tmp35_ = NULL;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = list;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34__length1 = list_length1;
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = g_strdup ("metadata:md5");
#line 1346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add94 (&list, &list_length1, &_list_size_, _tmp35_);
#line 10654 "Photo.c"
	}
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = updated_row;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = _tmp36_->master;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = _tmp37_->original_orientation;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = backing;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = _tmp39_->original_orientation;
#line 1348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp38_ != _tmp40_) {
#line 10668 "Photo.c"
		gchar** _tmp41_ = NULL;
		gint _tmp41__length1 = 0;
		gchar* _tmp42_ = NULL;
		PhotoRow* _tmp43_ = NULL;
		BackingPhotoRow* _tmp44_ = NULL;
		BackingPhotoRow* _tmp45_ = NULL;
		Orientation _tmp46_ = 0;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = list;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41__length1 = list_length1;
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = g_strdup ("image:orientation");
#line 1349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add95 (&list, &list_length1, &_list_size_, _tmp42_);
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = updated_row;
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = _tmp43_->master;
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = backing;
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = _tmp45_->original_orientation;
#line 1350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_->original_orientation = _tmp46_;
#line 10694 "Photo.c"
	}
#line 1353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = detected;
#line 1353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp48_ = _tmp47_->metadata;
#line 1353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp48_ != NULL) {
#line 10702 "Photo.c"
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp49_ = NULL;
		PhotoMetadata* _tmp50_ = NULL;
		MetadataDateTime* _tmp51_ = NULL;
		gboolean _tmp52_ = FALSE;
		MetadataDateTime* _tmp53_ = NULL;
		PhotoRow* _tmp60_ = NULL;
		const gchar* _tmp61_ = NULL;
		DetectedPhotoInformation* _tmp62_ = NULL;
		PhotoMetadata* _tmp63_ = NULL;
		gchar* _tmp64_ = NULL;
		gchar* _tmp65_ = NULL;
		gboolean _tmp66_ = FALSE;
		PhotoRow* _tmp69_ = NULL;
		const gchar* _tmp70_ = NULL;
		DetectedPhotoInformation* _tmp71_ = NULL;
		PhotoMetadata* _tmp72_ = NULL;
		gchar* _tmp73_ = NULL;
		gchar* _tmp74_ = NULL;
		gboolean _tmp75_ = FALSE;
#line 1354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = detected;
#line 1354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = _tmp49_->metadata;
#line 1354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = photo_metadata_get_exposure_date_time (_tmp50_);
#line 1354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp51_;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp53_ = date_time;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp53_ != NULL) {
#line 10735 "Photo.c"
			PhotoRow* _tmp54_ = NULL;
			time_t _tmp55_ = 0;
			MetadataDateTime* _tmp56_ = NULL;
			time_t _tmp57_ = 0;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp54_ = updated_row;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp55_ = _tmp54_->exposure_time;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp56_ = date_time;
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp57_ = metadata_date_time_get_timestamp (_tmp56_);
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp52_ = _tmp55_ != _tmp57_;
#line 10750 "Photo.c"
		} else {
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp52_ = FALSE;
#line 10754 "Photo.c"
		}
#line 1355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp52_) {
#line 10758 "Photo.c"
			gchar** _tmp58_ = NULL;
			gint _tmp58__length1 = 0;
			gchar* _tmp59_ = NULL;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp58_ = list;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp58__length1 = list_length1;
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp59_ = g_strdup ("metadata:exposure-time");
#line 1356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add96 (&list, &list_length1, &_list_size_, _tmp59_);
#line 10770 "Photo.c"
		}
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp60_ = updated_row;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp61_ = _tmp60_->title;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp62_ = detected;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp63_ = _tmp62_->metadata;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp64_ = media_metadata_get_title ((MediaMetadata*) _tmp63_);
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_ = _tmp64_;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = g_strcmp0 (_tmp61_, _tmp65_) != 0;
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp65_);
#line 1358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp66_) {
#line 10790 "Photo.c"
			gchar** _tmp67_ = NULL;
			gint _tmp67__length1 = 0;
			gchar* _tmp68_ = NULL;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp67_ = list;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp67__length1 = list_length1;
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp68_ = g_strdup ("metadata:name");
#line 1359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add97 (&list, &list_length1, &_list_size_, _tmp68_);
#line 10802 "Photo.c"
		}
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp69_ = updated_row;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = _tmp69_->comment;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = detected;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = _tmp71_->metadata;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = media_metadata_get_comment ((MediaMetadata*) _tmp72_);
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = _tmp73_;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = g_strcmp0 (_tmp70_, _tmp74_) != 0;
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp74_);
#line 1361 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp75_) {
#line 10822 "Photo.c"
			gchar** _tmp76_ = NULL;
			gint _tmp76__length1 = 0;
			gchar* _tmp77_ = NULL;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp76_ = list;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp76__length1 = list_length1;
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp77_ = g_strdup ("metadata:comment");
#line 1362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add98 (&list, &list_length1, &_list_size_, _tmp77_);
#line 10834 "Photo.c"
		}
#line 1353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10838 "Photo.c"
	}
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp78_ = updated_row;
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp79_ = backing;
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp80_ = _backing_photo_row_ref0 (_tmp79_);
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp78_->master);
#line 1365 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp78_->master = _tmp80_;
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp81_ = updated_row;
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp82_ = detected;
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp83_ = _tmp82_->md5;
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp84_ = g_strdup (_tmp83_);
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp81_->md5);
#line 1366 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp81_->md5 = _tmp84_;
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp85_ = updated_row;
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp86_ = detected;
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp87_ = _tmp86_->exif_md5;
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp88_ = g_strdup (_tmp87_);
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp85_->exif_md5);
#line 1367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp85_->exif_md5 = _tmp88_;
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_ = updated_row;
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp90_ = detected;
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp91_ = _tmp90_->thumbnail_md5;
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp92_ = g_strdup (_tmp91_);
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp89_->thumbnail_md5);
#line 1368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_->thumbnail_md5 = _tmp92_;
#line 1370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = NULL;
#line 1371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp93_ = detected;
#line 1371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp94_ = _tmp93_->metadata;
#line 1371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp94_ != NULL) {
#line 10894 "Photo.c"
		DetectedPhotoInformation* _tmp95_ = NULL;
		PhotoMetadata* _tmp96_ = NULL;
		PhotoMetadata* _tmp97_ = NULL;
		MetadataDateTime* date_time = NULL;
		DetectedPhotoInformation* _tmp98_ = NULL;
		PhotoMetadata* _tmp99_ = NULL;
		MetadataDateTime* _tmp100_ = NULL;
		MetadataDateTime* _tmp101_ = NULL;
		PhotoRow* _tmp105_ = NULL;
		DetectedPhotoInformation* _tmp106_ = NULL;
		PhotoMetadata* _tmp107_ = NULL;
		gchar* _tmp108_ = NULL;
		PhotoRow* _tmp109_ = NULL;
		DetectedPhotoInformation* _tmp110_ = NULL;
		PhotoMetadata* _tmp111_ = NULL;
		gchar* _tmp112_ = NULL;
		PhotoRow* _tmp113_ = NULL;
		DetectedPhotoInformation* _tmp114_ = NULL;
		PhotoMetadata* _tmp115_ = NULL;
		gchar* _tmp116_ = NULL;
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp95_ = detected;
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp96_ = _tmp95_->metadata;
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp97_ = _media_metadata_ref0 (_tmp96_);
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		metadata = _tmp97_;
#line 1374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp98_ = detected;
#line 1374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp99_ = _tmp98_->metadata;
#line 1374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp100_ = photo_metadata_get_exposure_date_time (_tmp99_);
#line 1374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp100_;
#line 1375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp101_ = date_time;
#line 1375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp101_ != NULL) {
#line 10937 "Photo.c"
			PhotoRow* _tmp102_ = NULL;
			MetadataDateTime* _tmp103_ = NULL;
			time_t _tmp104_ = 0;
#line 1376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp102_ = updated_row;
#line 1376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp103_ = date_time;
#line 1376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp104_ = metadata_date_time_get_timestamp (_tmp103_);
#line 1376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp102_->exposure_time = _tmp104_;
#line 10949 "Photo.c"
		}
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp105_ = updated_row;
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp106_ = detected;
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp107_ = _tmp106_->metadata;
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp108_ = media_metadata_get_title ((MediaMetadata*) _tmp107_);
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp105_->title);
#line 1378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp105_->title = _tmp108_;
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp109_ = updated_row;
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp110_ = detected;
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp111_ = _tmp110_->metadata;
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp112_ = media_metadata_get_comment ((MediaMetadata*) _tmp111_);
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp109_->comment);
#line 1379 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp109_->comment = _tmp112_;
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp113_ = updated_row;
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp114_ = detected;
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp115_ = _tmp114_->metadata;
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp116_ = media_metadata_get_comment ((MediaMetadata*) _tmp115_);
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp113_->comment);
#line 1380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp113_->comment = _tmp116_;
#line 1371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 10989 "Photo.c"
	}
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp117_ = updated_row;
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp118_ = metadata;
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp119_ = list;
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp119__length1 = list_length1;
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp120_ = photo_reimport_master_state_impl_new (_tmp117_, _tmp118_, _tmp119_, _tmp119__length1);
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 1383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_reimport_state = (PhotoReimportMasterState*) _tmp120_;
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (updated_row);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (reimport_state) {
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 11023 "Photo.c"
	} else {
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 11027 "Photo.c"
	}
#line 1385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 11031 "Photo.c"
}


static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 1388 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1388 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 11040 "Photo.c"
}


void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 1388 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1388 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 11049 "Photo.c"
}


static gpointer _photo_reimport_master_state_ref0 (gpointer self) {
#line 1392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 11056 "Photo.c"
}


static void _vala_array_add99 (gchar*** array, int* length, int* size, gchar* value) {
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11067 "Photo.c"
	}
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11073 "Photo.c"
}


static void _vala_array_add100 (gchar*** array, int* length, int* size, gchar* value) {
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 11084 "Photo.c"
	}
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 11090 "Photo.c"
}


void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterStateImpl* reimport_state = NULL;
	PhotoReimportMasterState* _tmp0_ = NULL;
	PhotoReimportMasterStateImpl* _tmp1_ = NULL;
	PhotoTable* _tmp2_ = NULL;
	PhotoTable* _tmp3_ = NULL;
	PhotoRow* _tmp4_ = NULL;
	PhotoMetadata* _tmp20_ = NULL;
	gboolean _tmp22_ = FALSE;
	gchar** _tmp28_ = NULL;
	gint _tmp28__length1 = 0;
	PhotoMetadata* _tmp32_ = NULL;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp35_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = state;
#line 1392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _photo_reimport_master_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl));
#line 1392 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reimport_state = _tmp1_;
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_table_get_instance ();
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = reimport_state->row;
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_table_reimport (_tmp3_, _tmp4_, &_inner_error_);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp3_);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 11139 "Photo.c"
		} else {
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1394 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 11149 "Photo.c"
		}
	}
	{
		PhotoRow* _tmp5_ = NULL;
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = self->row;
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 11158 "Photo.c"
		{
			BackingPhotoRow* original_master = NULL;
			PhotoRow* _tmp6_ = NULL;
			BackingPhotoRow* _tmp7_ = NULL;
			BackingPhotoRow* _tmp8_ = NULL;
			PhotoRow* _tmp9_ = NULL;
			PhotoRow* _tmp10_ = NULL;
			PhotoRow* _tmp11_ = NULL;
			BackingPhotoRow* _tmp12_ = NULL;
			BackingPhotoRow* _tmp13_ = NULL;
			PhotoRow* _tmp14_ = NULL;
			BackingPhotoRow* _tmp15_ = NULL;
			PhotoRow* _tmp16_ = NULL;
			BackingPhotoRow* _tmp17_ = NULL;
			gboolean _tmp18_ = FALSE;
#line 1398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 1398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_->master;
#line 1398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _backing_photo_row_ref0 (_tmp7_);
#line 1398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			original_master = _tmp8_;
#line 1399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = reimport_state->row;
#line 1399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _photo_row_ref0 (_tmp9_);
#line 1399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_row_unref0 (self->row);
#line 1399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->row = _tmp10_;
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->row;
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = original_master;
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = _backing_photo_row_ref0 (_tmp12_);
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (_tmp11_->master);
#line 1400 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_->master = _tmp13_;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = self->row;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_->master;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = reimport_state->row;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = _tmp16_->master;
#line 1401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_row_copy_from (_tmp15_, _tmp17_);
#line 1402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = reimport_state->metadata_only;
#line 1402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp18_) {
#line 1403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 11216 "Photo.c"
			}
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (original_master);
#line 11220 "Photo.c"
		}
		__finally160:
		{
			PhotoRow* _tmp19_ = NULL;
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->row;
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11229 "Photo.c"
		}
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 11241 "Photo.c"
			} else {
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 11251 "Photo.c"
			}
		}
	}
#line 1406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = reimport_state->metadata;
#line 1406 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp20_ != NULL) {
#line 11259 "Photo.c"
		PhotoMetadata* _tmp21_ = NULL;
#line 1407 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = reimport_state->metadata;
#line 1407 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp21_);
#line 11265 "Photo.c"
	}
#line 1409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = reimport_state->metadata_only;
#line 1409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp22_) {
#line 11271 "Photo.c"
		gchar** _tmp23_ = NULL;
		gint _tmp23__length1 = 0;
		gchar* _tmp24_ = NULL;
		gboolean _tmp25_ = FALSE;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = reimport_state->alterations;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23__length1 = reimport_state->alterations_length1;
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = g_strdup ("image:master");
#line 1410 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add99 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp24_);
#line 1411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = photo_is_master_baseline (self);
#line 1411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp25_) {
#line 11288 "Photo.c"
			gchar** _tmp26_ = NULL;
			gint _tmp26__length1 = 0;
			gchar* _tmp27_ = NULL;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = reimport_state->alterations;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26__length1 = reimport_state->alterations_length1;
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = g_strdup ("image:baseline");
#line 1412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add100 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp27_);
#line 11300 "Photo.c"
		}
	}
#line 1415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = reimport_state->alterations;
#line 1415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28__length1 = reimport_state->alterations_length1;
#line 1415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp28__length1 > 0) {
#line 11309 "Photo.c"
		gchar** _tmp29_ = NULL;
		gint _tmp29__length1 = 0;
		Alteration* _tmp30_ = NULL;
		Alteration* _tmp31_ = NULL;
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = reimport_state->alterations;
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29__length1 = reimport_state->alterations_length1;
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = alteration_new_from_array (_tmp29_, _tmp29__length1);
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = _tmp30_;
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp31_);
#line 1416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp31_);
#line 11326 "Photo.c"
	}
#line 1418 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = reimport_state->metadata;
#line 1418 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_notify_master_reimported (self, _tmp32_);
#line 1420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = photo_is_master_baseline (self);
#line 1420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp33_) {
#line 11336 "Photo.c"
		PhotoMetadata* _tmp34_ = NULL;
#line 1421 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = reimport_state->metadata;
#line 1421 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp34_);
#line 11342 "Photo.c"
	}
#line 1423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = photo_is_master_source (self);
#line 1423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp35_) {
#line 11348 "Photo.c"
		PhotoMetadata* _tmp36_ = NULL;
#line 1424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = reimport_state->metadata;
#line 1424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp36_);
#line 11354 "Photo.c"
	}
#line 1391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 11358 "Photo.c"
}


static gboolean photo_verify_file_for_reimport (Photo* self, GFile* file, BackingPhotoRow** backing, DetectedPhotoInformation** detected, GError** error) {
	BackingPhotoRow* _vala_backing = NULL;
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	BackingPhotoRow* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	DetectedPhotoInformation* _tmp2_ = NULL;
	BackingPhotoRow* _tmp3_ = NULL;
	BackingPhotoRow* _tmp5_ = NULL;
	BackingPhotoRow* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	DetectedPhotoInformation* _tmp9_ = NULL;
	GdkColorspace _tmp10_ = 0;
	GError * _inner_error_ = NULL;
#line 1428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_query_backing_photo_row (self, _tmp1_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp2_, &_inner_error_);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_detected = _tmp2_;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp3_;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11393 "Photo.c"
		gboolean _tmp4_ = FALSE;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp4_;
#line 11399 "Photo.c"
	}
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_vala_backing);
#line 1430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_backing = _tmp5_;
#line 1432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = _vala_backing;
#line 1432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (backing) {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*backing = _vala_backing;
#line 11421 "Photo.c"
		} else {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 11425 "Photo.c"
		}
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (detected) {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*detected = _vala_detected;
#line 11431 "Photo.c"
		} else {
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11435 "Photo.c"
		}
#line 1433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 11439 "Photo.c"
	}
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _vala_detected;
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _tmp9_->colorspace;
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp10_ != GDK_COLORSPACE_RGB) {
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = TRUE;
#line 11449 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp11_ = NULL;
		gint _tmp12_ = 0;
#line 1438 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _vala_detected;
#line 1438 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp11_->channels;
#line 1438 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = _tmp12_ < 3;
#line 11459 "Photo.c"
	}
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = TRUE;
#line 11465 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp13_ = NULL;
		gint _tmp14_ = 0;
#line 1439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _vala_detected;
#line 1439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _tmp13_->bits_per_channel;
#line 1439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp14_ != 8;
#line 11475 "Photo.c"
	}
#line 1437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp7_) {
#line 11479 "Photo.c"
		GFile* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = file;
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = g_file_get_path (_tmp15_);
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1440: Not re-importing %s: Unsupported color format", _tmp17_);
#line 1440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (_tmp0_);
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (backing) {
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*backing = _vala_backing;
#line 11501 "Photo.c"
		} else {
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (_vala_backing);
#line 11505 "Photo.c"
		}
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (detected) {
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*detected = _vala_detected;
#line 11511 "Photo.c"
		} else {
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 11515 "Photo.c"
		}
#line 1442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 11519 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp0_);
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (backing) {
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*backing = _vala_backing;
#line 11529 "Photo.c"
	} else {
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (_vala_backing);
#line 11533 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (detected) {
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*detected = _vala_detected;
#line 11539 "Photo.c"
	} else {
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 11543 "Photo.c"
	}
#line 1445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 11547 "Photo.c"
}


gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_ = NULL;
	BackingPhotoRow* _tmp4_ = NULL;
	DetectedPhotoInformation* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	BackingPhotoRow* _tmp8_ = NULL;
	DetectedPhotoInformation* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	PhotoReimportEditableStateImpl* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
#line 1449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = NULL;
#line 1452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 1452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp0_;
#line 1453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file;
#line 1453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 11591 "Photo.c"
		} else {
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 11595 "Photo.c"
		}
#line 1454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 11599 "Photo.c"
	}
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = file;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_verify_file_for_reimport (self, _tmp3_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp4_;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp5_;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp6_;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 11617 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp7_;
#line 11629 "Photo.c"
	}
#line 1458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp2_) {
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (backing);
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 11645 "Photo.c"
		} else {
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 11649 "Photo.c"
		}
#line 1459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 11653 "Photo.c"
	}
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = backing;
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = detected;
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _tmp9_->metadata;
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_reimport_editable_state_impl_new (_tmp8_, _tmp10_);
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = (PhotoReimportEditableState*) _tmp11_;
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 11679 "Photo.c"
	} else {
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 11683 "Photo.c"
	}
#line 1463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 11687 "Photo.c"
}


static gpointer _photo_reimport_editable_state_ref0 (gpointer self) {
#line 1472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 11694 "Photo.c"
}


void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error) {
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	PhotoReimportEditableStateImpl* reimport_state = NULL;
	PhotoReimportEditableState* _tmp2_ = NULL;
	PhotoReimportEditableStateImpl* _tmp3_ = NULL;
	PhotoReimportEditableStateImpl* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	PhotoReimportEditableStateImpl* _tmp21_ = NULL;
	PhotoMetadata* _tmp22_ = NULL;
	gchar* list = NULL;
	gchar* _tmp33_ = NULL;
	PhotoReimportEditableStateImpl* _tmp34_ = NULL;
	gboolean _tmp35_ = FALSE;
	const gchar* _tmp38_ = NULL;
	Alteration* _tmp39_ = NULL;
	Alteration* _tmp40_ = NULL;
	PhotoReimportEditableStateImpl* _tmp41_ = NULL;
	PhotoMetadata* _tmp42_ = NULL;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp46_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 1468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_id = _tmp0_;
#line 1469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = backing_photo_id_is_invalid (&editable_id);
#line 1469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 1470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 11735 "Photo.c"
	}
#line 1472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = state;
#line 1472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _photo_reimport_editable_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl));
#line 1472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reimport_state = _tmp3_;
#line 1474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = reimport_state;
#line 1474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_->metadata_only;
#line 1474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp5_) {
#line 11749 "Photo.c"
		BackingPhotoTable* _tmp6_ = NULL;
		BackingPhotoTable* _tmp7_ = NULL;
		PhotoReimportEditableStateImpl* _tmp8_ = NULL;
		BackingPhotoRow* _tmp9_ = NULL;
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = backing_photo_table_get_instance ();
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = reimport_state;
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = _tmp8_->backing_state;
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		backing_photo_table_update (_tmp7_, _tmp9_, &_inner_error_);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp7_);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 11776 "Photo.c"
			} else {
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 11786 "Photo.c"
			}
		}
		{
			PhotoRow* _tmp10_ = NULL;
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = self->row;
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 11795 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp11_ = NULL;
				BackingPhotoRow* _tmp12_ = NULL;
				BackingPhotoRow* _tmp13_ = NULL;
				PhotoReimportEditableStateImpl* _tmp14_ = NULL;
				BackingPhotoRow* _tmp15_ = NULL;
				Orientation _tmp16_ = 0;
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = reimport_state;
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_->backing_state;
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _backing_photo_row_ref0 (_tmp12_);
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (self->priv->editable);
#line 1478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->editable = _tmp13_;
#line 1479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = reimport_state;
#line 1479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = _tmp14_->backing_state;
#line 1479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = _tmp15_->original_orientation;
#line 1479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_set_orientation (self, _tmp16_);
#line 1480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 11823 "Photo.c"
			}
			__finally161:
			{
				PhotoRow* _tmp17_ = NULL;
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = self->row;
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 11832 "Photo.c"
			}
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 11844 "Photo.c"
				} else {
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 11854 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp18_ = NULL;
		BackingPhotoRow* _tmp19_ = NULL;
		Orientation _tmp20_ = 0;
#line 1483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = reimport_state;
#line 1483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp18_->backing_state;
#line 1483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = _tmp19_->original_orientation;
#line 1483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_set_orientation (self, _tmp20_);
#line 11870 "Photo.c"
	}
#line 1486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = reimport_state;
#line 1486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = _tmp21_->metadata;
#line 1486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 11878 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp23_ = NULL;
		PhotoMetadata* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
		PhotoReimportEditableStateImpl* _tmp27_ = NULL;
		PhotoMetadata* _tmp28_ = NULL;
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
		PhotoReimportEditableStateImpl* _tmp31_ = NULL;
		PhotoMetadata* _tmp32_ = NULL;
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = reimport_state;
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = _tmp23_->metadata;
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = media_metadata_get_title ((MediaMetadata*) _tmp24_);
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_set_title ((MediaSource*) self, _tmp26_);
#line 1487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp26_);
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = reimport_state;
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = _tmp27_->metadata;
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = media_metadata_get_comment ((MediaMetadata*) _tmp28_);
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, _tmp30_);
#line 1488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp30_);
#line 1489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = reimport_state;
#line 1489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = _tmp31_->metadata;
#line 1489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp32_);
#line 11919 "Photo.c"
	}
#line 1492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list = _tmp33_;
#line 1493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = reimport_state;
#line 1493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = _tmp34_->metadata_only;
#line 1493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp35_) {
#line 11931 "Photo.c"
		const gchar* _tmp36_ = NULL;
		gchar* _tmp37_ = NULL;
#line 1494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = list;
#line 1494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = g_strconcat (_tmp36_, "image:editable,image:baseline", NULL);
#line 1494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (list);
#line 1494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		list = _tmp37_;
#line 11942 "Photo.c"
	}
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = list;
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = alteration_new_from_list (_tmp38_);
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp40_);
#line 1496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp40_);
#line 1498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = reimport_state;
#line 1498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = _tmp41_->metadata;
#line 1498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp42_);
#line 1500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = photo_is_editable_baseline (self);
#line 1500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp43_) {
#line 11964 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp44_ = NULL;
		PhotoMetadata* _tmp45_ = NULL;
#line 1501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = reimport_state;
#line 1501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = _tmp44_->metadata;
#line 1501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp45_);
#line 11973 "Photo.c"
	}
#line 1503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = photo_is_editable_source (self);
#line 1503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp46_) {
#line 11979 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp47_ = NULL;
		PhotoMetadata* _tmp48_ = NULL;
#line 1504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = reimport_state;
#line 1504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = _tmp47_->metadata;
#line 1504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp48_);
#line 11988 "Photo.c"
	}
#line 1467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (list);
#line 1467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 11994 "Photo.c"
}


static gpointer _photo_reimport_raw_development_state_ref0 (gpointer self) {
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? photo_reimport_raw_development_state_ref (self) : NULL;
#line 12001 "Photo.c"
}


gboolean photo_prepare_for_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState** state, GError** error) {
	PhotoReimportRawDevelopmentState* _vala_state = NULL;
	gboolean result = FALSE;
	GeeCollection* files = NULL;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp19_ = NULL;
	PhotoReimportRawDevelopmentState* _tmp20_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	GError * _inner_error_ = NULL;
#line 1508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = NULL;
#line 1511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_raw_developer_files (self);
#line 1511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	files = _tmp0_;
#line 1512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = files;
#line 1512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (files);
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 12040 "Photo.c"
		} else {
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12044 "Photo.c"
		}
#line 1513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 12048 "Photo.c"
	}
#line 1515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_reimport_raw_development_state_impl_new ();
#line 1515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reimport_state = _tmp2_;
#line 12054 "Photo.c"
	{
		GeeIterator* _file_it = NULL;
		GeeCollection* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = files;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_file_it = _tmp4_;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 12067 "Photo.c"
			GeeIterator* _tmp5_ = NULL;
			gboolean _tmp6_ = FALSE;
			GFile* file = NULL;
			GeeIterator* _tmp7_ = NULL;
			gpointer _tmp8_ = NULL;
			DetectedPhotoInformation* detected = NULL;
			BackingPhotoRow* backing = NULL;
			gboolean _tmp9_ = FALSE;
			GFile* _tmp10_ = NULL;
			BackingPhotoRow* _tmp11_ = NULL;
			DetectedPhotoInformation* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			PhotoReimportRawDevelopmentStateImpl* _tmp15_ = NULL;
			BackingPhotoRow* _tmp16_ = NULL;
			DetectedPhotoInformation* _tmp17_ = NULL;
			PhotoMetadata* _tmp18_ = NULL;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _file_it;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp6_) {
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 12092 "Photo.c"
			}
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _file_it;
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			file = (GFile*) _tmp8_;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = file;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = photo_verify_file_for_reimport (self, _tmp10_, &_tmp11_, &_tmp12_, &_inner_error_);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing = _tmp11_;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			detected = _tmp12_;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp13_;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12116 "Photo.c"
				gboolean _tmp14_ = FALSE;
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_file_it);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (files);
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return _tmp14_;
#line 12134 "Photo.c"
			}
#line 1520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp9_) {
#line 1521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 1521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 1521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 1521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				continue;
#line 12146 "Photo.c"
			}
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = reimport_state;
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = backing;
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = detected;
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = _tmp17_->metadata;
#line 1523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_reimport_raw_development_state_impl_add (_tmp15_, _tmp16_, _tmp18_);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 12164 "Photo.c"
		}
#line 1517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_file_it);
#line 12168 "Photo.c"
	}
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = reimport_state;
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = _photo_reimport_raw_development_state_ref0 ((PhotoReimportRawDevelopmentState*) _tmp19_);
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 1526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = _tmp20_;
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = reimport_state;
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = photo_reimport_raw_development_state_impl_get_size (_tmp21_);
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp22_ > 0;
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (files);
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 12192 "Photo.c"
	} else {
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_raw_development_state_unref0 (_vala_state);
#line 12196 "Photo.c"
	}
#line 1527 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 12200 "Photo.c"
}


void photo_finish_reimport_raw_development (Photo* self, PhotoReimportRawDevelopmentState* state, GError** error) {
	PhotoFileFormat _tmp0_ = 0;
	PhotoReimportRawDevelopmentStateImpl* reimport_state = NULL;
	PhotoReimportRawDevelopmentState* _tmp1_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp2_ = NULL;
	gchar* list = NULL;
	gchar* _tmp32_ = NULL;
	PhotoReimportRawDevelopmentStateImpl* _tmp33_ = NULL;
	gboolean _tmp34_ = FALSE;
	const gchar* _tmp37_ = NULL;
	Alteration* _tmp38_ = NULL;
	Alteration* _tmp39_ = NULL;
	GError * _inner_error_ = NULL;
#line 1531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 1532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 1532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 1533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 12227 "Photo.c"
	}
#line 1535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = state;
#line 1535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _photo_reimport_raw_development_state_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl));
#line 1535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reimport_state = _tmp2_;
#line 12235 "Photo.c"
	{
		GeeIterator* _dev_it = NULL;
		PhotoReimportRawDevelopmentStateImpl* _tmp3_ = NULL;
		GeeCollection* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = reimport_state;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_->list;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_dev_it = _tmp5_;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 12251 "Photo.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			PhotoReimportRawDevelopmentStateImplDevToReimport* dev = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			PhotoReimportRawDevelopmentStateImpl* _tmp10_ = NULL;
			gboolean _tmp11_ = FALSE;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _dev_it;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp7_) {
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 12267 "Photo.c"
			}
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _dev_it;
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			dev = (PhotoReimportRawDevelopmentStateImplDevToReimport*) _tmp9_;
#line 1538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = reimport_state;
#line 1538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = _tmp10_->metadata_only;
#line 1538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp11_) {
#line 12281 "Photo.c"
				BackingPhotoTable* _tmp12_ = NULL;
				BackingPhotoTable* _tmp13_ = NULL;
				PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp14_ = NULL;
				BackingPhotoRow* _tmp15_ = NULL;
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = backing_photo_table_get_instance ();
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = dev;
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = _tmp14_->backing;
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				backing_photo_table_update (_tmp13_, _tmp15_, &_inner_error_);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp13_);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_propagate_error (error, _inner_error_);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return;
#line 12312 "Photo.c"
					} else {
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_dev_it);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_clear_error (&_inner_error_);
#line 1539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						return;
#line 12326 "Photo.c"
					}
				}
				{
					PhotoRow* _tmp16_ = NULL;
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = self->row;
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_row);
#line 12335 "Photo.c"
					{
						gint _tmp17_ = 0;
						RawDeveloper* _tmp18_ = NULL;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp18_ = raw_developer_as_array (&_tmp17_);
#line 12341 "Photo.c"
						{
							RawDeveloper* d_collection = NULL;
							gint d_collection_length1 = 0;
							gint _d_collection_size_ = 0;
							gint d_it = 0;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							d_collection = _tmp18_;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							d_collection_length1 = _tmp17_;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							for (d_it = 0; d_it < _tmp17_; d_it = d_it + 1) {
#line 12353 "Photo.c"
								RawDeveloper d = 0;
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								d = d_collection[d_it];
#line 12357 "Photo.c"
								{
									BackingPhotoID id = {0};
									PhotoRow* _tmp19_ = NULL;
									BackingPhotoID* _tmp20_ = NULL;
									gint _tmp20__length1 = 0;
									RawDeveloper _tmp21_ = 0;
									BackingPhotoID _tmp22_ = {0};
									BackingPhotoID _tmp23_ = {0};
									gint64 _tmp24_ = 0LL;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp19_ = self->row;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp20_ = _tmp19_->development_ids;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp20__length1 = _tmp19_->development_ids_length1;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp21_ = d;
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp22_ = _tmp20_[_tmp21_];
#line 1544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									id = _tmp22_;
#line 1545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp23_ = id;
#line 1545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									_tmp24_ = _tmp23_.id;
#line 1545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
									if (_tmp24_ != BACKING_PHOTO_ID_INVALID) {
#line 12385 "Photo.c"
										BackingPhotoRow* bpr = NULL;
										BackingPhotoID _tmp25_ = {0};
										BackingPhotoRow* _tmp26_ = NULL;
										BackingPhotoRow* _tmp27_ = NULL;
#line 1546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										_tmp25_ = id;
#line 1546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										_tmp26_ = photo_get_backing_row (self, &_tmp25_);
#line 1546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										bpr = _tmp26_;
#line 1547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										_tmp27_ = bpr;
#line 1547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										if (_tmp27_ != NULL) {
#line 12400 "Photo.c"
											GeeHashMap* _tmp28_ = NULL;
											RawDeveloper _tmp29_ = 0;
											BackingPhotoRow* _tmp30_ = NULL;
#line 1548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
											_tmp28_ = self->priv->developments;
#line 1548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
											_tmp29_ = d;
#line 1548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
											_tmp30_ = bpr;
#line 1548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
											gee_abstract_map_set ((GeeAbstractMap*) _tmp28_, (gpointer) ((gintptr) _tmp29_), _tmp30_);
#line 12412 "Photo.c"
										}
#line 1545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
										_backing_photo_row_unref0 (bpr);
#line 12416 "Photo.c"
									}
								}
							}
#line 1543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							d_collection = (g_free (d_collection), NULL);
#line 12422 "Photo.c"
						}
					}
					__finally162:
					{
						PhotoRow* _tmp31_ = NULL;
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp31_ = self->row;
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12432 "Photo.c"
					}
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_propagate_error (error, _inner_error_);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							return;
#line 12448 "Photo.c"
						} else {
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_dev_it);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							g_clear_error (&_inner_error_);
#line 1541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							return;
#line 12462 "Photo.c"
						}
					}
				}
			}
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (dev);
#line 12469 "Photo.c"
		}
#line 1537 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_dev_it);
#line 12473 "Photo.c"
	}
#line 1555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = g_strdup ("metadata:name,image:orientation,metadata:exposure-time");
#line 1555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	list = _tmp32_;
#line 1556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = reimport_state;
#line 1556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = _tmp33_->metadata_only;
#line 1556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp34_) {
#line 12485 "Photo.c"
		const gchar* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
#line 1557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = list;
#line 1557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = g_strconcat (_tmp35_, "image:editable,image:baseline", NULL);
#line 1557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (list);
#line 1557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		list = _tmp36_;
#line 12496 "Photo.c"
	}
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = list;
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = alteration_new_from_list (_tmp37_);
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp39_);
#line 1559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp39_);
#line 1561 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_notify_raw_development_modified (self);
#line 1531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (list);
#line 1531 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_unref0 (reimport_state);
#line 12514 "Photo.c"
}


static gchar* photo_real_get_typename (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 1564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 1565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 12530 "Photo.c"
}


static gint64 photo_real_get_instance_id (DataSource* base) {
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_ = 0LL;
#line 1568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 1569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 12549 "Photo.c"
}


static gchar* photo_real_get_source_id (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint64 _tmp2_ = 0LL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
#line 1572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = data_source_get_typename ((DataSource*) self);
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = data_source_get_instance_id ((DataSource*) self);
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, _tmp2_);
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 1576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 12579 "Photo.c"
}


void photo_set_master_timestamp (Photo* self, GFileInfo* info) {
	GTimeVal modification = {0};
	GFileInfo* _tmp0_ = NULL;
	GTimeVal _tmp1_ = {0};
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = info;
#line 1581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	modification = _tmp1_;
#line 12599 "Photo.c"
	{
		{
			PhotoRow* _tmp2_ = NULL;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 12607 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
				BackingPhotoRow* _tmp4_ = NULL;
				time_t _tmp5_ = 0;
				GTimeVal _tmp6_ = {0};
				glong _tmp7_ = 0L;
				PhotoTable* _tmp9_ = NULL;
				PhotoTable* _tmp10_ = NULL;
				PhotoRow* _tmp11_ = NULL;
				PhotoID _tmp12_ = {0};
				GTimeVal _tmp13_ = {0};
				glong _tmp14_ = 0L;
				PhotoRow* _tmp15_ = NULL;
				BackingPhotoRow* _tmp16_ = NULL;
				GTimeVal _tmp17_ = {0};
				glong _tmp18_ = 0L;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->master;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->timestamp;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = modification;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_.tv_sec;
#line 1585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp5_ == ((time_t) _tmp7_)) {
#line 12636 "Photo.c"
					{
						PhotoRow* _tmp8_ = NULL;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp8_ = self->row;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12643 "Photo.c"
					}
#line 1586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 12647 "Photo.c"
				}
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = photo_table_get_instance ();
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->row;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_->photo_id;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = modification;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = _tmp13_.tv_sec;
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_update_timestamp (_tmp10_, &_tmp12_, (time_t) _tmp14_, &_inner_error_);
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 1588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12667 "Photo.c"
					goto __finally164;
				}
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = self->row;
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = _tmp15_->master;
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = modification;
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = _tmp17_.tv_sec;
#line 1589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_->timestamp = (time_t) _tmp18_;
#line 12680 "Photo.c"
			}
			__finally164:
			{
				PhotoRow* _tmp19_ = NULL;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = self->row;
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12689 "Photo.c"
			}
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 12695 "Photo.c"
					goto __catch163_database_error;
				}
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 12704 "Photo.c"
			}
		}
	}
	goto __finally163;
	__catch163_database_error:
	{
		GError* err = NULL;
		GError* _tmp20_ = NULL;
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = err;
#line 1592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp20_);
#line 1594 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 1594 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 12725 "Photo.c"
	}
	__finally163:
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 12736 "Photo.c"
	}
#line 1597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = photo_is_master_baseline (self);
#line 1597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp21_) {
#line 12742 "Photo.c"
		Alteration* _tmp22_ = NULL;
		Alteration* _tmp23_ = NULL;
#line 1598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp23_);
#line 1598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 12753 "Photo.c"
	} else {
		Alteration* _tmp24_ = NULL;
		Alteration* _tmp25_ = NULL;
#line 1600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = alteration_new ("metadata", "master-timestamp");
#line 1600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 1600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp25_);
#line 1600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 12765 "Photo.c"
	}
}


void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error) {
	GTimeVal modification = {0};
	GFileInfo* _tmp0_ = NULL;
	GTimeVal _tmp1_ = {0};
	gboolean altered = FALSE;
	gboolean _tmp20_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1604 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1604 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 1605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = info;
#line 1605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	modification = _tmp1_;
#line 1607 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	altered = FALSE;
#line 12789 "Photo.c"
	{
		PhotoRow* _tmp2_ = NULL;
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->row;
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 12796 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
			PhotoRow* _tmp4_ = NULL;
			gboolean _tmp5_ = FALSE;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = backing_photo_id_is_valid (&_tmp4_->editable_id);
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp5_) {
#line 12807 "Photo.c"
				BackingPhotoRow* _tmp6_ = NULL;
				time_t _tmp7_ = 0;
				GTimeVal _tmp8_ = {0};
				glong _tmp9_ = 0L;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->priv->editable;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_->timestamp;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = modification;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_.tv_sec;
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _tmp7_ != ((time_t) _tmp9_);
#line 12822 "Photo.c"
			} else {
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = FALSE;
#line 12826 "Photo.c"
			}
#line 1609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_) {
#line 12830 "Photo.c"
				BackingPhotoTable* _tmp10_ = NULL;
				BackingPhotoTable* _tmp11_ = NULL;
				PhotoRow* _tmp12_ = NULL;
				BackingPhotoID _tmp13_ = {0};
				GTimeVal _tmp14_ = {0};
				glong _tmp15_ = 0L;
				BackingPhotoRow* _tmp16_ = NULL;
				GTimeVal _tmp17_ = {0};
				glong _tmp18_ = 0L;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = backing_photo_table_get_instance ();
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = self->row;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_->editable_id;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = modification;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = _tmp14_.tv_sec;
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp11_, &_tmp13_, (time_t) _tmp15_, &_inner_error_);
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp11_);
#line 1610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12858 "Photo.c"
					goto __finally165;
				}
#line 1612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = self->priv->editable;
#line 1612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = modification;
#line 1612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = _tmp17_.tv_sec;
#line 1612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_->timestamp = (time_t) _tmp18_;
#line 1613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				altered = TRUE;
#line 12871 "Photo.c"
			}
		}
		__finally165:
		{
			PhotoRow* _tmp19_ = NULL;
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->row;
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 12881 "Photo.c"
		}
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 12891 "Photo.c"
			} else {
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1608 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 12899 "Photo.c"
			}
		}
	}
#line 1617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = altered;
#line 1617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp20_) {
#line 12907 "Photo.c"
		Alteration* _tmp21_ = NULL;
		Alteration* _tmp22_ = NULL;
#line 1618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 1618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp22_);
#line 1618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp22_);
#line 12918 "Photo.c"
	}
}


void photo_update_many_editable_timestamps (GeeMap* map, GError** error) {
	GError * _inner_error_ = NULL;
#line 1622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_begin_transaction ();
#line 12929 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMap* _tmp0_ = NULL;
		GeeSet* _tmp1_ = NULL;
		GeeSet* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = map;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_it = _tmp5_;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 12956 "Photo.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			Photo* photo = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			Photo* _tmp10_ = NULL;
			GeeMap* _tmp11_ = NULL;
			Photo* _tmp12_ = NULL;
			gpointer _tmp13_ = NULL;
			GFileInfo* _tmp14_ = NULL;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp7_) {
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 12975 "Photo.c"
			}
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = (Photo*) _tmp9_;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = photo;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = map;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = photo;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = gee_map_get (_tmp11_, _tmp12_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = (GFileInfo*) _tmp13_;
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_update_editable_modification_time (_tmp10_, _tmp14_, &_inner_error_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp14_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 13009 "Photo.c"
				} else {
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 13021 "Photo.c"
				}
			}
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 13026 "Photo.c"
		}
#line 1625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 13030 "Photo.c"
	}
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 13042 "Photo.c"
		} else {
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 13050 "Photo.c"
		}
	}
}


static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base) {
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 1630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_file_format (self);
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write_image (_tmp1_);
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 13070 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_get_file_format (self);
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 13076 "Photo.c"
	} else {
		PhotoFileFormat _tmp4_ = 0;
#line 1632 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo_file_format_get_system_default_format ();
#line 1632 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 13083 "Photo.c"
	}
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 1631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13089 "Photo.c"
}


static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	Scaling _tmp2_ = {0};
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 1635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = scale;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	scaling_for_best_fit (_tmp1_, TRUE, &_tmp2_);
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_source_get_pixbuf ((PhotoSource*) self, &_tmp2_, &_inner_error_);
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp3_;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 13118 "Photo.c"
	}
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 1636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13130 "Photo.c"
}


gboolean photo_is_file_image (GFile* file) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 1639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file;
#line 1643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_format_is_file_supported (_tmp1_);
#line 1643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = TRUE;
#line 13149 "Photo.c"
	} else {
		GFile* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = file;
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = g_file_get_basename (_tmp3_);
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = photo_is_extension_found (_tmp5_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 1644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 13167 "Photo.c"
	}
#line 1643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 1643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13173 "Photo.c"
}


gboolean photo_can_write_file (Photo* self) {
	gboolean result = FALSE;
	GFile* file = NULL;
	PhotoRow* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFileInfo* file_info = NULL;
	GFileInfo* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->master;
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_->filepath;
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = g_file_new_for_path (_tmp2_);
#line 1648 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp3_;
#line 13200 "Photo.c"
	{
		GFileInfo* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		GFileInfo* _tmp6_ = NULL;
		GFileInfo* _tmp7_ = NULL;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = file;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = g_file_query_info (_tmp5_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp6_;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13214 "Photo.c"
			goto __catch166_g_error;
		}
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp4_;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = NULL;
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		file_info = _tmp7_;
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 13227 "Photo.c"
	}
	goto __finally166;
	__catch166_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		e = _inner_error_;
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = e;
#line 1653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = _tmp8_->message;
#line 1653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:1653: Error while testing if file is writeable: %s\n", _tmp9_);
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (e);
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 13255 "Photo.c"
	}
	__finally166:
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13260 "Photo.c"
		gboolean _tmp10_ = FALSE;
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file_info);
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp10_;
#line 13272 "Photo.c"
	}
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = file_info;
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = g_file_info_get_attribute_boolean (_tmp11_, G_FILE_ATTRIBUTE_ACCESS_CAN_WRITE);
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp12_;
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file_info);
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 1657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13286 "Photo.c"
}


static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1) {
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
#line 1660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = basename;
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	disassemble_filename (_tmp0_, &_tmp1_, &_tmp2_);
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (name);
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	name = _tmp1_;
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 1662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ext = _tmp2_;
#line 1663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = ext;
#line 1663 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 1664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 1664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (ext);
#line 1664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (name);
#line 1664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 13328 "Photo.c"
	}
#line 1667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = ext;
#line 1667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) -1);
#line 1667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 1667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ext = _tmp5_;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = extensions;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6__length1 = extensions_length1;
#line 13342 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		extension_collection = _tmp6_;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		extension_collection_length1 = _tmp6__length1;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		for (extension_it = 0; extension_it < _tmp6__length1; extension_it = extension_it + 1) {
#line 13354 "Photo.c"
			gchar* _tmp7_ = NULL;
			gchar* extension = NULL;
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = g_strdup (extension_collection[extension_it]);
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			extension = _tmp7_;
#line 13361 "Photo.c"
			{
				const gchar* _tmp8_ = NULL;
				const gchar* _tmp9_ = NULL;
#line 1671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = ext;
#line 1671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = extension;
#line 1671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (g_strcmp0 (_tmp8_, _tmp9_) == 0) {
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = TRUE;
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (extension);
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (ext);
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (name);
#line 1672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 13381 "Photo.c"
				}
#line 1670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (extension);
#line 13385 "Photo.c"
			}
		}
	}
#line 1675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = FALSE;
#line 1675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 1675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (name);
#line 1675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13397 "Photo.c"
}


gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	PhotoFileFormat _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = file;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = file_format;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_table_has_duplicate (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp7_;
#line 1684 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13433 "Photo.c"
}


PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1) {
	PhotoID* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	PhotoFileFormat _tmp5_ = 0;
	gint _tmp6_ = 0;
	PhotoID* _tmp7_ = NULL;
	PhotoID* _tmp8_ = NULL;
	gint _tmp8__length1 = 0;
	PhotoID* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = file;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = file_format;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = photo_table_get_duplicate_ids (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, &_tmp6_);
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8__length1 = _tmp6_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9__length1 = _tmp8__length1;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (result_length1) {
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result_length1 = _tmp9__length1;
#line 13479 "Photo.c"
	}
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp9_;
#line 1693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13485 "Photo.c"
}


gint64 photo_get_photo_key (DataSource* source) {
	gint64 result = 0LL;
	DataSource* _tmp0_ = NULL;
	PhotoID _tmp1_ = {0};
	gint64 _tmp2_ = 0LL;
#line 1700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source != NULL, 0LL);
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = source;
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id ((Photo*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto), &_tmp1_);
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 1701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13506 "Photo.c"
}


static GFile* photo_real_get_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
#line 1719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1720 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 13533 "Photo.c"
}


static void _vala_array_add101 (gchar*** array, int* length, int* size, gchar* value) {
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13544 "Photo.c"
	}
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13550 "Photo.c"
}


static void _vala_array_add102 (gchar*** array, int* length, int* size, gchar* value) {
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13561 "Photo.c"
	}
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13567 "Photo.c"
}


static void _vala_array_add103 (gchar*** array, int* length, int* size, gchar* value) {
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13578 "Photo.c"
	}
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13584 "Photo.c"
}


static void _vala_array_add104 (gchar*** array, int* length, int* size, gchar* value) {
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 13595 "Photo.c"
	}
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 13601 "Photo.c"
}


void photo_set_master_file (Photo* self, GFile* file) {
	gchar* filepath = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	gboolean name_changed = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp41_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 1726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	filepath = _tmp1_;
#line 1728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	altered = FALSE;
#line 1729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_baseline = FALSE;
#line 1730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_source = FALSE;
#line 1731 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	name_changed = FALSE;
#line 1732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old_file = NULL;
#line 13636 "Photo.c"
	{
		{
			PhotoRow* _tmp2_ = NULL;
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 13644 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp3_ = NULL;
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 13652 "Photo.c"
					{
						PhotoBackingReaders* _tmp4_ = NULL;
						PhotoFileReader* _tmp5_ = NULL;
						GFile* _tmp6_ = NULL;
						GFile* _tmp7_ = NULL;
						GFile* _tmp8_ = NULL;
						gboolean _tmp9_ = FALSE;
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp5_ = _tmp4_->master;
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp6_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp5_);
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						old_file = _tmp6_;
#line 1737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp7_ = file;
#line 1737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp8_ = old_file;
#line 1737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp9_ = g_file_equal (_tmp7_, _tmp8_);
#line 1737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!_tmp9_) {
#line 13678 "Photo.c"
							PhotoTable* _tmp10_ = NULL;
							PhotoTable* _tmp11_ = NULL;
							PhotoID _tmp12_ = {0};
							const gchar* _tmp13_ = NULL;
							PhotoRow* _tmp14_ = NULL;
							BackingPhotoRow* _tmp15_ = NULL;
							const gchar* _tmp16_ = NULL;
							gchar* _tmp17_ = NULL;
							GFile* _tmp18_ = NULL;
							gchar* _tmp19_ = NULL;
							PhotoBackingReaders* _tmp20_ = NULL;
							PhotoRow* _tmp21_ = NULL;
							BackingPhotoRow* _tmp22_ = NULL;
							PhotoFileFormat _tmp23_ = 0;
							const gchar* _tmp24_ = NULL;
							PhotoFileReader* _tmp25_ = NULL;
							gboolean _tmp26_ = FALSE;
							gboolean _tmp27_ = FALSE;
							gboolean _tmp28_ = FALSE;
							PhotoRow* _tmp29_ = NULL;
							const gchar* _tmp30_ = NULL;
							gboolean _tmp31_ = FALSE;
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp10_ = photo_table_get_instance ();
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp11_ = _tmp10_;
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							photo_get_photo_id (self, &_tmp12_);
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp13_ = filepath;
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							photo_table_set_filepath (_tmp11_, &_tmp12_, _tmp13_, &_inner_error_);
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_database_table_unref0 (_tmp11_);
#line 1738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13715 "Photo.c"
								goto __finally169;
							}
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp14_ = self->row;
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp15_ = _tmp14_->master;
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp16_ = filepath;
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp17_ = g_strdup (_tmp16_);
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (_tmp15_->filepath);
#line 1740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp15_->filepath = _tmp17_;
#line 1741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp18_ = file;
#line 1741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp19_ = g_file_get_basename (_tmp18_);
#line 1741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							self->priv->file_title = _tmp19_;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20_ = self->priv->readers;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_ = self->row;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp22_ = _tmp21_->master;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp23_ = _tmp22_->file_format;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp24_ = filepath;
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp25_ = photo_file_format_create_reader (_tmp23_, _tmp24_);
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp20_->master);
#line 1742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20_->master = _tmp25_;
#line 1744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							altered = TRUE;
#line 1745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp26_ = photo_is_master_baseline (self);
#line 1745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							is_baseline = _tmp26_;
#line 1746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp27_ = photo_is_master_source (self);
#line 1746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							is_source = _tmp27_;
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp29_ = self->row;
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp30_ = _tmp29_->title;
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp31_ = is_string_empty (_tmp30_);
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (_tmp31_) {
#line 13772 "Photo.c"
								GFile* _tmp32_ = NULL;
								gchar* _tmp33_ = NULL;
								gchar* _tmp34_ = NULL;
								GFile* _tmp35_ = NULL;
								gchar* _tmp36_ = NULL;
								gchar* _tmp37_ = NULL;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp32_ = old_file;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp33_ = g_file_get_basename (_tmp32_);
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp34_ = _tmp33_;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp35_ = file;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp36_ = g_file_get_basename (_tmp35_);
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp37_ = _tmp36_;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp28_ = g_strcmp0 (_tmp34_, _tmp37_) != 0;
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_free0 (_tmp37_);
#line 1748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_free0 (_tmp34_);
#line 13797 "Photo.c"
							} else {
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp28_ = FALSE;
#line 13801 "Photo.c"
							}
#line 1747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							name_changed = _tmp28_;
#line 13805 "Photo.c"
						}
					}
					__finally169:
					{
						PhotoBackingReaders* _tmp38_ = NULL;
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp38_ = self->priv->readers;
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 13815 "Photo.c"
					}
#line 1735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 13819 "Photo.c"
						goto __finally168;
					}
				}
			}
			__finally168:
			{
				PhotoRow* _tmp39_ = NULL;
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = self->row;
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 13831 "Photo.c"
			}
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 13837 "Photo.c"
					goto __catch167_database_error;
				}
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (filepath);
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 13850 "Photo.c"
			}
		}
	}
	goto __finally167;
	__catch167_database_error:
	{
		GError* err = NULL;
		GError* _tmp40_ = NULL;
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = err;
#line 1753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp40_);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 13869 "Photo.c"
	}
	__finally167:
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (filepath);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 13884 "Photo.c"
	}
#line 1756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = altered;
#line 1756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp41_) {
#line 13890 "Photo.c"
		GFile* _tmp42_ = NULL;
		GFile* _tmp43_ = NULL;
		gboolean _tmp44_ = FALSE;
		gchar** alteration_list = NULL;
		gchar** _tmp45_ = NULL;
		gint alteration_list_length1 = 0;
		gint _alteration_list_size_ = 0;
		gchar** _tmp46_ = NULL;
		gint _tmp46__length1 = 0;
		gchar* _tmp47_ = NULL;
		gboolean _tmp48_ = FALSE;
		gboolean _tmp51_ = FALSE;
		gboolean _tmp54_ = FALSE;
		gchar** _tmp57_ = NULL;
		gint _tmp57__length1 = 0;
		Alteration* _tmp58_ = NULL;
		Alteration* _tmp59_ = NULL;
#line 1757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = old_file;
#line 1757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = file;
#line 1757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_notify_master_replaced ((MediaSource*) self, _tmp42_, _tmp43_);
#line 1759 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = is_baseline;
#line 1759 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp44_) {
#line 1760 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 13920 "Photo.c"
		}
#line 1762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = g_new0 (gchar*, 0 + 1);
#line 1762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list = _tmp45_;
#line 1762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = alteration_list;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46__length1 = alteration_list_length1;
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = g_strdup ("backing:master");
#line 1763 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add101 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp47_);
#line 1767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = name_changed;
#line 1767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp48_) {
#line 13942 "Photo.c"
			gchar** _tmp49_ = NULL;
			gint _tmp49__length1 = 0;
			gchar* _tmp50_ = NULL;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp49_ = alteration_list;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp49__length1 = alteration_list_length1;
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp50_ = g_strdup ("metadata:name");
#line 1768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add102 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp50_);
#line 13954 "Photo.c"
		}
#line 1770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = is_source;
#line 1770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp51_) {
#line 13960 "Photo.c"
			gchar** _tmp52_ = NULL;
			gint _tmp52__length1 = 0;
			gchar* _tmp53_ = NULL;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp52_ = alteration_list;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp52__length1 = alteration_list_length1;
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp53_ = g_strdup ("backing:source");
#line 1771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add103 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp53_);
#line 13972 "Photo.c"
		}
#line 1773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp54_ = is_baseline;
#line 1773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp54_) {
#line 13978 "Photo.c"
			gchar** _tmp55_ = NULL;
			gint _tmp55__length1 = 0;
			gchar* _tmp56_ = NULL;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp55_ = alteration_list;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp55__length1 = alteration_list_length1;
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp56_ = g_strdup ("backing:baseline");
#line 1774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add104 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp56_);
#line 13990 "Photo.c"
		}
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = alteration_list;
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57__length1 = alteration_list_length1;
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp58_ = alteration_new_from_array (_tmp57_, _tmp57__length1);
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp59_ = _tmp58_;
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp59_);
#line 1776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp59_);
#line 1756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 14006 "Photo.c"
	}
#line 1725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (filepath);
#line 14012 "Photo.c"
}


static void _vala_array_add105 (gchar*** array, int* length, int* size, gchar* value) {
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14023 "Photo.c"
	}
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14029 "Photo.c"
}


static void _vala_array_add106 (gchar*** array, int* length, int* size, gchar* value) {
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14040 "Photo.c"
	}
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14046 "Photo.c"
}


static void _vala_array_add107 (gchar*** array, int* length, int* size, gchar* value) {
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 14057 "Photo.c"
	}
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 14063 "Photo.c"
}


void photo_set_editable_file (Photo* self, GFile* file) {
	gchar* filepath = NULL;
	GFile* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean altered = FALSE;
	gboolean is_baseline = FALSE;
	gboolean is_source = FALSE;
	GFile* old_file = NULL;
	gboolean _tmp34_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 1783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 1783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	filepath = _tmp1_;
#line 1785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	altered = FALSE;
#line 1786 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_baseline = FALSE;
#line 1787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_source = FALSE;
#line 1788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old_file = NULL;
#line 14095 "Photo.c"
	{
		{
			PhotoRow* _tmp2_ = NULL;
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 14103 "Photo.c"
			{
				{
					PhotoBackingReaders* _tmp3_ = NULL;
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_lock (&self->priv->__lock_readers);
#line 14111 "Photo.c"
					{
						GFile* _tmp4_ = NULL;
						PhotoBackingReaders* _tmp5_ = NULL;
						PhotoFileReader* _tmp6_ = NULL;
						GFile* _tmp10_ = NULL;
						gboolean _tmp11_ = FALSE;
						GFile* _tmp12_ = NULL;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp5_ = self->priv->readers;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp6_ = _tmp5_->editable;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp6_ != NULL) {
#line 14125 "Photo.c"
							PhotoBackingReaders* _tmp7_ = NULL;
							PhotoFileReader* _tmp8_ = NULL;
							GFile* _tmp9_ = NULL;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp7_ = self->priv->readers;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp8_ = _tmp7_->editable;
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp9_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp8_);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp4_ = _tmp9_;
#line 14139 "Photo.c"
						} else {
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp4_ = NULL;
#line 14145 "Photo.c"
						}
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp10_ = _g_object_ref0 (_tmp4_);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						old_file = _tmp10_;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp12_ = old_file;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp12_ != NULL) {
#line 14157 "Photo.c"
							GFile* _tmp13_ = NULL;
							GFile* _tmp14_ = NULL;
							gboolean _tmp15_ = FALSE;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp13_ = old_file;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp14_ = file;
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp15_ = g_file_equal (_tmp13_, _tmp14_);
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp11_ = !_tmp15_;
#line 14169 "Photo.c"
						} else {
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp11_ = FALSE;
#line 14173 "Photo.c"
						}
#line 1793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp11_) {
#line 14177 "Photo.c"
							BackingPhotoTable* _tmp16_ = NULL;
							BackingPhotoTable* _tmp17_ = NULL;
							PhotoRow* _tmp18_ = NULL;
							BackingPhotoID _tmp19_ = {0};
							const gchar* _tmp20_ = NULL;
							BackingPhotoRow* _tmp21_ = NULL;
							const gchar* _tmp22_ = NULL;
							gchar* _tmp23_ = NULL;
							PhotoBackingReaders* _tmp24_ = NULL;
							BackingPhotoRow* _tmp25_ = NULL;
							PhotoFileFormat _tmp26_ = 0;
							const gchar* _tmp27_ = NULL;
							PhotoFileReader* _tmp28_ = NULL;
							gboolean _tmp29_ = FALSE;
							gboolean _tmp30_ = FALSE;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp16_ = backing_photo_table_get_instance ();
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp17_ = _tmp16_;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp18_ = self->row;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp19_ = _tmp18_->editable_id;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp20_ = filepath;
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							backing_photo_table_set_filepath (_tmp17_, &_tmp19_, _tmp20_, &_inner_error_);
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_database_table_unref0 (_tmp17_);
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_g_object_unref0 (_tmp4_);
#line 14211 "Photo.c"
								goto __finally172;
							}
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_ = self->priv->editable;
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp22_ = filepath;
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp23_ = g_strdup (_tmp22_);
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (_tmp21_->filepath);
#line 1796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_->filepath = _tmp23_;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp24_ = self->priv->readers;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp25_ = self->priv->editable;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp26_ = _tmp25_->file_format;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp27_ = filepath;
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp28_ = photo_file_format_create_reader (_tmp26_, _tmp27_);
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_photo_file_adapter_unref0 (_tmp24_->editable);
#line 1797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp24_->editable = _tmp28_;
#line 1799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							altered = TRUE;
#line 1800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp29_ = photo_is_editable_baseline (self);
#line 1800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							is_baseline = _tmp29_;
#line 1801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp30_ = photo_is_editable_source (self);
#line 1801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							is_source = _tmp30_;
#line 14248 "Photo.c"
						}
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_tmp4_);
#line 14252 "Photo.c"
					}
					__finally172:
					{
						PhotoBackingReaders* _tmp31_ = NULL;
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp31_ = self->priv->readers;
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 14261 "Photo.c"
					}
#line 1791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 14265 "Photo.c"
						goto __finally171;
					}
				}
			}
			__finally171:
			{
				PhotoRow* _tmp32_ = NULL;
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = self->row;
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14277 "Photo.c"
			}
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 14283 "Photo.c"
					goto __catch170_database_error;
				}
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (filepath);
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 14296 "Photo.c"
			}
		}
	}
	goto __finally170;
	__catch170_database_error:
	{
		GError* err = NULL;
		GError* _tmp33_ = NULL;
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 1806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33_ = err;
#line 1806 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp33_);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 14315 "Photo.c"
	}
	__finally170:
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (filepath);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1789 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 14330 "Photo.c"
	}
#line 1809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = altered;
#line 1809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp34_) {
#line 14336 "Photo.c"
		GFile* _tmp35_ = NULL;
		GFile* _tmp36_ = NULL;
		gboolean _tmp37_ = FALSE;
		gchar** alteration_list = NULL;
		gchar** _tmp38_ = NULL;
		gint alteration_list_length1 = 0;
		gint _alteration_list_size_ = 0;
		gchar** _tmp39_ = NULL;
		gint _tmp39__length1 = 0;
		gchar* _tmp40_ = NULL;
		gboolean _tmp41_ = FALSE;
		gboolean _tmp44_ = FALSE;
		gchar** _tmp47_ = NULL;
		gint _tmp47__length1 = 0;
		Alteration* _tmp48_ = NULL;
		Alteration* _tmp49_ = NULL;
#line 1810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = old_file;
#line 1810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = file;
#line 1810 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp35_, _tmp36_);
#line 1812 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = is_baseline;
#line 1812 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp37_) {
#line 1813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 14365 "Photo.c"
		}
#line 1815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = g_new0 (gchar*, 0 + 1);
#line 1815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list = _tmp38_;
#line 1815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = alteration_list;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39__length1 = alteration_list_length1;
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = g_strdup ("backing:editable");
#line 1816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add105 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp40_);
#line 1818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = is_baseline;
#line 1818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp41_) {
#line 14387 "Photo.c"
			gchar** _tmp42_ = NULL;
			gint _tmp42__length1 = 0;
			gchar* _tmp43_ = NULL;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = alteration_list;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42__length1 = alteration_list_length1;
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43_ = g_strdup ("backing:baseline");
#line 1819 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add106 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp43_);
#line 14399 "Photo.c"
		}
#line 1821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = is_source;
#line 1821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp44_) {
#line 14405 "Photo.c"
			gchar** _tmp45_ = NULL;
			gint _tmp45__length1 = 0;
			gchar* _tmp46_ = NULL;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp45_ = alteration_list;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp45__length1 = alteration_list_length1;
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp46_ = g_strdup ("backing:source");
#line 1822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add107 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp46_);
#line 14417 "Photo.c"
		}
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = alteration_list;
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47__length1 = alteration_list_length1;
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = alteration_new_from_array (_tmp47_, _tmp47__length1);
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = _tmp48_;
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp49_);
#line 1824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp49_);
#line 1809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 14433 "Photo.c"
	}
#line 1782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (filepath);
#line 14439 "Photo.c"
}


void photo_set_many_editable_file (GeeMap* map, GError** error) {
	GeeMapIterator* map_iter = NULL;
	GeeMap* _tmp0_ = NULL;
	GeeMapIterator* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 1829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (map != NULL);
#line 1830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_begin_transaction ();
#line 1832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = map;
#line 1832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_map_map_iterator (_tmp0_);
#line 1832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map_iter = _tmp1_;
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	while (TRUE) {
#line 14460 "Photo.c"
		GeeMapIterator* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		GeeMapIterator* _tmp4_ = NULL;
		gpointer _tmp5_ = NULL;
		Photo* _tmp6_ = NULL;
		GeeMapIterator* _tmp7_ = NULL;
		gpointer _tmp8_ = NULL;
		GFile* _tmp9_ = NULL;
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = map_iter;
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_map_iterator_next (_tmp2_);
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (!_tmp3_) {
#line 1833 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 14477 "Photo.c"
		}
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = map_iter;
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = gee_map_iterator_get_key (_tmp4_);
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = (Photo*) _tmp5_;
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = map_iter;
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = gee_map_iterator_get_value (_tmp7_);
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = (GFile*) _tmp8_;
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_set_editable_file (_tmp6_, _tmp9_);
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp9_);
#line 1834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp6_);
#line 14497 "Photo.c"
	}
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 14511 "Photo.c"
		} else {
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 14521 "Photo.c"
		}
	}
#line 1829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 14526 "Photo.c"
}


GFile* photo_get_actual_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
#line 1841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14552 "Photo.c"
}


static GFile* photo_real_get_master_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
#line 1845 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14579 "Photo.c"
}


GFile* photo_get_editable_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
#line 1849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp0_;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reader;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 14599 "Photo.c"
		PhotoFileReader* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = reader;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp3_);
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 14610 "Photo.c"
	} else {
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 14616 "Photo.c"
	}
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1852 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14624 "Photo.c"
}


GeeCollection* photo_get_raw_developer_files (Photo* self) {
	GeeCollection* result = NULL;
	PhotoFileFormat _tmp0_ = 0;
	GeeArrayList* ret = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 1855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1856 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_file_format (self);
#line 1856 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ != PHOTO_FILE_FORMAT_RAW) {
#line 1857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 1857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 14644 "Photo.c"
	}
#line 1859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = _tmp1_;
#line 14650 "Photo.c"
	{
		PhotoRow* _tmp2_ = NULL;
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->row;
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14657 "Photo.c"
		{
			{
				GeeIterator* _row_it = NULL;
				GeeHashMap* _tmp3_ = NULL;
				GeeCollection* _tmp4_ = NULL;
				GeeCollection* _tmp5_ = NULL;
				GeeCollection* _tmp6_ = NULL;
				GeeIterator* _tmp7_ = NULL;
				GeeIterator* _tmp8_ = NULL;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->developments;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp3_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = _tmp5_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = gee_iterable_iterator ((GeeIterable*) _tmp6_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp6_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_row_it = _tmp8_;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				while (TRUE) {
#line 14685 "Photo.c"
					GeeIterator* _tmp9_ = NULL;
					gboolean _tmp10_ = FALSE;
					BackingPhotoRow* row = NULL;
					GeeIterator* _tmp11_ = NULL;
					gpointer _tmp12_ = NULL;
					GeeArrayList* _tmp13_ = NULL;
					BackingPhotoRow* _tmp14_ = NULL;
					const gchar* _tmp15_ = NULL;
					GFile* _tmp16_ = NULL;
					GFile* _tmp17_ = NULL;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = _row_it;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = gee_iterator_next (_tmp9_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (!_tmp10_) {
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						break;
#line 14704 "Photo.c"
					}
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = _row_it;
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = gee_iterator_get (_tmp11_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					row = (BackingPhotoRow*) _tmp12_;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = ret;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = row;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = _tmp14_->filepath;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = g_file_new_for_path (_tmp15_);
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = _tmp16_;
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp13_, _tmp17_);
#line 1862 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp17_);
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 14728 "Photo.c"
				}
#line 1861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_row_it);
#line 14732 "Photo.c"
			}
		}
		__finally173:
		{
			PhotoRow* _tmp18_ = NULL;
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = self->row;
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14742 "Photo.c"
		}
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (ret);
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 14754 "Photo.c"
		}
	}
#line 1865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (GeeCollection*) ret;
#line 1865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14761 "Photo.c"
}


GFile* photo_get_source_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
#line 1868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp1_);
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 1869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14787 "Photo.c"
}


PhotoFileFormat photo_get_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 14796 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14803 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			PhotoFileFormat _tmp2_ = 0;
#line 1874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->file_format;
#line 1874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 14813 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14820 "Photo.c"
			}
#line 1874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 14824 "Photo.c"
		}
		__finally174:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14833 "Photo.c"
		}
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 14841 "Photo.c"
	}
}


PhotoFileFormat photo_get_best_export_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	PhotoFileFormat file_format = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 1878 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1879 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_file_format (self);
#line 1879 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file_format = _tmp0_;
#line 1880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file_format;
#line 1880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write (_tmp1_);
#line 1880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp2_) {
#line 14864 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_file_format_get_system_default_format ();
#line 1881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		file_format = _tmp3_;
#line 14870 "Photo.c"
	}
#line 1883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = file_format;
#line 1883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 14876 "Photo.c"
}


PhotoFileFormat photo_get_master_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 14885 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14892 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			PhotoFileFormat _tmp3_ = 0;
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 14905 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14912 "Photo.c"
			}
#line 1888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 14916 "Photo.c"
		}
		__finally175:
		{
			PhotoRow* _tmp5_ = NULL;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14925 "Photo.c"
		}
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 14933 "Photo.c"
	}
}


static time_t photo_real_get_timestamp (MediaSource* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 1892 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 14944 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		time_t _tmp5_ = 0;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 14952 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			time_t _tmp2_ = 0;
#line 1894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 1894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->timestamp;
#line 1894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 14962 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14969 "Photo.c"
			}
#line 1894 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 14973 "Photo.c"
		}
		__finally176:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 14982 "Photo.c"
		}
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 14990 "Photo.c"
	}
}


void photo_get_photo_id (Photo* self, PhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1898 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 14999 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15006 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			PhotoID _tmp2_ = {0};
#line 1900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->photo_id;
#line 1900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result = _tmp2_;
#line 15016 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15023 "Photo.c"
			}
#line 1900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 15027 "Photo.c"
		}
		__finally177:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15036 "Photo.c"
		}
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 15044 "Photo.c"
	}
}


static inline void photo_real_get_event_id (MediaSource* base, EventID* result) {
	Photo * self;
	PhotoRow* _tmp0_ = NULL;
	EventID _tmp1_ = {0};
#line 1905 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 1906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 1906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp1_;
#line 1906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 15063 "Photo.c"
}


inline gint64 photo_get_raw_event_id (Photo* self) {
	gint64 result = 0LL;
	PhotoRow* _tmp0_ = NULL;
	EventID _tmp1_ = {0};
	gint64 _tmp2_ = 0LL;
#line 1910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->row;
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->event_id;
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 1911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15084 "Photo.c"
}


static void photo_real_get_import_id (MediaSource* base, ImportID* result) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 15093 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15100 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			ImportID _tmp2_ = {0};
#line 1916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->import_id;
#line 1916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result = _tmp2_;
#line 15110 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15117 "Photo.c"
			}
#line 1916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 15121 "Photo.c"
		}
		__finally178:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15130 "Photo.c"
		}
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 15138 "Photo.c"
	}
}


void photo_get_editable_id (Photo* self, BackingPhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 15147 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15154 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			BackingPhotoID _tmp2_ = {0};
#line 1922 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1922 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable_id;
#line 1922 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result = _tmp2_;
#line 15164 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15171 "Photo.c"
			}
#line 1922 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 15175 "Photo.c"
		}
		__finally179:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15184 "Photo.c"
		}
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 15192 "Photo.c"
	}
}


static gchar* photo_real_get_master_md5 (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 15203 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15210 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->md5;
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 15223 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15230 "Photo.c"
			}
#line 1928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 15234 "Photo.c"
		}
		__finally180:
		{
			PhotoRow* _tmp5_ = NULL;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15243 "Photo.c"
		}
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 15251 "Photo.c"
	}
}


guint64 photo_get_flags (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 15261 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		guint64 _tmp5_ = 0ULL;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15269 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
#line 1936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 15279 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15286 "Photo.c"
			}
#line 1936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 15290 "Photo.c"
		}
		__finally181:
		{
			PhotoRow* _tmp4_ = NULL;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15299 "Photo.c"
		}
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 15307 "Photo.c"
	}
}


static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration) {
	Alteration* alteration = NULL;
	Alteration* _tmp0_ = NULL;
	Alteration* _tmp1_ = NULL;
	Alteration* _tmp5_ = NULL;
#line 1940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 1941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	alteration = _tmp0_;
#line 1942 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = additional_alteration;
#line 1942 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 15327 "Photo.c"
		Alteration* _tmp2_ = NULL;
		Alteration* _tmp3_ = NULL;
		Alteration* _tmp4_ = NULL;
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = alteration;
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = additional_alteration;
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = alteration_compress (_tmp2_, _tmp3_);
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (alteration);
#line 1943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		alteration = _tmp4_;
#line 15341 "Photo.c"
	}
#line 1945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = alteration;
#line 1945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_object_notify_altered ((DataObject*) self, _tmp5_);
#line 1940 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (alteration);
#line 15349 "Photo.c"
}


guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp11_ = FALSE;
	guint64 _tmp13_ = 0ULL;
	GError * _inner_error_ = NULL;
#line 1948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 15361 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15368 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_ = NULL;
			PhotoID _tmp3_ = {0};
			guint64 _tmp4_ = 0ULL;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_ = FALSE;
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = flags;
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = photo_table_replace_flags (_tmp2_, &_tmp3_, _tmp4_);
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = _tmp5_;
#line 1951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 1952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = committed;
#line 1952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_) {
#line 15394 "Photo.c"
				PhotoRow* _tmp7_ = NULL;
				guint64 _tmp8_ = 0ULL;
#line 1953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = self->row;
#line 1953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = flags;
#line 1953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_->flags = _tmp8_;
#line 15403 "Photo.c"
			}
		}
		__finally182:
		{
			PhotoRow* _tmp9_ = NULL;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15413 "Photo.c"
		}
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 15417 "Photo.c"
			guint64 _tmp10_ = 0ULL;
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1950 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp10_;
#line 15425 "Photo.c"
		}
	}
#line 1956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = committed;
#line 1956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_) {
#line 15432 "Photo.c"
		Alteration* _tmp12_ = NULL;
#line 1957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = additional_alteration;
#line 1957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp12_);
#line 15438 "Photo.c"
	}
#line 1959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = flags;
#line 1959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp13_;
#line 1959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15446 "Photo.c"
}


gboolean photo_is_flag_set (Photo* self, guint64 mask) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1962 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 15455 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp7_ = FALSE;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15463 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			gboolean _tmp4_ = FALSE;
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = mask;
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = media_source_internal_is_flag_set (_tmp2_, _tmp3_);
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp4_;
#line 15479 "Photo.c"
			{
				PhotoRow* _tmp5_ = NULL;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = self->row;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15486 "Photo.c"
			}
#line 1964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 15490 "Photo.c"
		}
		__finally183:
		{
			PhotoRow* _tmp6_ = NULL;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15499 "Photo.c"
		}
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp7_;
#line 15507 "Photo.c"
	}
}


guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 1969 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	flags = (guint64) 0;
#line 1971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 15524 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15531 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_ = NULL;
			guint64 _tmp6_ = 0ULL;
			guint64 _tmp7_ = 0ULL;
#line 1973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = mask;
#line 1973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = media_source_internal_add_flags (_tmp2_, _tmp3_);
#line 1973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			flags = _tmp4_;
#line 1974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 1974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 1974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = flags;
#line 1974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15558 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_ = NULL;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_ = 0ULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = flags;
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = _tmp12_;
#line 1975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = committed;
#line 1976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp13_) {
#line 15583 "Photo.c"
					PhotoRow* _tmp14_ = NULL;
					guint64 _tmp15_ = 0ULL;
#line 1977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = self->row;
#line 1977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = flags;
#line 1977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15592 "Photo.c"
				}
			}
		}
		__finally184:
		{
			PhotoRow* _tmp16_ = NULL;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = self->row;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15603 "Photo.c"
		}
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 15607 "Photo.c"
			guint64 _tmp17_ = 0ULL;
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp17_;
#line 15615 "Photo.c"
		}
	}
#line 1981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = committed;
#line 1981 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_) {
#line 15622 "Photo.c"
		Alteration* _tmp19_ = NULL;
#line 1982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = additional_alteration;
#line 1982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp19_);
#line 15628 "Photo.c"
	}
#line 1984 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 1984 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15634 "Photo.c"
}


guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 1988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	flags = (guint64) 0;
#line 1990 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 15650 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15657 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_ = NULL;
			guint64 _tmp6_ = 0ULL;
			guint64 _tmp7_ = 0ULL;
#line 1992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 1992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 1992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = mask;
#line 1992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = media_source_internal_remove_flags (_tmp2_, _tmp3_);
#line 1992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			flags = _tmp4_;
#line 1993 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 1993 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 1993 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = flags;
#line 1993 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15684 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_ = NULL;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_ = 0ULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = flags;
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = _tmp12_;
#line 1994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = committed;
#line 1995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp13_) {
#line 15709 "Photo.c"
					PhotoRow* _tmp14_ = NULL;
					guint64 _tmp15_ = 0ULL;
#line 1996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = self->row;
#line 1996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = flags;
#line 1996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15718 "Photo.c"
				}
			}
		}
		__finally185:
		{
			PhotoRow* _tmp16_ = NULL;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = self->row;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15729 "Photo.c"
		}
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 15733 "Photo.c"
			guint64 _tmp17_ = 0ULL;
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp17_;
#line 15741 "Photo.c"
		}
	}
#line 2000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = committed;
#line 2000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_) {
#line 15748 "Photo.c"
		Alteration* _tmp19_ = NULL;
#line 2001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = additional_alteration;
#line 2001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp19_);
#line 15754 "Photo.c"
	}
#line 2003 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 2003 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15760 "Photo.c"
}


guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2007 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	flags = (guint64) 0;
#line 2009 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 15776 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 15783 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			guint64 _tmp4_ = 0ULL;
			PhotoRow* _tmp5_ = NULL;
			guint64 _tmp6_ = 0ULL;
			guint64 _tmp7_ = 0ULL;
#line 2011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = add;
#line 2011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = remove;
#line 2011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			flags = (_tmp2_ | _tmp3_) & (~_tmp4_);
#line 2012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->flags;
#line 2012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = flags;
#line 2012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 15810 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_ = NULL;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_ = 0ULL;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = flags;
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = _tmp12_;
#line 2013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 2014 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = committed;
#line 2014 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp13_) {
#line 15835 "Photo.c"
					PhotoRow* _tmp14_ = NULL;
					guint64 _tmp15_ = 0ULL;
#line 2015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = self->row;
#line 2015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = flags;
#line 2015 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_->flags = _tmp15_;
#line 15844 "Photo.c"
				}
			}
		}
		__finally186:
		{
			PhotoRow* _tmp16_ = NULL;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = self->row;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 15855 "Photo.c"
		}
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 15859 "Photo.c"
			guint64 _tmp17_ = 0ULL;
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp17_;
#line 15867 "Photo.c"
		}
	}
#line 2019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = committed;
#line 2019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_) {
#line 15874 "Photo.c"
		Alteration* _tmp19_ = NULL;
#line 2020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = additional_alteration;
#line 2020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp19_);
#line 15880 "Photo.c"
	}
#line 2022 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 2022 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 15886 "Photo.c"
}


void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
#line 2028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_begin_transaction ();
#line 2030 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = add;
#line 2030 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 15900 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeCollection* _tmp1_ = NULL;
			GeeIterator* _tmp2_ = NULL;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = add;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_it = _tmp2_;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 15913 "Photo.c"
				GeeIterator* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				Photo* photo = NULL;
				GeeIterator* _tmp5_ = NULL;
				gpointer _tmp6_ = NULL;
				Photo* _tmp7_ = NULL;
				guint64 _tmp8_ = 0ULL;
				Alteration* _tmp9_ = NULL;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _photo_it;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp4_) {
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 15930 "Photo.c"
				}
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _photo_it;
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = (Photo*) _tmp6_;
#line 2032 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = photo;
#line 2032 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = add_mask;
#line 2032 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = additional_add_alteration;
#line 2032 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_add_flags (_tmp7_, _tmp8_, _tmp9_);
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 15948 "Photo.c"
			}
#line 2031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 15952 "Photo.c"
		}
	}
#line 2035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = remove;
#line 2035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp10_ != NULL) {
#line 15959 "Photo.c"
		{
			GeeIterator* _photo_it = NULL;
			GeeCollection* _tmp11_ = NULL;
			GeeIterator* _tmp12_ = NULL;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = remove;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = gee_iterable_iterator ((GeeIterable*) _tmp11_);
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_it = _tmp12_;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 15972 "Photo.c"
				GeeIterator* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				Photo* photo = NULL;
				GeeIterator* _tmp15_ = NULL;
				gpointer _tmp16_ = NULL;
				Photo* _tmp17_ = NULL;
				guint64 _tmp18_ = 0ULL;
				Alteration* _tmp19_ = NULL;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _photo_it;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = gee_iterator_next (_tmp13_);
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp14_) {
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 15989 "Photo.c"
				}
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = _photo_it;
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = gee_iterator_get (_tmp15_);
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = (Photo*) _tmp16_;
#line 2037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = photo;
#line 2037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = remove_mask;
#line 2037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = additional_remove_alteration;
#line 2037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_remove_flags (_tmp17_, _tmp18_, _tmp19_);
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 16007 "Photo.c"
			}
#line 2036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 16011 "Photo.c"
		}
	}
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 16024 "Photo.c"
		} else {
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 16032 "Photo.c"
		}
	}
}


guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp17_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 2044 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	flags = (guint64) 0;
#line 2046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 16050 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16057 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			guint64 _tmp2_ = 0ULL;
			guint64 _tmp3_ = 0ULL;
			PhotoRow* _tmp4_ = NULL;
			guint64 _tmp5_ = 0ULL;
			guint64 _tmp6_ = 0ULL;
#line 2048 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2048 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->flags;
#line 2048 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = mask;
#line 2048 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			flags = _tmp2_ ^ _tmp3_;
#line 2049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _tmp4_->flags;
#line 2049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = flags;
#line 2049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp5_ != _tmp6_) {
#line 16081 "Photo.c"
				PhotoTable* _tmp7_ = NULL;
				PhotoTable* _tmp8_ = NULL;
				PhotoID _tmp9_ = {0};
				guint64 _tmp10_ = 0ULL;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = photo_table_get_instance ();
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp9_);
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = flags;
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = photo_table_replace_flags (_tmp8_, &_tmp9_, _tmp10_);
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = _tmp11_;
#line 2050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp8_);
#line 2051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = committed;
#line 2051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp12_) {
#line 16106 "Photo.c"
					PhotoRow* _tmp13_ = NULL;
					guint64 _tmp14_ = 0ULL;
#line 2052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = self->row;
#line 2052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = flags;
#line 2052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_->flags = _tmp14_;
#line 16115 "Photo.c"
				}
			}
		}
		__finally187:
		{
			PhotoRow* _tmp15_ = NULL;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16126 "Photo.c"
		}
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16130 "Photo.c"
			guint64 _tmp16_ = 0ULL;
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp16_;
#line 16138 "Photo.c"
		}
	}
#line 2056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = committed;
#line 2056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp17_) {
#line 16145 "Photo.c"
		Alteration* _tmp18_ = NULL;
#line 2057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = additional_alteration;
#line 2057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp18_);
#line 16151 "Photo.c"
	}
#line 2059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = flags;
#line 2059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 16157 "Photo.c"
}


gboolean photo_is_master_metadata_dirty (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 16166 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16174 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 2064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 16184 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16191 "Photo.c"
			}
#line 2064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 16195 "Photo.c"
		}
		__finally188:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16204 "Photo.c"
		}
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 16212 "Photo.c"
	}
}


void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error) {
	gboolean committed = FALSE;
	gboolean _tmp11_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2069 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 16225 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16232 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
#line 2071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->metadata_dirty;
#line 2071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = dirty;
#line 2071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 16245 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_ = NULL;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_ = FALSE;
				PhotoRow* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = dirty;
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp5_, &_tmp6_, _tmp7_, &_inner_error_);
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16266 "Photo.c"
					goto __finally189;
				}
#line 2073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->row;
#line 2073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = dirty;
#line 2073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_->metadata_dirty = _tmp9_;
#line 2074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = TRUE;
#line 16277 "Photo.c"
			}
		}
		__finally189:
		{
			PhotoRow* _tmp10_ = NULL;
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = self->row;
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16287 "Photo.c"
		}
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 16297 "Photo.c"
			} else {
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2070 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 16305 "Photo.c"
			}
		}
	}
#line 2078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = committed;
#line 2078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_) {
#line 16313 "Photo.c"
		Alteration* _tmp12_ = NULL;
		Alteration* _tmp13_ = NULL;
#line 2079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = alteration_new ("metadata", "master-dirty");
#line 2079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp12_;
#line 2079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp13_);
#line 2079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp13_);
#line 16324 "Photo.c"
	}
}


gboolean photo_is_enhanced (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 16334 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp5_ = FALSE;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16342 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 2084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 2084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 16352 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16359 "Photo.c"
			}
#line 2084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 16363 "Photo.c"
		}
		__finally190:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16372 "Photo.c"
		}
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 16380 "Photo.c"
	}
}


void photo_set_enhanced (Photo* self, gboolean enhanced) {
	gboolean committed = FALSE;
	gboolean _tmp13_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2088 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2089 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 16393 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16400 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
#line 2091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 2091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = enhanced;
#line 2091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 16413 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_ = NULL;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_ = FALSE;
				gboolean _tmp8_ = FALSE;
				gboolean _tmp9_ = FALSE;
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = enhanced;
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = photo_table_set_enhanced (_tmp5_, &_tmp6_, _tmp7_);
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = _tmp8_;
#line 2092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = committed;
#line 2093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp9_) {
#line 16438 "Photo.c"
					PhotoRow* _tmp10_ = NULL;
					gboolean _tmp11_ = FALSE;
#line 2094 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = self->row;
#line 2094 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = enhanced;
#line 2094 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_->enhanced = _tmp11_;
#line 16447 "Photo.c"
				}
			}
		}
		__finally191:
		{
			PhotoRow* _tmp12_ = NULL;
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->row;
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16458 "Photo.c"
		}
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 16468 "Photo.c"
		}
	}
#line 2098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = committed;
#line 2098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_) {
#line 16475 "Photo.c"
		Alteration* _tmp14_ = NULL;
		Alteration* _tmp15_ = NULL;
#line 2099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "enhanced");
#line 2099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 2099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 16486 "Photo.c"
	}
}


static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 2102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 16496 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_ = NULL;
		PhotoID _tmp2_ = {0};
		const gchar* _tmp3_ = NULL;
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = backlinks;
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, _tmp3_, &_inner_error_);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 16518 "Photo.c"
				goto __catch192_database_error;
			}
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 16527 "Photo.c"
		}
		{
			PhotoRow* _tmp4_ = NULL;
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 16535 "Photo.c"
			{
				PhotoRow* _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				gchar* _tmp7_ = NULL;
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = self->row;
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = backlinks;
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp5_->backlinks);
#line 2109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_->backlinks = _tmp7_;
#line 16550 "Photo.c"
			}
			__finally193:
			{
				PhotoRow* _tmp8_ = NULL;
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->row;
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16559 "Photo.c"
			}
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 16565 "Photo.c"
					goto __catch192_database_error;
				}
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 16574 "Photo.c"
			}
		}
	}
	goto __finally192;
	__catch192_database_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = data_object_to_string ((DataObject*) self);
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = err;
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2112: Unable to update link state for %s: %s", _tmp10_, _tmp12_);
#line 2112 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 16604 "Photo.c"
	}
	__finally192:
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 16615 "Photo.c"
	}
}


static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id) {
	Photo * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2120 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 16628 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp13_ = FALSE;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 16636 "Photo.c"
		{
			gboolean committed = FALSE;
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_ = NULL;
			PhotoRow* _tmp3_ = NULL;
			PhotoID _tmp4_ = {0};
			EventID _tmp5_ = {0};
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = *event_id;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = _tmp7_;
#line 2124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = committed;
#line 2124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp8_) {
#line 16669 "Photo.c"
				PhotoRow* _tmp9_ = NULL;
				EventID _tmp10_ = {0};
#line 2125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->row;
#line 2125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = *event_id;
#line 2125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_->event_id = _tmp10_;
#line 16678 "Photo.c"
			}
#line 2127 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = committed;
#line 16682 "Photo.c"
			{
				PhotoRow* _tmp11_ = NULL;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->row;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16689 "Photo.c"
			}
#line 2127 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 16693 "Photo.c"
		}
		__finally194:
		{
			PhotoRow* _tmp12_ = NULL;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->row;
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 16702 "Photo.c"
		}
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2121 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp13_;
#line 16710 "Photo.c"
	}
}


static gchar* photo_real_to_string (DataObject* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	PhotoID _tmp10_ = {0};
	gint64 _tmp11_ = 0LL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	PhotoFileReader* _tmp14_ = NULL;
	PhotoFileReader* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
#line 2131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_is_master_baseline (self);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp1_) {
#line 16736 "Photo.c"
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = photo_get_actual_file (self);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = g_strconcat (" (", _tmp5_, NULL);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = g_strconcat (_tmp7_, ")", NULL);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 16768 "Photo.c"
	} else {
		gchar* _tmp9_ = NULL;
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = g_strdup ("");
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp9_;
#line 16777 "Photo.c"
	}
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id (self, &_tmp10_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_.id;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp11_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = photo_get_master_reader (self);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp15_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = g_strdup_printf ("[%s] %s%s", _tmp13_, _tmp17_, _tmp0_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp17_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp15_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp13_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp19_;
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2132 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 16811 "Photo.c"
}


static gboolean photo_real_equals (DataSource* base, DataSource* source) {
	Photo * self;
	gboolean result = FALSE;
	Photo* photo = NULL;
	DataSource* _tmp0_ = NULL;
	Photo* _tmp1_ = NULL;
	Photo* _tmp2_ = NULL;
	DataSource* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
#line 2136 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2138 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = source;
#line 2138 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_PHOTO) ? ((Photo*) _tmp0_) : NULL);
#line 2138 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp1_;
#line 2139 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo;
#line 2139 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 16836 "Photo.c"
		PhotoID photo_id = {0};
		PhotoID _tmp3_ = {0};
		PhotoID other_photo_id = {0};
		Photo* _tmp4_ = NULL;
		PhotoID _tmp5_ = {0};
		gboolean _tmp6_ = FALSE;
		Photo* _tmp7_ = NULL;
#line 2140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_photo_id (self, &_tmp3_);
#line 2140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_id = _tmp3_;
#line 2141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo;
#line 2141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_photo_id (_tmp4_, &_tmp5_);
#line 2141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		other_photo_id = _tmp5_;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = photo;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (self != _tmp7_) {
#line 16858 "Photo.c"
			PhotoID _tmp8_ = {0};
			gint64 _tmp9_ = 0LL;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = photo_id;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_.id;
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp9_ != PHOTO_ID_INVALID;
#line 16867 "Photo.c"
		} else {
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = FALSE;
#line 16871 "Photo.c"
		}
#line 2143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp6_) {
#line 16875 "Photo.c"
			PhotoID _tmp10_ = {0};
			gint64 _tmp11_ = 0LL;
			PhotoID _tmp12_ = {0};
			gint64 _tmp13_ = 0LL;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = photo_id;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = _tmp10_.id;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = other_photo_id;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = _tmp12_.id;
#line 2144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_assert (_tmp11_ != _tmp13_, "photo_id.id != other_photo_id.id");
#line 16890 "Photo.c"
		}
	}
#line 2148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = source;
#line 2148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = DATA_SOURCE_CLASS (photo_parent_class)->equals ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO_SOURCE, PhotoSource), _tmp14_);
#line 2148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp15_;
#line 2148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 2148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 16903 "Photo.c"
}


static void photo_file_exif_updated (Photo* self) {
	GFile* file = NULL;
	GFile* _tmp0_ = NULL;
	GFileInfo* info = NULL;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp7_ = NULL;
	GTimeVal _tmp8_ = {0};
	PhotoFileInterrogator* interrogator = NULL;
	PhotoFileInterrogator* _tmp9_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	DetectedPhotoInformation* _tmp14_ = NULL;
	DetectedPhotoInformation* _tmp15_ = NULL;
	gboolean success = FALSE;
	gboolean _tmp35_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_get_file ((MediaSource*) self);
#line 2153 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp0_;
#line 2155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	info = NULL;
#line 16930 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_ = NULL;
		GFileInfo* _tmp3_ = NULL;
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp2_;
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 16941 "Photo.c"
			goto __catch195_g_error;
		}
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp1_;
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 2157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		info = _tmp3_;
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 16954 "Photo.c"
	}
	goto __finally195;
	__catch195_g_error:
	{
		GError* err = NULL;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = data_object_to_string ((DataObject*) self);
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = err->message;
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_error ("Photo.vala:2160: Unable to read file information for %s: %s", _tmp5_, _tmp6_);
#line 2160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 16979 "Photo.c"
	}
	__finally195:
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 16994 "Photo.c"
	}
#line 2163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = info;
#line 2163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_info_get_modification_time (_tmp7_, &_tmp8_);
#line 2163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	timestamp = _tmp8_;
#line 2166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 2166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	interrogator = _tmp9_;
#line 17006 "Photo.c"
	{
#line 2168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 2168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17012 "Photo.c"
			goto __catch196_g_error;
		}
	}
	goto __finally196;
	__catch196_g_error:
	{
		GError* err = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		GError* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = g_file_get_path (file);
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = err;
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp12_->message;
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2170: Unable to interrogate photo file %s: %s", _tmp11_, _tmp13_);
#line 2170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp11_);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 17042 "Photo.c"
	}
	__finally196:
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 17059 "Photo.c"
	}
#line 2173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 2173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp14_;
#line 2174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = detected;
#line 2174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 17069 "Photo.c"
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
#line 2175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = data_object_to_string ((DataObject*) self);
#line 2175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("Photo.vala:2175: file_exif_updated: %s no longer an image", _tmp17_);
#line 2175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 2177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 17090 "Photo.c"
	}
	{
		PhotoRow* _tmp18_ = NULL;
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = self->row;
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17098 "Photo.c"
		{
			PhotoTable* _tmp19_ = NULL;
			PhotoTable* _tmp20_ = NULL;
			PhotoID _tmp21_ = {0};
			GFileInfo* _tmp22_ = NULL;
			gint64 _tmp23_ = 0LL;
			GTimeVal _tmp24_ = {0};
			glong _tmp25_ = 0L;
			DetectedPhotoInformation* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			DetectedPhotoInformation* _tmp28_ = NULL;
			const gchar* _tmp29_ = NULL;
			DetectedPhotoInformation* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			PhotoRow* _tmp32_ = NULL;
			gboolean _tmp33_ = FALSE;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = photo_table_get_instance ();
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_get_photo_id (self, &_tmp21_);
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = info;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = g_file_info_get_size (_tmp22_);
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = timestamp;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = _tmp24_.tv_sec;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = detected;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = _tmp26_->md5;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = detected;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp29_ = _tmp28_->exif_md5;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp30_ = detected;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp31_ = _tmp30_->thumbnail_md5;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_ = self->row;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = photo_table_master_exif_updated (_tmp20_, &_tmp21_, _tmp23_, _tmp25_, _tmp27_, _tmp29_, _tmp31_, _tmp32_);
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			success = _tmp33_;
#line 2182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp20_);
#line 17149 "Photo.c"
		}
		__finally197:
		{
			PhotoRow* _tmp34_ = NULL;
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = self->row;
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17158 "Photo.c"
		}
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 17176 "Photo.c"
		}
	}
#line 2186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = success;
#line 2186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp35_) {
#line 17183 "Photo.c"
		Alteration* _tmp36_ = NULL;
		Alteration* _tmp37_ = NULL;
#line 2187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 2187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = _tmp36_;
#line 2187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp37_);
#line 2187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp37_);
#line 17194 "Photo.c"
	}
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (info);
#line 2152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 17204 "Photo.c"
}


static guint64 photo_real_get_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 17214 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		guint64 _tmp5_ = 0ULL;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17222 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			gint64 _tmp2_ = 0LL;
#line 2194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 17232 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17239 "Photo.c"
			}
#line 2194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17243 "Photo.c"
		}
		__finally198:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17252 "Photo.c"
		}
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 17260 "Photo.c"
	}
}


static guint64 photo_real_get_master_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 17271 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		guint64 _tmp6_ = 0ULL;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17279 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			BackingPhotoRow* _tmp2_ = NULL;
			gint64 _tmp3_ = 0LL;
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->master;
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->filesize;
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = (guint64) _tmp3_;
#line 17292 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17299 "Photo.c"
			}
#line 2200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17303 "Photo.c"
		}
		__finally199:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17312 "Photo.c"
		}
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp6_;
#line 17320 "Photo.c"
	}
}


guint64 photo_get_editable_filesize (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 2204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 17330 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		guint64 _tmp5_ = 0ULL;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17338 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			gint64 _tmp2_ = 0LL;
#line 2206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 2206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->filesize;
#line 2206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 17348 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17355 "Photo.c"
			}
#line 2206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17359 "Photo.c"
		}
		__finally200:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17368 "Photo.c"
		}
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp5_;
#line 17376 "Photo.c"
	}
}


static time_t photo_real_get_exposure_time (Dateable* base) {
	Photo * self;
	time_t result = 0;
	time_t _tmp0_ = 0;
#line 2210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->cached_exposure_time;
#line 2211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 2211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 17393 "Photo.c"
}


static gchar* photo_real_get_basename (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 17403 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17410 "Photo.c"
		{
			const gchar* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
#line 2216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 2216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 2216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 17420 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17427 "Photo.c"
			}
#line 2216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17431 "Photo.c"
		}
		__finally201:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17440 "Photo.c"
		}
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 17448 "Photo.c"
	}
}


static gchar* photo_real_get_title (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 17459 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17466 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->title;
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 17479 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17486 "Photo.c"
			}
#line 2222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17490 "Photo.c"
		}
		__finally202:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17499 "Photo.c"
		}
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 17507 "Photo.c"
	}
}


static gchar* photo_real_get_comment (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 2226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 17518 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17525 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->comment;
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 17538 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17545 "Photo.c"
			}
#line 2228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 17549 "Photo.c"
		}
		__finally203:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17558 "Photo.c"
		}
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 17566 "Photo.c"
	}
}


static void photo_real_set_title (MediaSource* base, const gchar* title) {
	Photo * self;
	gchar* new_title = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean committed = FALSE;
	gboolean _tmp18_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = title;
#line 2233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = media_source_prep_title (_tmp0_);
#line 2233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	new_title = _tmp1_;
#line 2235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 17589 "Photo.c"
	{
		PhotoRow* _tmp2_ = NULL;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->row;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17596 "Photo.c"
		{
			const gchar* _tmp3_ = NULL;
			PhotoRow* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
			PhotoTable* _tmp7_ = NULL;
			PhotoTable* _tmp8_ = NULL;
			PhotoRow* _tmp9_ = NULL;
			PhotoID _tmp10_ = {0};
			const gchar* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
#line 2237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = new_title;
#line 2237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _tmp4_->title;
#line 2237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 17616 "Photo.c"
				{
					PhotoRow* _tmp6_ = NULL;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->row;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17623 "Photo.c"
				}
#line 2238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (new_title);
#line 2238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 17629 "Photo.c"
			}
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = photo_table_get_instance ();
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_->photo_id;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = new_title;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = photo_table_set_title (_tmp8_, &_tmp10_, _tmp11_);
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = _tmp12_;
#line 2240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp8_);
#line 2241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = committed;
#line 2241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp13_) {
#line 17651 "Photo.c"
				PhotoRow* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = self->row;
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = new_title;
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp14_->title);
#line 2242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_->title = _tmp16_;
#line 17665 "Photo.c"
			}
		}
		__finally204:
		{
			PhotoRow* _tmp17_ = NULL;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->row;
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17675 "Photo.c"
		}
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (new_title);
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 17687 "Photo.c"
		}
	}
#line 2245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = committed;
#line 2245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp18_) {
#line 17694 "Photo.c"
		Alteration* _tmp19_ = NULL;
		Alteration* _tmp20_ = NULL;
#line 2246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = alteration_new ("metadata", "name");
#line 2246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 2246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp20_);
#line 2246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 17705 "Photo.c"
	}
#line 2232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (new_title);
#line 17709 "Photo.c"
}


static gboolean photo_real_set_comment (MediaSource* base, const gchar* comment) {
	Photo * self;
	gboolean result = FALSE;
	gchar* new_comment = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gboolean committed = FALSE;
	gboolean _tmp19_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = comment;
#line 2250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = media_source_prep_comment (_tmp0_);
#line 2250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	new_comment = _tmp1_;
#line 2252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 17732 "Photo.c"
	{
		PhotoRow* _tmp2_ = NULL;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->row;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17739 "Photo.c"
		{
			const gchar* _tmp3_ = NULL;
			PhotoRow* _tmp4_ = NULL;
			const gchar* _tmp5_ = NULL;
			PhotoTable* _tmp7_ = NULL;
			PhotoTable* _tmp8_ = NULL;
			PhotoRow* _tmp9_ = NULL;
			PhotoID _tmp10_ = {0};
			const gchar* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
#line 2254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = new_comment;
#line 2254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _tmp4_->comment;
#line 2254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 2255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = TRUE;
#line 17761 "Photo.c"
				{
					PhotoRow* _tmp6_ = NULL;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->row;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17768 "Photo.c"
				}
#line 2255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (new_comment);
#line 2255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 17774 "Photo.c"
			}
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = photo_table_get_instance ();
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_->photo_id;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = new_comment;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = photo_table_set_comment (_tmp8_, &_tmp10_, _tmp11_);
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = _tmp12_;
#line 2257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp8_);
#line 2258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = committed;
#line 2258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp13_) {
#line 17796 "Photo.c"
				PhotoRow* _tmp14_ = NULL;
				const gchar* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = self->row;
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = new_comment;
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = g_strdup (_tmp15_);
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp14_->comment);
#line 2259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_->comment = _tmp16_;
#line 17810 "Photo.c"
			}
		}
		__finally205:
		{
			PhotoRow* _tmp17_ = NULL;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->row;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17820 "Photo.c"
		}
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17824 "Photo.c"
			gboolean _tmp18_ = FALSE;
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (new_comment);
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp18_;
#line 17834 "Photo.c"
		}
	}
#line 2262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = committed;
#line 2262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp19_) {
#line 17841 "Photo.c"
		Alteration* _tmp20_ = NULL;
		Alteration* _tmp21_ = NULL;
#line 2263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = alteration_new ("metadata", "comment");
#line 2263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp21_);
#line 2263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp21_);
#line 17852 "Photo.c"
	}
#line 2265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = committed;
#line 2265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (new_comment);
#line 2265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 17860 "Photo.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 17867 "Photo.c"
}


void photo_set_import_id (Photo* self, ImportID* import_id) {
	GError* dberr = NULL;
	GError* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
#line 2268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 2269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dberr = NULL;
#line 17881 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 17888 "Photo.c"
		{
			{
				PhotoTable* _tmp1_ = NULL;
				PhotoTable* _tmp2_ = NULL;
				PhotoRow* _tmp3_ = NULL;
				PhotoID _tmp4_ = {0};
				ImportID _tmp5_ = {0};
				PhotoRow* _tmp7_ = NULL;
				ImportID _tmp8_ = {0};
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->photo_id;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = *import_id;
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 17916 "Photo.c"
						goto __catch207_database_error;
					}
					{
						PhotoRow* _tmp6_ = NULL;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp6_ = self->row;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17925 "Photo.c"
					}
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_error_free0 (dberr);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 2272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 17935 "Photo.c"
				}
#line 2273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = self->row;
#line 2273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = *import_id;
#line 2273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_->import_id = _tmp8_;
#line 17943 "Photo.c"
			}
			goto __finally207;
			__catch207_database_error:
			{
				GError* err = NULL;
				GError* _tmp9_ = NULL;
				GError* _tmp10_ = NULL;
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				err = _inner_error_;
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = err;
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _g_error_copy0 (_tmp9_);
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				dberr = _tmp10_;
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 17965 "Photo.c"
			}
			__finally207:
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 17970 "Photo.c"
				{
					PhotoRow* _tmp11_ = NULL;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = self->row;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17977 "Photo.c"
				}
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (dberr);
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 17987 "Photo.c"
			}
		}
		__finally206:
		{
			PhotoRow* _tmp12_ = NULL;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->row;
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 17997 "Photo.c"
		}
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (dberr);
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 18009 "Photo.c"
		}
	}
#line 2279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = dberr;
#line 2279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_ == NULL) {
#line 18016 "Photo.c"
		Alteration* _tmp14_ = NULL;
		Alteration* _tmp15_ = NULL;
#line 2280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = alteration_new ("metadata", "import-id");
#line 2280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp15_);
#line 2280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 18027 "Photo.c"
	} else {
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_ = NULL;
		GError* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = data_object_to_string ((DataObject*) self);
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = dberr;
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp18_->message;
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2282: Unable to write import ID for %s: %s", _tmp17_, _tmp19_);
#line 2282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 18045 "Photo.c"
	}
#line 2268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_error_free0 (dberr);
#line 18049 "Photo.c"
}


void photo_set_title_persistent (Photo* self, const gchar* title, GError** error) {
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp12_ = NULL;
	PhotoFileMetadataWriter* _tmp13_ = NULL;
	PhotoFileReader* _tmp14_ = NULL;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_ = NULL;
	const gchar* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
#line 2285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source = _tmp0_;
#line 2289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = source;
#line 2289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_);
#line 2289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp3_) {
#line 18086 "Photo.c"
		PhotoFileReader* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = source;
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp4_);
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2290: No photo file writer available for %s", _tmp6_);
#line 2290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = title;
#line 2292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_set_title ((MediaSource*) self, _tmp7_);
#line 2294 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2294 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18109 "Photo.c"
	}
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = source;
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp9_;
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18125 "Photo.c"
	}
#line 2298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = metadata;
#line 2298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = title;
#line 2298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_metadata_set_title (_tmp10_, _tmp11_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = source;
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = photo_file_reader_create_metadata_writer (_tmp12_, &_inner_error_);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp13_;
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18149 "Photo.c"
	}
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = source;
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp14_);
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_monitor_blacklist_file (_tmp16_, "Photo.set_persistent_title");
#line 2301 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp16_);
#line 18161 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp17_ = NULL;
		PhotoMetadata* _tmp18_ = NULL;
#line 2303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = writer;
#line 2303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = metadata;
#line 2303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp17_, _tmp18_, &_inner_error_);
#line 2303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18173 "Photo.c"
			goto __finally208;
		}
	}
	__finally208:
	{
		PhotoFileReader* _tmp19_ = NULL;
		GFile* _tmp20_ = NULL;
		GFile* _tmp21_ = NULL;
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = source;
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp19_);
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp21_);
#line 2305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 18192 "Photo.c"
	}
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18206 "Photo.c"
	}
#line 2308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = title;
#line 2308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_set_title ((MediaSource*) self, _tmp22_);
#line 2310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18220 "Photo.c"
}


void photo_set_comment_persistent (Photo* self, const gchar* comment, GError** error) {
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp12_ = NULL;
	PhotoFileMetadataWriter* _tmp13_ = NULL;
	PhotoFileReader* _tmp14_ = NULL;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_ = NULL;
	const gchar* _tmp22_ = NULL;
	GError * _inner_error_ = NULL;
#line 2313 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2314 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2314 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source = _tmp0_;
#line 2317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = source;
#line 2317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_);
#line 2317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp3_) {
#line 18257 "Photo.c"
		PhotoFileReader* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = source;
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp4_);
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2318: No photo file writer available for %s", _tmp6_);
#line 2318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = comment;
#line 2320 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_set_comment ((MediaSource*) self, _tmp7_);
#line 2322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18280 "Photo.c"
	}
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = source;
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp9_;
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18296 "Photo.c"
	}
#line 2326 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = metadata;
#line 2326 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = comment;
#line 2326 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_metadata_set_comment (_tmp10_, _tmp11_);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = source;
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = photo_file_reader_create_metadata_writer (_tmp12_, &_inner_error_);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp13_;
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18320 "Photo.c"
	}
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = source;
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp14_);
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_monitor_blacklist_file (_tmp16_, "Photo.set_persistent_comment");
#line 2329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp16_);
#line 18332 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp17_ = NULL;
		PhotoMetadata* _tmp18_ = NULL;
#line 2331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = writer;
#line 2331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = metadata;
#line 2331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp17_, _tmp18_, &_inner_error_);
#line 2331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18344 "Photo.c"
			goto __finally209;
		}
	}
	__finally209:
	{
		PhotoFileReader* _tmp19_ = NULL;
		GFile* _tmp20_ = NULL;
		GFile* _tmp21_ = NULL;
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = source;
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp19_);
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp21_);
#line 2333 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 18363 "Photo.c"
	}
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18377 "Photo.c"
	}
#line 2336 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = comment;
#line 2336 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_set_comment ((MediaSource*) self, _tmp22_);
#line 2338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2313 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2313 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2313 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18391 "Photo.c"
}


static void photo_real_set_exposure_time (Dateable* base, time_t time) {
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp12_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 18402 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18409 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_ = NULL;
			PhotoRow* _tmp3_ = NULL;
			PhotoID _tmp4_ = {0};
			time_t _tmp5_ = 0;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_ = FALSE;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = time;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = photo_table_set_exposure_time (_tmp2_, &_tmp4_, _tmp5_);
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = _tmp6_;
#line 2344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = committed;
#line 2345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp7_) {
#line 18438 "Photo.c"
				PhotoRow* _tmp8_ = NULL;
				time_t _tmp9_ = 0;
				time_t _tmp10_ = 0;
#line 2346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->row;
#line 2346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = time;
#line 2346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_->exposure_time = _tmp9_;
#line 2347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = time;
#line 2347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->cached_exposure_time = _tmp10_;
#line 18452 "Photo.c"
			}
		}
		__finally210:
		{
			PhotoRow* _tmp11_ = NULL;
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->row;
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18462 "Photo.c"
		}
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 18472 "Photo.c"
		}
	}
#line 2351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = committed;
#line 2351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_) {
#line 18479 "Photo.c"
		Alteration* _tmp13_ = NULL;
		Alteration* _tmp14_ = NULL;
#line 2352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "exposure-time");
#line 2352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp14_);
#line 2352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 18490 "Photo.c"
	}
}


void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error) {
	PhotoFileReader* source = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp8_ = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	time_t _tmp11_ = 0;
	MetadataDateTime* _tmp12_ = NULL;
	MetadataDateTime* _tmp13_ = NULL;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp14_ = NULL;
	PhotoFileMetadataWriter* _tmp15_ = NULL;
	PhotoFileReader* _tmp16_ = NULL;
	GFile* _tmp17_ = NULL;
	GFile* _tmp18_ = NULL;
	time_t _tmp24_ = 0;
	GError * _inner_error_ = NULL;
#line 2355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 2356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source = _tmp0_;
#line 2359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = source;
#line 2359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_);
#line 2359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp3_) {
#line 18530 "Photo.c"
		PhotoFileReader* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		time_t _tmp7_ = 0;
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = source;
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp4_);
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2360: No photo file writer available for %s", _tmp6_);
#line 2360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 2362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = time;
#line 2362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dateable_set_exposure_time ((Dateable*) self, _tmp7_);
#line 2364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18553 "Photo.c"
	}
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = source;
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp9_;
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18569 "Photo.c"
	}
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = metadata;
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = time;
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = metadata_date_time_new (_tmp11_);
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp10_, _tmp13_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_metadata_date_time_unref0 (_tmp13_);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = source;
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = photo_file_reader_create_metadata_writer (_tmp14_, &_inner_error_);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp15_;
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18599 "Photo.c"
	}
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = source;
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp16_);
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_monitor_blacklist_file (_tmp18_, "Photo.set_exposure_time_persistent");
#line 2371 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp18_);
#line 18611 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp19_ = NULL;
		PhotoMetadata* _tmp20_ = NULL;
#line 2373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = writer;
#line 2373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = metadata;
#line 2373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp19_, _tmp20_, &_inner_error_);
#line 2373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 18623 "Photo.c"
			goto __finally211;
		}
	}
	__finally211:
	{
		PhotoFileReader* _tmp21_ = NULL;
		GFile* _tmp22_ = NULL;
		GFile* _tmp23_ = NULL;
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = source;
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp21_);
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp23_);
#line 2375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp23_);
#line 18642 "Photo.c"
	}
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 2372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 18656 "Photo.c"
	}
#line 2378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = time;
#line 2378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dateable_set_exposure_time ((Dateable*) self, _tmp24_);
#line 2380 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_exif_updated (self);
#line 2355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 18670 "Photo.c"
}


/**
     * @brief Returns the width and height of the Photo after various
     * arbitrary stages of the pipeline have been applied in
     * the same order they're applied in get_pixbuf_with_options.
     * With no argument passed, it works exactly like the
     * previous incarnation did.
     *
     * @param disallowed_steps Which pipeline steps should NOT
     *      be taken into account when computing image dimensions
     *      (matching the convention set by get_pixbuf_with_options ()).
     *      Pipeline steps that do not affect the image geometry are
     *      ignored.
     */
static void photo_real_get_dimensions (MediaSource* base, PhotoException disallowed_steps, Dimensions* result) {
	Photo * self;
	Dimensions returned_dims = {0};
	Dimensions _tmp0_ = {0};
	PhotoException _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	PhotoException _tmp10_ = 0;
	gboolean _tmp11_ = FALSE;
	PhotoException _tmp22_ = 0;
	gboolean _tmp23_ = FALSE;
#line 2396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 2398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2398 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	returned_dims = _tmp0_;
#line 2401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = disallowed_steps;
#line 2401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_exception_allows (_tmp1_, PHOTO_EXCEPTION_ORIENTATION);
#line 2401 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 18709 "Photo.c"
		Orientation ori_tmp = 0;
		Orientation _tmp3_ = 0;
		Orientation _tmp4_ = 0;
#line 2402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_get_orientation (self);
#line 2402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		ori_tmp = _tmp3_;
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = ori_tmp;
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		switch (_tmp4_) {
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			case ORIENTATION_LEFT_TOP:
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			case ORIENTATION_RIGHT_TOP:
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			case ORIENTATION_LEFT_BOTTOM:
#line 2405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			case ORIENTATION_RIGHT_BOTTOM:
#line 18729 "Photo.c"
			{
				gint width_tmp = 0;
				Dimensions _tmp5_ = {0};
				gint _tmp6_ = 0;
				Dimensions _tmp7_ = {0};
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
#line 2411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = returned_dims;
#line 2411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = _tmp5_.width;
#line 2411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				width_tmp = _tmp6_;
#line 2413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = returned_dims;
#line 2413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_.height;
#line 2413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				returned_dims.width = _tmp8_;
#line 2414 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = width_tmp;
#line 2414 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				returned_dims.height = _tmp9_;
#line 2415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 18755 "Photo.c"
			}
			default:
			{
#line 2419 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 18761 "Photo.c"
			}
		}
	}
#line 2424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = disallowed_steps;
#line 2424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_exception_allows (_tmp10_, PHOTO_EXCEPTION_STRAIGHTEN);
#line 2424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_) {
#line 18771 "Photo.c"
		gdouble x_size = 0.0;
		gdouble y_size = 0.0;
		gdouble angle = 0.0;
		gdouble _tmp12_ = 0.0;
		Dimensions _tmp13_ = {0};
		gint _tmp14_ = 0;
		Dimensions _tmp15_ = {0};
		gint _tmp16_ = 0;
		gdouble _tmp17_ = 0.0;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_ = 0.0;
		gdouble _tmp20_ = 0.0;
		gdouble _tmp21_ = 0.0;
#line 2426 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		angle = 0.0;
#line 2428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_straighten (self, &_tmp12_);
#line 2428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		angle = _tmp12_;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = returned_dims;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _tmp13_.width;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = returned_dims;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = _tmp15_.height;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = angle;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		compute_arb_rotated_size ((gdouble) _tmp14_, (gdouble) _tmp16_, _tmp17_, &_tmp18_, &_tmp19_);
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		x_size = _tmp18_;
#line 2430 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		y_size = _tmp19_;
#line 2432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = x_size;
#line 2432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		returned_dims.width = (gint) _tmp20_;
#line 2433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = y_size;
#line 2433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		returned_dims.height = (gint) _tmp21_;
#line 18815 "Photo.c"
	}
#line 2437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = disallowed_steps;
#line 2437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = photo_exception_allows (_tmp22_, PHOTO_EXCEPTION_CROP);
#line 2437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp23_) {
#line 18823 "Photo.c"
		Box crop = {0};
		PhotoException _tmp24_ = 0;
		Box _tmp25_ = {0};
		gboolean _tmp26_ = FALSE;
#line 2439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = disallowed_steps;
#line 2439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = photo_get_crop (self, &_tmp25_, _tmp24_);
#line 2439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		crop = _tmp25_;
#line 2439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp26_) {
#line 18836 "Photo.c"
			Dimensions _tmp27_ = {0};
#line 2440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp27_);
#line 2440 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			returned_dims = _tmp27_;
#line 18842 "Photo.c"
		}
	}
#line 2443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = returned_dims;
#line 2443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 18849 "Photo.c"
}


static void photo_locked_create_adjustments_from_data (Photo* self) {
	PixelTransformationBundle* _tmp0_ = NULL;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp1_ = NULL;
	KeyValueMap* _tmp2_ = NULL;
	PixelTransformationBundle* _tmp6_ = NULL;
	PixelTransformer* _tmp7_ = NULL;
#line 2447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 2450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp1_;
#line 2451 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = map;
#line 2451 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 18876 "Photo.c"
		PixelTransformationBundle* _tmp3_ = NULL;
#line 2452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 2452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 18882 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_ = NULL;
		KeyValueMap* _tmp5_ = NULL;
#line 2454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 2454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = map;
#line 2454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 18892 "Photo.c"
	}
#line 2456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 2456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 2447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 18904 "Photo.c"
}


PixelTransformationBundle* photo_get_color_adjustments (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GError * _inner_error_ = NULL;
#line 2460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18913 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 18920 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_ = NULL;
			PixelTransformationBundle* _tmp2_ = NULL;
			PixelTransformationBundle* _tmp3_ = NULL;
#line 2462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 2462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 18931 "Photo.c"
			}
#line 2465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 2465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 2465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 18939 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18946 "Photo.c"
			}
#line 2465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 18950 "Photo.c"
		}
		__finally212:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 18959 "Photo.c"
		}
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 18967 "Photo.c"
	}
}


static PixelTransformationBundle* photo_locked_original_color_adjustments (Photo* self) {
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* original_adjustments = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	KeyValueMap* map = NULL;
	PhotoRow* _tmp1_ = NULL;
	GeeHashMap* _tmp2_ = NULL;
	KeyValueMap* _tmp10_ = NULL;
#line 2470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 2471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	original_adjustments = _tmp0_;
#line 2474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->row;
#line 2474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_->original_transforms;
#line 2474 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 18992 "Photo.c"
		PhotoRow* _tmp3_ = NULL;
		GeeHashMap* _tmp4_ = NULL;
		gpointer _tmp5_ = NULL;
		KeyValueMap* _tmp6_ = NULL;
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = self->row;
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_->original_transforms;
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, "adjustments");
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		map = (KeyValueMap*) _tmp5_;
#line 2476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = map;
#line 2476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 19011 "Photo.c"
			KeyValueMap* _tmp7_ = NULL;
			KeyValueMap* _tmp8_ = NULL;
#line 2477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = map;
#line 2477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = key_value_map_copy (_tmp7_);
#line 2477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2477 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			map = _tmp8_;
#line 19022 "Photo.c"
		}
	} else {
		KeyValueMap* _tmp9_ = NULL;
#line 2479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = key_value_map_new ("adjustments");
#line 2479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		map = _tmp9_;
#line 19032 "Photo.c"
	}
#line 2481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = map;
#line 2481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 19038 "Photo.c"
		PixelTransformationBundle* _tmp11_ = NULL;
#line 2482 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = original_adjustments;
#line 2482 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp11_);
#line 19044 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp12_ = NULL;
		KeyValueMap* _tmp13_ = NULL;
#line 2484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = original_adjustments;
#line 2484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = map;
#line 2484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp12_, _tmp13_);
#line 19054 "Photo.c"
	}
#line 2486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = original_adjustments;
#line 2486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19062 "Photo.c"
}


static KeyValueMap* photo_get_color_adjustments_map (Photo* self) {
	KeyValueMap* result = NULL;
	GError * _inner_error_ = NULL;
#line 2491 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19071 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19078 "Photo.c"
		{
			KeyValueMap* map = NULL;
			KeyValueMap* _tmp1_ = NULL;
			KeyValueMap* _tmp2_ = NULL;
#line 2493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_get_transformation (self, "adjustments");
#line 2493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			map = _tmp1_;
#line 2494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = map;
#line 2494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 19091 "Photo.c"
				KeyValueMap* _tmp3_ = NULL;
#line 2495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = key_value_map_new ("adjustments");
#line 2495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				map = _tmp3_;
#line 19099 "Photo.c"
			}
#line 2496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = map;
#line 19103 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19110 "Photo.c"
			}
#line 2496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 19114 "Photo.c"
		}
		__finally213:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19123 "Photo.c"
		}
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 19131 "Photo.c"
	}
}


PixelTransformer* photo_get_pixel_transformer (Photo* self) {
	PixelTransformer* result = NULL;
	GError * _inner_error_ = NULL;
#line 2500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19141 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19148 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_ = NULL;
			PixelTransformer* _tmp3_ = NULL;
#line 2502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 2502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 2503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 19159 "Photo.c"
			}
#line 2505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 2505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp3_;
#line 19167 "Photo.c"
			{
				PhotoRow* _tmp4_ = NULL;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19174 "Photo.c"
			}
#line 2505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 19178 "Photo.c"
		}
		__finally214:
		{
			PhotoRow* _tmp5_ = NULL;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19187 "Photo.c"
		}
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 19195 "Photo.c"
	}
}


gboolean photo_has_color_adjustments (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "adjustments");
#line 2510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 2510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19211 "Photo.c"
}


PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type) {
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_ = NULL;
	PixelTransformationType _tmp2_ = 0;
	PixelTransformation* _tmp3_ = NULL;
	PixelTransformation* _tmp4_ = NULL;
#line 2513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = type;
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = pixel_transformation_bundle_get_transformation (_tmp1_, _tmp2_);
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 2514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19240 "Photo.c"
}


void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments) {
	PixelTransformationBundle* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	KeyValueMap* map = NULL;
	PixelTransformationBundle* _tmp8_ = NULL;
	KeyValueMap* _tmp9_ = NULL;
	gboolean committed = FALSE;
	gboolean _tmp39_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (new_adjustments != NULL);
#line 2520 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_set_enhanced (self, FALSE);
#line 2521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = new_adjustments;
#line 2521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = pixel_transformation_bundle_is_identity (_tmp0_);
#line 2521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 19265 "Photo.c"
		gboolean _result_ = FALSE;
		gboolean _tmp5_ = FALSE;
		{
			PhotoRow* _tmp2_ = NULL;
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 19274 "Photo.c"
			{
				gboolean _tmp3_ = FALSE;
#line 2524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = photo_remove_transformation (self, "adjustments");
#line 2524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_result_ = _tmp3_;
#line 2525 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2525 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->adjustments = NULL;
#line 2526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->transformer = NULL;
#line 19289 "Photo.c"
			}
			__finally215:
			{
				PhotoRow* _tmp4_ = NULL;
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19298 "Photo.c"
			}
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 19308 "Photo.c"
			}
		}
#line 2529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _result_;
#line 2529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp5_) {
#line 19315 "Photo.c"
			Alteration* _tmp6_ = NULL;
			Alteration* _tmp7_ = NULL;
#line 2530 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = alteration_new ("image", "color-adjustments");
#line 2530 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 2530 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			data_object_notify_altered ((DataObject*) self, _tmp7_);
#line 2530 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_alteration_unref0 (_tmp7_);
#line 19326 "Photo.c"
		}
#line 2532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 19330 "Photo.c"
	}
#line 2536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = new_adjustments;
#line 2536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = pixel_transformation_bundle_save (_tmp8_, "adjustments");
#line 2536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp9_;
#line 19338 "Photo.c"
	{
		PhotoRow* _tmp10_ = NULL;
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = self->row;
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 19345 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
			PixelTransformer* _tmp12_ = NULL;
			KeyValueMap* _tmp36_ = NULL;
			gboolean _tmp37_ = FALSE;
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->priv->transformer;
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp12_ == NULL) {
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = TRUE;
#line 19357 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp13_ = NULL;
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = self->priv->adjustments;
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tmp13_ == NULL;
#line 19364 "Photo.c"
			}
#line 2540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp11_) {
#line 19368 "Photo.c"
				PixelTransformationBundle* _tmp14_ = NULL;
				PixelTransformationBundle* _tmp15_ = NULL;
				PixelTransformationBundle* _tmp16_ = NULL;
				PixelTransformer* _tmp17_ = NULL;
#line 2542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = new_adjustments;
#line 2542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = pixel_transformation_bundle_copy (_tmp14_);
#line 2542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->adjustments = _tmp15_;
#line 2543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = new_adjustments;
#line 2543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = pixel_transformation_bundle_generate_transformer (_tmp16_);
#line 2543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2543 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->transformer = _tmp17_;
#line 19389 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp34_ = NULL;
				PixelTransformationBundle* _tmp35_ = NULL;
				{
					GeeIterator* _transformation_it = NULL;
					PixelTransformationBundle* _tmp18_ = NULL;
					GeeIterable* _tmp19_ = NULL;
					GeeIterable* _tmp20_ = NULL;
					GeeIterator* _tmp21_ = NULL;
					GeeIterator* _tmp22_ = NULL;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = new_adjustments;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = pixel_transformation_bundle_get_transformations (_tmp18_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = _tmp19_;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp21_ = gee_iterable_iterator (_tmp20_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp20_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_transformation_it = _tmp22_;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 19416 "Photo.c"
						GeeIterator* _tmp23_ = NULL;
						gboolean _tmp24_ = FALSE;
						PixelTransformation* transformation = NULL;
						GeeIterator* _tmp25_ = NULL;
						gpointer _tmp26_ = NULL;
						PixelTransformer* _tmp27_ = NULL;
						PixelTransformationBundle* _tmp28_ = NULL;
						PixelTransformation* _tmp29_ = NULL;
						PixelTransformationType _tmp30_ = 0;
						PixelTransformation* _tmp31_ = NULL;
						PixelTransformation* _tmp32_ = NULL;
						PixelTransformation* _tmp33_ = NULL;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp23_ = _transformation_it;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp24_ = gee_iterator_next (_tmp23_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!_tmp24_) {
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 19437 "Photo.c"
						}
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp25_ = _transformation_it;
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp26_ = gee_iterator_get (_tmp25_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						transformation = (PixelTransformation*) _tmp26_;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp27_ = self->priv->transformer;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp28_ = self->priv->adjustments;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp29_ = transformation;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp30_ = pixel_transformation_get_transformation_type (_tmp29_);
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp31_ = pixel_transformation_bundle_get_transformation (_tmp28_, _tmp30_);
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp32_ = _tmp31_;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp33_ = transformation;
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp27_, _tmp32_, _tmp33_);
#line 2547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_pixel_transformation_unref0 (_tmp32_);
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 19465 "Photo.c"
					}
#line 2546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 19469 "Photo.c"
				}
#line 2552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = new_adjustments;
#line 2552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = pixel_transformation_bundle_copy (_tmp34_);
#line 2552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->adjustments = _tmp35_;
#line 19479 "Photo.c"
			}
#line 2555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = map;
#line 2555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = photo_set_transformation (self, _tmp36_);
#line 2555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = _tmp37_;
#line 19487 "Photo.c"
		}
		__finally216:
		{
			PhotoRow* _tmp38_ = NULL;
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp38_ = self->row;
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 19496 "Photo.c"
		}
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 19508 "Photo.c"
		}
	}
#line 2558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = committed;
#line 2558 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp39_) {
#line 19515 "Photo.c"
		Alteration* _tmp40_ = NULL;
		Alteration* _tmp41_ = NULL;
#line 2559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = alteration_new ("image", "color-adjustments");
#line 2559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = _tmp40_;
#line 2559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp41_);
#line 2559 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp41_);
#line 19526 "Photo.c"
	}
#line 2517 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 19530 "Photo.c"
}


static PhotoMetadata* photo_real_get_metadata (PhotoSource* base) {
	Photo * self;
	PhotoMetadata* result = NULL;
	GError * _inner_error_ = NULL;
#line 2563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 19540 "Photo.c"
	{
		PhotoMetadata* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_ = NULL;
		PhotoFileReader* _tmp2_ = NULL;
		PhotoMetadata* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_ = NULL;
		PhotoMetadata* _tmp5_ = NULL;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = photo_get_source_reader (self);
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error_);
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp2_);
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 19562 "Photo.c"
			goto __catch217_g_error;
		}
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp0_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp5_;
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (_tmp0_);
#line 2565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 19575 "Photo.c"
	}
	goto __finally217;
	__catch217_g_error:
	{
		GError* err = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 2567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = err;
#line 2567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 2567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:2567: Unable to load metadata: %s", _tmp7_);
#line 2569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 2569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 2569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 19599 "Photo.c"
	}
	__finally217:
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_clear_error (&_inner_error_);
#line 2564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 19608 "Photo.c"
}


PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
	PhotoMetadata* _tmp4_ = NULL;
	PhotoMetadata* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 2573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_master_reader (self);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_reader_read_metadata (_tmp2_, &_inner_error_);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp2_);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp4_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 19641 "Photo.c"
	}
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp0_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp5_;
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (_tmp0_);
#line 2574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19653 "Photo.c"
}


PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
#line 2577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2578 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2578 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp0_;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reader;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 19674 "Photo.c"
		PhotoFileReader* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_ = NULL;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = reader;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 19695 "Photo.c"
		}
	} else {
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = NULL;
#line 19702 "Photo.c"
	}
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19710 "Photo.c"
}


gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error) {
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* master_reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileMetadataWriter* _tmp4_ = NULL;
	PhotoFileReader* _tmp5_ = NULL;
	PhotoFileMetadataWriter* _tmp6_ = NULL;
	PhotoFileMetadataWriter* _tmp8_ = NULL;
	PhotoFileMetadataWriter* _tmp9_ = NULL;
	PhotoMetadata* _tmp10_ = NULL;
	gboolean _tmp12_ = FALSE;
	PhotoReimportMasterState* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
	PhotoReimportMasterState* _tmp16_ = NULL;
	GError * _inner_error_ = NULL;
#line 2586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = NULL;
#line 2590 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 2590 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	master_reader = _tmp0_;
#line 2592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = master_reader;
#line 2592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp1_);
#line 2592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 2592 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp3_) {
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 19761 "Photo.c"
		} else {
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 19765 "Photo.c"
		}
#line 2593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 19769 "Photo.c"
	}
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = master_reader;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_file_reader_create_metadata_writer (_tmp5_, &_inner_error_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp6_;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 19779 "Photo.c"
		gboolean _tmp7_ = FALSE;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp7_;
#line 19787 "Photo.c"
	}
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp4_;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = NULL;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = metadata;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp9_, _tmp10_, &_inner_error_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp9_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 19803 "Photo.c"
		gboolean _tmp11_ = FALSE;
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp4_);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2595 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp11_;
#line 19813 "Photo.c"
	}
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = photo_prepare_for_reimport_master (self, &_tmp13_, &_inner_error_);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = _tmp13_;
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _tmp14_;
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 19825 "Photo.c"
		gboolean _tmp15_ = FALSE;
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp4_);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp15_;
#line 19835 "Photo.c"
	}
#line 2597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp12_) {
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp4_);
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 19849 "Photo.c"
		} else {
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 19853 "Photo.c"
		}
#line 2598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 19857 "Photo.c"
	}
#line 2600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = _vala_state;
#line 2600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl)->metadata_only = TRUE;
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp4_);
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 19873 "Photo.c"
	} else {
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 19877 "Photo.c"
	}
#line 2602 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 19881 "Photo.c"
}


void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterState* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 2605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = state;
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_finish_reimport_master (self, _tmp0_, &_inner_error_);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 19904 "Photo.c"
		} else {
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 19912 "Photo.c"
		}
	}
}


gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* editable_reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	PhotoFileMetadataWriter* _tmp5_ = NULL;
	PhotoFileReader* _tmp6_ = NULL;
	PhotoFileMetadataWriter* _tmp7_ = NULL;
	PhotoFileMetadataWriter* _tmp9_ = NULL;
	PhotoFileMetadataWriter* _tmp10_ = NULL;
	PhotoMetadata* _tmp11_ = NULL;
	gboolean _tmp13_ = FALSE;
	PhotoReimportEditableState* _tmp14_ = NULL;
	gboolean _tmp15_ = FALSE;
	PhotoReimportEditableState* _tmp17_ = NULL;
	GError * _inner_error_ = NULL;
#line 2609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (metadata != NULL, FALSE);
#line 2611 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2611 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = NULL;
#line 2613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 2613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_reader = _tmp0_;
#line 2614 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = editable_reader;
#line 2614 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 19962 "Photo.c"
		} else {
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 19966 "Photo.c"
		}
#line 2615 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 19970 "Photo.c"
	}
#line 2617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = editable_reader;
#line 2617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp2_);
#line 2617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_file_format_can_write_metadata (_tmp3_);
#line 2617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp4_) {
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 19988 "Photo.c"
		} else {
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 19992 "Photo.c"
		}
#line 2618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 19996 "Photo.c"
	}
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = editable_reader;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = photo_file_reader_create_metadata_writer (_tmp6_, &_inner_error_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp7_;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20006 "Photo.c"
		gboolean _tmp8_ = FALSE;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp8_;
#line 20014 "Photo.c"
	}
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp5_;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = NULL;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = metadata;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp10_, _tmp11_, &_inner_error_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp10_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20030 "Photo.c"
		gboolean _tmp12_ = FALSE;
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp5_);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp12_;
#line 20040 "Photo.c"
	}
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = photo_prepare_for_reimport_editable (self, &_tmp14_, &_inner_error_);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = _tmp14_;
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp15_;
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20052 "Photo.c"
		gboolean _tmp16_ = FALSE;
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp5_);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp16_;
#line 20062 "Photo.c"
	}
#line 2622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp13_) {
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp5_);
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 20076 "Photo.c"
		} else {
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 20080 "Photo.c"
		}
#line 2623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20084 "Photo.c"
	}
#line 2625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = _vala_state;
#line 2625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl)->metadata_only = TRUE;
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp5_);
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 20100 "Photo.c"
	} else {
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 20104 "Photo.c"
	}
#line 2627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 20108 "Photo.c"
}


void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error) {
	PhotoReimportEditableState* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 2630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (state != NULL);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = state;
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_finish_reimport_editable (self, _tmp0_, &_inner_error_);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20131 "Photo.c"
		} else {
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20139 "Photo.c"
		}
	}
}


void photo_get_raw_dimensions (Photo* self, Dimensions* result) {
	GError * _inner_error_ = NULL;
#line 2636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 20149 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20156 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			Dimensions _tmp2_ = {0};
#line 2638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->dim;
#line 2638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result = _tmp2_;
#line 20166 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20173 "Photo.c"
			}
#line 2638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 20177 "Photo.c"
		}
		__finally218:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20186 "Photo.c"
		}
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 20194 "Photo.c"
	}
}


gboolean photo_has_transformations (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2642 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20204 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20212 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_ = NULL;
			Orientation _tmp3_ = 0;
			BackingPhotoRow* _tmp4_ = NULL;
			Orientation _tmp5_ = 0;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->orientation;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->backing_photo_row;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _tmp4_->original_orientation;
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 2645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = TRUE;
#line 20231 "Photo.c"
			} else {
				PhotoRow* _tmp6_ = NULL;
				GeeHashMap* _tmp7_ = NULL;
#line 2646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 2646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_->transformations;
#line 2646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 20241 "Photo.c"
			}
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 20245 "Photo.c"
			{
				PhotoRow* _tmp8_ = NULL;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->row;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20252 "Photo.c"
			}
#line 2644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 20256 "Photo.c"
		}
		__finally219:
		{
			PhotoRow* _tmp9_ = NULL;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20265 "Photo.c"
		}
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2643 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp10_;
#line 20273 "Photo.c"
	}
}


gboolean photo_only_metadata_changed (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 2650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2651 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	date_time = NULL;
#line 2653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2653 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp0_;
#line 2654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = metadata;
#line 2654 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20297 "Photo.c"
		PhotoMetadata* _tmp2_ = NULL;
		MetadataDateTime* _tmp3_ = NULL;
#line 2655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = metadata;
#line 2655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp3_;
#line 20308 "Photo.c"
	}
	{
		PhotoRow* _tmp4_ = NULL;
		gboolean _tmp21_ = FALSE;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = self->row;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20317 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_ = NULL;
			GeeHashMap* _tmp7_ = NULL;
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp6_->transformations;
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 20328 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow* _tmp9_ = NULL;
				Orientation _tmp10_ = 0;
				BackingPhotoRow* _tmp11_ = NULL;
				Orientation _tmp12_ = 0;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->row;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_->orientation;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->backing_photo_row;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_->original_orientation;
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = TRUE;
#line 20346 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_ = NULL;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = date_time;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 20354 "Photo.c"
						PhotoRow* _tmp15_ = NULL;
						time_t _tmp16_ = 0;
						MetadataDateTime* _tmp17_ = NULL;
						time_t _tmp18_ = 0;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp15_ = self->row;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp16_ = _tmp15_->exposure_time;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp17_ = date_time;
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp18_ = metadata_date_time_get_timestamp (_tmp17_);
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = _tmp16_ != _tmp18_;
#line 20369 "Photo.c"
					} else {
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = FALSE;
#line 20373 "Photo.c"
					}
#line 2660 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = _tmp13_;
#line 20377 "Photo.c"
				}
#line 2659 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 20381 "Photo.c"
			} else {
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = FALSE;
#line 20385 "Photo.c"
			}
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp5_;
#line 20389 "Photo.c"
			{
				PhotoRow* _tmp19_ = NULL;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = self->row;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20396 "Photo.c"
			}
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 20404 "Photo.c"
		}
		__finally220:
		{
			PhotoRow* _tmp20_ = NULL;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = self->row;
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20413 "Photo.c"
		}
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp21_;
#line 20425 "Photo.c"
	}
#line 2650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 20431 "Photo.c"
}


gboolean photo_has_alterations (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time = NULL;
	gchar* title = NULL;
	gchar* comment = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
	MetadataDateTime* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2665 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	date_time = NULL;
#line 2666 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	title = NULL;
#line 2667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	comment = NULL;
#line 2669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata ((PhotoSource*) self);
#line 2669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp0_;
#line 2670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = metadata;
#line 2670 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 20461 "Photo.c"
		PhotoMetadata* _tmp2_ = NULL;
		MetadataDateTime* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		PhotoMetadata* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
#line 2671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = metadata;
#line 2671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 2671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		date_time = _tmp3_;
#line 2672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = metadata;
#line 2672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = media_metadata_get_title ((MediaMetadata*) _tmp4_);
#line 2672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (title);
#line 2672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		title = _tmp5_;
#line 2673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = metadata;
#line 2673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = media_metadata_get_comment ((MediaMetadata*) _tmp6_);
#line 2673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (comment);
#line 2673 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		comment = _tmp7_;
#line 20492 "Photo.c"
	}
#line 2677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = date_time;
#line 2677 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ == NULL) {
#line 20498 "Photo.c"
		{
			PhotoRow* _tmp9_ = NULL;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 20505 "Photo.c"
			{
				BackingPhotoRow* _tmp10_ = NULL;
				time_t _tmp11_ = 0;
				PhotoRow* _tmp12_ = NULL;
				time_t _tmp13_ = 0;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = self->backing_photo_row;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tmp10_->timestamp;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = self->row;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_->exposure_time;
#line 2681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp11_ != _tmp13_) {
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = TRUE;
#line 20523 "Photo.c"
					{
						PhotoRow* _tmp14_ = NULL;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp14_ = self->row;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20530 "Photo.c"
					}
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (comment);
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (title);
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_metadata_date_time_unref0 (date_time);
#line 2683 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 20542 "Photo.c"
				}
			}
			__finally221:
			{
				PhotoRow* _tmp15_ = NULL;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = self->row;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20552 "Photo.c"
			}
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 20556 "Photo.c"
				gboolean _tmp16_ = FALSE;
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_media_metadata_unref0 (metadata);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (comment);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (title);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_metadata_date_time_unref0 (date_time);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return _tmp16_;
#line 20572 "Photo.c"
			}
		}
	}
	{
		PhotoRow* _tmp17_ = NULL;
		gboolean _tmp42_ = FALSE;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = self->row;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20583 "Photo.c"
		{
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_ = FALSE;
			gboolean _tmp20_ = FALSE;
			gboolean _tmp21_ = FALSE;
			PhotoRow* _tmp22_ = NULL;
			GeeHashMap* _tmp23_ = NULL;
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = self->row;
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = _tmp22_->transformations;
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp23_ != NULL) {
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = TRUE;
#line 20599 "Photo.c"
			} else {
				PhotoRow* _tmp24_ = NULL;
				Orientation _tmp25_ = 0;
				BackingPhotoRow* _tmp26_ = NULL;
				Orientation _tmp27_ = 0;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = self->row;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = _tmp24_->orientation;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = self->backing_photo_row;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = _tmp26_->original_orientation;
#line 2690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = _tmp25_ != _tmp27_;
#line 20615 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp21_) {
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = TRUE;
#line 20621 "Photo.c"
			} else {
				gboolean _tmp28_ = FALSE;
				MetadataDateTime* _tmp29_ = NULL;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = date_time;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp29_ != NULL) {
#line 20629 "Photo.c"
					PhotoRow* _tmp30_ = NULL;
					time_t _tmp31_ = 0;
					MetadataDateTime* _tmp32_ = NULL;
					time_t _tmp33_ = 0;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = self->row;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31_ = _tmp30_->exposure_time;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp32_ = date_time;
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp33_ = metadata_date_time_get_timestamp (_tmp32_);
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp28_ = _tmp31_ != _tmp33_;
#line 20644 "Photo.c"
				} else {
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp28_ = FALSE;
#line 20648 "Photo.c"
				}
#line 2691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = _tmp28_;
#line 20652 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp20_) {
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = TRUE;
#line 20658 "Photo.c"
			} else {
				gchar* _tmp34_ = NULL;
				gchar* _tmp35_ = NULL;
				const gchar* _tmp36_ = NULL;
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = media_source_get_comment ((MediaSource*) self);
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = _tmp34_;
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = comment;
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = g_strcmp0 (_tmp35_, _tmp36_) != 0;
#line 2692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp35_);
#line 20673 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp19_) {
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = TRUE;
#line 20679 "Photo.c"
			} else {
				gchar* _tmp37_ = NULL;
				gchar* _tmp38_ = NULL;
				const gchar* _tmp39_ = NULL;
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = media_source_get_title ((MediaSource*) self);
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = title;
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = g_strcmp0 (_tmp38_, _tmp39_) != 0;
#line 2693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp38_);
#line 20694 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp18_;
#line 20698 "Photo.c"
			{
				PhotoRow* _tmp40_ = NULL;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = self->row;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20705 "Photo.c"
			}
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (comment);
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (title);
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 2689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 20717 "Photo.c"
		}
		__finally222:
		{
			PhotoRow* _tmp41_ = NULL;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = self->row;
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20726 "Photo.c"
		}
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (comment);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (title);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2688 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp42_;
#line 20742 "Photo.c"
	}
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (comment);
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (title);
#line 2664 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 20752 "Photo.c"
}


PhotoTransformationState* photo_save_transformation_state (Photo* self) {
	PhotoTransformationState* result = NULL;
	GError * _inner_error_ = NULL;
#line 2698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20761 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20768 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_ = NULL;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_ = NULL;
			PhotoRow* _tmp9_ = NULL;
			Orientation _tmp10_ = 0;
			PhotoRow* _tmp11_ = NULL;
			GeeHashMap* _tmp12_ = NULL;
			PhotoRow* _tmp13_ = NULL;
			GeeHashMap* _tmp14_ = NULL;
			PhotoRow* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			PhotoPhotoTransformationStateImpl* _tmp17_ = NULL;
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 20787 "Photo.c"
				PixelTransformer* _tmp3_ = NULL;
				PixelTransformer* _tmp4_ = NULL;
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 20798 "Photo.c"
			} else {
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = NULL;
#line 20804 "Photo.c"
			}
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 20810 "Photo.c"
				PixelTransformationBundle* _tmp7_ = NULL;
				PixelTransformationBundle* _tmp8_ = NULL;
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 20821 "Photo.c"
			} else {
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = NULL;
#line 20827 "Photo.c"
			}
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_->orientation;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = self->row;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_->transformations;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->original_transforms;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = self->row;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = _tmp15_->enhanced;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp1_, _tmp5_, _tmp14_, _tmp16_);
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = (PhotoTransformationState*) _tmp17_;
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 20853 "Photo.c"
			{
				PhotoRow* _tmp18_ = NULL;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->row;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20860 "Photo.c"
			}
#line 2700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 20864 "Photo.c"
		}
		__finally223:
		{
			PhotoRow* _tmp19_ = NULL;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->row;
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 20873 "Photo.c"
		}
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 20881 "Photo.c"
	}
}


static gpointer _pixel_transformer_ref0 (gpointer self) {
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 20889 "Photo.c"
}


static gpointer _pixel_transformation_bundle_ref0 (gpointer self) {
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 20896 "Photo.c"
}


gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state) {
	gboolean result = FALSE;
	PhotoPhotoTransformationStateImpl* state_impl = NULL;
	PhotoTransformationState* _tmp0_ = NULL;
	PhotoPhotoTransformationStateImpl* _tmp1_ = NULL;
	PhotoPhotoTransformationStateImpl* _tmp2_ = NULL;
	Orientation saved_orientation = 0;
	PhotoPhotoTransformationStateImpl* _tmp3_ = NULL;
	Orientation _tmp4_ = 0;
	gboolean saved_enhanced = FALSE;
	PhotoPhotoTransformationStateImpl* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	GeeHashMap* saved_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp7_ = NULL;
	GeeHashMap* _tmp8_ = NULL;
	GeeHashMap* saved_original_transformations = NULL;
	PhotoPhotoTransformationStateImpl* _tmp9_ = NULL;
	GeeHashMap* _tmp10_ = NULL;
	PixelTransformer* saved_transformer = NULL;
	PhotoPhotoTransformationStateImpl* _tmp11_ = NULL;
	PixelTransformer* _tmp12_ = NULL;
	PixelTransformationBundle* saved_adjustments = NULL;
	PhotoPhotoTransformationStateImpl* _tmp13_ = NULL;
	PixelTransformationBundle* _tmp14_ = NULL;
	gboolean committed = FALSE;
	gboolean _tmp42_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2708 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2708 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (state != NULL, FALSE);
#line 2709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = state;
#line 2709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL) ? ((PhotoPhotoTransformationStateImpl*) _tmp0_) : NULL);
#line 2709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	state_impl = _tmp1_;
#line 2710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = state_impl;
#line 2710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 2711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 20947 "Photo.c"
	}
#line 2713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = state_impl;
#line 2713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_orientation (_tmp3_);
#line 2713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_orientation = _tmp4_;
#line 2714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = state_impl;
#line 2714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_enhanced (_tmp5_);
#line 2714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_enhanced = _tmp6_;
#line 2715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = state_impl;
#line 2715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_transformations (_tmp7_);
#line 2715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_transformations = _tmp8_;
#line 2716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = state_impl;
#line 2716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = photo_photo_transformation_state_impl_get_original_transformations (_tmp9_);
#line 2716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_original_transformations = _tmp10_;
#line 2717 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = state_impl;
#line 2717 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = photo_photo_transformation_state_impl_get_transformer (_tmp11_);
#line 2717 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_transformer = _tmp12_;
#line 2718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = state_impl;
#line 2718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp13_);
#line 2718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	saved_adjustments = _tmp14_;
#line 20985 "Photo.c"
	{
		PhotoRow* _tmp15_ = NULL;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = self->row;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 20992 "Photo.c"
		{
			PhotoTable* _tmp16_ = NULL;
			PhotoTable* _tmp17_ = NULL;
			PhotoRow* _tmp18_ = NULL;
			PhotoID _tmp19_ = {0};
			Orientation _tmp20_ = 0;
			GeeHashMap* _tmp21_ = NULL;
			GeeHashMap* _tmp22_ = NULL;
			gboolean _tmp23_ = FALSE;
			gboolean _tmp24_ = FALSE;
			gboolean _tmp25_ = FALSE;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = photo_table_get_instance ();
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = self->row;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = _tmp18_->photo_id;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = saved_orientation;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = saved_transformations;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = saved_transformations;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = saved_enhanced;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = photo_table_set_transformation_state (_tmp17_, &_tmp19_, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			committed = _tmp24_;
#line 2722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp17_);
#line 2724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = committed;
#line 2724 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp25_) {
#line 21030 "Photo.c"
				PhotoRow* _tmp26_ = NULL;
				Orientation _tmp27_ = 0;
				PhotoRow* _tmp28_ = NULL;
				GeeHashMap* _tmp29_ = NULL;
				GeeHashMap* _tmp30_ = NULL;
				PhotoRow* _tmp31_ = NULL;
				GeeHashMap* _tmp32_ = NULL;
				GeeHashMap* _tmp33_ = NULL;
				PhotoRow* _tmp34_ = NULL;
				gboolean _tmp35_ = FALSE;
				PixelTransformer* _tmp36_ = NULL;
				PixelTransformer* _tmp37_ = NULL;
				PixelTransformationBundle* _tmp38_ = NULL;
				PixelTransformationBundle* _tmp39_ = NULL;
#line 2725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = self->row;
#line 2725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = saved_orientation;
#line 2725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_->orientation = _tmp27_;
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = self->row;
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = saved_transformations;
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = _g_object_ref0 (_tmp29_);
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp28_->transformations);
#line 2726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_->transformations = _tmp30_;
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = self->row;
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = saved_original_transformations;
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _g_object_ref0 (_tmp32_);
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp31_->original_transforms);
#line 2727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_->original_transforms = _tmp33_;
#line 2728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = self->row;
#line 2728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = saved_enhanced;
#line 2728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_->enhanced = _tmp35_;
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = saved_transformer;
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _pixel_transformer_ref0 (_tmp36_);
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->transformer = _tmp37_;
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = saved_adjustments;
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = _pixel_transformation_bundle_ref0 (_tmp38_);
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->adjustments = _tmp39_;
#line 21093 "Photo.c"
			}
		}
		__finally224:
		{
			PhotoRow* _tmp40_ = NULL;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = self->row;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21103 "Photo.c"
		}
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 21107 "Photo.c"
			gboolean _tmp41_ = FALSE;
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (saved_original_transformations);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp41_;
#line 21125 "Photo.c"
		}
	}
#line 2734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = committed;
#line 2734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp42_) {
#line 21132 "Photo.c"
		Alteration* _tmp43_ = NULL;
		Alteration* _tmp44_ = NULL;
#line 2735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = alteration_new ("image", "transformation-state");
#line 2735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = _tmp43_;
#line 2735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp44_);
#line 2735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp44_);
#line 21143 "Photo.c"
	}
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = committed;
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (saved_original_transformations);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2737 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 21159 "Photo.c"
}


void photo_remove_all_transformations (Photo* self) {
#line 2740 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2741 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_internal_remove_all_transformations (self, TRUE);
#line 21168 "Photo.c"
}


static void photo_internal_remove_all_transformations (Photo* self, gboolean notify) {
	gboolean is_altered = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2744 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2745 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_altered = FALSE;
#line 21181 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21188 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_ = NULL;
			PhotoRow* _tmp3_ = NULL;
			PhotoID _tmp4_ = {0};
			gboolean _tmp5_ = FALSE;
			PhotoRow* _tmp6_ = NULL;
			PhotoRow* _tmp7_ = NULL;
			PhotoRow* _tmp8_ = NULL;
			Orientation _tmp9_ = 0;
			BackingPhotoRow* _tmp10_ = NULL;
			Orientation _tmp11_ = 0;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_->photo_id;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			is_altered = _tmp5_;
#line 2747 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 2748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp6_->transformations);
#line 2748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_->transformations = NULL;
#line 2749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 2749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_->enhanced = FALSE;
#line 2750 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2750 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->priv->transformer = NULL;
#line 2751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = self->row;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_->orientation;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = self->backing_photo_row;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = _tmp10_->original_orientation;
#line 2753 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp9_ != _tmp11_) {
#line 21243 "Photo.c"
				PhotoTable* _tmp12_ = NULL;
				PhotoTable* _tmp13_ = NULL;
				PhotoRow* _tmp14_ = NULL;
				PhotoID _tmp15_ = {0};
				BackingPhotoRow* _tmp16_ = NULL;
				Orientation _tmp17_ = 0;
				PhotoRow* _tmp18_ = NULL;
				BackingPhotoRow* _tmp19_ = NULL;
				Orientation _tmp20_ = 0;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = photo_table_get_instance ();
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = self->row;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = _tmp14_->photo_id;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = self->backing_photo_row;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = _tmp16_->original_orientation;
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_table_set_orientation (_tmp13_, &_tmp15_, _tmp17_);
#line 2754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp13_);
#line 2756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->row;
#line 2756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = self->backing_photo_row;
#line 2756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = _tmp19_->original_orientation;
#line 2756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_->orientation = _tmp20_;
#line 2757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				is_altered = TRUE;
#line 21279 "Photo.c"
			}
		}
		__finally225:
		{
			PhotoRow* _tmp21_ = NULL;
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = self->row;
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21289 "Photo.c"
		}
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 21299 "Photo.c"
		}
	}
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = is_altered;
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp23_) {
#line 21306 "Photo.c"
		gboolean _tmp24_ = FALSE;
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = notify;
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = _tmp24_;
#line 21312 "Photo.c"
	} else {
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = FALSE;
#line 21316 "Photo.c"
	}
#line 2761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp22_) {
#line 21320 "Photo.c"
		Alteration* _tmp25_ = NULL;
		Alteration* _tmp26_ = NULL;
#line 2762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = alteration_new ("image", "revert");
#line 2762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = _tmp25_;
#line 2762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp26_);
#line 2762 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp26_);
#line 21331 "Photo.c"
	}
}


Orientation photo_get_original_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21341 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21348 "Photo.c"
		{
			BackingPhotoRow* _tmp1_ = NULL;
			Orientation _tmp2_ = 0;
#line 2767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->backing_photo_row;
#line 2767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->original_orientation;
#line 2767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 21358 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21365 "Photo.c"
			}
#line 2767 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 21369 "Photo.c"
		}
		__finally226:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21378 "Photo.c"
		}
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 21386 "Photo.c"
	}
}


Orientation photo_get_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 21396 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21403 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			Orientation _tmp2_ = 0;
#line 2773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp2_;
#line 21413 "Photo.c"
			{
				PhotoRow* _tmp3_ = NULL;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21420 "Photo.c"
			}
#line 2773 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 21424 "Photo.c"
		}
		__finally227:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21433 "Photo.c"
		}
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return 0;
#line 21441 "Photo.c"
	}
}


gboolean photo_set_orientation (Photo* self, Orientation orientation) {
	gboolean result = FALSE;
	gboolean committed = FALSE;
	gboolean _tmp15_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2777 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	committed = FALSE;
#line 21455 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21462 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			Orientation _tmp2_ = 0;
			Orientation _tmp3_ = 0;
#line 2780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->orientation;
#line 2780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = orientation;
#line 2780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 21475 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_ = NULL;
				PhotoRow* _tmp6_ = NULL;
				PhotoID _tmp7_ = {0};
				Orientation _tmp8_ = 0;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp6_->photo_id;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = orientation;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = photo_table_set_orientation (_tmp5_, &_tmp7_, _tmp8_);
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				committed = _tmp9_;
#line 2781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = committed;
#line 2782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_) {
#line 21503 "Photo.c"
					PhotoRow* _tmp11_ = NULL;
					Orientation _tmp12_ = 0;
#line 2783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = self->row;
#line 2783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = orientation;
#line 2783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_->orientation = _tmp12_;
#line 21512 "Photo.c"
				}
			}
		}
		__finally228:
		{
			PhotoRow* _tmp13_ = NULL;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21523 "Photo.c"
		}
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 21527 "Photo.c"
			gboolean _tmp14_ = FALSE;
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp14_;
#line 21535 "Photo.c"
		}
	}
#line 2787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = committed;
#line 2787 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_) {
#line 21542 "Photo.c"
		Alteration* _tmp16_ = NULL;
		Alteration* _tmp17_ = NULL;
#line 2788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = alteration_new ("image", "orientation");
#line 2788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 2788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp17_);
#line 2788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp17_);
#line 21553 "Photo.c"
	}
#line 2790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = committed;
#line 2790 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 21559 "Photo.c"
}


gboolean photo_check_can_rotate (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->can_rotate_now;
#line 2794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 2794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 21574 "Photo.c"
}


static void photo_real_rotate (Photo* self, Rotation rotation) {
	GError * _inner_error_ = NULL;
	{
		PhotoRow* _tmp0_ = NULL;
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21586 "Photo.c"
		{
			Orientation _tmp1_ = 0;
			Rotation _tmp2_ = 0;
			Orientation _tmp3_ = 0;
#line 2799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_get_orientation (self);
#line 2799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = rotation;
#line 2799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = orientation_perform (_tmp1_, _tmp2_);
#line 2799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_orientation (self, _tmp3_);
#line 21599 "Photo.c"
		}
		__finally229:
		{
			PhotoRow* _tmp4_ = NULL;
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->row;
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21608 "Photo.c"
		}
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 21618 "Photo.c"
		}
	}
}


void photo_rotate (Photo* self, Rotation rotation) {
#line 2797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 21629 "Photo.c"
}


static gboolean photo_has_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2803 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 21640 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21648 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow* _tmp2_ = NULL;
			GeeHashMap* _tmp3_ = NULL;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->row;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->transformations;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 21659 "Photo.c"
				PhotoRow* _tmp4_ = NULL;
				GeeHashMap* _tmp5_ = NULL;
				const gchar* _tmp6_ = NULL;
				gboolean _tmp7_ = FALSE;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->transformations;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = name;
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp6_);
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 21674 "Photo.c"
			} else {
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 21678 "Photo.c"
			}
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp1_;
#line 21682 "Photo.c"
			{
				PhotoRow* _tmp8_ = NULL;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->row;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21689 "Photo.c"
			}
#line 2805 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 21693 "Photo.c"
		}
		__finally230:
		{
			PhotoRow* _tmp9_ = NULL;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->row;
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21702 "Photo.c"
		}
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp10_;
#line 21710 "Photo.c"
	}
}


static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name) {
	KeyValueMap* result = NULL;
	KeyValueMap* map = NULL;
	GError * _inner_error_ = NULL;
#line 2812 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2812 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = NULL;
#line 21725 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21732 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
#line 2815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 21742 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				gpointer _tmp6_ = NULL;
				KeyValueMap* _tmp7_ = NULL;
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = name;
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				map = (KeyValueMap*) _tmp6_;
#line 2817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = map;
#line 2817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp7_ != NULL) {
#line 21764 "Photo.c"
					KeyValueMap* _tmp8_ = NULL;
					KeyValueMap* _tmp9_ = NULL;
#line 2818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = map;
#line 2818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = key_value_map_copy (_tmp8_);
#line 2818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					map = _tmp9_;
#line 21775 "Photo.c"
				}
			}
		}
		__finally231:
		{
			PhotoRow* _tmp10_ = NULL;
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = self->row;
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21786 "Photo.c"
		}
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 21798 "Photo.c"
		}
	}
#line 2822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = map;
#line 2822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 21805 "Photo.c"
}


static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 21816 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp20_ = FALSE;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21824 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
			PhotoRow* _tmp5_ = NULL;
			GeeHashMap* _tmp6_ = NULL;
			KeyValueMap* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			KeyValueMap* _tmp10_ = NULL;
			PhotoTable* _tmp11_ = NULL;
			PhotoTable* _tmp12_ = NULL;
			PhotoRow* _tmp13_ = NULL;
			PhotoID _tmp14_ = {0};
			KeyValueMap* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
#line 2827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2827 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 21847 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
#line 2828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp3_->transformations);
#line 2828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_->transformations = _tmp4_;
#line 21858 "Photo.c"
			}
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->transformations;
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = trans;
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = key_value_map_get_group (_tmp7_);
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = trans;
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp9_, _tmp10_);
#line 2830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp9_);
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = photo_table_get_instance ();
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->photo_id;
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = trans;
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = photo_table_set_transformation (_tmp12_, &_tmp14_, _tmp15_);
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp17_;
#line 21894 "Photo.c"
			{
				PhotoRow* _tmp18_ = NULL;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->row;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21901 "Photo.c"
			}
#line 2832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 21905 "Photo.c"
		}
		__finally232:
		{
			PhotoRow* _tmp19_ = NULL;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->row;
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 21914 "Photo.c"
		}
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2826 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp20_;
#line 21922 "Photo.c"
	}
}


static gboolean photo_set_original_transforms (Photo* self, KeyValueMap* trans) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (trans != NULL, FALSE);
#line 21934 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp20_ = FALSE;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 21942 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
			PhotoRow* _tmp5_ = NULL;
			GeeHashMap* _tmp6_ = NULL;
			KeyValueMap* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			KeyValueMap* _tmp10_ = NULL;
			PhotoTable* _tmp11_ = NULL;
			PhotoTable* _tmp12_ = NULL;
			PhotoRow* _tmp13_ = NULL;
			PhotoID _tmp14_ = {0};
			KeyValueMap* _tmp15_ = NULL;
			gboolean _tmp16_ = FALSE;
			gboolean _tmp17_ = FALSE;
#line 2838 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2838 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2838 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 21965 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
#line 2839 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2839 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2839 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2839 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 21976 "Photo.c"
			}
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_->original_transforms;
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = trans;
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = key_value_map_get_group (_tmp7_);
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = trans;
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp9_, _tmp10_);
#line 2841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp9_);
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = photo_table_get_instance ();
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = self->row;
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_->photo_id;
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = trans;
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = photo_table_set_original_transforms (_tmp12_, &_tmp14_, _tmp15_);
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = _tmp16_;
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp17_;
#line 22012 "Photo.c"
			{
				PhotoRow* _tmp18_ = NULL;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->row;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22019 "Photo.c"
			}
#line 2843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 22023 "Photo.c"
		}
		__finally233:
		{
			PhotoRow* _tmp19_ = NULL;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->row;
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22032 "Photo.c"
		}
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp20_;
#line 22040 "Photo.c"
	}
}


static gboolean photo_clear_original_transforms (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 22050 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp13_ = FALSE;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22058 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
			PhotoTable* _tmp5_ = NULL;
			PhotoTable* _tmp6_ = NULL;
			PhotoRow* _tmp7_ = NULL;
			PhotoID _tmp8_ = {0};
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
#line 2849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->original_transforms;
#line 2849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 22074 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
#line 2850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 2850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp3_->original_transforms);
#line 2850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_->original_transforms = _tmp4_;
#line 22085 "Photo.c"
			}
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = photo_table_get_instance ();
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp5_;
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_->photo_id;
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo_table_set_original_transforms (_tmp6_, &_tmp8_, NULL);
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp6_);
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp10_;
#line 22103 "Photo.c"
			{
				PhotoRow* _tmp11_ = NULL;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->row;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22110 "Photo.c"
			}
#line 2851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 22114 "Photo.c"
		}
		__finally234:
		{
			PhotoRow* _tmp12_ = NULL;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->row;
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22123 "Photo.c"
		}
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp13_;
#line 22131 "Photo.c"
	}
}


static gboolean photo_remove_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 22147 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 22154 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			GeeHashMap* _tmp2_ = NULL;
			PhotoTable* _tmp12_ = NULL;
			PhotoTable* _tmp13_ = NULL;
			PhotoRow* _tmp14_ = NULL;
			PhotoID _tmp15_ = {0};
			const gchar* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
#line 2858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 2858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->transformations;
#line 2858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22170 "Photo.c"
				PhotoRow* _tmp3_ = NULL;
				GeeHashMap* _tmp4_ = NULL;
				const gchar* _tmp5_ = NULL;
				gboolean _tmp6_ = FALSE;
				PhotoRow* _tmp7_ = NULL;
				GeeHashMap* _tmp8_ = NULL;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->row;
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->transformations;
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = name;
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, _tmp5_, NULL);
#line 2859 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				altered_cache = _tmp6_;
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = self->row;
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_->transformations;
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp8_);
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 2860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp10_ == 0) {
#line 22199 "Photo.c"
					PhotoRow* _tmp11_ = NULL;
#line 2861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = self->row;
#line 2861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp11_->transformations);
#line 2861 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_->transformations = NULL;
#line 22207 "Photo.c"
				}
			} else {
#line 2863 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				altered_cache = FALSE;
#line 22212 "Photo.c"
			}
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = photo_table_get_instance ();
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = self->row;
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = _tmp14_->photo_id;
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = name;
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = photo_table_remove_transformation (_tmp13_, &_tmp15_, _tmp16_);
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			altered_persistent = _tmp17_;
#line 2866 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp13_);
#line 22230 "Photo.c"
		}
		__finally235:
		{
			PhotoRow* _tmp18_ = NULL;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = self->row;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 22239 "Photo.c"
		}
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 22243 "Photo.c"
			gboolean _tmp19_ = FALSE;
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp19_;
#line 22251 "Photo.c"
		}
	}
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = altered_cache;
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp21_) {
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = TRUE;
#line 22260 "Photo.c"
	} else {
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = altered_persistent;
#line 22264 "Photo.c"
	}
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp20_;
#line 2870 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22270 "Photo.c"
}


gboolean photo_has_crop (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2873 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "crop");
#line 2874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 2874 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22285 "Photo.c"
}


gboolean photo_get_raw_crop (Photo* self, Box* crop) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	gint left = 0;
	KeyValueMap* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint top = 0;
	KeyValueMap* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint right = 0;
	KeyValueMap* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint bottom = 0;
	KeyValueMap* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gint _tmp20_ = 0;
#line 2878 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2879 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	box_init (&_vala_crop, 0, 0, 0, 0);
#line 2881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (crop) {
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*crop = _vala_crop;
#line 22335 "Photo.c"
		}
#line 2883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 22339 "Photo.c"
	}
#line 2885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = map;
#line 2885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = key_value_map_get_int (_tmp2_, "left", -1);
#line 2885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	left = _tmp3_;
#line 2886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = map;
#line 2886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "top", -1);
#line 2886 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	top = _tmp5_;
#line 2887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = map;
#line 2887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = key_value_map_get_int (_tmp6_, "right", -1);
#line 2887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	right = _tmp7_;
#line 2888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = map;
#line 2888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = key_value_map_get_int (_tmp8_, "bottom", -1);
#line 2888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	bottom = _tmp9_;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = left;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp13_ == -1) {
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = TRUE;
#line 22371 "Photo.c"
	} else {
		gint _tmp14_ = 0;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = top;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp14_ == -1;
#line 22378 "Photo.c"
	}
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_) {
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = TRUE;
#line 22384 "Photo.c"
	} else {
		gint _tmp15_ = 0;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = right;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp15_ == -1;
#line 22391 "Photo.c"
	}
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_) {
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = TRUE;
#line 22397 "Photo.c"
	} else {
		gint _tmp16_ = 0;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = bottom;
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp16_ == -1;
#line 22404 "Photo.c"
	}
#line 2890 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp10_) {
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (crop) {
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*crop = _vala_crop;
#line 22416 "Photo.c"
		}
#line 2891 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 22420 "Photo.c"
	}
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = left;
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = top;
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = right;
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = bottom;
#line 2893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	box_init (&_vala_crop, _tmp17_, _tmp18_, _tmp19_, _tmp20_);
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (crop) {
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*crop = _vala_crop;
#line 22440 "Photo.c"
	}
#line 2895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22444 "Photo.c"
}


static void photo_set_raw_crop (Photo* self, Box* crop) {
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	Box _tmp2_ = {0};
	gint _tmp3_ = 0;
	KeyValueMap* _tmp4_ = NULL;
	Box _tmp5_ = {0};
	gint _tmp6_ = 0;
	KeyValueMap* _tmp7_ = NULL;
	Box _tmp8_ = {0};
	gint _tmp9_ = 0;
	KeyValueMap* _tmp10_ = NULL;
	Box _tmp11_ = {0};
	gint _tmp12_ = 0;
	KeyValueMap* _tmp13_ = NULL;
	gboolean _tmp14_ = FALSE;
#line 2899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *crop;
#line 2901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_.left;
#line 2901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp3_);
#line 2902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = map;
#line 2902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = *crop;
#line 2902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = _tmp5_.top;
#line 2902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp4_, "top", _tmp6_);
#line 2903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = map;
#line 2903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = *crop;
#line 2903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 2903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp7_, "right", _tmp9_);
#line 2904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = map;
#line 2904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = *crop;
#line 2904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = _tmp11_.bottom;
#line 2904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp10_, "bottom", _tmp12_);
#line 2906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = map;
#line 2906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = photo_set_transformation (self, _tmp13_);
#line 2906 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp14_) {
#line 22511 "Photo.c"
		Alteration* _tmp15_ = NULL;
		Alteration* _tmp16_ = NULL;
#line 2907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = alteration_new ("image", "crop");
#line 2907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp16_);
#line 2907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 22522 "Photo.c"
	}
#line 2899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22526 "Photo.c"
}


static gboolean photo_get_raw_straighten (Photo* self, gdouble* angle) {
	gdouble _vala_angle = 0.0;
	gboolean result = FALSE;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	KeyValueMap* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
#line 2910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "straighten");
#line 2911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_angle = 0.0;
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (angle) {
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*angle = _vala_angle;
#line 22558 "Photo.c"
		}
#line 2915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 22562 "Photo.c"
	}
#line 2918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = map;
#line 2918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = key_value_map_get_double (_tmp2_, "angle", 0.0);
#line 2918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_angle = _tmp3_;
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (angle) {
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*angle = _vala_angle;
#line 22578 "Photo.c"
	}
#line 2920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22582 "Photo.c"
}


static void photo_set_raw_straighten (Photo* self, gdouble theta) {
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	KeyValueMap* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 2923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = key_value_map_new ("straighten");
#line 2924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = theta;
#line 2925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_double (_tmp1_, "angle", _tmp2_);
#line 2927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = map;
#line 2927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_set_transformation (self, _tmp3_);
#line 2927 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_) {
#line 22611 "Photo.c"
		Alteration* _tmp5_ = NULL;
		Alteration* _tmp6_ = NULL;
#line 2928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = alteration_new ("image", "straighten");
#line 2928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp6_);
#line 2928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp6_);
#line 22622 "Photo.c"
	}
#line 2923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 22626 "Photo.c"
}


static EditingToolsRedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1) {
	EditingToolsRedeyeInstance* result = NULL;
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	gint num_points = 0;
	KeyValueMap* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	EditingToolsRedeyeInstance* res = NULL;
	gint _tmp7_ = 0;
	EditingToolsRedeyeInstance* _tmp8_ = NULL;
	gint res_length1 = 0;
	gint _res_size_ = 0;
	GdkPoint default_point = {0};
	GdkPoint _tmp9_ = {0};
	EditingToolsRedeyeInstance* _tmp47_ = NULL;
	gint _tmp47__length1 = 0;
#line 2933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 22658 "Photo.c"
		EditingToolsRedeyeInstance* _tmp2_ = NULL;
		EditingToolsRedeyeInstance* _tmp3_ = NULL;
		gint _tmp3__length1 = 0;
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = g_new0 (EditingToolsRedeyeInstance, 0);
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3__length1 = 0;
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (result_length1) {
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 22672 "Photo.c"
		}
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp3_;
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 22680 "Photo.c"
	}
#line 2938 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = map;
#line 2938 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2938 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	num_points = _tmp5_;
#line 2939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = num_points;
#line 2939 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp6_ > 0, "num_points > 0");
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = num_points;
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = g_new0 (EditingToolsRedeyeInstance, _tmp7_);
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	res = _tmp8_;
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	res_length1 = _tmp7_;
#line 2941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_res_size_ = res_length1;
#line 2943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_.x = 0;
#line 2943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	default_point = _tmp9_;
#line 2944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	default_point.x = -1;
#line 2945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	default_point.y = -1;
#line 22710 "Photo.c"
	{
		gint i = 0;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		i = 0;
#line 22715 "Photo.c"
		{
			gboolean _tmp10_ = FALSE;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = TRUE;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 22722 "Photo.c"
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gchar* center_key = NULL;
				gint _tmp14_ = 0;
				gchar* _tmp15_ = NULL;
				gchar* radius_key = NULL;
				gint _tmp16_ = 0;
				gchar* _tmp17_ = NULL;
				EditingToolsRedeyeInstance* _tmp18_ = NULL;
				gint _tmp18__length1 = 0;
				gint _tmp19_ = 0;
				KeyValueMap* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				GdkPoint _tmp22_ = {0};
				GdkPoint _tmp23_ = {0};
				EditingToolsRedeyeInstance* _tmp24_ = NULL;
				gint _tmp24__length1 = 0;
				gint _tmp25_ = 0;
				EditingToolsRedeyeInstance _tmp26_ = {0};
				GdkPoint _tmp27_ = {0};
				gint _tmp28_ = 0;
				GdkPoint _tmp29_ = {0};
				gint _tmp30_ = 0;
				EditingToolsRedeyeInstance* _tmp31_ = NULL;
				gint _tmp31__length1 = 0;
				gint _tmp32_ = 0;
				EditingToolsRedeyeInstance _tmp33_ = {0};
				GdkPoint _tmp34_ = {0};
				gint _tmp35_ = 0;
				GdkPoint _tmp36_ = {0};
				gint _tmp37_ = 0;
				EditingToolsRedeyeInstance* _tmp38_ = NULL;
				gint _tmp38__length1 = 0;
				gint _tmp39_ = 0;
				KeyValueMap* _tmp40_ = NULL;
				const gchar* _tmp41_ = NULL;
				gint _tmp42_ = 0;
				EditingToolsRedeyeInstance* _tmp43_ = NULL;
				gint _tmp43__length1 = 0;
				gint _tmp44_ = 0;
				EditingToolsRedeyeInstance _tmp45_ = {0};
				gint _tmp46_ = 0;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp10_) {
#line 22767 "Photo.c"
					gint _tmp11_ = 0;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = i;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					i = _tmp11_ + 1;
#line 22773 "Photo.c"
				}
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = FALSE;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = i;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = num_points;
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp12_ < _tmp13_)) {
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 22785 "Photo.c"
				}
#line 2948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = i;
#line 2948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = g_strdup_printf ("center%d", _tmp14_);
#line 2948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				center_key = _tmp15_;
#line 2949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = i;
#line 2949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = g_strdup_printf ("radius%d", _tmp16_);
#line 2949 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				radius_key = _tmp17_;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = res;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18__length1 = res_length1;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = i;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = map;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = center_key;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = default_point;
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				key_value_map_get_point (_tmp20_, _tmp21_, &_tmp22_, &_tmp23_);
#line 2951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_[_tmp19_].center = _tmp23_;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = res;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24__length1 = res_length1;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = i;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = _tmp24_[_tmp25_];
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = _tmp26_.center;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = _tmp27_.x;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = default_point;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = _tmp29_.x;
#line 2952 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_assert (_tmp28_ != _tmp30_, "res[i].center.x != default_point.x");
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = res;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31__length1 = res_length1;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = i;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _tmp31_[_tmp32_];
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = _tmp33_.center;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = _tmp34_.y;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = default_point;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _tmp36_.y;
#line 2953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_assert (_tmp35_ != _tmp37_, "res[i].center.y != default_point.y");
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = res;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38__length1 = res_length1;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = i;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = map;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = radius_key;
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = key_value_map_get_int (_tmp40_, _tmp41_, -1);
#line 2955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_[_tmp39_].radius = _tmp42_;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = res;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43__length1 = res_length1;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = i;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp45_ = _tmp43_[_tmp44_];
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp46_ = _tmp45_.radius;
#line 2956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_assert (_tmp46_ != -1, "res[i].radius != -1");
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (radius_key);
#line 2947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (center_key);
#line 22881 "Photo.c"
			}
		}
	}
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = res;
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47__length1 = res_length1;
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (result_length1) {
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result_length1 = _tmp47__length1;
#line 22893 "Photo.c"
	}
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp47_;
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2959 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22901 "Photo.c"
}


gboolean photo_has_redeye_transformations (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2962 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "redeye");
#line 2963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 2963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 22916 "Photo.c"
}


void photo_add_redeye_instance (Photo* self, EditingToolsRedeyeInstance* redeye) {
	KeyValueMap* map = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* _tmp1_ = NULL;
	gint num_points = 0;
	KeyValueMap* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gchar* radius_key = NULL;
	gint _tmp8_ = 0;
	gchar* _tmp9_ = NULL;
	gchar* center_key = NULL;
	gint _tmp10_ = 0;
	gchar* _tmp11_ = NULL;
	KeyValueMap* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	EditingToolsRedeyeInstance _tmp14_ = {0};
	gint _tmp15_ = 0;
	KeyValueMap* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	EditingToolsRedeyeInstance _tmp18_ = {0};
	GdkPoint _tmp19_ = {0};
	KeyValueMap* _tmp20_ = NULL;
	gint _tmp21_ = 0;
	KeyValueMap* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 2968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2968 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 2969 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = map;
#line 2969 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 22959 "Photo.c"
		KeyValueMap* _tmp2_ = NULL;
		KeyValueMap* _tmp3_ = NULL;
#line 2970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 2970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		map = _tmp2_;
#line 2971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = map;
#line 2971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 22972 "Photo.c"
	}
#line 2974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = map;
#line 2974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	num_points = _tmp5_;
#line 2975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = num_points;
#line 2975 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp6_ >= 0, "num_points >= 0");
#line 2977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = num_points;
#line 2977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	num_points = _tmp7_ + 1;
#line 2979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = num_points;
#line 2979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = g_strdup_printf ("radius%d", _tmp8_ - 1);
#line 2979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	radius_key = _tmp9_;
#line 2980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = num_points;
#line 2980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = g_strdup_printf ("center%d", _tmp10_ - 1);
#line 2980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	center_key = _tmp11_;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = map;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = radius_key;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = *redeye;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_.radius;
#line 2982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp12_, _tmp13_, _tmp15_);
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = map;
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = center_key;
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = *redeye;
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_.center;
#line 2983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_point (_tmp16_, _tmp17_, &_tmp19_);
#line 2985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = map;
#line 2985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = num_points;
#line 2985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	key_value_map_set_int (_tmp20_, "num_points", _tmp21_);
#line 2987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = map;
#line 2987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = photo_set_transformation (self, _tmp22_);
#line 2987 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp23_) {
#line 23032 "Photo.c"
		Alteration* _tmp24_ = NULL;
		Alteration* _tmp25_ = NULL;
#line 2988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = alteration_new ("image", "redeye");
#line 2988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 2988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp25_);
#line 2988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 23043 "Photo.c"
	}
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (center_key);
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (radius_key);
#line 2967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 23051 "Photo.c"
}


static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 23064 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
		gboolean _tmp8_ = FALSE;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23072 "Photo.c"
		{
			Scaling _tmp1_ = {0};
			PhotoException _tmp2_ = 0;
			Dimensions _tmp3_ = {0};
			Dimensions _tmp4_ = {0};
			gboolean _tmp5_ = FALSE;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = exceptions;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, _tmp2_, &_tmp3_, &_tmp4_);
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_image = _tmp3_;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp4_;
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp5_;
#line 23091 "Photo.c"
			{
				PhotoRow* _tmp6_ = NULL;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->row;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23098 "Photo.c"
			}
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (scaled_image) {
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 23104 "Photo.c"
			}
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (scaled_to_viewport) {
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23110 "Photo.c"
			}
#line 3006 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 23114 "Photo.c"
		}
		__finally236:
		{
			PhotoRow* _tmp7_ = NULL;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->row;
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23123 "Photo.c"
		}
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp8_;
#line 23131 "Photo.c"
	}
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaled_image) {
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23137 "Photo.c"
	}
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3002 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23143 "Photo.c"
	}
}


static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions raw = {0};
	Dimensions _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Orientation orientation = 0;
	Orientation _tmp4_ = 0;
	PhotoException _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp53_ = FALSE;
	Dimensions _tmp54_ = {0};
	gint _tmp55_ = 0;
	Dimensions _tmp56_ = {0};
	gint _tmp57_ = 0;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_ = FALSE;
#line 3012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3014 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3014 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw = _tmp0_;
#line 3016 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = scaling_is_unscaled (scaling);
#line 3016 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 23179 "Photo.c"
		Dimensions _tmp2_ = {0};
		Dimensions _tmp3_ = {0};
#line 3017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = raw;
#line 3017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_image = _tmp2_;
#line 3018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = raw;
#line 3018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp3_;
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (scaled_image) {
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23196 "Photo.c"
		}
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23202 "Photo.c"
		}
#line 3020 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 23206 "Photo.c"
	}
#line 3023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_get_orientation (self);
#line 3023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = _tmp4_;
#line 3028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&_vala_scaled_image, 0, 0);
#line 3029 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&_vala_scaled_to_viewport, 0, 0);
#line 3031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = exceptions;
#line 3031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_exception_allows (_tmp5_, PHOTO_EXCEPTION_CROP);
#line 3031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_) {
#line 23222 "Photo.c"
		Box crop = {0};
		Box _tmp7_ = {0};
		gboolean _tmp8_ = FALSE;
#line 3033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = photo_get_raw_crop (self, &_tmp7_);
#line 3033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		crop = _tmp7_;
#line 3033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp8_) {
#line 23232 "Photo.c"
			Dimensions rotated_raw = {0};
			Dimensions _tmp9_ = {0};
			PhotoException _tmp10_ = 0;
			gboolean _tmp11_ = FALSE;
			Box scaled_crop = {0};
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
			Box _tmp21_ = {0};
			Dimensions _tmp22_ = {0};
			gboolean _tmp23_ = FALSE;
			gint _tmp24_ = 0;
			gint _tmp25_ = 0;
			Dimensions _tmp30_ = {0};
			Dimensions _tmp31_ = {0};
			Dimensions _tmp32_ = {0};
			PhotoException _tmp33_ = 0;
			gboolean _tmp34_ = FALSE;
#line 3036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = raw;
#line 3036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			rotated_raw = _tmp9_;
#line 3037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = exceptions;
#line 3037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = photo_exception_allows (_tmp10_, PHOTO_EXCEPTION_ORIENTATION);
#line 3037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp11_) {
#line 23260 "Photo.c"
				Orientation _tmp12_ = 0;
				Dimensions _tmp13_ = {0};
				Box _tmp14_ = {0};
				Box _tmp15_ = {0};
				Orientation _tmp16_ = 0;
				Dimensions _tmp17_ = {0};
				Dimensions _tmp18_ = {0};
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = orientation;
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = raw;
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = crop;
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				orientation_rotate_box (_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 3038 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				crop = _tmp15_;
#line 3039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = orientation;
#line 3039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = raw;
#line 3039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				orientation_rotate_dimensions (_tmp16_, &_tmp17_, &_tmp18_);
#line 3039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				rotated_raw = _tmp18_;
#line 23286 "Photo.c"
			}
#line 3043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp19_);
#line 3043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp19_, &_tmp20_);
#line 3043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_scaled (&crop, &_tmp20_, &_tmp21_);
#line 3043 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled_crop = _tmp21_;
#line 3046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp22_);
#line 3046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp22_;
#line 3049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = box_get_width (&crop);
#line 3049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = box_get_width (&scaled_crop);
#line 3049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp24_ <= _tmp25_) {
#line 23306 "Photo.c"
				gint _tmp26_ = 0;
				gint _tmp27_ = 0;
#line 3050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = box_get_height (&crop);
#line 3050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = box_get_height (&scaled_crop);
#line 3050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = _tmp26_ <= _tmp27_;
#line 23315 "Photo.c"
			} else {
#line 3049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = FALSE;
#line 23319 "Photo.c"
			}
#line 3049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp23_) {
#line 23323 "Photo.c"
				Dimensions _tmp28_ = {0};
				Dimensions _tmp29_ = {0};
#line 3051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = raw;
#line 3051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_scaled_image = _tmp28_;
#line 3052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				box_get_dimensions (&crop, &_tmp29_);
#line 3052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_scaled_to_viewport = _tmp29_;
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (scaled_image) {
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 23340 "Photo.c"
				}
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (scaled_to_viewport) {
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23346 "Photo.c"
				}
#line 3054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 23350 "Photo.c"
			}
#line 3059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp30_);
#line 3059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp31_);
#line 3059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp30_, &_tmp31_, &_tmp32_);
#line 3059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_image = _tmp32_;
#line 3063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp33_ = exceptions;
#line 3063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = photo_exception_allows (_tmp33_, PHOTO_EXCEPTION_ORIENTATION);
#line 3063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp34_) {
#line 23366 "Photo.c"
				Orientation _tmp35_ = 0;
				Dimensions _tmp36_ = {0};
				Dimensions _tmp37_ = {0};
#line 3064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = orientation;
#line 3064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = _vala_scaled_image;
#line 3064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				orientation_derotate_dimensions (_tmp35_, &_tmp36_, &_tmp37_);
#line 3064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_vala_scaled_image = _tmp37_;
#line 23378 "Photo.c"
			}
		}
	}
#line 3069 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = dimensions_has_area (&_vala_scaled_image);
#line 3069 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp38_) {
#line 23386 "Photo.c"
		Dimensions rotated_raw = {0};
		Dimensions _tmp39_ = {0};
		PhotoException _tmp40_ = 0;
		gboolean _tmp41_ = FALSE;
		Dimensions _tmp45_ = {0};
		Dimensions _tmp46_ = {0};
		Dimensions _tmp47_ = {0};
		PhotoException _tmp48_ = 0;
		gboolean _tmp49_ = FALSE;
#line 3071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = raw;
#line 3071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		rotated_raw = _tmp39_;
#line 3072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = exceptions;
#line 3072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = photo_exception_allows (_tmp40_, PHOTO_EXCEPTION_ORIENTATION);
#line 3072 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp41_) {
#line 23406 "Photo.c"
			Orientation _tmp42_ = 0;
			Dimensions _tmp43_ = {0};
			Dimensions _tmp44_ = {0};
#line 3073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = orientation;
#line 3073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43_ = raw;
#line 3073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			orientation_rotate_dimensions (_tmp42_, &_tmp43_, &_tmp44_);
#line 3073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			rotated_raw = _tmp44_;
#line 23418 "Photo.c"
		}
#line 3075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = rotated_raw;
#line 3075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp45_, &_tmp46_);
#line 3075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_image = _tmp46_;
#line 3076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = _vala_scaled_image;
#line 3076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp47_;
#line 3079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = exceptions;
#line 3079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = photo_exception_allows (_tmp48_, PHOTO_EXCEPTION_ORIENTATION);
#line 3079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp49_) {
#line 23436 "Photo.c"
			Orientation _tmp50_ = 0;
			Dimensions _tmp51_ = {0};
			Dimensions _tmp52_ = {0};
#line 3080 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp50_ = orientation;
#line 3080 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp51_ = _vala_scaled_image;
#line 3080 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			orientation_derotate_dimensions (_tmp50_, &_tmp51_, &_tmp52_);
#line 3080 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_scaled_image = _tmp52_;
#line 23448 "Photo.c"
		}
	}
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp54_ = _vala_scaled_image;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp55_ = _tmp54_.width;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp56_ = raw;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp57_ = _tmp56_.width;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp55_ >= _tmp57_) {
#line 23461 "Photo.c"
		Dimensions _tmp58_ = {0};
		gint _tmp59_ = 0;
		Dimensions _tmp60_ = {0};
		gint _tmp61_ = 0;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp58_ = _vala_scaled_image;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp59_ = _tmp58_.height;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp60_ = raw;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp61_ = _tmp60_.height;
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp53_ = _tmp59_ >= _tmp61_;
#line 23476 "Photo.c"
	} else {
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp53_ = FALSE;
#line 23480 "Photo.c"
	}
#line 3084 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp53_) {
#line 23484 "Photo.c"
		Dimensions _tmp62_ = {0};
#line 3085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp62_ = raw;
#line 3085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_scaled_image = _tmp62_;
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (scaled_image) {
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 23496 "Photo.c"
		}
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (scaled_to_viewport) {
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23502 "Photo.c"
		}
#line 3087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 23506 "Photo.c"
	}
#line 3090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp63_ = dimensions_has_area (&_vala_scaled_image);
#line 3090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp63_, "scaled_image.has_area ()");
#line 3091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp64_ = dimensions_has_area (&_vala_scaled_to_viewport);
#line 3091 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp64_, "scaled_to_viewport.has_area ()");
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaled_image) {
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 23522 "Photo.c"
	}
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (scaled_to_viewport) {
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 23528 "Photo.c"
	}
#line 3093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23532 "Photo.c"
}


static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	PhotoFileReader* loader = NULL;
	BackingFetchMode _tmp0_ = 0;
	PhotoFileReader* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	gboolean is_scaled = FALSE;
	Scaling _tmp7_ = {0};
	PhotoException _tmp8_ = 0;
	Dimensions _tmp9_ = {0};
	Dimensions _tmp10_ = {0};
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	GdkPixbuf* pixbuf = NULL;
	PhotoFileReader* _tmp17_ = NULL;
	Dimensions _tmp18_ = {0};
	Dimensions _tmp19_ = {0};
	GdkPixbuf* _tmp20_ = NULL;
	GdkPixbuf* _tmp21_ = NULL;
	Dimensions _tmp22_ = {0};
	gboolean _tmp23_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = fetch_mode;
#line 3102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_backing_reader (self, _tmp0_);
#line 3102 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	loader = _tmp1_;
#line 3105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = scaling_is_unscaled (scaling);
#line 3105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 23574 "Photo.c"
		GdkPixbuf* _tmp3_ = NULL;
		PhotoFileReader* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_ = NULL;
		GdkPixbuf* _tmp6_ = NULL;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = loader;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = photo_file_reader_unscaled_read (_tmp4_, &_inner_error_);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp5_;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 23593 "Photo.c"
		}
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp3_;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = NULL;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp6_;
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 23607 "Photo.c"
	}
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = *scaling;
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = exceptions;
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = photo_calculate_pixbuf_dimensions (self, &_tmp7_, _tmp8_, &_tmp9_, &_tmp10_);
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	scaled_image = _tmp9_;
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	scaled_to_viewport = _tmp10_;
#line 3115 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_scaled = _tmp11_;
#line 3117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = is_scaled;
#line 3117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp12_) {
#line 23625 "Photo.c"
		GdkPixbuf* _tmp13_ = NULL;
		PhotoFileReader* _tmp14_ = NULL;
		GdkPixbuf* _tmp15_ = NULL;
		GdkPixbuf* _tmp16_ = NULL;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = loader;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = photo_file_reader_unscaled_read (_tmp14_, &_inner_error_);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _tmp15_;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 23644 "Photo.c"
		}
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = _tmp13_;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = NULL;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp16_;
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp13_);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 23658 "Photo.c"
	}
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = loader;
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp18_);
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = scaled_image;
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = photo_file_reader_scaled_read (_tmp17_, &_tmp18_, &_tmp19_, &_inner_error_);
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = _tmp20_;
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 3125 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 23678 "Photo.c"
	}
#line 3133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = pixbuf;
#line 3133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_for_pixbuf (_tmp21_, &_tmp22_);
#line 3133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = dimensions_approx_equals (&scaled_image, &_tmp22_, PHOTO_SCALING_FUDGE);
#line 3133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp23_, "scaled_image.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 3135 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = pixbuf;
#line 3135 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 3135 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23694 "Photo.c"
}


GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 3140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3140 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = rotate;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_get_untransformed_pixbuf (self, &_tmp1_, _tmp2_, BACKING_FETCH_MODE_MASTER, &_inner_error_);
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp3_;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 23724 "Photo.c"
	}
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3141 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23736 "Photo.c"
}


GdkPixbuf* photo_get_unmodified_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 3145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3145 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = rotate;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_get_untransformed_pixbuf (self, &_tmp1_, _tmp2_, BACKING_FETCH_MODE_UNMODIFIED, &_inner_error_);
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp3_;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 23766 "Photo.c"
	}
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23778 "Photo.c"
}


static GdkPixbuf* photo_get_untransformed_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	Scaling _tmp6_ = {0};
	BackingFetchMode _tmp7_ = 0;
	GdkPixbuf* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 23797 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 23804 "Photo.c"
		{
			Scaling _tmp1_ = {0};
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			Orientation _tmp4_ = 0;
#line 3165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = *scaling;
#line 3165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 3165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled_image = _tmp2_;
#line 3165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 3167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = photo_get_original_orientation (self);
#line 3167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			original_orientation = _tmp4_;
#line 23822 "Photo.c"
		}
		__finally237:
		{
			PhotoRow* _tmp5_ = NULL;
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = self->row;
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 23831 "Photo.c"
		}
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 23839 "Photo.c"
		}
	}
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = *scaling;
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = fetch_mode;
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo_load_raw_pixbuf (self, &_tmp6_, PHOTO_EXCEPTION_NONE, _tmp7_, &_inner_error_);
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = _tmp8_;
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 23856 "Photo.c"
	}
#line 3177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = rotate;
#line 3177 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp9_) {
#line 23862 "Photo.c"
		GdkPixbuf* _tmp10_ = NULL;
		GdkPixbuf* _tmp11_ = NULL;
#line 3178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = pixbuf;
#line 3178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = orientation_rotate_pixbuf (original_orientation, _tmp10_);
#line 3178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp11_;
#line 23873 "Photo.c"
	}
#line 3187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = pixbuf;
#line 3187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23879 "Photo.c"
}


static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 3190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (Photo*) base;
#line 3190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = *scaling;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 23907 "Photo.c"
	}
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 3191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 23919 "Photo.c"
}


/**
     * @brief Populates the cached version of the unmodified image.
     */
void photo_populate_prefetched (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 23930 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 23937 "Photo.c"
		{
			GdkPixbuf* _tmp1_ = NULL;
#line 3200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 23944 "Photo.c"
				GdkPixbuf* _tmp2_ = NULL;
				Scaling _tmp3_ = {0};
				GdkPixbuf* _tmp4_ = NULL;
				GdkPixbuf* _tmp5_ = NULL;
				GTimer* _tmp6_ = NULL;
				gchar* _tmp7_ = NULL;
				gchar* _tmp8_ = NULL;
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				scaling_for_original (&_tmp3_);
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = photo_load_raw_pixbuf (self, &_tmp3_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = _tmp4_;
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 23960 "Photo.c"
					goto __finally238;
				}
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp2_;
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp2_ = NULL;
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3201 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->unmodified_precached = _tmp5_;
#line 3202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = g_timer_new ();
#line 3202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->secs_since_access = _tmp6_;
#line 3203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 5, (GSourceFunc) photo_discard_prefetched, g_object_ref (self), g_object_unref);
#line 3204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = data_object_to_string ((DataObject*) self);
#line 3204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("Photo.vala:3204: spawning new precache timeout for %s", _tmp8_);
#line 3204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp8_);
#line 3200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp2_);
#line 23989 "Photo.c"
			}
		}
		__finally238:
		{
			GdkPixbuf* _tmp9_ = NULL;
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 23999 "Photo.c"
		}
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 24007 "Photo.c"
		}
	}
}


/**
     * @brief Get a copy of what's in the cache.
     *
     * @return A Pixbuf with the image data from unmodified_precached.
     */
GdkPixbuf* photo_get_prefetched_copy (Photo* self) {
	GdkPixbuf* result = NULL;
	GError * _inner_error_ = NULL;
#line 3214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24023 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 24030 "Photo.c"
		{
			GdkPixbuf* _tmp1_ = NULL;
			GdkPixbuf* _tmp6_ = NULL;
			GdkPixbuf* _tmp7_ = NULL;
#line 3216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->unmodified_precached;
#line 3216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 24039 "Photo.c"
				{
#line 3218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_populate_prefetched (self, &_inner_error_);
#line 3218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 24045 "Photo.c"
						goto __catch240_g_error;
					}
				}
				goto __finally240;
				__catch240_g_error:
				{
					GError* e = NULL;
					gchar* _tmp2_ = NULL;
					gchar* _tmp3_ = NULL;
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					e = _inner_error_;
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_inner_error_ = NULL;
#line 3220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp2_ = data_object_to_string ((DataObject*) self);
#line 3220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp3_ = _tmp2_;
#line 3220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_warning ("Photo.vala:3220: raw pixbuf for %s could not be loaded", _tmp3_);
#line 3220 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (_tmp3_);
#line 3221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = NULL;
#line 3221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_error_free0 (e);
#line 24071 "Photo.c"
					{
						GdkPixbuf* _tmp4_ = NULL;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp4_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24078 "Photo.c"
					}
#line 3221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 24082 "Photo.c"
				}
				__finally240:
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 24087 "Photo.c"
					{
						GdkPixbuf* _tmp5_ = NULL;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp5_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24094 "Photo.c"
					}
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return NULL;
#line 24102 "Photo.c"
				}
			}
#line 3225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->unmodified_precached;
#line 3225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gdk_pixbuf_copy (_tmp6_);
#line 3225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp7_;
#line 24111 "Photo.c"
			{
				GdkPixbuf* _tmp8_ = NULL;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24118 "Photo.c"
			}
#line 3225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 24122 "Photo.c"
		}
		__finally239:
		{
			GdkPixbuf* _tmp9_ = NULL;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = self->priv->unmodified_precached;
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24131 "Photo.c"
		}
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24139 "Photo.c"
	}
}


/**
     * @brief Discards the cached version of the unmodified image.
     *
     * @param immed Whether the cached version should be discarded now, or not.
     */
gboolean photo_discard_prefetched (Photo* self, gboolean immed) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 3234 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 24154 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		gboolean _tmp13_ = FALSE;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_unmodified_precached);
#line 24162 "Photo.c"
		{
			GTimer* _tmp1_ = NULL;
			gdouble tmp = 0.0;
			gboolean _tmp3_ = FALSE;
			GTimer* _tmp4_ = NULL;
			gulong _tmp5_ = 0UL;
			gdouble _tmp6_ = 0.0;
#line 3236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->secs_since_access;
#line 3236 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 3237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 24176 "Photo.c"
				{
					GdkPixbuf* _tmp2_ = NULL;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp2_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24183 "Photo.c"
				}
#line 3237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 24187 "Photo.c"
			}
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = self->priv->secs_since_access;
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = g_timer_elapsed (_tmp4_, &_tmp5_);
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			tmp = (gdouble) _tmp5_;
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ > ((gdouble) PHOTO_PRECACHE_TIME_TO_LIVE)) {
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = TRUE;
#line 24199 "Photo.c"
			} else {
				gboolean _tmp7_ = FALSE;
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = immed;
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _tmp7_;
#line 24206 "Photo.c"
			}
#line 3240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_) {
#line 24210 "Photo.c"
				gchar* _tmp8_ = NULL;
				gchar* _tmp9_ = NULL;
#line 3241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = data_object_to_string ((DataObject*) self);
#line 3241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 3241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_debug ("pipeline not run in over %d seconds or got immediate command, discardi" \
"ng " "cached original for %s", PHOTO_PRECACHE_TIME_TO_LIVE, _tmp9_);
#line 3241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp9_);
#line 3244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (self->priv->unmodified_precached);
#line 3244 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->unmodified_precached = NULL;
#line 3245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_timer_destroy0 (self->priv->secs_since_access);
#line 3245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->secs_since_access = NULL;
#line 3246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = FALSE;
#line 24231 "Photo.c"
				{
					GdkPixbuf* _tmp10_ = NULL;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24238 "Photo.c"
				}
#line 3246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 24242 "Photo.c"
			}
#line 3249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = TRUE;
#line 24246 "Photo.c"
			{
				GdkPixbuf* _tmp11_ = NULL;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24253 "Photo.c"
			}
#line 3249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 24257 "Photo.c"
		}
		__finally241:
		{
			GdkPixbuf* _tmp12_ = NULL;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = self->priv->unmodified_precached;
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_unmodified_precached);
#line 24266 "Photo.c"
		}
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp13_;
#line 24274 "Photo.c"
	}
}


/**
     * @brief Returns a fully transformed and scaled pixbuf.  Transformations may be excluded via
     * the mask. If the image is smaller than the scaling, it will be returned in its actual size.
     * The caller is responsible for scaling thereafter.
     *
     * @param scaling A scaling object that describes the size the output pixbuf should be.
     * @param exceptions The parts of the pipeline that should be skipped; defaults to NONE if
     *      left unset.
     * @param fetch_mode The fetch mode; if left unset, defaults to BASELINE so that
     *      we get the image exactly as it is in the file.
     */
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	gboolean is_straightened = FALSE;
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	EditingToolsRedeyeInstance* redeye_instances = NULL;
	gint redeye_instances_length1 = 0;
	gint _redeye_instances_size_ = 0;
	Box crop = {0};
	gdouble straightening_angle = 0.0;
	PixelTransformer* transformer = NULL;
	Orientation orientation = 0;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp33_ = NULL;
	GTimer* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	gchar* _tmp36_ = NULL;
	GdkPixbuf* _tmp37_ = NULL;
	PhotoException _tmp38_ = 0;
	gboolean _tmp39_ = FALSE;
	PhotoException _tmp44_ = 0;
	gboolean _tmp45_ = FALSE;
	PhotoException _tmp50_ = 0;
	gboolean _tmp51_ = FALSE;
	PhotoException _tmp89_ = 0;
	gboolean _tmp90_ = FALSE;
	gboolean _tmp93_ = FALSE;
	PhotoException _tmp100_ = 0;
	gboolean _tmp101_ = FALSE;
	gboolean _tmp105_ = FALSE;
	gboolean _tmp106_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_get_develop_raw_photos_to_files ();
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_) {
#line 24340 "Photo.c"
		PhotoFileFormat _tmp5_ = 0;
#line 3278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = photo_get_master_file_format (self);
#line 3278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp5_ == PHOTO_FILE_FORMAT_RAW;
#line 24346 "Photo.c"
	} else {
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = FALSE;
#line 24350 "Photo.c"
	}
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 24354 "Photo.c"
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		BackingFetchMode _tmp8_ = 0;
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = fetch_mode;
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp8_ == BACKING_FETCH_MODE_BASELINE) {
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = TRUE;
#line 24364 "Photo.c"
		} else {
			BackingFetchMode _tmp9_ = 0;
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = fetch_mode;
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _tmp9_ == BACKING_FETCH_MODE_UNMODIFIED;
#line 24371 "Photo.c"
		}
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp7_) {
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = TRUE;
#line 24377 "Photo.c"
		} else {
			BackingFetchMode _tmp10_ = 0;
#line 3280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = fetch_mode;
#line 3280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tmp10_ == BACKING_FETCH_MODE_SOURCE;
#line 24384 "Photo.c"
		}
#line 3279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 24388 "Photo.c"
	} else {
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = FALSE;
#line 24392 "Photo.c"
	}
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 24396 "Photo.c"
		RawDeveloper _tmp11_ = 0;
		gboolean _tmp12_ = FALSE;
#line 3281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = photo_get_raw_developer (self);
#line 3281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = photo_is_raw_developer_complete (self, _tmp11_);
#line 3281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = !_tmp12_;
#line 24405 "Photo.c"
	} else {
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = FALSE;
#line 24409 "Photo.c"
	}
#line 3277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 24413 "Photo.c"
		RawDeveloper _tmp13_ = 0;
#line 3282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = photo_get_raw_developer (self);
#line 3282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_set_raw_developer (self, _tmp13_);
#line 24419 "Photo.c"
	}
#line 3287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 3288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 3289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	redeye_instances = NULL;
#line 3289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	redeye_instances_length1 = 0;
#line 3289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 3292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	transformer = NULL;
#line 24433 "Photo.c"
	{
		PhotoRow* _tmp14_ = NULL;
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = self->row;
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 24440 "Photo.c"
		{
			Dimensions _tmp15_ = {0};
			PhotoException _tmp16_ = 0;
			Dimensions _tmp17_ = {0};
			Dimensions _tmp18_ = {0};
			Dimensions _tmp19_ = {0};
			Dimensions _tmp20_ = {0};
			Dimensions _tmp21_ = {0};
			gboolean _tmp22_ = FALSE;
			gint _tmp23_ = 0;
			EditingToolsRedeyeInstance* _tmp24_ = NULL;
			Box _tmp25_ = {0};
			gboolean _tmp26_ = FALSE;
			gdouble _tmp27_ = 0.0;
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_ = FALSE;
			Orientation _tmp31_ = 0;
#line 3296 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ALL, &_tmp15_);
#line 3296 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			original = _tmp15_;
#line 3297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = exceptions;
#line 3297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, _tmp16_, &_tmp17_);
#line 3297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp17_, &_tmp18_);
#line 3297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled = _tmp18_;
#line 3298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = scaled;
#line 3298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaled_to_viewport = _tmp19_;
#line 3300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp20_);
#line 3300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = scaled;
#line 3300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = dimensions_equals (&_tmp20_, &_tmp21_);
#line 3300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			is_scaled = !_tmp22_;
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = photo_get_raw_redeye_instances (self, &_tmp23_);
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			redeye_instances = _tmp24_;
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			redeye_instances_length1 = _tmp23_;
#line 3302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 3304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = photo_get_raw_crop (self, &_tmp25_);
#line 3304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop = _tmp25_;
#line 3304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			is_cropped = _tmp26_;
#line 3306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = photo_get_raw_straighten (self, &_tmp27_);
#line 3306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			straightening_angle = _tmp27_;
#line 3306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			is_straightened = _tmp28_;
#line 3308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp29_ = photo_has_color_adjustments (self);
#line 3308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp29_) {
#line 24508 "Photo.c"
				PixelTransformer* _tmp30_ = NULL;
#line 3309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = photo_get_pixel_transformer (self);
#line 3309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 3309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				transformer = _tmp30_;
#line 24516 "Photo.c"
			}
#line 3311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp31_ = photo_get_orientation (self);
#line 3311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			orientation = _tmp31_;
#line 24522 "Photo.c"
		}
		__finally242:
		{
			PhotoRow* _tmp32_ = NULL;
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp32_ = self->row;
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 24531 "Photo.c"
		}
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 3295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 24543 "Photo.c"
		}
	}
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_populate_prefetched (self, &_inner_error_);
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 3317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 24558 "Photo.c"
	}
#line 3319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = photo_get_prefetched_copy (self);
#line 3319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = _tmp33_;
#line 3322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = self->priv->secs_since_access;
#line 3322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_timer_start (_tmp34_);
#line 3323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = data_object_to_string ((DataObject*) self);
#line 3323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 3323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3323: pipeline being run against %s, timer restarted.", _tmp36_);
#line 3323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp36_);
#line 3325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = pixbuf;
#line 3325 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp37_ != NULL, "pixbuf != null");
#line 3332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = exceptions;
#line 3332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = photo_exception_allows (_tmp38_, PHOTO_EXCEPTION_REDEYE);
#line 3332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp39_) {
#line 24586 "Photo.c"
		EditingToolsRedeyeInstance* _tmp40_ = NULL;
		gint _tmp40__length1 = 0;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = redeye_instances;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40__length1 = redeye_instances_length1;
#line 24593 "Photo.c"
		{
			EditingToolsRedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			instance_collection = _tmp40_;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			instance_collection_length1 = _tmp40__length1;
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			for (instance_it = 0; instance_it < _tmp40__length1; instance_it = instance_it + 1) {
#line 24605 "Photo.c"
				EditingToolsRedeyeInstance instance = {0};
#line 3337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				instance = instance_collection[instance_it];
#line 24609 "Photo.c"
				{
					GdkPixbuf* _tmp41_ = NULL;
					EditingToolsRedeyeInstance _tmp42_ = {0};
					GdkPixbuf* _tmp43_ = NULL;
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp41_ = pixbuf;
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp42_ = instance;
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp43_ = photo_do_redeye (self, _tmp41_, &_tmp42_);
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 3338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					pixbuf = _tmp43_;
#line 24624 "Photo.c"
				}
			}
		}
	}
#line 3346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = exceptions;
#line 3346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = photo_exception_allows (_tmp44_, PHOTO_EXCEPTION_STRAIGHTEN);
#line 3346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp45_) {
#line 24635 "Photo.c"
		gboolean _tmp46_ = FALSE;
#line 3350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = is_straightened;
#line 3350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp46_) {
#line 24641 "Photo.c"
			GdkPixbuf* _tmp47_ = NULL;
			gdouble _tmp48_ = 0.0;
			GdkPixbuf* _tmp49_ = NULL;
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp47_ = pixbuf;
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp48_ = straightening_angle;
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp49_ = rotate_arb (_tmp47_, _tmp48_);
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			pixbuf = _tmp49_;
#line 24655 "Photo.c"
		}
	}
#line 3360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp50_ = exceptions;
#line 3360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp51_ = photo_exception_allows (_tmp50_, PHOTO_EXCEPTION_CROP);
#line 3360 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp51_) {
#line 24664 "Photo.c"
		gboolean _tmp52_ = FALSE;
#line 3364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp52_ = is_cropped;
#line 3364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp52_) {
#line 24670 "Photo.c"
			Box _tmp53_ = {0};
			gint _tmp54_ = 0;
			GdkPixbuf* _tmp55_ = NULL;
			gint _tmp56_ = 0;
			gint _tmp57_ = 0;
			gint _tmp58_ = 0;
			Box _tmp59_ = {0};
			gint _tmp60_ = 0;
			GdkPixbuf* _tmp61_ = NULL;
			gint _tmp62_ = 0;
			gint _tmp63_ = 0;
			gint _tmp64_ = 0;
			Box _tmp65_ = {0};
			gint _tmp66_ = 0;
			Box _tmp67_ = {0};
			gint _tmp68_ = 0;
			GdkPixbuf* _tmp69_ = NULL;
			gint _tmp70_ = 0;
			gint _tmp71_ = 0;
			gint _tmp72_ = 0;
			Box _tmp73_ = {0};
			gint _tmp74_ = 0;
			Box _tmp75_ = {0};
			gint _tmp76_ = 0;
			GdkPixbuf* _tmp77_ = NULL;
			gint _tmp78_ = 0;
			gint _tmp79_ = 0;
			gint _tmp80_ = 0;
			GdkPixbuf* _tmp81_ = NULL;
			Box _tmp82_ = {0};
			gint _tmp83_ = 0;
			Box _tmp84_ = {0};
			gint _tmp85_ = 0;
			gint _tmp86_ = 0;
			gint _tmp87_ = 0;
			GdkPixbuf* _tmp88_ = NULL;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp53_ = crop;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp54_ = _tmp53_.left;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp55_ = pixbuf;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp56_ = gdk_pixbuf_get_width (_tmp55_);
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp57_ = _tmp56_;
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp58_ = CLAMP (_tmp54_, 0, _tmp57_ - 2);
#line 3369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop.left = _tmp58_;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp59_ = crop;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp60_ = _tmp59_.top;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp61_ = pixbuf;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp62_ = gdk_pixbuf_get_height (_tmp61_);
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp63_ = _tmp62_;
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp64_ = CLAMP (_tmp60_, 0, _tmp63_ - 2);
#line 3370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop.top = _tmp64_;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp65_ = crop;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp66_ = _tmp65_.right;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp67_ = crop;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp68_ = _tmp67_.left;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp69_ = pixbuf;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp70_ = gdk_pixbuf_get_width (_tmp69_);
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp71_ = _tmp70_;
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp72_ = CLAMP (_tmp66_, _tmp68_ + 1, _tmp71_ - 1);
#line 3372 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop.right = _tmp72_;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp73_ = crop;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp74_ = _tmp73_.bottom;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp75_ = crop;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp76_ = _tmp75_.top;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp77_ = pixbuf;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp78_ = gdk_pixbuf_get_height (_tmp77_);
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp79_ = _tmp78_;
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp80_ = CLAMP (_tmp74_, _tmp76_ + 1, _tmp79_ - 1);
#line 3373 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			crop.bottom = _tmp80_;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp81_ = pixbuf;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp82_ = crop;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp83_ = _tmp82_.left;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp84_ = crop;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp85_ = _tmp84_.top;
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp86_ = box_get_width (&crop);
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp87_ = box_get_height (&crop);
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp88_ = gdk_pixbuf_new_subpixbuf (_tmp81_, _tmp83_, _tmp85_, _tmp86_, _tmp87_);
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			pixbuf = _tmp88_;
#line 24791 "Photo.c"
		}
	}
#line 3385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_ = exceptions;
#line 3385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp90_ = photo_exception_allows (_tmp89_, PHOTO_EXCEPTION_ORIENTATION);
#line 3385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp90_) {
#line 24800 "Photo.c"
		GdkPixbuf* _tmp91_ = NULL;
		GdkPixbuf* _tmp92_ = NULL;
#line 3389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp91_ = pixbuf;
#line 3389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp92_ = orientation_rotate_pixbuf (orientation, _tmp91_);
#line 3389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp92_;
#line 24811 "Photo.c"
	}
#line 3402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp93_ = is_scaled;
#line 3402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp93_) {
#line 24817 "Photo.c"
		GdkPixbuf* _tmp94_ = NULL;
		Dimensions _tmp95_ = {0};
		gint _tmp96_ = 0;
		Dimensions _tmp97_ = {0};
		gint _tmp98_ = 0;
		GdkPixbuf* _tmp99_ = NULL;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp94_ = pixbuf;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp95_ = scaled_to_viewport;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp96_ = _tmp95_.width;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp97_ = scaled_to_viewport;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp98_ = _tmp97_.height;
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp99_ = gdk_pixbuf_scale_simple (_tmp94_, _tmp96_, _tmp98_, GDK_INTERP_BILINEAR);
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3403 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp99_;
#line 24840 "Photo.c"
	}
#line 3408 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp100_ = exceptions;
#line 3408 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp101_ = photo_exception_allows (_tmp100_, PHOTO_EXCEPTION_ADJUST);
#line 3408 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp101_) {
#line 24848 "Photo.c"
		PixelTransformer* _tmp102_ = NULL;
#line 3412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp102_ = transformer;
#line 3412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp102_ != NULL) {
#line 24854 "Photo.c"
			PixelTransformer* _tmp103_ = NULL;
			GdkPixbuf* _tmp104_ = NULL;
#line 3413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp103_ = transformer;
#line 3413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp104_ = pixbuf;
#line 3413 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp103_, _tmp104_, NULL);
#line 24863 "Photo.c"
		}
	}
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp106_ = is_scaled;
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp106_) {
#line 24870 "Photo.c"
		gboolean _tmp107_ = FALSE;
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp107_ = is_straightened;
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp105_ = !_tmp107_;
#line 24876 "Photo.c"
	} else {
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp105_ = FALSE;
#line 24880 "Photo.c"
	}
#line 3422 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp105_) {
#line 24884 "Photo.c"
		GdkPixbuf* _tmp108_ = NULL;
		Dimensions _tmp109_ = {0};
		gboolean _tmp110_ = FALSE;
#line 3423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp108_ = pixbuf;
#line 3423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dimensions_for_pixbuf (_tmp108_, &_tmp109_);
#line 3423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp110_ = dimensions_approx_equals (&scaled_to_viewport, &_tmp109_, PHOTO_SCALING_FUDGE);
#line 3423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_assert (_tmp110_, "scaled_to_viewport.approx_equals (Dimensions.for_pixbuf (pixbuf), SCALING_FUDGE)");
#line 24896 "Photo.c"
	}
#line 3425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = pixbuf;
#line 3425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 3425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 3425 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 24906 "Photo.c"
}


static gboolean photo_real_has_user_generated_metadata (Photo* self) {
	gboolean _tmp0_ = FALSE;
#line 3433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return _tmp0_;
#line 24916 "Photo.c"
}


gboolean photo_has_user_generated_metadata (Photo* self) {
#line 3433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3433 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 24925 "Photo.c"
}


static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 3437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 24934 "Photo.c"
}


void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 3437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3437 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 24943 "Photo.c"
}


gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format) {
	gchar* result = NULL;
	PhotoFileFormat* _tmp0_ = NULL;
#line 3444 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file_format;
#line 3445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 24956 "Photo.c"
		PhotoFileFormat* _tmp1_ = NULL;
		PhotoFileFormatProperties* _tmp2_ = NULL;
		PhotoFileFormatProperties* _tmp3_ = NULL;
		GFile* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		GFile* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = file_format;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = photo_file_format_get_properties (*_tmp1_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = media_source_get_master_file ((MediaSource*) self);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = photo_file_format_properties_convert_file_extension (_tmp3_, _tmp5_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = g_file_get_basename (_tmp7_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp3_);
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp9_;
#line 3446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 24994 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_ = 0;
		gboolean _tmp11_ = FALSE;
#line 3448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = photo_get_file_format (self);
#line 3448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = photo_file_format_can_write (_tmp10_);
#line 3448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp11_) {
#line 25004 "Photo.c"
			PhotoFileFormat _tmp12_ = 0;
			PhotoFileFormatProperties* _tmp13_ = NULL;
			PhotoFileFormatProperties* _tmp14_ = NULL;
			GFile* _tmp15_ = NULL;
			GFile* _tmp16_ = NULL;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_ = NULL;
			gchar* _tmp19_ = NULL;
			gchar* _tmp20_ = NULL;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = photo_get_file_format (self);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = photo_file_format_get_properties (_tmp12_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = media_source_get_master_file ((MediaSource*) self);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = photo_file_format_properties_convert_file_extension (_tmp14_, _tmp16_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = _tmp17_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = g_file_get_basename (_tmp18_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp18_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp16_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp14_);
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp20_;
#line 3449 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 25042 "Photo.c"
		} else {
			PhotoFileFormat _tmp21_ = 0;
			PhotoFileFormatProperties* _tmp22_ = NULL;
			PhotoFileFormatProperties* _tmp23_ = NULL;
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_ = NULL;
			GFile* _tmp26_ = NULL;
			GFile* _tmp27_ = NULL;
			gchar* _tmp28_ = NULL;
			gchar* _tmp29_ = NULL;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = photo_file_format_get_system_default_format ();
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = photo_file_format_get_properties (_tmp21_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = media_source_get_master_file ((MediaSource*) self);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = _tmp24_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = photo_file_format_properties_convert_file_extension (_tmp23_, _tmp25_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = _tmp26_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = g_file_get_basename (_tmp27_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp29_ = _tmp28_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp27_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp25_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp23_);
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			result = _tmp29_;
#line 3452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return result;
#line 25081 "Photo.c"
		}
	}
}


static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, gboolean export_metadata, GError** error) {
	gboolean result = FALSE;
	PhotoFileReader* export_reader = NULL;
	gboolean is_master = FALSE;
	PhotoFileReader* _tmp30_ = NULL;
	PhotoFileFormatProperties* format_properties = NULL;
	PhotoFileReader* _tmp31_ = NULL;
	PhotoFileFormat _tmp32_ = 0;
	PhotoFileFormatProperties* _tmp33_ = NULL;
	GFile* dest_file = NULL;
	PhotoFileFormatProperties* _tmp34_ = NULL;
	GFile* _tmp35_ = NULL;
	GFile* _tmp36_ = NULL;
	PhotoFileMetadataWriter* writer = NULL;
	PhotoFileReader* _tmp37_ = NULL;
	PhotoFileFormat _tmp38_ = 0;
	GFile* _tmp39_ = NULL;
	gchar* _tmp40_ = NULL;
	gchar* _tmp41_ = NULL;
	PhotoFileMetadataWriter* _tmp42_ = NULL;
	PhotoFileMetadataWriter* _tmp43_ = NULL;
	gchar* _tmp45_ = NULL;
	gchar* _tmp46_ = NULL;
	PhotoFileMetadataWriter* _tmp47_ = NULL;
	gchar* _tmp48_ = NULL;
	gchar* _tmp49_ = NULL;
	PhotoFileReader* _tmp50_ = NULL;
	GFile* _tmp51_ = NULL;
	GFile* _tmp52_ = NULL;
	GFile* _tmp53_ = NULL;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp59_ = FALSE;
	gboolean _tmp60_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoFileReader* _tmp68_ = NULL;
	PhotoMetadata* _tmp69_ = NULL;
	PhotoMetadata* _tmp71_ = NULL;
	PhotoFileMetadataWriter* _tmp75_ = NULL;
	gchar* _tmp76_ = NULL;
	gchar* _tmp77_ = NULL;
	time_t _tmp78_ = 0;
	gboolean _tmp84_ = FALSE;
	PhotoFileMetadataWriter* _tmp102_ = NULL;
	PhotoMetadata* _tmp103_ = NULL;
	GError * _inner_error_ = NULL;
#line 3458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	export_reader = NULL;
#line 3462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_master = TRUE;
#line 25143 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 25150 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 25161 "Photo.c"
				PhotoBackingReaders* _tmp4_ = NULL;
				PhotoFileReader* _tmp5_ = NULL;
				PhotoFileFormat _tmp6_ = 0;
				gboolean _tmp7_ = FALSE;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->editable;
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp5_);
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = photo_file_format_can_write_metadata (_tmp6_);
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 25176 "Photo.c"
			} else {
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 25180 "Photo.c"
			}
#line 3464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp1_) {
#line 25184 "Photo.c"
				PhotoBackingReaders* _tmp8_ = NULL;
				PhotoFileReader* _tmp9_ = NULL;
				PhotoFileReader* _tmp10_ = NULL;
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = self->priv->readers;
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tmp8_->editable;
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _photo_file_adapter_ref0 (_tmp9_);
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 3465 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				export_reader = _tmp10_;
#line 3466 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				is_master = FALSE;
#line 25200 "Photo.c"
			} else {
				gboolean _tmp11_ = FALSE;
				PhotoBackingReaders* _tmp12_ = NULL;
				PhotoFileReader* _tmp13_ = NULL;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = self->priv->readers;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tmp12_->developer;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp13_ != NULL) {
#line 25211 "Photo.c"
					PhotoBackingReaders* _tmp14_ = NULL;
					PhotoFileReader* _tmp15_ = NULL;
					PhotoFileFormat _tmp16_ = 0;
					gboolean _tmp17_ = FALSE;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = self->priv->readers;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = _tmp14_->developer;
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp15_);
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = photo_file_format_can_write_metadata (_tmp16_);
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = _tmp17_;
#line 25226 "Photo.c"
				} else {
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = FALSE;
#line 25230 "Photo.c"
				}
#line 3467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp11_) {
#line 25234 "Photo.c"
					PhotoBackingReaders* _tmp18_ = NULL;
					PhotoFileReader* _tmp19_ = NULL;
					PhotoFileReader* _tmp20_ = NULL;
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = self->priv->readers;
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = _tmp18_->developer;
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = _photo_file_adapter_ref0 (_tmp19_);
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 3468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					export_reader = _tmp20_;
#line 3469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					is_master = FALSE;
#line 25250 "Photo.c"
				} else {
					PhotoBackingReaders* _tmp21_ = NULL;
					PhotoFileReader* _tmp22_ = NULL;
					PhotoFileFormat _tmp23_ = 0;
					gboolean _tmp24_ = FALSE;
#line 3470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp21_ = self->priv->readers;
#line 3470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = _tmp21_->master;
#line 3470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp22_);
#line 3470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp24_ = photo_file_format_can_write_metadata (_tmp23_);
#line 3470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp24_) {
#line 25266 "Photo.c"
						PhotoBackingReaders* _tmp25_ = NULL;
						PhotoFileReader* _tmp26_ = NULL;
						PhotoFileReader* _tmp27_ = NULL;
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp25_ = self->priv->readers;
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp26_ = _tmp25_->master;
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp27_ = _photo_file_adapter_ref0 (_tmp26_);
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 3471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						export_reader = _tmp27_;
#line 25280 "Photo.c"
					}
				}
			}
		}
		__finally243:
		{
			PhotoBackingReaders* _tmp28_ = NULL;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = self->priv->readers;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 25292 "Photo.c"
		}
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25296 "Photo.c"
			gboolean _tmp29_ = FALSE;
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 3463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp29_;
#line 25304 "Photo.c"
		}
	}
#line 3475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = export_reader;
#line 3475 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp30_ == NULL) {
#line 3476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 3476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3476 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 25317 "Photo.c"
	}
#line 3478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = export_reader;
#line 3478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp31_);
#line 3478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = photo_file_format_get_properties (_tmp32_);
#line 3478 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	format_properties = _tmp33_;
#line 3481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = format_properties;
#line 3481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = file;
#line 3481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = photo_file_format_properties_convert_file_extension (_tmp34_, _tmp35_);
#line 3481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dest_file = _tmp36_;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = export_reader;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp37_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = dest_file;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = g_file_get_path (_tmp39_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = _tmp40_;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = photo_file_format_create_metadata_writer (_tmp38_, _tmp41_, &_inner_error_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = _tmp42_;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp41_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp43_;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25355 "Photo.c"
		gboolean _tmp44_ = FALSE;
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp44_;
#line 25367 "Photo.c"
	}
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = data_object_to_string ((DataObject*) self);
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = _tmp45_;
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = writer;
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp48_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp47_);
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3487: Exporting full-sized copy of %s to %s", _tmp46_, _tmp49_);
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp49_);
#line 3487 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp46_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp50_ = export_reader;
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp51_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp50_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp52_ = _tmp51_;
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp53_ = dest_file;
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_copy (_tmp52_, _tmp53_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp52_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25399 "Photo.c"
		gboolean _tmp54_ = FALSE;
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3489 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp54_;
#line 25413 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp60_ = photo_has_alterations (self);
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp60_) {
#line 25419 "Photo.c"
		gboolean _tmp61_ = FALSE;
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp61_ = is_master;
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp59_ = _tmp61_;
#line 25425 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp59_ = FALSE;
#line 25429 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp59_) {
#line 25433 "Photo.c"
		gboolean _tmp62_ = FALSE;
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp62_ = photo_has_user_generated_metadata (self);
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp58_ = !_tmp62_;
#line 25439 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp58_ = FALSE;
#line 25443 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp58_) {
#line 25447 "Photo.c"
		gchar* _tmp63_ = NULL;
		gchar* _tmp64_ = NULL;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp63_ = media_source_get_title ((MediaSource*) self);
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp64_ = _tmp63_;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = _tmp64_ == NULL;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp64_);
#line 25458 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = FALSE;
#line 25462 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp57_) {
#line 25466 "Photo.c"
		gchar* _tmp65_ = NULL;
		gchar* _tmp66_ = NULL;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp65_ = media_source_get_comment ((MediaSource*) self);
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp66_ = _tmp65_;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp56_ = _tmp66_ == NULL;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp66_);
#line 25477 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp56_ = FALSE;
#line 25481 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp56_) {
#line 25485 "Photo.c"
		gboolean _tmp67_ = FALSE;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp67_ = export_metadata;
#line 3495 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp55_ = _tmp67_;
#line 25491 "Photo.c"
	} else {
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp55_ = FALSE;
#line 25495 "Photo.c"
	}
#line 3494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp55_) {
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 25511 "Photo.c"
	}
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp68_ = export_reader;
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp69_ = photo_file_reader_read_metadata (_tmp68_, &_inner_error_);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp69_;
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25521 "Photo.c"
		gboolean _tmp70_ = FALSE;
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp70_;
#line 25535 "Photo.c"
	}
#line 3500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp71_ = metadata;
#line 3500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp71_ == NULL) {
#line 25541 "Photo.c"
		PhotoFileReader* _tmp72_ = NULL;
		PhotoFileFormat _tmp73_ = 0;
		PhotoMetadata* _tmp74_ = NULL;
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = export_reader;
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp72_);
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = photo_file_format_create_metadata (_tmp73_);
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		metadata = _tmp74_;
#line 25555 "Photo.c"
	}
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp75_ = writer;
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp76_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp75_);
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp77_ = _tmp76_;
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3503: Updating metadata of %s", _tmp77_);
#line 3503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp77_);
#line 3505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp78_ = media_source_get_exposure_time ((MediaSource*) self);
#line 3505 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp78_ != ((time_t) 0)) {
#line 25571 "Photo.c"
		PhotoMetadata* _tmp79_ = NULL;
		time_t _tmp80_ = 0;
		MetadataDateTime* _tmp81_ = NULL;
		MetadataDateTime* _tmp82_ = NULL;
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp79_ = metadata;
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp80_ = media_source_get_exposure_time ((MediaSource*) self);
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp81_ = metadata_date_time_new (_tmp80_);
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp82_ = _tmp81_;
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp79_, _tmp82_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3506 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_metadata_date_time_unref0 (_tmp82_);
#line 25588 "Photo.c"
	} else {
		PhotoMetadata* _tmp83_ = NULL;
#line 3508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp83_ = metadata;
#line 3508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp83_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 25595 "Photo.c"
	}
#line 3510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp84_ = export_metadata;
#line 3510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp84_) {
#line 25601 "Photo.c"
		PhotoMetadata* _tmp85_ = NULL;
		gchar* _tmp86_ = NULL;
		gchar* _tmp87_ = NULL;
		PhotoMetadata* _tmp88_ = NULL;
		gchar* _tmp89_ = NULL;
		gchar* _tmp90_ = NULL;
		PhotoMetadata* _tmp91_ = NULL;
		Dimensions _tmp92_ = {0};
		PhotoMetadata* _tmp93_ = NULL;
		Orientation _tmp94_ = 0;
		PhotoMetadata* _tmp95_ = NULL;
		const gchar* _tmp96_ = NULL;
		Orientation _tmp97_ = 0;
		Orientation _tmp98_ = 0;
		PhotoMetadata* _tmp100_ = NULL;
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp85_ = metadata;
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp86_ = media_source_get_title ((MediaSource*) self);
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp87_ = _tmp86_;
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_title (_tmp85_, _tmp87_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp87_);
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp88_ = metadata;
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp89_ = media_source_get_comment ((MediaSource*) self);
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp90_ = _tmp89_;
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_comment (_tmp88_, _tmp90_);
#line 3513 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp90_);
#line 3514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp91_ = metadata;
#line 3514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp92_);
#line 3514 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp91_, &_tmp92_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp93_ = metadata;
#line 3515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp94_ = photo_get_orientation (self);
#line 3515 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_orientation (_tmp93_, _tmp94_);
#line 3516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp95_ = metadata;
#line 3516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp96_ = _ (RESOURCES_APP_TITLE);
#line 3516 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_software (_tmp95_, _tmp96_, RESOURCES_APP_VERSION);
#line 3518 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp97_ = photo_get_orientation (self);
#line 3518 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp98_ = photo_get_original_orientation (self);
#line 3518 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp97_ != _tmp98_) {
#line 25661 "Photo.c"
			PhotoMetadata* _tmp99_ = NULL;
#line 3519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp99_ = metadata;
#line 3519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_metadata_remove_exif_thumbnail (_tmp99_);
#line 25667 "Photo.c"
		}
#line 3521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp100_ = metadata;
#line 3521 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp100_);
#line 25673 "Photo.c"
	} else {
		PhotoMetadata* _tmp101_ = NULL;
#line 3524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp101_ = metadata;
#line 3524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_clear (_tmp101_);
#line 25680 "Photo.c"
	}
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp102_ = writer;
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp103_ = metadata;
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp102_, _tmp103_, &_inner_error_);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 25690 "Photo.c"
		gboolean _tmp104_ = FALSE;
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 3526 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp104_;
#line 25706 "Photo.c"
	}
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 3528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 25722 "Photo.c"
}


gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 3534 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3534 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = scaling_is_unscaled (scaling);
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp3_) {
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = TRUE;
#line 25742 "Photo.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = photo_has_alterations (self);
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 25749 "Photo.c"
	}
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = TRUE;
#line 25755 "Photo.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = photo_has_user_generated_metadata (self);
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp5_;
#line 25762 "Photo.c"
	}
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = TRUE;
#line 25768 "Photo.c"
	} else {
		PhotoFileFormat _tmp6_ = 0;
		PhotoFileFormat _tmp7_ = 0;
#line 3536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = export_format;
#line 3536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = photo_get_file_format (self);
#line 3536 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp6_ != _tmp7_;
#line 25778 "Photo.c"
	}
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 3535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 25784 "Photo.c"
}


void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, gboolean export_metadata, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp18_ = NULL;
	PhotoMetadata* _tmp19_ = NULL;
	PhotoFileFormat _tmp22_ = 0;
	gboolean _tmp23_ = FALSE;
	PhotoFileWriter* writer = NULL;
	PhotoFileFormat _tmp25_ = 0;
	GFile* _tmp26_ = NULL;
	gchar* _tmp27_ = NULL;
	gchar* _tmp28_ = NULL;
	PhotoFileWriter* _tmp29_ = NULL;
	PhotoFileWriter* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	gchar* _tmp32_ = NULL;
	PhotoFileWriter* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	PhotoFileFormat _tmp36_ = 0;
	GEnumValue* _tmp37_;
	GdkPixbuf* pixbuf = NULL;
	gboolean _tmp38_ = FALSE;
	PhotoFileFormat _tmp39_ = 0;
	PhotoFileWriter* _tmp49_ = NULL;
	GdkPixbuf* _tmp50_ = NULL;
	JpegQuality _tmp51_ = 0;
	PhotoFileWriter* _tmp52_ = NULL;
	gchar* _tmp53_ = NULL;
	gchar* _tmp54_ = NULL;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp76_ = FALSE;
	PhotoFileFormat _tmp77_ = 0;
	PhotoFileMetadataWriter* _tmp87_ = NULL;
	PhotoFileFormat _tmp88_ = 0;
	GFile* _tmp89_ = NULL;
	gchar* _tmp90_ = NULL;
	gchar* _tmp91_ = NULL;
	PhotoFileMetadataWriter* _tmp92_ = NULL;
	PhotoFileMetadataWriter* _tmp93_ = NULL;
	PhotoFileMetadataWriter* _tmp94_ = NULL;
	PhotoFileMetadataWriter* _tmp95_ = NULL;
	PhotoMetadata* _tmp96_ = NULL;
	GError * _inner_error_ = NULL;
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (dest_file != NULL);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 3544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = direct_copy_unmodified;
#line 3544 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 25846 "Photo.c"
		GFile* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = media_source_get_master_file ((MediaSource*) self);
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = dest_file;
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_file_copy (_tmp2_, _tmp3_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 25866 "Photo.c"
		}
#line 3547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 25870 "Photo.c"
	}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = scaling_is_unscaled (scaling);
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp7_) {
#line 25876 "Photo.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = photo_has_alterations (self);
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (!_tmp9_) {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = TRUE;
#line 25885 "Photo.c"
		} else {
			gboolean _tmp10_ = FALSE;
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = photo_only_metadata_changed (self);
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp10_;
#line 25892 "Photo.c"
		}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp8_;
#line 25896 "Photo.c"
	} else {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = FALSE;
#line 25900 "Photo.c"
	}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_) {
#line 25904 "Photo.c"
		PhotoFileFormat _tmp11_ = 0;
		PhotoFileFormat _tmp12_ = 0;
#line 3555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = export_format;
#line 3555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = photo_get_file_format (self);
#line 3555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp11_ == _tmp12_;
#line 25913 "Photo.c"
	} else {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = FALSE;
#line 25917 "Photo.c"
	}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_) {
#line 25921 "Photo.c"
		PhotoFileFormat _tmp13_ = 0;
#line 3555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = photo_get_file_format (self);
#line 3555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp13_ == PHOTO_FILE_FORMAT_JFIF;
#line 25927 "Photo.c"
	} else {
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = FALSE;
#line 25931 "Photo.c"
	}
#line 3554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp4_) {
#line 25935 "Photo.c"
		gboolean _tmp14_ = FALSE;
		GFile* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_ = FALSE;
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = dest_file;
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = export_metadata;
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = photo_export_fullsized_backing (self, _tmp15_, _tmp16_, &_inner_error_);
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _tmp17_;
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 25954 "Photo.c"
		}
#line 3556 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp14_) {
#line 3557 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 25960 "Photo.c"
		}
	}
#line 3563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = photo_source_get_metadata ((PhotoSource*) self);
#line 3563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp18_;
#line 3564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = metadata;
#line 3564 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp19_ == NULL) {
#line 25971 "Photo.c"
		PhotoFileFormat _tmp20_ = 0;
		PhotoMetadata* _tmp21_ = NULL;
#line 3565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = export_format;
#line 3565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = photo_file_format_create_metadata (_tmp20_);
#line 3565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		metadata = _tmp21_;
#line 25982 "Photo.c"
	}
#line 3567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = export_format;
#line 3567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = photo_file_format_can_write (_tmp22_);
#line 3567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp23_) {
#line 25990 "Photo.c"
		PhotoFileFormat _tmp24_ = 0;
#line 3568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = photo_file_format_get_system_default_format ();
#line 3568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		export_format = _tmp24_;
#line 25996 "Photo.c"
	}
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = export_format;
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = dest_file;
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = g_file_get_path (_tmp26_);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = _tmp27_;
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = photo_file_format_create_writer (_tmp25_, _tmp28_, &_inner_error_);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = _tmp29_;
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp28_);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	writer = _tmp30_;
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26022 "Photo.c"
	}
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = data_object_to_string ((DataObject*) self);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = writer;
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp33_);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = _tmp34_;
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = export_format;
#line 3573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), _tmp36_);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3572: Saving transformed version of %s to %s in file format" \
" %s", _tmp32_, _tmp35_, (_tmp37_ != NULL) ? _tmp37_->value_name : NULL);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp35_);
#line 3572 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp32_);
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = photo_get_file_format (self);
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp39_ == PHOTO_FILE_FORMAT_JFIF) {
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = TRUE;
#line 26050 "Photo.c"
	} else {
		PhotoFileFormat _tmp40_ = 0;
#line 3580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = photo_get_file_format (self);
#line 3580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp38_ = _tmp40_ == PHOTO_FILE_FORMAT_RAW;
#line 26057 "Photo.c"
	}
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp38_) {
#line 26061 "Photo.c"
		GdkPixbuf* _tmp41_ = NULL;
		Scaling _tmp42_ = {0};
		GdkPixbuf* _tmp43_ = NULL;
		GdkPixbuf* _tmp44_ = NULL;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = *scaling;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = photo_get_pixbuf_with_options (self, &_tmp42_, PHOTO_EXCEPTION_ORIENTATION, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = _tmp43_;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 26084 "Photo.c"
		}
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp44_ = _tmp41_;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = NULL;
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp44_;
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp41_);
#line 26096 "Photo.c"
	} else {
		GdkPixbuf* _tmp45_ = NULL;
		Scaling _tmp46_ = {0};
		GdkPixbuf* _tmp47_ = NULL;
		GdkPixbuf* _tmp48_ = NULL;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = *scaling;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = photo_get_pixbuf_with_options (self, &_tmp46_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = _tmp47_;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (writer);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 26120 "Photo.c"
		}
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = _tmp45_;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = NULL;
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp48_;
#line 3579 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp45_);
#line 26132 "Photo.c"
	}
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp49_ = writer;
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp50_ = pixbuf;
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp51_ = quality;
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_writer_write (_tmp49_, _tmp50_, _tmp51_, &_inner_error_);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3589 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26154 "Photo.c"
	}
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp52_ = writer;
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp53_ = photo_file_adapter_get_filepath ((PhotoFileAdapter*) _tmp52_);
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp54_ = _tmp53_;
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3591: Setting EXIF for %s", _tmp54_);
#line 3591 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp54_);
#line 3594 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp55_ = export_metadata;
#line 3594 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp55_) {
#line 26170 "Photo.c"
		PhotoMetadata* _tmp56_ = NULL;
		gchar* _tmp57_ = NULL;
		gchar* _tmp58_ = NULL;
		PhotoMetadata* _tmp59_ = NULL;
		gchar* _tmp60_ = NULL;
		gchar* _tmp61_ = NULL;
		PhotoMetadata* _tmp62_ = NULL;
		const gchar* _tmp63_ = NULL;
		time_t _tmp64_ = 0;
		PhotoMetadata* _tmp70_ = NULL;
		PhotoMetadata* _tmp71_ = NULL;
		PhotoMetadata* _tmp72_ = NULL;
		gboolean _tmp73_ = FALSE;
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp56_ = metadata;
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp57_ = media_source_get_title ((MediaSource*) self);
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp58_ = _tmp57_;
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_title (_tmp56_, _tmp58_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3596 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp58_);
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp59_ = metadata;
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp60_ = media_source_get_comment ((MediaSource*) self);
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp61_ = _tmp60_;
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_comment (_tmp59_, _tmp61_);
#line 3597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp61_);
#line 3598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp62_ = metadata;
#line 3598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp63_ = _ (RESOURCES_APP_TITLE);
#line 3598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_software (_tmp62_, _tmp63_, RESOURCES_APP_VERSION);
#line 3600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp64_ = media_source_get_exposure_time ((MediaSource*) self);
#line 3600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp64_ != ((time_t) 0)) {
#line 26214 "Photo.c"
			PhotoMetadata* _tmp65_ = NULL;
			time_t _tmp66_ = 0;
			MetadataDateTime* _tmp67_ = NULL;
			MetadataDateTime* _tmp68_ = NULL;
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp65_ = metadata;
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp66_ = media_source_get_exposure_time ((MediaSource*) self);
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp67_ = metadata_date_time_new (_tmp66_);
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp68_ = _tmp67_;
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp65_, _tmp68_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_metadata_date_time_unref0 (_tmp68_);
#line 26231 "Photo.c"
		} else {
			PhotoMetadata* _tmp69_ = NULL;
#line 3603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp69_ = metadata;
#line 3603 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_metadata_set_exposure_date_time (_tmp69_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 26238 "Photo.c"
		}
#line 3605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp70_ = metadata;
#line 3605 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_remove_tag (_tmp70_, "Exif.Iop.RelatedImageWidth");
#line 3606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = metadata;
#line 3606 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_remove_tag (_tmp71_, "Exif.Iop.RelatedImageHeight");
#line 3607 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp72_ = metadata;
#line 3607 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp72_);
#line 3609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp73_ = photo_has_user_generated_metadata (self);
#line 3609 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp73_) {
#line 26256 "Photo.c"
			PhotoMetadata* _tmp74_ = NULL;
#line 3610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp74_ = metadata;
#line 3610 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_user_metadata_for_export (self, _tmp74_);
#line 26262 "Photo.c"
		}
	} else {
		PhotoMetadata* _tmp75_ = NULL;
#line 3613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = metadata;
#line 3613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_clear (_tmp75_);
#line 26270 "Photo.c"
	}
#line 3620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp77_ = photo_get_file_format (self);
#line 3620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp77_ == PHOTO_FILE_FORMAT_JFIF) {
#line 3620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp76_ = TRUE;
#line 26278 "Photo.c"
	} else {
		PhotoFileFormat _tmp78_ = 0;
#line 3621 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp78_ = photo_get_file_format (self);
#line 3621 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp76_ = _tmp78_ == PHOTO_FILE_FORMAT_RAW;
#line 26285 "Photo.c"
	}
#line 3620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp76_) {
#line 26289 "Photo.c"
		PhotoMetadata* _tmp79_ = NULL;
		Dimensions _tmp80_ = {0};
		PhotoMetadata* _tmp81_ = NULL;
		Orientation _tmp82_ = 0;
#line 3622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp79_ = metadata;
#line 3622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_ORIENTATION, &_tmp80_);
#line 3622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp79_, &_tmp80_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp81_ = metadata;
#line 3623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp82_ = photo_get_orientation (self);
#line 3623 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_orientation (_tmp81_, _tmp82_);
#line 26306 "Photo.c"
	} else {
		PhotoMetadata* _tmp83_ = NULL;
		GdkPixbuf* _tmp84_ = NULL;
		Dimensions _tmp85_ = {0};
		PhotoMetadata* _tmp86_ = NULL;
#line 3626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp83_ = metadata;
#line 3626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp84_ = pixbuf;
#line 3626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dimensions_for_pixbuf (_tmp84_, &_tmp85_);
#line 3626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_pixel_dimensions (_tmp83_, &_tmp85_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 3627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp86_ = metadata;
#line 3627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_orientation (_tmp86_, ORIENTATION_TOP_LEFT);
#line 26324 "Photo.c"
	}
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp88_ = export_format;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_ = dest_file;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp90_ = g_file_get_path (_tmp89_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp91_ = _tmp90_;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp92_ = photo_file_format_create_metadata_writer (_tmp88_, _tmp91_, &_inner_error_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp93_ = _tmp92_;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp91_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp87_ = _tmp93_;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26354 "Photo.c"
	}
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp94_ = _tmp87_;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp87_ = NULL;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp95_ = _tmp94_;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp96_ = metadata;
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp95_, _tmp96_, &_inner_error_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp95_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp87_);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 3630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26382 "Photo.c"
	}
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp87_);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 3542 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 26392 "Photo.c"
}


static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error) {
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_ = NULL;
	gchar* editable_basename = NULL;
	const gchar* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	gboolean collision = FALSE;
	GFile* _tmp26_ = NULL;
	GFile* _tmp27_ = NULL;
	GFile* _tmp28_ = NULL;
	gboolean _tmp29_ = FALSE;
	GFile* _tmp30_ = NULL;
	GFile* _tmp31_ = NULL;
	GFile* _tmp32_ = NULL;
	GError * _inner_error_ = NULL;
#line 3633 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26426 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 26433 "Photo.c"
		{
			PhotoFileFormat _tmp1_ = 0;
			GFile* _tmp2_ = NULL;
#line 3636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = photo_get_file_format (self);
#line 3636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_file_format = _tmp1_;
#line 3637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = media_source_get_file ((MediaSource*) self);
#line 3637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing = _tmp2_;
#line 26447 "Photo.c"
		}
		__finally244:
		{
			PhotoRow* _tmp3_ = NULL;
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = self->row;
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 26456 "Photo.c"
		}
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (backing);
#line 3635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 26466 "Photo.c"
		}
	}
#line 3640 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _vala_file_format;
#line 3640 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_file_format_can_write (_tmp4_);
#line 3640 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp5_) {
#line 26475 "Photo.c"
		PhotoFileFormat _tmp6_ = 0;
#line 3641 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = photo_file_format_get_system_default_format ();
#line 3641 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_file_format = _tmp6_;
#line 26481 "Photo.c"
	}
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = g_file_get_basename (backing);
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	disassemble_filename (_tmp8_, &_tmp9_, &_tmp10_);
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (name);
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	name = _tmp9_;
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ext = _tmp10_;
#line 3644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp8_);
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = ext;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = TRUE;
#line 26505 "Photo.c"
	} else {
		PhotoFileFormat _tmp13_ = 0;
		PhotoFileFormatProperties* _tmp14_ = NULL;
		PhotoFileFormatProperties* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		gboolean _tmp17_ = FALSE;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = _vala_file_format;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = photo_file_format_get_properties (_tmp13_);
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = ext;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = photo_file_format_properties_is_recognized_extension (_tmp15_, _tmp16_);
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = !_tmp17_;
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp15_);
#line 26526 "Photo.c"
	}
#line 3646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_) {
#line 26530 "Photo.c"
		PhotoFileFormat _tmp18_ = 0;
		PhotoFileFormatProperties* _tmp19_ = NULL;
		PhotoFileFormatProperties* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = _vala_file_format;
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = photo_file_format_get_properties (_tmp18_);
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = photo_file_format_properties_get_default_extension (_tmp20_);
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (ext);
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		ext = _tmp21_;
#line 3647 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp20_);
#line 26549 "Photo.c"
	}
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = name;
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = _ ("modified");
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = ext;
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = g_strdup_printf ("%s_%s.%s", _tmp22_, _tmp23_, _tmp24_);
#line 3649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_basename = _tmp25_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = g_file_get_parent (backing);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = _tmp27_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = generate_unique_file (_tmp28_, editable_basename, &_tmp29_, &_inner_error_);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	collision = _tmp29_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp28_);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp31_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (editable_basename);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (ext);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (name);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (backing);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 26589 "Photo.c"
	}
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = _tmp26_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = NULL;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp32_;
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp26_);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (editable_basename);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (ext);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (name);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (backing);
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (file_format) {
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*file_format = _vala_file_format;
#line 26611 "Photo.c"
	}
#line 3652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 26615 "Photo.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 26622 "Photo.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_list_free (self);
#line 26631 "Photo.c"
}


static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, const gchar* commandline, GError** error) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GAppInfo* app = NULL;
	GList* files = NULL;
	GFile* _tmp7_ = NULL;
	GFile* _tmp8_ = NULL;
	GAppInfo* _tmp9_ = NULL;
	gchar** argv = NULL;
	gchar** _tmp15_ = NULL;
	gint argv_length1 = 0;
	gint _argv_size_ = 0;
	gchar** _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	const gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gchar** _tmp20_ = NULL;
	gint _tmp20__length1 = 0;
	GFile* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	GPid child_pid = 0;
	gboolean _tmp24_ = FALSE;
	gchar** _tmp25_ = NULL;
	gint _tmp25__length1 = 0;
	GPid _tmp26_ = 0;
	gboolean _tmp27_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 3655 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (commandline != NULL, FALSE);
#line 3657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = commandline;
#line 3657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = is_string_empty (_tmp0_);
#line 3657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 3658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 3658 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 26679 "Photo.c"
	}
	{
		GAppInfo* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GAppInfo* _tmp4_ = NULL;
		GAppInfo* _tmp5_ = NULL;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = commandline;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = g_app_info_create_from_commandline (_tmp3_, "", G_APP_INFO_CREATE_NONE, &_inner_error_);
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26694 "Photo.c"
			goto __catch245_g_error;
		}
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp2_;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = NULL;
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app = _tmp5_;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 26707 "Photo.c"
	}
	goto __finally245;
	__catch245_g_error:
	{
		GError* er = NULL;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		er = _inner_error_;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 3665 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3665 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app = NULL;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (er);
#line 26723 "Photo.c"
	}
	__finally245:
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26728 "Photo.c"
		gboolean _tmp6_ = FALSE;
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp6_;
#line 26736 "Photo.c"
	}
#line 3668 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	files = NULL;
#line 3669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = file;
#line 3669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 3669 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	files = g_list_insert (files, _tmp8_, -1);
#line 3671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = app;
#line 3671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp9_ != NULL) {
#line 26750 "Photo.c"
		gboolean _tmp10_ = FALSE;
		GAppInfo* _tmp11_ = NULL;
		GList* _tmp12_ = NULL;
		gboolean _tmp13_ = FALSE;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = app;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = files;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = g_app_info_launch (_tmp11_, _tmp12_, NULL, &_inner_error_);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp13_;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26765 "Photo.c"
			gboolean _tmp14_ = FALSE;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			__g_list_free__g_object_unref0_0 (files);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (app);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp14_;
#line 26775 "Photo.c"
		}
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp10_;
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 26785 "Photo.c"
	}
#line 3674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = g_new0 (gchar*, 2 + 1);
#line 3674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	argv = _tmp15_;
#line 3674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	argv_length1 = 2;
#line 3674 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_argv_size_ = argv_length1;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = argv;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16__length1 = argv_length1;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = commandline;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp16_[0]);
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_[0] = _tmp18_;
#line 3675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp16_[0];
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = argv;
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20__length1 = argv_length1;
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = file;
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = g_file_get_path (_tmp21_);
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp20_[1]);
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_[1] = _tmp22_;
#line 3676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = _tmp20_[1];
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = argv;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25__length1 = argv_length1;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = g_spawn_async ("/", _tmp25_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp26_, &_inner_error_);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	child_pid = _tmp26_;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = _tmp27_;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 26835 "Photo.c"
		gboolean _tmp28_ = FALSE;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (app);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp28_;
#line 26847 "Photo.c"
	}
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp24_;
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	__g_list_free__g_object_unref0_0 (files);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (app);
#line 3680 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 26859 "Photo.c"
}


void photo_open_with_raw_external_editor (Photo* self, const gchar* external_editor, GError** error) {
	ConfigFacade* _tmp0_ = NULL;
	ConfigFacade* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	PhotoFileFormat _tmp5_ = 0;
	const gchar* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
#line 3690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3690 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = config_facade_get_instance ();
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = external_editor;
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	configuration_facade_set_external_raw_app ((ConfigurationFacade*) _tmp1_, _tmp2_);
#line 3692 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_get_master_file ((MediaSource*) self);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_get_master_file_format (self);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = external_editor;
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_launch_editor (_tmp4_, _tmp5_, _tmp6_, &_inner_error_);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp4_);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3693 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26904 "Photo.c"
	}
}


void photo_open_with_external_editor (Photo* self, const gchar* external_editor, GError** error) {
	GFile* modified_file = NULL;
	GFile* _tmp0_ = NULL;
	ConfigFacade* _tmp1_ = NULL;
	ConfigFacade* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	PhotoFileFormat _tmp5_ = 0;
	const gchar* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
#line 3697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (external_editor != NULL);
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_modified_file (self, &_inner_error_);
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	modified_file = _tmp0_;
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3698 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26933 "Photo.c"
	}
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = config_facade_get_instance ();
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = external_editor;
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	configuration_facade_set_external_photo_app ((ConfigurationFacade*) _tmp2_, _tmp3_);
#line 3701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp2_);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = modified_file;
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_get_file_format (self);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = external_editor;
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_launch_editor (_tmp4_, _tmp5_, _tmp6_, &_inner_error_);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (modified_file);
#line 3702 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 26961 "Photo.c"
	}
#line 3697 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (modified_file);
#line 26965 "Photo.c"
}


GFile* photo_get_modified_file (Photo* self, GError** error) {
	GFile* result = NULL;
	GFile* current_editable_file = NULL;
	GFile* create_editable_file = NULL;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	GFile* _tmp17_ = NULL;
	gboolean _tmp25_ = FALSE;
	GFile* _tmp26_ = NULL;
	GFile* _tmp44_ = NULL;
	GFileMonitor* _tmp45_ = NULL;
	GError * _inner_error_ = NULL;
#line 3705 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3706 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	current_editable_file = NULL;
#line 3707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	create_editable_file = NULL;
#line 26988 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 26995 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
			GFile* _tmp6_ = NULL;
#line 3710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 27006 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				GFile* _tmp5_ = NULL;
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				current_editable_file = _tmp5_;
#line 27020 "Photo.c"
			}
#line 3713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 3713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 27026 "Photo.c"
				GFile* _tmp7_ = NULL;
				PhotoFileFormat _tmp8_ = 0;
				GFile* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = photo_generate_new_editable_file (self, &_tmp8_, &_inner_error_);
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_file_format = _tmp8_;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = _tmp9_;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27039 "Photo.c"
					goto __finally246;
				}
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tmp7_;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = NULL;
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				create_editable_file = _tmp10_;
#line 3713 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp7_);
#line 27052 "Photo.c"
			} else {
				PhotoBackingReaders* _tmp11_ = NULL;
				PhotoFileReader* _tmp12_ = NULL;
				PhotoFileFormat _tmp13_ = 0;
#line 3716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = self->priv->readers;
#line 3716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_->editable;
#line 3716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = photo_file_adapter_get_file_format ((PhotoFileAdapter*) _tmp12_);
#line 3716 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_file_format = _tmp13_;
#line 27065 "Photo.c"
			}
		}
		__finally246:
		{
			PhotoBackingReaders* _tmp14_ = NULL;
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = self->priv->readers;
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 27075 "Photo.c"
		}
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3709 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 27087 "Photo.c"
		}
	}
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = create_editable_file;
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp17_ == NULL) {
#line 27094 "Photo.c"
		GFile* _tmp18_ = NULL;
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = current_editable_file;
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = _tmp18_ != NULL;
#line 27100 "Photo.c"
	} else {
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = FALSE;
#line 27104 "Photo.c"
	}
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp16_) {
#line 27108 "Photo.c"
		gboolean _tmp19_ = FALSE;
		GFile* _tmp20_ = NULL;
		gboolean _tmp21_ = FALSE;
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = g_file_query_exists (_tmp20_, NULL);
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (!_tmp21_) {
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = TRUE;
#line 27120 "Photo.c"
		} else {
			gboolean _tmp22_ = FALSE;
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = photo_has_transformations (self);
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = _tmp22_;
#line 27127 "Photo.c"
		}
#line 3722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp19_;
#line 27131 "Photo.c"
	} else {
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = FALSE;
#line 27135 "Photo.c"
	}
#line 3721 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_) {
#line 27139 "Photo.c"
		GFile* _tmp23_ = NULL;
		GFile* _tmp24_ = NULL;
#line 3723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = current_editable_file;
#line 3723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 3723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 3723 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		create_editable_file = _tmp24_;
#line 27150 "Photo.c"
	}
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = create_editable_file;
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp26_ != NULL) {
#line 27156 "Photo.c"
		PhotoFileFormat _tmp27_ = 0;
		gboolean _tmp28_ = FALSE;
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = editable_file_format;
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = photo_file_format_can_write (_tmp27_);
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = _tmp28_;
#line 27165 "Photo.c"
	} else {
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = FALSE;
#line 27169 "Photo.c"
	}
#line 3726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp25_) {
#line 27173 "Photo.c"
		PhotoFileFormat _tmp40_ = 0;
		GFile* _tmp41_ = NULL;
		GFile* _tmp42_ = NULL;
		GFile* _tmp43_ = NULL;
#line 3727 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 27180 "Photo.c"
		{
			GFile* _tmp29_ = NULL;
			Scaling _tmp30_ = {0};
			PhotoFileFormat _tmp31_ = 0;
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp29_ = create_editable_file;
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			scaling_for_original (&_tmp30_);
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp31_ = editable_file_format;
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_export (self, _tmp29_, &_tmp30_, JPEG_QUALITY_MAXIMUM, _tmp31_, FALSE, TRUE, &_inner_error_);
#line 3730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27195 "Photo.c"
				goto __catch247_g_error;
			}
		}
		goto __finally247;
		__catch247_g_error:
		{
			GError* err = NULL;
			GError* _tmp38_ = NULL;
			GError* _tmp39_ = NULL;
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 27209 "Photo.c"
			{
				GFile* _tmp32_ = NULL;
#line 3735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = create_editable_file;
#line 3735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_file_delete (_tmp32_, NULL, &_inner_error_);
#line 3735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27218 "Photo.c"
					goto __catch248_g_error;
				}
			}
			goto __finally248;
			__catch248_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp33_ = NULL;
				gchar* _tmp34_ = NULL;
				gchar* _tmp35_ = NULL;
				GError* _tmp36_ = NULL;
				const gchar* _tmp37_ = NULL;
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				delete_err = _inner_error_;
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_inner_error_ = NULL;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = create_editable_file;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = g_file_get_path (_tmp33_);
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = _tmp34_;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = delete_err;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _tmp36_->message;
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_warning ("Photo.vala:3738: Unable to delete editable file %s after export error:" \
" %s", _tmp35_, _tmp37_);
#line 3738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp35_);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (delete_err);
#line 27251 "Photo.c"
			}
			__finally248:
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_error_free0 (err);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 3734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return NULL;
#line 27270 "Photo.c"
			}
#line 3742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp38_ = err;
#line 3742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = _g_error_copy0 (_tmp38_);
#line 3742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = _tmp39_;
#line 3742 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 27280 "Photo.c"
			goto __finally247;
		}
		__finally247:
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 27294 "Photo.c"
		}
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp40_ = editable_file_format;
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp41_ = create_editable_file;
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_attach_editable (self, _tmp40_, _tmp41_, &_inner_error_);
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 27312 "Photo.c"
		}
#line 3748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = create_editable_file;
#line 3748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = _g_object_ref0 (_tmp42_);
#line 3748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 3748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		current_editable_file = _tmp43_;
#line 27322 "Photo.c"
	}
#line 3751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = current_editable_file;
#line 3751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp44_ != NULL, "current_editable_file != null");
#line 3754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = self->priv->editable_monitor;
#line 3754 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp45_ == NULL) {
#line 27332 "Photo.c"
		GFile* _tmp46_ = NULL;
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = current_editable_file;
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp46_, &_inner_error_);
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 3755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return NULL;
#line 27348 "Photo.c"
		}
	}
#line 3757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = current_editable_file;
#line 3757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 3757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 27357 "Photo.c"
}


void photo_revert_to_master (Photo* self, gboolean notify) {
	gboolean _tmp0_ = FALSE;
#line 3760 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = notify;
#line 3761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE, _tmp0_);
#line 27369 "Photo.c"
}


static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 3771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_on_editable_file_changed ((Photo*) self, file, other_file, event_type);
#line 27376 "Photo.c"
}


static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error) {
	GFile* _tmp0_ = NULL;
	GFileMonitor* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFileMonitor* _tmp3_ = NULL;
	GFileMonitor* _tmp4_ = NULL;
	GFileMonitor* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 3764 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3764 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 3768 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_monitor_blacklist_file (_tmp0_, "Photo.start_monitoring_editable");
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = file;
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = g_file_monitor (_tmp2_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp3_;
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27410 "Photo.c"
	}
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp1_;
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = NULL;
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable_monitor = _tmp4_;
#line 3771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = self->priv->editable_monitor;
#line 3771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_connect_object (_tmp5_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 3764 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 27426 "Photo.c"
}


static void photo_halt_monitoring_editable (Photo* self) {
	GFileMonitor* _tmp0_ = NULL;
	GFile* file = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFileMonitor* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	GFileMonitor* _tmp6_ = NULL;
#line 3774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 3775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 3776 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27446 "Photo.c"
	}
#line 3779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 3779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp1_;
#line 3780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = file;
#line 3780 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 27456 "Photo.c"
		GFile* _tmp3_ = NULL;
#line 3781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = file;
#line 3781 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 27462 "Photo.c"
	}
#line 3783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 3783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp5_, NULL, FALSE);
#line 3783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 3784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 3784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 3785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 3785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 3774 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 27480 "Photo.c"
}


static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error) {
	PhotoFileFormat _tmp0_ = 0;
	GFile* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	PhotoFileReader* _tmp4_ = NULL;
	PhotoFileReader* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 3788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 3793 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file_format;
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file;
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_file_format_create_reader (_tmp0_, _tmp3_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp5_, &_inner_error_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp5_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp3_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3794 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27522 "Photo.c"
	}
}


static void photo_update_editable_attributes (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3797 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error_);
#line 3798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3798 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27539 "Photo.c"
	}
}


void photo_reimport_editable (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 3801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error_);
#line 3802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27556 "Photo.c"
	}
}


static void _vala_array_add108 (gchar*** array, int* length, int* size, gchar* value) {
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27568 "Photo.c"
	}
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27574 "Photo.c"
}


static void _vala_array_add109 (gchar*** array, int* length, int* size, gchar* value) {
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27585 "Photo.c"
	}
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27591 "Photo.c"
}


static void _vala_array_add110 (gchar*** array, int* length, int* size, gchar* value) {
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27602 "Photo.c"
	}
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27608 "Photo.c"
}


static void _vala_array_add111 (gchar*** array, int* length, int* size, gchar* value) {
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27619 "Photo.c"
	}
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27625 "Photo.c"
}


static void _vala_array_add112 (gchar*** array, int* length, int* size, gchar* value) {
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27636 "Photo.c"
	}
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27642 "Photo.c"
}


static void _vala_array_add113 (gchar*** array, int* length, int* size, gchar* value) {
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 27653 "Photo.c"
	}
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	(*array)[*length] = NULL;
#line 27659 "Photo.c"
}


static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	PhotoFileReader* old_reader = NULL;
	PhotoFileReader* _tmp5_ = NULL;
	PhotoFileReader* _tmp6_ = NULL;
	PhotoFileReader* _tmp7_ = NULL;
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp9_ = NULL;
	PhotoFileReader* _tmp10_ = NULL;
	gboolean timestamp_changed = FALSE;
	gboolean filesize_changed = FALSE;
	gboolean is_new_editable = FALSE;
	BackingPhotoID editable_id = {0};
	BackingPhotoID _tmp11_ = {0};
	GFile* file = NULL;
	PhotoFileReader* _tmp12_ = NULL;
	GFile* _tmp13_ = NULL;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoRow* backing = NULL;
	GFile* _tmp14_ = NULL;
	DetectedPhotoInformation* _tmp15_ = NULL;
	BackingPhotoRow* _tmp16_ = NULL;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp35_ = FALSE;
	PhotoFileReader* _tmp94_ = NULL;
	gboolean _tmp100_ = FALSE;
	gboolean _tmp101_ = FALSE;
	gchar** alteration_list = NULL;
	gchar** _tmp112_ = NULL;
	gint alteration_list_length1 = 0;
	gint _alteration_list_size_ = 0;
	gboolean _tmp113_ = FALSE;
	gboolean _tmp121_ = FALSE;
	gboolean _tmp122_ = FALSE;
	gchar** _tmp131_ = NULL;
	gint _tmp131__length1 = 0;
	GError * _inner_error_ = NULL;
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = only_attributes;
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_) {
#line 27708 "Photo.c"
		PhotoFileReader* _tmp3_ = NULL;
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = new_reader;
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 27714 "Photo.c"
	} else {
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = FALSE;
#line 27718 "Photo.c"
	}
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = TRUE;
#line 27724 "Photo.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = only_attributes;
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = !_tmp4_;
#line 27731 "Photo.c"
	}
#line 3809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp0_, "(only_attributes  &&new_reader == null) || (!only_attributes)");
#line 3811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_get_editable_reader (self);
#line 3811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old_reader = _tmp5_;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = new_reader;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = _tmp7_;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_ == NULL) {
#line 27745 "Photo.c"
		PhotoFileReader* _tmp8_ = NULL;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = old_reader;
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp8_;
#line 27751 "Photo.c"
	}
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _photo_file_adapter_ref0 (_tmp6_);
#line 3813 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp9_;
#line 3814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = reader;
#line 3814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp10_ == NULL) {
#line 3815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3817 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27769 "Photo.c"
	}
#line 3820 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	timestamp_changed = FALSE;
#line 3821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	filesize_changed = FALSE;
#line 3822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	is_new_editable = FALSE;
#line 3824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_editable_id (self, &_tmp11_);
#line 3824 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_id = _tmp11_;
#line 3825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = reader;
#line 3825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp12_);
#line 3825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp13_;
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = file;
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = photo_query_backing_photo_row (self, _tmp14_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp15_, &_inner_error_);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	detected = _tmp15_;
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing = _tmp16_;
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 3828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 27811 "Photo.c"
	}
#line 3832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = backing_photo_id_is_invalid (&editable_id);
#line 3832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp17_) {
#line 27817 "Photo.c"
		BackingPhotoRow* _tmp18_ = NULL;
#line 3834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = backing;
#line 3834 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp18_ != NULL) {
#line 27823 "Photo.c"
			BackingPhotoTable* _tmp19_ = NULL;
			BackingPhotoTable* _tmp20_ = NULL;
			BackingPhotoRow* _tmp21_ = NULL;
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = backing_photo_table_get_instance ();
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = backing;
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_table_add (_tmp20_, _tmp21_, &_inner_error_);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp20_);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 27853 "Photo.c"
			}
			{
				PhotoRow* _tmp22_ = NULL;
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = self->row;
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 27861 "Photo.c"
				{
					PhotoTable* _tmp23_ = NULL;
					PhotoTable* _tmp24_ = NULL;
					PhotoRow* _tmp25_ = NULL;
					BackingPhotoRow* _tmp26_ = NULL;
					BackingPhotoID _tmp27_ = {0};
					BackingPhotoRow* _tmp28_ = NULL;
					BackingPhotoRow* _tmp29_ = NULL;
					BackingPhotoRow* _tmp30_ = NULL;
					BackingPhotoRow* _tmp31_ = NULL;
					BackingPhotoRow* _tmp32_ = NULL;
					Orientation _tmp33_ = 0;
#line 3837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					timestamp_changed = TRUE;
#line 3838 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					filesize_changed = TRUE;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = photo_table_get_instance ();
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp24_ = _tmp23_;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = self->row;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp26_ = backing;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp27_ = _tmp26_->id;
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_table_attach_editable (_tmp24_, _tmp25_, &_tmp27_, &_inner_error_);
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_database_table_unref0 (_tmp24_);
#line 3840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27894 "Photo.c"
						goto __finally249;
					}
#line 3841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp28_ = backing;
#line 3841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp29_ = _backing_photo_row_ref0 (_tmp28_);
#line 3841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->priv->editable = _tmp29_;
#line 3842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = self->priv->editable;
#line 3842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31_ = _backing_photo_row_ref0 (_tmp30_);
#line 3842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->backing_photo_row = _tmp31_;
#line 3843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp32_ = self->backing_photo_row;
#line 3843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp33_ = _tmp32_->original_orientation;
#line 3843 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_set_orientation (self, _tmp33_);
#line 27919 "Photo.c"
				}
				__finally249:
				{
					PhotoRow* _tmp34_ = NULL;
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp34_ = self->row;
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 27928 "Photo.c"
				}
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (file);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3836 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 27946 "Photo.c"
				}
			}
		}
#line 3846 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		is_new_editable = TRUE;
#line 27952 "Photo.c"
	}
#line 3849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = only_attributes;
#line 3849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp35_) {
#line 27958 "Photo.c"
		gboolean _tmp36_ = FALSE;
		GFileInfo* info = NULL;
		GTimeVal timestamp = {0};
		GFileInfo* _tmp45_ = NULL;
		GTimeVal _tmp46_ = {0};
		BackingPhotoTable* _tmp47_ = NULL;
		BackingPhotoTable* _tmp48_ = NULL;
		BackingPhotoID _tmp49_ = {0};
		GTimeVal _tmp50_ = {0};
		glong _tmp51_ = 0L;
		GFileInfo* _tmp52_ = NULL;
		gint64 _tmp53_ = 0LL;
#line 3851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp36_ = backing_photo_id_is_valid (&editable_id);
#line 3851 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_assert (_tmp36_, "editable_id.is_valid ()");
#line 27975 "Photo.c"
		{
			GFileInfo* _tmp37_ = NULL;
			GFile* _tmp38_ = NULL;
			GFileInfo* _tmp39_ = NULL;
			GFileInfo* _tmp40_ = NULL;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp38_ = file;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = g_file_query_filesystem_info (_tmp38_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error_);
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = _tmp39_;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 27989 "Photo.c"
				goto __catch250_g_error;
			}
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = _tmp37_;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = NULL;
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 3855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			info = _tmp40_;
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp37_);
#line 28002 "Photo.c"
		}
		goto __finally250;
		__catch250_g_error:
		{
			GError* err = NULL;
			gchar* _tmp41_ = NULL;
			gchar* _tmp42_ = NULL;
			GError* _tmp43_ = NULL;
			const gchar* _tmp44_ = NULL;
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = data_object_to_string ((DataObject*) self);
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = _tmp41_;
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43_ = err;
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp44_ = _tmp43_->message;
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_warning ("Photo.vala:3857: Unable to read editable filesystem info for %s: %s", _tmp42_, _tmp44_);
#line 3857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp42_);
#line 3858 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3860 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28046 "Photo.c"
		}
		__finally250:
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28067 "Photo.c"
		}
#line 3863 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = info;
#line 3863 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_file_info_get_modification_time (_tmp45_, &_tmp46_);
#line 3863 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		timestamp = _tmp46_;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = backing_photo_table_get_instance ();
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = editable_id;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = timestamp;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = _tmp50_.tv_sec;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp52_ = info;
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp53_ = g_file_info_get_size (_tmp52_);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		backing_photo_table_update_attributes (_tmp48_, &_tmp49_, (time_t) _tmp51_, _tmp53_, &_inner_error_);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp48_);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (info);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_backing_photo_row_unref0 (backing);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 3865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28111 "Photo.c"
		}
		{
			PhotoRow* _tmp54_ = NULL;
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp54_ = self->row;
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_row);
#line 28119 "Photo.c"
			{
				BackingPhotoRow* _tmp55_ = NULL;
				time_t _tmp56_ = 0;
				GTimeVal _tmp57_ = {0};
				glong _tmp58_ = 0L;
				BackingPhotoRow* _tmp59_ = NULL;
				gint64 _tmp60_ = 0LL;
				GFileInfo* _tmp61_ = NULL;
				gint64 _tmp62_ = 0LL;
				BackingPhotoRow* _tmp63_ = NULL;
				GTimeVal _tmp64_ = {0};
				glong _tmp65_ = 0L;
				BackingPhotoRow* _tmp66_ = NULL;
				GFileInfo* _tmp67_ = NULL;
				gint64 _tmp68_ = 0LL;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp55_ = self->priv->editable;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = _tmp55_->timestamp;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = timestamp;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = _tmp57_.tv_sec;
#line 3868 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				timestamp_changed = _tmp56_ != ((time_t) _tmp58_);
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp59_ = self->priv->editable;
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp60_ = _tmp59_->filesize;
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp61_ = info;
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp62_ = g_file_info_get_size (_tmp61_);
#line 3869 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				filesize_changed = _tmp60_ != _tmp62_;
#line 3871 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp63_ = self->priv->editable;
#line 3871 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp64_ = timestamp;
#line 3871 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp65_ = _tmp64_.tv_sec;
#line 3871 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp63_->timestamp = (time_t) _tmp65_;
#line 3872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp66_ = self->priv->editable;
#line 3872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_ = info;
#line 3872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp68_ = g_file_info_get_size (_tmp67_);
#line 3872 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp66_->filesize = _tmp68_;
#line 28171 "Photo.c"
			}
			__finally251:
			{
				PhotoRow* _tmp69_ = NULL;
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp69_ = self->row;
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28180 "Photo.c"
			}
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (info);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3867 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 28200 "Photo.c"
			}
		}
#line 3849 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (info);
#line 28205 "Photo.c"
	} else {
		gboolean _tmp70_ = FALSE;
		gboolean _tmp71_ = FALSE;
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp71_ = backing_photo_id_is_valid (&editable_id);
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp71_) {
#line 28213 "Photo.c"
			gboolean _tmp72_ = FALSE;
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp72_ = is_new_editable;
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp70_ = !_tmp72_;
#line 28219 "Photo.c"
		} else {
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp70_ = FALSE;
#line 28223 "Photo.c"
		}
#line 3876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp70_) {
#line 28227 "Photo.c"
			BackingPhotoRow* _tmp73_ = NULL;
			BackingPhotoID _tmp74_ = {0};
			BackingPhotoTable* _tmp75_ = NULL;
			BackingPhotoTable* _tmp76_ = NULL;
			BackingPhotoRow* _tmp77_ = NULL;
#line 3881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp73_ = backing;
#line 3881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp74_ = editable_id;
#line 3881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp73_->id = _tmp74_;
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp75_ = backing_photo_table_get_instance ();
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp76_ = _tmp75_;
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp77_ = backing;
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_table_update (_tmp76_, _tmp77_, &_inner_error_);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp76_);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3882 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 28265 "Photo.c"
			}
			{
				PhotoRow* _tmp78_ = NULL;
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp78_ = self->row;
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28273 "Photo.c"
				{
					BackingPhotoRow* _tmp79_ = NULL;
					time_t _tmp80_ = 0;
					BackingPhotoRow* _tmp81_ = NULL;
					time_t _tmp82_ = 0;
					BackingPhotoRow* _tmp83_ = NULL;
					gint64 _tmp84_ = 0LL;
					BackingPhotoRow* _tmp85_ = NULL;
					gint64 _tmp86_ = 0LL;
					BackingPhotoRow* _tmp87_ = NULL;
					BackingPhotoRow* _tmp88_ = NULL;
					BackingPhotoRow* _tmp89_ = NULL;
					BackingPhotoRow* _tmp90_ = NULL;
					BackingPhotoRow* _tmp91_ = NULL;
					Orientation _tmp92_ = 0;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp79_ = self->priv->editable;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp80_ = _tmp79_->timestamp;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp81_ = backing;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp82_ = _tmp81_->timestamp;
#line 3884 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					timestamp_changed = _tmp80_ != _tmp82_;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp83_ = self->priv->editable;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp84_ = _tmp83_->filesize;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp85_ = backing;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp86_ = _tmp85_->filesize;
#line 3885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					filesize_changed = _tmp84_ != _tmp86_;
#line 3887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp87_ = backing;
#line 3887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp88_ = _backing_photo_row_ref0 (_tmp87_);
#line 3887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->priv->editable);
#line 3887 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->priv->editable = _tmp88_;
#line 3888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp89_ = self->priv->editable;
#line 3888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp90_ = _backing_photo_row_ref0 (_tmp89_);
#line 3888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->backing_photo_row = _tmp90_;
#line 3889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp91_ = self->backing_photo_row;
#line 3889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp92_ = _tmp91_->original_orientation;
#line 3889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_set_orientation (self, _tmp92_);
#line 28331 "Photo.c"
				}
				__finally252:
				{
					PhotoRow* _tmp93_ = NULL;
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp93_ = self->row;
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28340 "Photo.c"
				}
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (backing);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (file);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 3883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 28358 "Photo.c"
				}
			}
		}
	}
#line 3895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp94_ = new_reader;
#line 3895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp94_ != NULL) {
#line 28367 "Photo.c"
		{
			PhotoBackingReaders* _tmp95_ = NULL;
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp95_ = self->priv->readers;
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28374 "Photo.c"
			{
				PhotoBackingReaders* _tmp96_ = NULL;
				PhotoFileReader* _tmp97_ = NULL;
				PhotoFileReader* _tmp98_ = NULL;
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp96_ = self->priv->readers;
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp97_ = new_reader;
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp98_ = _photo_file_adapter_ref0 (_tmp97_);
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp96_->editable);
#line 3897 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp96_->editable = _tmp98_;
#line 28389 "Photo.c"
			}
			__finally253:
			{
				PhotoBackingReaders* _tmp99_ = NULL;
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp99_ = self->priv->readers;
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28398 "Photo.c"
			}
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (backing);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 3896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 28416 "Photo.c"
			}
		}
	}
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp101_ = only_attributes;
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp101_) {
#line 28424 "Photo.c"
		PhotoFileReader* _tmp102_ = NULL;
		PhotoFileReader* _tmp103_ = NULL;
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp102_ = reader;
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp103_ = old_reader;
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp100_ = _tmp102_ != _tmp103_;
#line 28433 "Photo.c"
	} else {
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp100_ = FALSE;
#line 28437 "Photo.c"
	}
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp100_) {
#line 28441 "Photo.c"
		GFile* _tmp104_ = NULL;
		PhotoFileReader* _tmp105_ = NULL;
		GFile* _tmp108_ = NULL;
		PhotoFileReader* _tmp109_ = NULL;
#line 3902 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp105_ = old_reader;
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp105_ != NULL) {
#line 28452 "Photo.c"
			PhotoFileReader* _tmp106_ = NULL;
			GFile* _tmp107_ = NULL;
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp106_ = old_reader;
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp107_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp106_);
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp104_);
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp104_ = _tmp107_;
#line 28463 "Photo.c"
		} else {
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp104_);
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp104_ = NULL;
#line 28469 "Photo.c"
		}
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp109_ = new_reader;
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp109_ != NULL) {
#line 28475 "Photo.c"
			PhotoFileReader* _tmp110_ = NULL;
			GFile* _tmp111_ = NULL;
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp110_ = new_reader;
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp111_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp110_);
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp108_);
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp108_ = _tmp111_;
#line 28486 "Photo.c"
		} else {
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp108_);
#line 3904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp108_ = NULL;
#line 28492 "Photo.c"
		}
#line 3903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp104_, _tmp108_);
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp108_);
#line 3901 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp104_);
#line 28500 "Photo.c"
	}
#line 3907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp112_ = g_new0 (gchar*, 0 + 1);
#line 3907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	alteration_list = _tmp112_;
#line 3907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	alteration_list_length1 = 0;
#line 3907 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 3908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp113_ = timestamp_changed;
#line 3908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp113_) {
#line 28514 "Photo.c"
		gchar** _tmp114_ = NULL;
		gint _tmp114__length1 = 0;
		gchar* _tmp115_ = NULL;
		gchar** _tmp116_ = NULL;
		gint _tmp116__length1 = 0;
		gchar* _tmp117_ = NULL;
		gboolean _tmp118_ = FALSE;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp114_ = alteration_list;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp114__length1 = alteration_list_length1;
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp115_ = g_strdup ("metadata:editable-timestamp");
#line 3909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add108 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp115_);
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp116_ = alteration_list;
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp116__length1 = alteration_list_length1;
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp117_ = g_strdup ("metadata:baseline-timestamp");
#line 3910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add109 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp117_);
#line 3912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp118_ = photo_is_editable_source (self);
#line 3912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp118_) {
#line 28542 "Photo.c"
			gchar** _tmp119_ = NULL;
			gint _tmp119__length1 = 0;
			gchar* _tmp120_ = NULL;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp119_ = alteration_list;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp119__length1 = alteration_list_length1;
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp120_ = g_strdup ("metadata:source-timestamp");
#line 3913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add110 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp120_);
#line 28554 "Photo.c"
		}
	}
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp122_ = filesize_changed;
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp122_) {
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp121_ = TRUE;
#line 28563 "Photo.c"
	} else {
		PhotoFileReader* _tmp123_ = NULL;
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp123_ = new_reader;
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp121_ = _tmp123_ != NULL;
#line 28570 "Photo.c"
	}
#line 3916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp121_) {
#line 28574 "Photo.c"
		gchar** _tmp124_ = NULL;
		gint _tmp124__length1 = 0;
		gchar* _tmp125_ = NULL;
		gchar** _tmp126_ = NULL;
		gint _tmp126__length1 = 0;
		gchar* _tmp127_ = NULL;
		gboolean _tmp128_ = FALSE;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp124_ = alteration_list;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp124__length1 = alteration_list_length1;
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp125_ = g_strdup ("image:editable");
#line 3917 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add111 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp125_);
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp126_ = alteration_list;
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp126__length1 = alteration_list_length1;
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp127_ = g_strdup ("image:baseline");
#line 3918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_array_add112 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp127_);
#line 3920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp128_ = photo_is_editable_source (self);
#line 3920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp128_) {
#line 28602 "Photo.c"
			gchar** _tmp129_ = NULL;
			gint _tmp129__length1 = 0;
			gchar* _tmp130_ = NULL;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp129_ = alteration_list;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp129__length1 = alteration_list_length1;
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp130_ = g_strdup ("image:source");
#line 3921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_array_add113 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp130_);
#line 28614 "Photo.c"
		}
	}
#line 3924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp131_ = alteration_list;
#line 3924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp131__length1 = alteration_list_length1;
#line 3924 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp131__length1 > 0) {
#line 28623 "Photo.c"
		gchar** _tmp132_ = NULL;
		gint _tmp132__length1 = 0;
		Alteration* _tmp133_ = NULL;
		Alteration* _tmp134_ = NULL;
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp132_ = alteration_list;
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp132__length1 = alteration_list_length1;
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp133_ = alteration_new_from_array (_tmp132_, _tmp132__length1);
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp134_ = _tmp133_;
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp134_);
#line 3925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp134_);
#line 28640 "Photo.c"
	}
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (backing);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 3807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 28654 "Photo.c"
}


static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations, gboolean notify) {
	gboolean has_editable = FALSE;
	GFile* editable_file = NULL;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
	GError * _inner_error_ = NULL;
#line 3928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3931 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	has_editable = FALSE;
#line 3932 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable_file = NULL;
#line 28678 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 28685 "Photo.c"
		{
			PhotoBackingReaders* _tmp1_ = NULL;
			PhotoFileReader* _tmp2_ = NULL;
#line 3934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->editable;
#line 3934 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 28695 "Photo.c"
				PhotoBackingReaders* _tmp3_ = NULL;
				PhotoFileReader* _tmp4_ = NULL;
				GFile* _tmp5_ = NULL;
				PhotoBackingReaders* _tmp6_ = NULL;
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = _tmp3_->editable;
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp4_);
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 3935 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_file = _tmp5_;
#line 3936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 3936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp6_->editable);
#line 3936 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_->editable = NULL;
#line 3937 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				has_editable = TRUE;
#line 28718 "Photo.c"
			}
		}
		__finally254:
		{
			PhotoBackingReaders* _tmp7_ = NULL;
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 28728 "Photo.c"
		}
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3933 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28740 "Photo.c"
		}
	}
#line 3941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = has_editable;
#line 3941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 28747 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 3942 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 28751 "Photo.c"
		{
			{
				PhotoRow* _tmp9_ = NULL;
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = self->row;
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_rec_mutex_lock (&self->priv->__lock_row);
#line 28759 "Photo.c"
				{
					PhotoRow* _tmp10_ = NULL;
					BackingPhotoID _tmp11_ = {0};
					gboolean _tmp12_ = FALSE;
					PhotoRow* _tmp16_ = NULL;
					BackingPhotoRow* _tmp17_ = NULL;
					BackingPhotoRow* _tmp18_ = NULL;
#line 3945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = self->row;
#line 3945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = _tmp10_->editable_id;
#line 3945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					editable_id = _tmp11_;
#line 3946 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = backing_photo_id_is_valid (&editable_id);
#line 3946 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp12_) {
#line 28777 "Photo.c"
						PhotoTable* _tmp13_ = NULL;
						PhotoTable* _tmp14_ = NULL;
						PhotoRow* _tmp15_ = NULL;
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = photo_table_get_instance ();
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp14_ = _tmp13_;
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp15_ = self->row;
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						photo_table_detach_editable (_tmp14_, _tmp15_, &_inner_error_);
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_database_table_unref0 (_tmp14_);
#line 3947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 28793 "Photo.c"
							goto __finally256;
						}
					}
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = self->row;
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = _tmp16_->master;
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = _backing_photo_row_ref0 (_tmp17_);
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (self->backing_photo_row);
#line 3948 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->backing_photo_row = _tmp18_;
#line 28807 "Photo.c"
				}
				__finally256:
				{
					PhotoRow* _tmp19_ = NULL;
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = self->row;
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 28816 "Photo.c"
				}
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 28822 "Photo.c"
						goto __catch255_database_error;
					}
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 28833 "Photo.c"
				}
			}
		}
		goto __finally255;
		__catch255_database_error:
		{
			GError* err = NULL;
			GError* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 3951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = err;
#line 3951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = _tmp20_->message;
#line 3951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_warning ("Photo.vala:3951: Unable to remove editable from PhotoTable: %s", _tmp21_);
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 28855 "Photo.c"
		}
		__finally255:
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28868 "Photo.c"
		}
		{
			gboolean _tmp22_ = FALSE;
#line 3955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = backing_photo_id_is_valid (&editable_id);
#line 3955 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp22_) {
#line 28876 "Photo.c"
				BackingPhotoTable* _tmp23_ = NULL;
				BackingPhotoTable* _tmp24_ = NULL;
				BackingPhotoID _tmp25_ = {0};
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = backing_photo_table_get_instance ();
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = _tmp23_;
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = editable_id;
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				backing_photo_table_remove (_tmp24_, &_tmp25_, &_inner_error_);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_database_table_unref0 (_tmp24_);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 28894 "Photo.c"
						goto __catch257_database_error;
					}
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 28905 "Photo.c"
				}
			}
		}
		goto __finally257;
		__catch257_database_error:
		{
			GError* err = NULL;
			GError* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 3958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = err;
#line 3958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = _tmp26_->message;
#line 3958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_warning ("Photo.vala:3958: Unable to remove editable from BackingPhotoTable: %s", _tmp27_);
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 28927 "Photo.c"
		}
		__finally257:
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3954 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 28940 "Photo.c"
		}
	}
#line 3962 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = remove_transformations;
#line 3962 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp28_) {
#line 3963 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_internal_remove_all_transformations (self, FALSE);
#line 28949 "Photo.c"
	}
#line 3965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = has_editable;
#line 3965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp29_) {
#line 28955 "Photo.c"
		GFile* _tmp30_ = NULL;
#line 3966 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = editable_file;
#line 3967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp30_, NULL);
#line 28963 "Photo.c"
	}
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = delete_editable;
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp32_) {
#line 28969 "Photo.c"
		GFile* _tmp33_ = NULL;
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33_ = editable_file;
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = _tmp33_ != NULL;
#line 28975 "Photo.c"
	} else {
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = FALSE;
#line 28979 "Photo.c"
	}
#line 3970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp31_) {
#line 28983 "Photo.c"
		{
			GFile* _tmp34_ = NULL;
#line 3972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp34_ = editable_file;
#line 3972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_file_trash (_tmp34_, NULL, &_inner_error_);
#line 3972 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 28992 "Photo.c"
				goto __catch258_g_error;
			}
		}
		goto __finally258;
		__catch258_g_error:
		{
			GError* err = NULL;
			GFile* _tmp35_ = NULL;
			gchar* _tmp36_ = NULL;
			gchar* _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			GError* _tmp40_ = NULL;
			const gchar* _tmp41_ = NULL;
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			err = _inner_error_;
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_inner_error_ = NULL;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp35_ = editable_file;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp36_ = g_file_get_path (_tmp35_);
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp37_ = _tmp36_;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp38_ = data_object_to_string ((DataObject*) self);
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = _tmp38_;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = err;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = _tmp40_->message;
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_warning ("Photo.vala:3974: Unable to trash editable %s for %s: %s", _tmp37_, _tmp39_, _tmp41_);
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp39_);
#line 3974 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (_tmp37_);
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_error_free0 (err);
#line 29033 "Photo.c"
		}
		__finally258:
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 29046 "Photo.c"
		}
	}
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = has_editable;
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp44_) {
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = TRUE;
#line 29055 "Photo.c"
	} else {
		gboolean _tmp45_ = FALSE;
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp45_ = remove_transformations;
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = _tmp45_;
#line 29062 "Photo.c"
	}
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp43_) {
#line 29066 "Photo.c"
		gboolean _tmp46_ = FALSE;
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = notify;
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = _tmp46_;
#line 29072 "Photo.c"
	} else {
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp42_ = FALSE;
#line 29076 "Photo.c"
	}
#line 3979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp42_) {
#line 29080 "Photo.c"
		Alteration* _tmp47_ = NULL;
		Alteration* _tmp48_ = NULL;
#line 3980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = alteration_new ("image", "revert");
#line 3980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 3980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_object_notify_altered ((DataObject*) self, _tmp48_);
#line 3980 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_alteration_unref0 (_tmp48_);
#line 29091 "Photo.c"
	}
#line 3928 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 29095 "Photo.c"
}


static void _photo_on_reimport_editable_one_shot_callback (gpointer self) {
#line 3995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_on_reimport_editable ((Photo*) self);
#line 29102 "Photo.c"
}


static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self) {
#line 4004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_on_update_editable_attributes ((Photo*) self);
#line 29109 "Photo.c"
}


static void _photo_on_remove_editable_one_shot_callback (gpointer self) {
#line 4013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_on_remove_editable ((Photo*) self);
#line 29116 "Photo.c"
}


static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	GFileMonitorEvent _tmp11_ = 0;
	GEnumValue* _tmp12_;
	GFile* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	GFileMonitorEvent _tmp16_ = 0;
	GError * _inner_error_ = NULL;
#line 3983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 3983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (file != NULL);
#line 29132 "Photo.c"
	{
		PhotoBackingReaders* _tmp0_ = NULL;
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_readers);
#line 29139 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders* _tmp2_ = NULL;
			PhotoFileReader* _tmp3_ = NULL;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _tmp2_->editable;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 29150 "Photo.c"
				GFile* _tmp4_ = NULL;
				PhotoBackingReaders* _tmp5_ = NULL;
				PhotoFileReader* _tmp6_ = NULL;
				GFile* _tmp7_ = NULL;
				GFile* _tmp8_ = NULL;
				gboolean _tmp9_ = FALSE;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = file;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = self->priv->readers;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = _tmp5_->editable;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp6_);
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = g_file_equal (_tmp4_, _tmp8_);
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = _tmp9_;
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 29173 "Photo.c"
			} else {
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp1_ = FALSE;
#line 29177 "Photo.c"
			}
#line 3986 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_vala_assert (_tmp1_, "readers.editable != null && file.equal (readers.editable.get_file ())");
#line 29181 "Photo.c"
		}
		__finally259:
		{
			PhotoBackingReaders* _tmp10_ = NULL;
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = self->priv->readers;
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_readers);
#line 29190 "Photo.c"
		}
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 29200 "Photo.c"
		}
	}
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = event;
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = g_enum_get_value (g_type_class_ref (g_file_monitor_event_get_type ()), _tmp11_);
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = file;
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = g_file_get_path (_tmp13_);
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:3989: EDITABLE %s: %s", (_tmp12_ != NULL) ? _tmp12_->value_name : NULL, _tmp15_);
#line 3989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp15_);
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = event;
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (_tmp16_) {
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 29225 "Photo.c"
		{
			OneShotScheduler* _tmp17_ = NULL;
			OneShotScheduler* _tmp19_ = NULL;
#line 3994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->priv->reimport_editable_scheduler;
#line 3994 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp17_ == NULL) {
#line 29233 "Photo.c"
				OneShotScheduler* _tmp18_ = NULL;
#line 3995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 3995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 3995 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp18_;
#line 29241 "Photo.c"
			}
#line 3999 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = self->priv->reimport_editable_scheduler;
#line 3999 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp19_, (guint) 1000, TRUE);
#line 4000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 29249 "Photo.c"
		}
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 29253 "Photo.c"
		{
			OneShotScheduler* _tmp20_ = NULL;
			OneShotScheduler* _tmp22_ = NULL;
#line 4003 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = self->priv->update_editable_attributes_scheduler;
#line 4003 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp20_ == NULL) {
#line 29261 "Photo.c"
				OneShotScheduler* _tmp21_ = NULL;
#line 4004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 4004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 4004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp21_;
#line 29269 "Photo.c"
			}
#line 4008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = self->priv->update_editable_attributes_scheduler;
#line 4008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp22_, (guint) 1000, TRUE);
#line 4009 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 29277 "Photo.c"
		}
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 29281 "Photo.c"
		{
			OneShotScheduler* _tmp23_ = NULL;
			OneShotScheduler* _tmp25_ = NULL;
#line 4012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = self->priv->remove_editable_scheduler;
#line 4012 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp23_ == NULL) {
#line 29289 "Photo.c"
				OneShotScheduler* _tmp24_ = NULL;
#line 4013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 4013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 4013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp24_;
#line 29297 "Photo.c"
			}
#line 4017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = self->priv->remove_editable_scheduler;
#line 4017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp25_, (guint) 3000, TRUE);
#line 4018 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 29305 "Photo.c"
		}
		default:
#line 3991 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 29310 "Photo.c"
		{
#line 4023 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			break;
#line 29314 "Photo.c"
		}
	}
#line 4028 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 29319 "Photo.c"
}


static void photo_on_reimport_editable (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4031 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_discard_prefetched (self, TRUE);
#line 4035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:4035: Reimporting editable for %s", _tmp1_);
#line 4035 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29339 "Photo.c"
	{
#line 4037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable (self, &_inner_error_);
#line 4037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 29345 "Photo.c"
			goto __catch260_g_error;
		}
	}
	goto __finally260;
	__catch260_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = data_object_to_string ((DataObject*) self);
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = err;
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:4039: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 4039 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 29375 "Photo.c"
	}
	__finally260:
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4036 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 29386 "Photo.c"
	}
}


static void photo_on_update_editable_attributes (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4044 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:4045: Updating editable attributes for %s", _tmp1_);
#line 4045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 29405 "Photo.c"
	{
#line 4047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error_);
#line 4047 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 29411 "Photo.c"
			goto __catch261_g_error;
		}
	}
	goto __finally261;
	__catch261_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = err;
#line 4049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4049 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:4049: Unable to update editable attributes: %s", _tmp3_);
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 29433 "Photo.c"
	}
	__finally261:
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4046 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 29444 "Photo.c"
	}
}


static void photo_on_remove_editable (Photo* self) {
	PhotoFileReader* reader = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_ = NULL;
	GFile* file = NULL;
	PhotoFileReader* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
#line 4053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 4054 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	reader = _tmp0_;
#line 4055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = reader;
#line 4055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 29474 "Photo.c"
	}
#line 4058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = reader;
#line 4058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file ((PhotoFileAdapter*) _tmp2_);
#line 4058 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp3_;
#line 4059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = file;
#line 4059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 4059 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_) {
#line 29488 "Photo.c"
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
#line 4060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = data_object_to_string ((DataObject*) self);
#line 4060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 4060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_debug ("Photo.vala:4060: Not removing editable for %s: file exists", _tmp7_);
#line 4060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 4062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (file);
#line 4062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 4062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 29505 "Photo.c"
	}
#line 4065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = data_object_to_string ((DataObject*) self);
#line 4065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 4065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_debug ("Photo.vala:4065: Removing editable for %s: file no longer exists", _tmp9_);
#line 4065 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp9_);
#line 4066 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE, TRUE);
#line 4053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 4053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 29521 "Photo.c"
}


void photo_get_original_dimensions (Photo* self, Dimensions* result) {
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Orientation _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
#line 4074 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 4075 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dim = _tmp0_;
#line 4076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 4076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = _tmp1_;
#line 4078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = dim;
#line 4078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp2_, &_tmp3_);
#line 4078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp3_;
#line 4078 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 29550 "Photo.c"
}


void photo_get_master_dimensions (Photo* self, Dimensions* result) {
	Orientation _tmp0_ = 0;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 4082 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_original_orientation (self);
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp1_);
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp2_;
#line 4083 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 29570 "Photo.c"
}


gboolean photo_get_crop (Photo* self, Box* crop, PhotoException exceptions) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions dim = {0};
	Dimensions _tmp2_ = {0};
	Orientation orientation = 0;
	Orientation _tmp3_ = 0;
	PhotoException _tmp4_ = 0;
	gboolean _tmp5_ = FALSE;
#line 4087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4089 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 4089 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw = _tmp0_;
#line 4089 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp1_) {
#line 4090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		box_init (&_vala_crop, 0, 0, 0, 0);
#line 4092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 4092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (crop) {
#line 4092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*crop = _vala_crop;
#line 29602 "Photo.c"
		}
#line 4092 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 29606 "Photo.c"
	}
#line 4095 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp2_);
#line 4095 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dim = _tmp2_;
#line 4096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_get_orientation (self);
#line 4096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = _tmp3_;
#line 4098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = exceptions;
#line 4098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_exception_allows (_tmp4_, PHOTO_EXCEPTION_ORIENTATION);
#line 4098 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_) {
#line 29622 "Photo.c"
		Orientation _tmp6_ = 0;
		Dimensions _tmp7_ = {0};
		Box _tmp8_ = {0};
		Box _tmp9_ = {0};
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = orientation;
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = dim;
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = raw;
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		orientation_rotate_box (_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 4099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_crop = _tmp9_;
#line 29637 "Photo.c"
	} else {
		Box _tmp10_ = {0};
#line 4101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = raw;
#line 4101 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_crop = _tmp10_;
#line 29644 "Photo.c"
	}
#line 4103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 4103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (crop) {
#line 4103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*crop = _vala_crop;
#line 29652 "Photo.c"
	}
#line 4103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 29656 "Photo.c"
}


void photo_set_crop (Photo* self, Box* crop) {
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Orientation orientation = 0;
	Orientation _tmp1_ = 0;
	Box derotated = {0};
	Dimensions _tmp2_ = {0};
	Box _tmp3_ = {0};
	Box _tmp4_ = {0};
	Box _tmp5_ = {0};
	gint _tmp6_ = 0;
	Dimensions _tmp7_ = {0};
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	Box _tmp10_ = {0};
	gint _tmp11_ = 0;
	Box _tmp12_ = {0};
	gint _tmp13_ = 0;
	Dimensions _tmp14_ = {0};
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	Box _tmp17_ = {0};
	gint _tmp18_ = 0;
	Dimensions _tmp19_ = {0};
	gint _tmp20_ = 0;
	gint _tmp21_ = 0;
	Box _tmp22_ = {0};
	gint _tmp23_ = 0;
	Box _tmp24_ = {0};
	gint _tmp25_ = 0;
	Dimensions _tmp26_ = {0};
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	Box _tmp29_ = {0};
#line 4107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4107 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 4108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_ORIENTATION, &_tmp0_);
#line 4108 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dim = _tmp0_;
#line 4109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 4109 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation = _tmp1_;
#line 4111 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = dim;
#line 4111 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = *crop;
#line 4111 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp2_, &_tmp3_, &_tmp4_);
#line 4111 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated = _tmp4_;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = derotated;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = _tmp5_.left;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = dim;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp7_.width;
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = CLAMP (_tmp6_, 0, _tmp8_ - 2);
#line 4113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated.left = _tmp9_;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = derotated;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_.right;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = derotated;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_.left;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = dim;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_.width;
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = CLAMP (_tmp11_, _tmp13_, _tmp15_ - 1);
#line 4114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated.right = _tmp16_;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = derotated;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = _tmp17_.top;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = dim;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = _tmp19_.height;
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = CLAMP (_tmp18_, 0, _tmp20_ - 2);
#line 4116 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated.top = _tmp21_;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = derotated;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = _tmp22_.bottom;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = derotated;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = _tmp24_.top;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = dim;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = _tmp26_.height;
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = CLAMP (_tmp23_, _tmp25_, _tmp27_ - 1);
#line 4117 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated.bottom = _tmp28_;
#line 4119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = derotated;
#line 4119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_set_raw_crop (self, &_tmp29_);
#line 29774 "Photo.c"
}


gboolean photo_get_straighten (Photo* self, gdouble* theta) {
	gdouble _vala_theta = 0.0;
	gboolean result = FALSE;
	gdouble _tmp0_ = 0.0;
	gboolean _tmp1_ = FALSE;
#line 4122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_raw_straighten (self, &_tmp0_);
#line 4123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_theta = _tmp0_;
#line 4123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp1_) {
#line 4124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 4124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (theta) {
#line 4124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*theta = _vala_theta;
#line 29797 "Photo.c"
		}
#line 4124 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 29801 "Photo.c"
	}
#line 4126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 4126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (theta) {
#line 4126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*theta = _vala_theta;
#line 29809 "Photo.c"
	}
#line 4126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 29813 "Photo.c"
}


void photo_set_straighten (Photo* self, gdouble theta) {
	gdouble _tmp0_ = 0.0;
#line 4129 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = theta;
#line 4130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_set_raw_straighten (self, _tmp0_);
#line 29825 "Photo.c"
}


static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, EditingToolsRedeyeInstance* inst) {
	GdkPixbuf* result = NULL;
	gdouble r = 0.0;
	EditingToolsRedeyeInstance _tmp0_ = {0};
	gint _tmp1_ = 0;
	gint* x_insets_first_quadrant = NULL;
	EditingToolsRedeyeInstance _tmp2_ = {0};
	gint _tmp3_ = 0;
	gint* _tmp4_ = NULL;
	gint x_insets_first_quadrant_length1 = 0;
	gint _x_insets_first_quadrant_size_ = 0;
	gint i = 0;
	gint x_bounds_min = 0;
	EditingToolsRedeyeInstance _tmp22_ = {0};
	GdkPoint _tmp23_ = {0};
	gint _tmp24_ = 0;
	EditingToolsRedeyeInstance _tmp25_ = {0};
	gint _tmp26_ = 0;
	gint x_bounds_max = 0;
	EditingToolsRedeyeInstance _tmp27_ = {0};
	GdkPoint _tmp28_ = {0};
	gint _tmp29_ = 0;
	EditingToolsRedeyeInstance _tmp30_ = {0};
	gint _tmp31_ = 0;
	gint ymin = 0;
	EditingToolsRedeyeInstance _tmp32_ = {0};
	GdkPoint _tmp33_ = {0};
	gint _tmp34_ = 0;
	EditingToolsRedeyeInstance _tmp35_ = {0};
	gint _tmp36_ = 0;
	gint _tmp37_ = 0;
	gint _tmp38_ = 0;
	gint ymax = 0;
	EditingToolsRedeyeInstance _tmp40_ = {0};
	GdkPoint _tmp41_ = {0};
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	gint _tmp44_ = 0;
	GdkPixbuf* _tmp45_ = NULL;
	gint _tmp46_ = 0;
	gint _tmp47_ = 0;
	gint inset_index = 0;
	EditingToolsRedeyeInstance _tmp88_ = {0};
	GdkPoint _tmp89_ = {0};
	gint _tmp90_ = 0;
	EditingToolsRedeyeInstance _tmp91_ = {0};
	GdkPoint _tmp92_ = {0};
	gint _tmp93_ = 0;
	EditingToolsRedeyeInstance _tmp94_ = {0};
	gint _tmp95_ = 0;
	gint* _tmp96_ = NULL;
	gint _tmp96__length1 = 0;
	GdkPixbuf* _tmp133_ = NULL;
	GdkPixbuf* _tmp134_ = NULL;
#line 4133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4133 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 4143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *inst;
#line 4143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.radius;
#line 4143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	r = (gdouble) _tmp1_;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *inst;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_.radius;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = g_new0 (gint, _tmp3_ + 1);
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_insets_first_quadrant = _tmp4_;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp3_ + 1;
#line 4144 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 4146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	i = 0;
#line 29909 "Photo.c"
	{
		gdouble y = 0.0;
		gdouble _tmp5_ = 0.0;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = r;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		y = _tmp5_;
#line 29917 "Photo.c"
		{
			gboolean _tmp6_ = FALSE;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = TRUE;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 29924 "Photo.c"
				gdouble _tmp8_ = 0.0;
				gdouble theta = 0.0;
				gdouble _tmp9_ = 0.0;
				gdouble _tmp10_ = 0.0;
				gdouble _tmp11_ = 0.0;
				gint x = 0;
				gdouble _tmp12_ = 0.0;
				gdouble _tmp13_ = 0.0;
				gdouble _tmp14_ = 0.0;
				gint* _tmp15_ = NULL;
				gint _tmp15__length1 = 0;
				gint _tmp16_ = 0;
				EditingToolsRedeyeInstance _tmp17_ = {0};
				gint _tmp18_ = 0;
				gint _tmp19_ = 0;
				gint _tmp20_ = 0;
				gint _tmp21_ = 0;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp6_) {
#line 29944 "Photo.c"
					gdouble _tmp7_ = 0.0;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp7_ = y;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					y = _tmp7_ - 1.0;
#line 29950 "Photo.c"
				}
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = FALSE;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = y;
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp8_ >= 0.0)) {
#line 4147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 29960 "Photo.c"
				}
#line 4148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = y;
#line 4148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = r;
#line 4148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = asin (_tmp9_ / _tmp10_);
#line 4148 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				theta = _tmp11_;
#line 4149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = r;
#line 4149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = theta;
#line 4149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = cos (_tmp13_);
#line 4149 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				x = (gint) ((_tmp12_ * _tmp14_) + 0.5);
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = x_insets_first_quadrant;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15__length1 = x_insets_first_quadrant_length1;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = i;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = *inst;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = _tmp17_.radius;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = x;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_[_tmp16_] = _tmp18_ - _tmp19_;
#line 4150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = _tmp15_[_tmp16_];
#line 4152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = i;
#line 4152 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				i = _tmp21_ + 1;
#line 29998 "Photo.c"
			}
		}
	}
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = *inst;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = _tmp22_.center;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = _tmp23_.x;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = *inst;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = _tmp25_.radius;
#line 4155 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_bounds_min = _tmp24_ - _tmp26_;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = *inst;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = _tmp27_.center;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = _tmp28_.x;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = *inst;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _tmp30_.radius;
#line 4156 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_bounds_max = _tmp29_ + _tmp31_;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = *inst;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = _tmp32_.center;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = _tmp33_.y;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = *inst;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = _tmp35_.radius;
#line 4157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymin = _tmp34_ - _tmp36_;
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = ymin;
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp38_ < 0) {
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = 0;
#line 30044 "Photo.c"
	} else {
		gint _tmp39_ = 0;
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp39_ = ymin;
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp37_ = _tmp39_;
#line 30051 "Photo.c"
	}
#line 4158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymin = _tmp37_;
#line 4159 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = *inst;
#line 4159 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = _tmp40_.center;
#line 4159 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = _tmp41_.y;
#line 4159 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymax = _tmp42_;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = ymax;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = pixbuf;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = gdk_pixbuf_get_height (_tmp45_);
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = _tmp46_;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp44_ > (_tmp47_ - 1)) {
#line 30073 "Photo.c"
		GdkPixbuf* _tmp48_ = NULL;
		gint _tmp49_ = 0;
		gint _tmp50_ = 0;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = pixbuf;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = gdk_pixbuf_get_height (_tmp48_);
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp50_ = _tmp49_;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = _tmp50_ - 1;
#line 30085 "Photo.c"
	} else {
		gint _tmp51_ = 0;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp51_ = ymax;
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp43_ = _tmp51_;
#line 30092 "Photo.c"
	}
#line 4160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymax = _tmp43_;
#line 4164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	inset_index = 0;
#line 30098 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp52_ = 0;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp52_ = ymin;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		y_it = _tmp52_;
#line 30106 "Photo.c"
		{
			gboolean _tmp53_ = FALSE;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp53_ = TRUE;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 30113 "Photo.c"
				gint _tmp55_ = 0;
				gint _tmp56_ = 0;
				gint xmin = 0;
				gint _tmp57_ = 0;
				gint* _tmp58_ = NULL;
				gint _tmp58__length1 = 0;
				gint _tmp59_ = 0;
				gint _tmp60_ = 0;
				gint _tmp61_ = 0;
				gint _tmp62_ = 0;
				gint xmax = 0;
				gint _tmp64_ = 0;
				gint* _tmp65_ = NULL;
				gint _tmp65__length1 = 0;
				gint _tmp66_ = 0;
				gint _tmp67_ = 0;
				gint _tmp68_ = 0;
				gint _tmp69_ = 0;
				GdkPixbuf* _tmp70_ = NULL;
				gint _tmp71_ = 0;
				gint _tmp72_ = 0;
				gint _tmp87_ = 0;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp53_) {
#line 30138 "Photo.c"
					gint _tmp54_ = 0;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp54_ = y_it;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					y_it = _tmp54_ + 1;
#line 30144 "Photo.c"
				}
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp53_ = FALSE;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp55_ = y_it;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = ymax;
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp55_ <= _tmp56_)) {
#line 4165 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 30156 "Photo.c"
				}
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = x_bounds_min;
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = x_insets_first_quadrant;
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58__length1 = x_insets_first_quadrant_length1;
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp59_ = inset_index;
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp60_ = _tmp58_[_tmp59_];
#line 4166 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmin = _tmp57_ + _tmp60_;
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp62_ = xmin;
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp62_ < 0) {
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp61_ = 0;
#line 30176 "Photo.c"
				} else {
					gint _tmp63_ = 0;
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp63_ = xmin;
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp61_ = _tmp63_;
#line 30183 "Photo.c"
				}
#line 4167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmin = _tmp61_;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp64_ = x_bounds_max;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp65_ = x_insets_first_quadrant;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp65__length1 = x_insets_first_quadrant_length1;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp66_ = inset_index;
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp67_ = _tmp65_[_tmp66_];
#line 4168 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmax = _tmp64_ - _tmp67_;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp69_ = xmax;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp70_ = pixbuf;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp71_ = gdk_pixbuf_get_width (_tmp70_);
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp72_ = _tmp71_;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp69_ > (_tmp72_ - 1)) {
#line 30209 "Photo.c"
					GdkPixbuf* _tmp73_ = NULL;
					gint _tmp74_ = 0;
					gint _tmp75_ = 0;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp73_ = pixbuf;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp74_ = gdk_pixbuf_get_width (_tmp73_);
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp75_ = _tmp74_;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp68_ = _tmp75_ - 1;
#line 30221 "Photo.c"
				} else {
					gint _tmp76_ = 0;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp76_ = xmax;
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp68_ = _tmp76_;
#line 30228 "Photo.c"
				}
#line 4169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmax = _tmp68_;
#line 30232 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp77_ = 0;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp77_ = xmin;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					x_it = _tmp77_;
#line 30240 "Photo.c"
					{
						gboolean _tmp78_ = FALSE;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp78_ = TRUE;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 30247 "Photo.c"
							gint _tmp80_ = 0;
							gint _tmp81_ = 0;
							GdkPixbuf* _tmp82_ = NULL;
							gint _tmp83_ = 0;
							gint _tmp84_ = 0;
							GdkPixbuf* _tmp85_ = NULL;
							GdkPixbuf* _tmp86_ = NULL;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp78_) {
#line 30257 "Photo.c"
								gint _tmp79_ = 0;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp79_ = x_it;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								x_it = _tmp79_ + 1;
#line 30263 "Photo.c"
							}
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp78_ = FALSE;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp80_ = x_it;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp81_ = xmax;
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!(_tmp80_ <= _tmp81_)) {
#line 4171 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 30275 "Photo.c"
							}
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp82_ = pixbuf;
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp83_ = x_it;
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp84_ = y_it;
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp85_ = photo_red_reduce_pixel (self, _tmp82_, _tmp83_, _tmp84_);
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp86_ = _tmp85_;
#line 4172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp86_);
#line 30289 "Photo.c"
						}
					}
				}
#line 4174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp87_ = inset_index;
#line 4174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				inset_index = _tmp87_ + 1;
#line 30297 "Photo.c"
			}
		}
	}
#line 4179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp88_ = *inst;
#line 4179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp89_ = _tmp88_.center;
#line 4179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp90_ = _tmp89_.y;
#line 4179 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymin = _tmp90_;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp91_ = *inst;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp92_ = _tmp91_.center;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp93_ = _tmp92_.y;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp94_ = *inst;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp95_ = _tmp94_.radius;
#line 4180 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ymax = _tmp93_ + _tmp95_;
#line 4181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp96_ = x_insets_first_quadrant;
#line 4181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp96__length1 = x_insets_first_quadrant_length1;
#line 4181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	inset_index = _tmp96__length1 - 1;
#line 30327 "Photo.c"
	{
		gint y_it = 0;
		gint _tmp97_ = 0;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp97_ = ymin;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		y_it = _tmp97_;
#line 30335 "Photo.c"
		{
			gboolean _tmp98_ = FALSE;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp98_ = TRUE;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 30342 "Photo.c"
				gint _tmp100_ = 0;
				gint _tmp101_ = 0;
				gint xmin = 0;
				gint _tmp102_ = 0;
				gint* _tmp103_ = NULL;
				gint _tmp103__length1 = 0;
				gint _tmp104_ = 0;
				gint _tmp105_ = 0;
				gint _tmp106_ = 0;
				gint _tmp107_ = 0;
				gint xmax = 0;
				gint _tmp109_ = 0;
				gint* _tmp110_ = NULL;
				gint _tmp110__length1 = 0;
				gint _tmp111_ = 0;
				gint _tmp112_ = 0;
				gint _tmp113_ = 0;
				gint _tmp114_ = 0;
				GdkPixbuf* _tmp115_ = NULL;
				gint _tmp116_ = 0;
				gint _tmp117_ = 0;
				gint _tmp132_ = 0;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp98_) {
#line 30367 "Photo.c"
					gint _tmp99_ = 0;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp99_ = y_it;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					y_it = _tmp99_ + 1;
#line 30373 "Photo.c"
				}
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp98_ = FALSE;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp100_ = y_it;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp101_ = ymax;
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp100_ <= _tmp101_)) {
#line 4182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 30385 "Photo.c"
				}
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp102_ = x_bounds_min;
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp103_ = x_insets_first_quadrant;
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp103__length1 = x_insets_first_quadrant_length1;
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp104_ = inset_index;
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp105_ = _tmp103_[_tmp104_];
#line 4183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmin = _tmp102_ + _tmp105_;
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp107_ = xmin;
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp107_ < 0) {
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp106_ = 0;
#line 30405 "Photo.c"
				} else {
					gint _tmp108_ = 0;
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp108_ = xmin;
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp106_ = _tmp108_;
#line 30412 "Photo.c"
				}
#line 4184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmin = _tmp106_;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp109_ = x_bounds_max;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp110_ = x_insets_first_quadrant;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp110__length1 = x_insets_first_quadrant_length1;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp111_ = inset_index;
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp112_ = _tmp110_[_tmp111_];
#line 4185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmax = _tmp109_ - _tmp112_;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp114_ = xmax;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp115_ = pixbuf;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp116_ = gdk_pixbuf_get_width (_tmp115_);
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp117_ = _tmp116_;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp114_ > (_tmp117_ - 1)) {
#line 30438 "Photo.c"
					GdkPixbuf* _tmp118_ = NULL;
					gint _tmp119_ = 0;
					gint _tmp120_ = 0;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp118_ = pixbuf;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp119_ = gdk_pixbuf_get_width (_tmp118_);
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp120_ = _tmp119_;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp113_ = _tmp120_ - 1;
#line 30450 "Photo.c"
				} else {
					gint _tmp121_ = 0;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp121_ = xmax;
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp113_ = _tmp121_;
#line 30457 "Photo.c"
				}
#line 4186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				xmax = _tmp113_;
#line 30461 "Photo.c"
				{
					gint x_it = 0;
					gint _tmp122_ = 0;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp122_ = xmin;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					x_it = _tmp122_;
#line 30469 "Photo.c"
					{
						gboolean _tmp123_ = FALSE;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp123_ = TRUE;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 30476 "Photo.c"
							gint _tmp125_ = 0;
							gint _tmp126_ = 0;
							GdkPixbuf* _tmp127_ = NULL;
							gint _tmp128_ = 0;
							gint _tmp129_ = 0;
							GdkPixbuf* _tmp130_ = NULL;
							GdkPixbuf* _tmp131_ = NULL;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp123_) {
#line 30486 "Photo.c"
								gint _tmp124_ = 0;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp124_ = x_it;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								x_it = _tmp124_ + 1;
#line 30492 "Photo.c"
							}
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp123_ = FALSE;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp125_ = x_it;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp126_ = xmax;
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!(_tmp125_ <= _tmp126_)) {
#line 4188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 30504 "Photo.c"
							}
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp127_ = pixbuf;
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp128_ = x_it;
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp129_ = y_it;
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp130_ = photo_red_reduce_pixel (self, _tmp127_, _tmp128_, _tmp129_);
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp131_ = _tmp130_;
#line 4189 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp131_);
#line 30518 "Photo.c"
						}
					}
				}
#line 4191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp132_ = inset_index;
#line 4191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				inset_index = _tmp132_ - 1;
#line 30526 "Photo.c"
			}
		}
	}
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp133_ = pixbuf;
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp134_ = _g_object_ref0 (_tmp133_);
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp134_;
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 4194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 30540 "Photo.c"
}


static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y) {
	GdkPixbuf* result = NULL;
	gint px_start_byte_offset = 0;
	gint _tmp0_ = 0;
	GdkPixbuf* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GdkPixbuf* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_ = 0;
	GdkPixbuf* _tmp33_ = NULL;
	GdkPixbuf* _tmp34_ = NULL;
#line 4197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4197 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 4198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = y;
#line 4198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = pixbuf;
#line 4198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = gdk_pixbuf_get_rowstride (_tmp1_);
#line 4198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = x;
#line 4198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = gdk_pixbuf_get_n_channels (_tmp4_);
#line 4198 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	px_start_byte_offset = (_tmp0_ * _tmp2_) + (_tmp3_ * _tmp5_);
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = x;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp9_ >= 0) {
#line 30581 "Photo.c"
		gint _tmp10_ = 0;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = y;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = _tmp10_ >= 0;
#line 30587 "Photo.c"
	} else {
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = FALSE;
#line 30591 "Photo.c"
	}
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 30595 "Photo.c"
		gint _tmp11_ = 0;
		GdkPixbuf* _tmp12_ = NULL;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = x;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = pixbuf;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = gdk_pixbuf_get_width (_tmp12_);
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp11_ < _tmp14_;
#line 30610 "Photo.c"
	} else {
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = FALSE;
#line 30614 "Photo.c"
	}
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp7_) {
#line 30618 "Photo.c"
		gint _tmp15_ = 0;
		GdkPixbuf* _tmp16_ = NULL;
		gint _tmp17_ = 0;
		gint _tmp18_ = 0;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = y;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = pixbuf;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = gdk_pixbuf_get_height (_tmp16_);
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp15_ < _tmp18_;
#line 30633 "Photo.c"
	} else {
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = FALSE;
#line 30637 "Photo.c"
	}
#line 4205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_) {
#line 30641 "Photo.c"
		guchar* pixel_data = NULL;
		GdkPixbuf* _tmp19_ = NULL;
		guint8* _tmp20_ = NULL;
		gint pixel_data_length1 = 0;
		gint _pixel_data_size_ = 0;
		guchar g = '\0';
		guchar* _tmp21_ = NULL;
		gint _tmp21__length1 = 0;
		gint _tmp22_ = 0;
		guchar _tmp23_ = '\0';
		guchar b = '\0';
		guchar* _tmp24_ = NULL;
		gint _tmp24__length1 = 0;
		gint _tmp25_ = 0;
		guchar _tmp26_ = '\0';
		guchar r = '\0';
		guchar _tmp27_ = '\0';
		guchar _tmp28_ = '\0';
		guchar* _tmp29_ = NULL;
		gint _tmp29__length1 = 0;
		gint _tmp30_ = 0;
		guchar _tmp31_ = '\0';
		guchar _tmp32_ = '\0';
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = pixbuf;
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = gdk_pixbuf_get_pixels (_tmp19_);
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_data = _tmp20_;
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixel_data_length1 = -1;
#line 4206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_data_size_ = pixel_data_length1;
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = pixel_data;
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21__length1 = pixel_data_length1;
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = px_start_byte_offset;
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp21_[_tmp22_ + 1];
#line 4216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g = _tmp23_;
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = pixel_data;
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24__length1 = pixel_data_length1;
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = px_start_byte_offset;
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = _tmp24_[_tmp25_ + 2];
#line 4217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		b = _tmp26_;
#line 4219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp27_ = g;
#line 4219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp28_ = b;
#line 4219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		r = (guchar) ((_tmp27_ + _tmp28_) / 2);
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_ = pixel_data;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29__length1 = pixel_data_length1;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp30_ = px_start_byte_offset;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = r;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp29_[_tmp30_] = _tmp31_;
#line 4221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = _tmp29_[_tmp30_];
#line 30713 "Photo.c"
	}
#line 4224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = pixbuf;
#line 4224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = _g_object_ref0 (_tmp33_);
#line 4224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp34_;
#line 4224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 30723 "Photo.c"
}


void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result) {
	Orientation unscaled_orientation = 0;
	Orientation _tmp0_ = 0;
	Dimensions unscaled_dims = {0};
	Orientation _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	gint unscaled_x_offset_raw = 0;
	gint unscaled_y_offset_raw = 0;
	Box crop_box = {0};
	Box _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	GdkPoint derotated_point = {0};
	Orientation _tmp10_ = 0;
	Dimensions _tmp11_ = {0};
	GdkPoint _tmp12_ = {0};
	GdkPoint _tmp13_ = {0};
	gint _tmp14_ = 0;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
#line 4227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 4228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_orientation (self);
#line 4228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	unscaled_orientation = _tmp0_;
#line 4230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = unscaled_orientation;
#line 4230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_get_dimensions ((MediaSource*) self, PHOTO_EXCEPTION_NONE, &_tmp2_);
#line 4230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_rotate_dimensions (_tmp1_, &_tmp2_, &_tmp3_);
#line 4230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	unscaled_dims = _tmp3_;
#line 4233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 4234 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 4237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_get_raw_crop (self, &_tmp4_);
#line 4237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	crop_box = _tmp4_;
#line 4237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_) {
#line 30774 "Photo.c"
		Box _tmp6_ = {0};
		gint _tmp7_ = 0;
		Box _tmp8_ = {0};
		gint _tmp9_ = 0;
#line 4238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = crop_box;
#line 4238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_.left;
#line 4238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		unscaled_x_offset_raw = _tmp7_;
#line 4239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = crop_box;
#line 4239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = _tmp8_.top;
#line 4239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		unscaled_y_offset_raw = _tmp9_;
#line 30791 "Photo.c"
	}
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = unscaled_orientation;
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = unscaled_dims;
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = *unscaled_point;
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	orientation_derotate_point (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
#line 4242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated_point = _tmp13_;
#line 4246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = derotated_point.x;
#line 4246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = unscaled_x_offset_raw;
#line 4246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated_point.x = _tmp14_ + _tmp15_;
#line 4247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = derotated_point.y;
#line 4247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = unscaled_y_offset_raw;
#line 4247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	derotated_point.y = _tmp16_ + _tmp17_;
#line 4249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = derotated_point;
#line 4249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 30819 "Photo.c"
}


void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result) {
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_ = {0};
	gint _tmp3_ = 0;
	GdkRectangle _tmp4_ = {0};
	gint _tmp5_ = 0;
	GdkPoint _tmp6_ = {0};
	gint _tmp7_ = 0;
	GdkRectangle _tmp8_ = {0};
	gint _tmp9_ = 0;
	GdkPoint _tmp10_ = {0};
	gint _tmp11_ = 0;
	GdkRectangle _tmp12_ = {0};
	gint _tmp13_ = 0;
	GdkPoint _tmp14_ = {0};
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_ = {0};
	GdkPoint _tmp17_ = {0};
	GdkPoint _tmp18_ = {0};
	gint _tmp19_ = 0;
	GdkPoint _tmp20_ = {0};
	gint _tmp21_ = 0;
	GdkPoint _tmp27_ = {0};
	gint _tmp28_ = 0;
	GdkPoint _tmp29_ = {0};
	gint _tmp30_ = 0;
	GdkRectangle raw_rect = {0};
	GdkPoint _tmp36_ = {0};
	gint _tmp37_ = 0;
	GdkPoint _tmp38_ = {0};
	gint _tmp39_ = 0;
	GdkPoint _tmp40_ = {0};
	gint _tmp41_ = 0;
	GdkPoint _tmp42_ = {0};
	gint _tmp43_ = 0;
	GdkPoint _tmp44_ = {0};
	gint _tmp45_ = 0;
	GdkPoint _tmp46_ = {0};
	gint _tmp47_ = 0;
#line 4252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 4253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_.x = 0;
#line 4253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	upper_left = _tmp0_;
#line 4254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_.x = 0;
#line 4254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	lower_right = _tmp1_;
#line 4255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 4255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_.x;
#line 4255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	upper_left.x = _tmp3_;
#line 4256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = *unscaled_rect;
#line 4256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_.y;
#line 4256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	upper_left.y = _tmp5_;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = upper_left;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_.x;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = *unscaled_rect;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_.width;
#line 4257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	lower_right.x = _tmp7_ + _tmp9_;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = upper_left;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_.y;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = *unscaled_rect;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_.height;
#line 4258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	lower_right.y = _tmp11_ + _tmp13_;
#line 4260 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = upper_left;
#line 4260 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp14_, &_tmp15_);
#line 4260 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	upper_left = _tmp15_;
#line 4261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = lower_right;
#line 4261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp16_, &_tmp17_);
#line 4261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	lower_right = _tmp17_;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = upper_left;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_.x;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = lower_right;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 4263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp19_ > _tmp21_) {
#line 30931 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp22_ = {0};
		gint _tmp23_ = 0;
		GdkPoint _tmp24_ = {0};
		gint _tmp25_ = 0;
		gint _tmp26_ = 0;
#line 4264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = upper_left;
#line 4264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp22_.x;
#line 4264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		temp = _tmp23_;
#line 4265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp24_ = lower_right;
#line 4265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = _tmp24_.x;
#line 4265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		upper_left.x = _tmp25_;
#line 4266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp26_ = temp;
#line 4266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		lower_right.x = _tmp26_;
#line 30954 "Photo.c"
	}
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = upper_left;
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = _tmp27_.y;
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = lower_right;
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp30_ = _tmp29_.y;
#line 4268 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp28_ > _tmp30_) {
#line 30966 "Photo.c"
		gint temp = 0;
		GdkPoint _tmp31_ = {0};
		gint _tmp32_ = 0;
		GdkPoint _tmp33_ = {0};
		gint _tmp34_ = 0;
		gint _tmp35_ = 0;
#line 4269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp31_ = upper_left;
#line 4269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp32_ = _tmp31_.y;
#line 4269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		temp = _tmp32_;
#line 4270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp33_ = lower_right;
#line 4270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp34_ = _tmp33_.y;
#line 4270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		upper_left.y = _tmp34_;
#line 4271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp35_ = temp;
#line 4271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		lower_right.y = _tmp35_;
#line 30989 "Photo.c"
	}
#line 4274 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	memset (&raw_rect, 0, sizeof (GdkRectangle));
#line 4275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = upper_left;
#line 4275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = _tmp36_.x;
#line 4275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rect.x = _tmp37_;
#line 4276 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = upper_left;
#line 4276 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = _tmp38_.y;
#line 4276 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rect.y = _tmp39_;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = lower_right;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = _tmp40_.x;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = upper_left;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = _tmp42_.x;
#line 4277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rect.width = _tmp41_ - _tmp43_;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = lower_right;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = _tmp44_.y;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp46_ = upper_left;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp47_ = _tmp46_.y;
#line 4278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rect.height = _tmp45_ - _tmp47_;
#line 4280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = raw_rect;
#line 4280 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 31029 "Photo.c"
}


PixelTransformationBundle* photo_get_enhance_transformations (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	PixelTransformationBundle* transformations = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	PixelTransformationBundle* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
#line 4283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4284 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = NULL;
#line 31044 "Photo.c"
	{
		GdkPixbuf* _tmp0_ = NULL;
		Scaling _tmp1_ = {0};
		GdkPixbuf* _tmp2_ = NULL;
		GdkPixbuf* _tmp3_ = NULL;
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp1_);
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = photo_get_pixbuf_with_options (self, &_tmp1_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp2_;
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 31058 "Photo.c"
			goto __catch262_g_error;
		}
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp0_;
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		pixbuf = _tmp3_;
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp0_);
#line 31071 "Photo.c"
	}
	goto __finally262;
	__catch262_g_error:
	{
		GError* e = NULL;
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		e = _inner_error_;
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:4298: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 4300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 4300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (e);
#line 4300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 31091 "Photo.c"
	}
	__finally262:
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 31104 "Photo.c"
	}
#line 4307 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 4307 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = auto_enhance_create_auto_enhance_adjustments (_tmp4_);
#line 4307 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	transformations = _tmp5_;
#line 4315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = transformations;
#line 4315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 4315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31118 "Photo.c"
}


gboolean photo_enhance (Photo* self) {
	gboolean result = FALSE;
	PixelTransformationBundle* transformations = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 4318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 4319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	transformations = _tmp0_;
#line 4321 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = transformations;
#line 4321 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 4322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 4322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 4322 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 31144 "Photo.c"
	}
	{
		PhotoRow* _tmp2_ = NULL;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->row;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 31152 "Photo.c"
		{
			KeyValueMap* _tmp3_ = NULL;
			KeyValueMap* _tmp4_ = NULL;
			PixelTransformationBundle* _tmp5_ = NULL;
#line 4328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_clear_original_transforms (self);
#line 4329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = photo_get_color_adjustments_map (self);
#line 4329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 4329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_original_transforms (self, _tmp4_);
#line 4329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (_tmp4_);
#line 4330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = transformations;
#line 4330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo_set_color_adjustments (self, _tmp5_);
#line 31171 "Photo.c"
		}
		__finally263:
		{
			PhotoRow* _tmp6_ = NULL;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->row;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31180 "Photo.c"
		}
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 31184 "Photo.c"
			gboolean _tmp7_ = FALSE;
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4327 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp7_;
#line 31194 "Photo.c"
		}
	}
#line 4337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_set_enhanced (self, TRUE);
#line 4338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = TRUE;
#line 4338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 4338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31205 "Photo.c"
}


gboolean photo_unenhance (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 4341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 31214 "Photo.c"
	{
		PhotoRow* _tmp0_ = NULL;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->row;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_rec_mutex_lock (&self->priv->__lock_row);
#line 31221 "Photo.c"
		{
			PhotoRow* _tmp1_ = NULL;
			gboolean _tmp2_ = FALSE;
#line 4343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = self->row;
#line 4343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = _tmp1_->enhanced;
#line 4343 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp2_) {
#line 31231 "Photo.c"
				gboolean _tmp3_ = FALSE;
				PhotoRow* _tmp4_ = NULL;
				GeeHashMap* _tmp5_ = NULL;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = self->row;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _tmp4_->original_transforms;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp5_ == NULL) {
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp3_ = TRUE;
#line 31243 "Photo.c"
				} else {
					PhotoRow* _tmp6_ = NULL;
					GeeHashMap* _tmp7_ = NULL;
					gpointer _tmp8_ = NULL;
					KeyValueMap* _tmp9_ = NULL;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp6_ = self->row;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp7_ = _tmp6_->original_transforms;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp8_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp7_, "adjustments");
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp9_ = (KeyValueMap*) _tmp8_;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp3_ = _tmp9_ == NULL;
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_key_value_map_unref0 (_tmp9_);
#line 31261 "Photo.c"
				}
#line 4344 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp3_) {
#line 31265 "Photo.c"
					gboolean _result_ = FALSE;
					gboolean _tmp10_ = FALSE;
					gboolean _tmp11_ = FALSE;
#line 4345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_remove_transformation (self, "adjustments");
#line 4346 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_result_ = FALSE;
#line 4347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp10_ = photo_remove_transformation (self, "adjustments");
#line 4347 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_result_ = _tmp10_;
#line 4348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 4348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->priv->adjustments = NULL;
#line 4349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_pixel_transformer_unref0 (self->priv->transformer);
#line 4349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					self->priv->transformer = NULL;
#line 4350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp11_ = _result_;
#line 4350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if (_tmp11_) {
#line 31289 "Photo.c"
						Alteration* _tmp12_ = NULL;
						Alteration* _tmp13_ = NULL;
#line 4351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp12_ = alteration_new ("image", "color-adjustments");
#line 4351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp13_ = _tmp12_;
#line 4351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						data_object_notify_altered ((DataObject*) self, _tmp13_);
#line 4351 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_alteration_unref0 (_tmp13_);
#line 31300 "Photo.c"
					}
				} else {
					PixelTransformationBundle* _tmp14_ = NULL;
					PixelTransformationBundle* _tmp15_ = NULL;
#line 4354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = photo_locked_original_color_adjustments (self);
#line 4354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 4354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					photo_set_color_adjustments (self, _tmp15_);
#line 4354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_pixel_transformation_bundle_unref0 (_tmp15_);
#line 31313 "Photo.c"
				}
#line 4355 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_set_enhanced (self, FALSE);
#line 4356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				result = TRUE;
#line 31319 "Photo.c"
				{
					PhotoRow* _tmp16_ = NULL;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = self->row;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31326 "Photo.c"
				}
#line 4356 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return result;
#line 31330 "Photo.c"
			}
		}
		__finally264:
		{
			PhotoRow* _tmp17_ = NULL;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = self->row;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_rec_mutex_unlock (&self->priv->__lock_row);
#line 31340 "Photo.c"
		}
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 31344 "Photo.c"
			gboolean _tmp18_ = FALSE;
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4342 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return _tmp18_;
#line 31352 "Photo.c"
		}
	}
#line 4359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = FALSE;
#line 4359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31359 "Photo.c"
}


gboolean photo_get_develop_raw_photos_to_files (void) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo__develop_raw_photos_to_files;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31372 "Photo.c"
}


void photo_set_develop_raw_photos_to_files (gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = value;
#line 282 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo__develop_raw_photos_to_files = _tmp0_;
#line 31382 "Photo.c"
}


static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = closure->data;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31405 "Photo.c"
	} else {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = closure->data;
#line 31411 "Photo.c"
	}
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 31417 "Photo.c"
}


static void photo_real_raw_development_modified (Photo* self) {
}


static void photo_real_baseline_replaced (Photo* self) {
}


static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata) {
}


static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = closure->data;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 31448 "Photo.c"
	} else {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = closure->data;
#line 31454 "Photo.c"
	}
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 31460 "Photo.c"
}


static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata) {
}


static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
}


static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata) {
}


static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self) {
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced ((PhotoPhotoTransformationStateImpl*) self);
#line 31479 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments, GeeHashMap* original_transformations, gboolean enhanced) {
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_ = NULL;
	Photo* _tmp1_ = NULL;
	Orientation _tmp2_ = 0;
	GeeHashMap* _tmp3_ = NULL;
	GeeHashMap* _tmp4_ = NULL;
	GeeHashMap* _tmp5_ = NULL;
	GeeHashMap* _tmp6_ = NULL;
	PixelTransformer* _tmp7_ = NULL;
	PixelTransformer* _tmp8_ = NULL;
	PixelTransformationBundle* _tmp9_ = NULL;
	PixelTransformationBundle* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	Photo* _tmp12_ = NULL;
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (photo != NULL, NULL);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo;
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 181 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->photo = _tmp1_;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = orientation;
#line 182 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->orientation = _tmp2_;
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = transformations;
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_copy_transformations (_tmp3_);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->transformations = _tmp4_;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = original_transformations;
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_copy_transformations (_tmp5_);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 184 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->original_transformations = _tmp6_;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = transformer;
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _pixel_transformer_ref0 (_tmp7_);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 185 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->transformer = _tmp8_;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = adjustments;
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _pixel_transformation_bundle_ref0 (_tmp9_);
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 186 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->adjustments = _tmp10_;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = enhanced;
#line 187 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->enhanced = _tmp11_;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = photo;
#line 188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_connect_object (_tmp12_, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 31556 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments, GeeHashMap* original_transformations, gboolean enhanced) {
#line 178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments, original_transformations, enhanced);
#line 31563 "Photo.c"
}


static gboolean photo_photo_transformation_state_impl_get_enhanced (PhotoPhotoTransformationStateImpl* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->enhanced;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31578 "Photo.c"
}


static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self) {
	Orientation result = 0;
	Orientation _tmp0_ = 0;
#line 199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 200 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31593 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
#line 203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 204 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31611 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_get_original_transformations (PhotoPhotoTransformationStateImpl* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
#line 207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->original_transformations;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 208 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31629 "Photo.c"
}


static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_ = NULL;
#line 211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31643 "Photo.c"
		PixelTransformer* _tmp2_ = NULL;
		PixelTransformer* _tmp3_ = NULL;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31654 "Photo.c"
	} else {
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 31660 "Photo.c"
	}
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 212 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31666 "Photo.c"
}


static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_ = NULL;
#line 215 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 31680 "Photo.c"
		PixelTransformationBundle* _tmp2_ = NULL;
		PixelTransformationBundle* _tmp3_ = NULL;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 31691 "Photo.c"
	} else {
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = NULL;
#line 31697 "Photo.c"
	}
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31703 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* clone = NULL;
	GeeHashMap* _tmp1_ = NULL;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = original;
#line 221 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = NULL;
#line 222 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 31720 "Photo.c"
	}
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, (GDestroyNotify) key_value_map_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 224 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	clone = _tmp1_;
#line 31726 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeHashMap* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_ = NULL;
		GeeSet* _tmp5_ = NULL;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_ = NULL;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = original;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp2_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_object_it = _tmp7_;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 31753 "Photo.c"
			GeeIterator* _tmp8_ = NULL;
			gboolean _tmp9_ = FALSE;
			gchar* object = NULL;
			GeeIterator* _tmp10_ = NULL;
			gpointer _tmp11_ = NULL;
			GeeHashMap* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
			GeeHashMap* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			gpointer _tmp16_ = NULL;
			KeyValueMap* _tmp17_ = NULL;
			KeyValueMap* _tmp18_ = NULL;
			KeyValueMap* _tmp19_ = NULL;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _object_it;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp9_) {
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 31775 "Photo.c"
			}
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = _object_it;
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			object = (gchar*) _tmp11_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = clone;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = object;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = original;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = object;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, _tmp15_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = (KeyValueMap*) _tmp16_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = key_value_map_copy (_tmp17_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, _tmp19_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (_tmp19_);
#line 226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_key_value_map_unref0 (_tmp17_);
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_free0 (object);
#line 31807 "Photo.c"
		}
#line 225 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 31811 "Photo.c"
	}
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = clone;
#line 228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 31817 "Photo.c"
}


static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self) {
	gboolean _tmp0_ = FALSE;
#line 231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_transformation_state_is_broken ((PhotoTransformationState*) self);
#line 232 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp0_) {
#line 233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_signal_emit_by_name ((PhotoTransformationState*) self, "broken");
#line 31831 "Photo.c"
	}
}


static void photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass) {
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPhotoTransformationStateImplPrivate));
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 31843 "Photo.c"
}


static void photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self) {
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE (self);
#line 31850 "Photo.c"
}


static void photo_photo_transformation_state_impl_finalize (GObject* obj) {
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 192 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 170 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->original_transformations);
#line 174 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 169 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 31878 "Photo.c"
}


static GType photo_photo_transformation_state_impl_get_type (void) {
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


static PhotoBackingReaders* photo_backing_readers_construct (GType object_type) {
	PhotoBackingReaders* self = NULL;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoBackingReaders*) g_type_create_instance (object_type);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 31900 "Photo.c"
}


static PhotoBackingReaders* photo_backing_readers_new (void) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_backing_readers_construct (PHOTO_TYPE_BACKING_READERS);
#line 31907 "Photo.c"
}


static void photo_value_backing_readers_init (GValue* value) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 31914 "Photo.c"
}


static void photo_value_backing_readers_free_value (GValue* value) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_backing_readers_unref (value->data[0].v_pointer);
#line 31923 "Photo.c"
	}
}


static void photo_value_backing_readers_copy_value (const GValue* src_value, GValue* dest_value) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_backing_readers_ref (src_value->data[0].v_pointer);
#line 31933 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 31937 "Photo.c"
	}
}


static gpointer photo_value_backing_readers_peek_pointer (const GValue* value) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 31945 "Photo.c"
}


static gchar* photo_value_backing_readers_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 31952 "Photo.c"
		PhotoBackingReaders* object;
		object = collect_values[0].v_pointer;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31959 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 31963 "Photo.c"
		}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_backing_readers_ref (object);
#line 31967 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 31971 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 31975 "Photo.c"
}


static gchar* photo_value_backing_readers_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoBackingReaders** object_p;
	object_p = collect_values[0].v_pointer;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 31986 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 31992 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 31996 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_backing_readers_ref (value->data[0].v_pointer);
#line 32000 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32004 "Photo.c"
}


static GParamSpec* photo_param_spec_backing_readers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecBackingReaders* spec;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32018 "Photo.c"
}


static gpointer photo_value_get_backing_readers (const GValue* value) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS), NULL);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32027 "Photo.c"
}


static void photo_value_set_backing_readers (GValue* value, gpointer v_object) {
	PhotoBackingReaders* old;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_backing_readers_ref (value->data[0].v_pointer);
#line 32047 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32051 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32057 "Photo.c"
	}
}


static void photo_value_take_backing_readers (GValue* value, gpointer v_object) {
	PhotoBackingReaders* old;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_BACKING_READERS));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32076 "Photo.c"
	} else {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32080 "Photo.c"
	}
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_backing_readers_unref (old);
#line 32086 "Photo.c"
	}
}


static void photo_backing_readers_class_init (PhotoBackingReadersClass * klass) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_backing_readers_parent_class = g_type_class_peek_parent (klass);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoBackingReadersClass *) klass)->finalize = photo_backing_readers_finalize;
#line 32096 "Photo.c"
}


static void photo_backing_readers_instance_init (PhotoBackingReaders * self) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 32103 "Photo.c"
}


static void photo_backing_readers_finalize (PhotoBackingReaders* obj) {
	PhotoBackingReaders * self;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_BACKING_READERS, PhotoBackingReaders);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (self->master);
#line 239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (self->developer);
#line 240 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_file_adapter_unref0 (self->editable);
#line 32119 "Photo.c"
}


static GType photo_backing_readers_get_type (void) {
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_backing_readers_init, photo_value_backing_readers_free_value, photo_value_backing_readers_copy_value, photo_value_backing_readers_peek_pointer, "p", photo_value_backing_readers_collect_value, "p", photo_value_backing_readers_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoBackingReadersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_backing_readers_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoBackingReaders), 0, (GInstanceInitFunc) photo_backing_readers_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoBackingReaders", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static gpointer photo_backing_readers_ref (gpointer instance) {
	PhotoBackingReaders* self;
	self = instance;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 32144 "Photo.c"
}


static void photo_backing_readers_unref (gpointer instance) {
	PhotoBackingReaders* self;
	self = instance;
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_BACKING_READERS_GET_CLASS (self)->finalize (self);
#line 237 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32157 "Photo.c"
	}
}


PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type) {
	PhotoReimportMasterState* self = NULL;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32168 "Photo.c"
}


static void photo_value_reimport_master_state_init (GValue* value) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32175 "Photo.c"
}


static void photo_value_reimport_master_state_free_value (GValue* value) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 32184 "Photo.c"
	}
}


static void photo_value_reimport_master_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 32194 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32198 "Photo.c"
	}
}


static gpointer photo_value_reimport_master_state_peek_pointer (const GValue* value) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32206 "Photo.c"
}


static gchar* photo_value_reimport_master_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32213 "Photo.c"
		PhotoReimportMasterState* object;
		object = collect_values[0].v_pointer;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32220 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32224 "Photo.c"
		}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 32228 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32232 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32236 "Photo.c"
}


static gchar* photo_value_reimport_master_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportMasterState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32247 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 32253 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32257 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32261 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32265 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportMasterState* spec;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32279 "Photo.c"
}


gpointer photo_value_get_reimport_master_state (const GValue* value) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32288 "Photo.c"
}


void photo_value_set_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 32308 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32312 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32318 "Photo.c"
	}
}


void photo_value_take_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32337 "Photo.c"
	} else {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32341 "Photo.c"
	}
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 32347 "Photo.c"
	}
}


static void photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_finalize;
#line 32357 "Photo.c"
}


static void photo_reimport_master_state_instance_init (PhotoReimportMasterState * self) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 32364 "Photo.c"
}


static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterState * self;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32374 "Photo.c"
}


GType photo_reimport_master_state_get_type (void) {
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer photo_reimport_master_state_ref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 32399 "Photo.c"
}


void photo_reimport_master_state_unref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 1253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32412 "Photo.c"
	}
}


static gchar** _vala_array_dup6 (gchar** self, int length) {
	gchar** result;
	int i;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 32424 "Photo.c"
		gchar* _tmp0_ = NULL;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result[i] = _tmp0_;
#line 32430 "Photo.c"
	}
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 32434 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow* _tmp0_ = NULL;
	PhotoRow* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gchar** _tmp5_ = NULL;
	gint _tmp5__length1 = 0;
#line 1262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 1262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 1263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = row;
#line 1263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _photo_row_ref0 (_tmp0_);
#line 1263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->row = _tmp1_;
#line 1264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = metadata;
#line 1264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1264 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = alterations;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4__length1 = alterations_length1;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup6 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->alterations = _tmp5_;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->alterations_length1 = _tmp5__length1;
#line 1265 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 1262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32486 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
#line 1262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 32493 "Photo.c"
}


static void photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass) {
#line 1256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportMasterStateClass *) klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 32502 "Photo.c"
}


static void photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self) {
	PhotoRow* _tmp0_ = NULL;
#line 1257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_row_new ();
#line 1257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->row = _tmp0_;
#line 1260 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata_only = FALSE;
#line 32514 "Photo.c"
}


static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterStateImpl * self;
#line 1256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl);
#line 1257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 1258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1259 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 1256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 32530 "Photo.c"
}


static GType photo_reimport_master_state_impl_get_type (void) {
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type) {
	PhotoReimportEditableState* self = NULL;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32552 "Photo.c"
}


static void photo_value_reimport_editable_state_init (GValue* value) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32559 "Photo.c"
}


static void photo_value_reimport_editable_state_free_value (GValue* value) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 32568 "Photo.c"
	}
}


static void photo_value_reimport_editable_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 32578 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32582 "Photo.c"
	}
}


static gpointer photo_value_reimport_editable_state_peek_pointer (const GValue* value) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32590 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32597 "Photo.c"
		PhotoReimportEditableState* object;
		object = collect_values[0].v_pointer;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32604 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32608 "Photo.c"
		}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 32612 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32616 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32620 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportEditableState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32631 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 32637 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32641 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32645 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32649 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportEditableState* spec;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 32663 "Photo.c"
}


gpointer photo_value_get_reimport_editable_state (const GValue* value) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32672 "Photo.c"
}


void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 32692 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32696 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32702 "Photo.c"
	}
}


void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 32721 "Photo.c"
	} else {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32725 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 32731 "Photo.c"
	}
}


static void photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_finalize;
#line 32741 "Photo.c"
}


static void photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 32748 "Photo.c"
}


static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableState * self;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 32758 "Photo.c"
}


GType photo_reimport_editable_state_get_type (void) {
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer photo_reimport_editable_state_ref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 32783 "Photo.c"
}


void photo_reimport_editable_state_unref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 1269 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 32796 "Photo.c"
	}
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoRow* backing_state, PhotoMetadata* metadata) {
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (backing_state != NULL, NULL);
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 1278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_state;
#line 1278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _backing_photo_row_ref0 (_tmp0_);
#line 1278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing_state = _tmp1_;
#line 1279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = metadata;
#line 1279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32829 "Photo.c"
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoRow* backing_state, PhotoMetadata* metadata) {
#line 1277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 32836 "Photo.c"
}


static void photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass) {
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportEditableStateClass *) klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 32845 "Photo.c"
}


static void photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self) {
	BackingPhotoRow* _tmp0_ = NULL;
#line 1273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 1275 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata_only = FALSE;
#line 32857 "Photo.c"
}


static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableStateImpl * self;
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl);
#line 1273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_state);
#line 1274 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 32871 "Photo.c"
}


static GType photo_reimport_editable_state_impl_get_type (void) {
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


PhotoReimportRawDevelopmentState* photo_reimport_raw_development_state_construct (GType object_type) {
	PhotoReimportRawDevelopmentState* self = NULL;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentState*) g_type_create_instance (object_type);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 32893 "Photo.c"
}


static void photo_value_reimport_raw_development_state_init (GValue* value) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 32900 "Photo.c"
}


static void photo_value_reimport_raw_development_state_free_value (GValue* value) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_unref (value->data[0].v_pointer);
#line 32909 "Photo.c"
	}
}


static void photo_value_reimport_raw_development_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_ref (src_value->data[0].v_pointer);
#line 32919 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 32923 "Photo.c"
	}
}


static gpointer photo_value_reimport_raw_development_state_peek_pointer (const GValue* value) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 32931 "Photo.c"
}


static gchar* photo_value_reimport_raw_development_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 32938 "Photo.c"
		PhotoReimportRawDevelopmentState* object;
		object = collect_values[0].v_pointer;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32945 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 32949 "Photo.c"
		}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_ref (object);
#line 32953 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 32957 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32961 "Photo.c"
}


static gchar* photo_value_reimport_raw_development_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportRawDevelopmentState** object_p;
	object_p = collect_values[0].v_pointer;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 32972 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 32978 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 32982 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 32986 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 32990 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_raw_development_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportRawDevelopmentState* spec;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33004 "Photo.c"
}


gpointer photo_value_get_reimport_raw_development_state (const GValue* value) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE), NULL);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33013 "Photo.c"
}


void photo_value_set_reimport_raw_development_state (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentState* old;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_ref (value->data[0].v_pointer);
#line 33033 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33037 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 33043 "Photo.c"
	}
}


void photo_value_take_reimport_raw_development_state (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentState* old;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33062 "Photo.c"
	} else {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33066 "Photo.c"
	}
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_unref (old);
#line 33072 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_class_init (PhotoReimportRawDevelopmentStateClass * klass) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_raw_development_state_parent_class = g_type_class_peek_parent (klass);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_finalize;
#line 33082 "Photo.c"
}


static void photo_reimport_raw_development_state_instance_init (PhotoReimportRawDevelopmentState * self) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 33089 "Photo.c"
}


static void photo_reimport_raw_development_state_finalize (PhotoReimportRawDevelopmentState* obj) {
	PhotoReimportRawDevelopmentState * self;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, PhotoReimportRawDevelopmentState);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 33099 "Photo.c"
}


GType photo_reimport_raw_development_state_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_raw_development_state_init, photo_value_reimport_raw_development_state_free_value, photo_value_reimport_raw_development_state_copy_value, photo_value_reimport_raw_development_state_peek_pointer, "p", photo_value_reimport_raw_development_state_collect_value, "p", photo_value_reimport_raw_development_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentState), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_type_id;
		photo_reimport_raw_development_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_raw_development_state_type_id__volatile, photo_reimport_raw_development_state_type_id);
	}
	return photo_reimport_raw_development_state_type_id__volatile;
}


gpointer photo_reimport_raw_development_state_ref (gpointer instance) {
	PhotoReimportRawDevelopmentState* self;
	self = instance;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 33124 "Photo.c"
}


void photo_reimport_raw_development_state_unref (gpointer instance) {
	PhotoReimportRawDevelopmentState* self;
	self = instance;
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_GET_CLASS (self)->finalize (self);
#line 1283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33137 "Photo.c"
	}
}


static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_construct (GType object_type) {
	PhotoReimportRawDevelopmentStateImpl* self = NULL;
#line 1300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImpl*) photo_reimport_raw_development_state_construct (object_type);
#line 1300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 33148 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImpl* photo_reimport_raw_development_state_impl_new (void) {
#line 1300 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_construct (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL);
#line 33155 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_add (PhotoReimportRawDevelopmentStateImpl* self, BackingPhotoRow* backing, PhotoMetadata* metadata) {
	GeeCollection* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp3_ = NULL;
	PhotoReimportRawDevelopmentStateImplDevToReimport* _tmp4_ = NULL;
#line 1303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 1303 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (backing != NULL);
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->list;
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = backing;
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = metadata;
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_reimport_raw_development_state_impl_dev_to_reimport_new (_tmp1_, _tmp2_);
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	gee_collection_add (_tmp0_, _tmp4_);
#line 1304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_reimport_raw_development_state_impl_dev_to_reimport_unref0 (_tmp4_);
#line 33183 "Photo.c"
}


static gint photo_reimport_raw_development_state_impl_get_size (PhotoReimportRawDevelopmentStateImpl* self) {
	gint result = 0;
	GeeCollection* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
#line 1307 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->list;
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 1308 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33204 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_construct (GType object_type, BackingPhotoRow* backing, PhotoMetadata* metadata) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self = NULL;
	BackingPhotoRow* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
#line 1291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (backing != NULL, NULL);
#line 1291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (PhotoReimportRawDevelopmentStateImplDevToReimport*) g_type_create_instance (object_type);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing;
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _backing_photo_row_ref0 (_tmp0_);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1292 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing = _tmp1_;
#line 1293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = metadata;
#line 1293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 1293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 1293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata = _tmp3_;
#line 1291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 33236 "Photo.c"
}


static PhotoReimportRawDevelopmentStateImplDevToReimport* photo_reimport_raw_development_state_impl_dev_to_reimport_new (BackingPhotoRow* backing, PhotoMetadata* metadata) {
#line 1291 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return photo_reimport_raw_development_state_impl_dev_to_reimport_construct (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, backing, metadata);
#line 33243 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_init (GValue* value) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 33250 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value (GValue* value) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (value->data[0].v_pointer);
#line 33259 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value (const GValue* src_value, GValue* dest_value) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (src_value->data[0].v_pointer);
#line 33269 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 33273 "Photo.c"
	}
}


static gpointer photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer (const GValue* value) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33281 "Photo.c"
}


static gchar* photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 33288 "Photo.c"
		PhotoReimportRawDevelopmentStateImplDevToReimport* object;
		object = collect_values[0].v_pointer;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33295 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 33299 "Photo.c"
		}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (object);
#line 33303 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33307 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 33311 "Photo.c"
}


static gchar* photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportRawDevelopmentStateImplDevToReimport** object_p;
	object_p = collect_values[0].v_pointer;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!object_p) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 33322 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = NULL;
#line 33328 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 33332 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*object_p = photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33336 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return NULL;
#line 33340 "Photo.c"
}


static GParamSpec* photo_reimport_raw_development_state_impl_param_spec_dev_to_reimport (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoReimportRawDevelopmentStateImplParamSpecDevToReimport* spec;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 33354 "Photo.c"
}


static gpointer photo_reimport_raw_development_state_impl_value_get_dev_to_reimport (const GValue* value) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT), NULL);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return value->data[0].v_pointer;
#line 33363 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_value_set_dev_to_reimport (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* old;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_ref (value->data[0].v_pointer);
#line 33383 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33387 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33393 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_value_take_dev_to_reimport (GValue* value, gpointer v_object) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* old;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (v_object) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 33412 "Photo.c"
	} else {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 33416 "Photo.c"
	}
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (old) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_reimport_raw_development_state_impl_dev_to_reimport_unref (old);
#line 33422 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_class_init (PhotoReimportRawDevelopmentStateImplDevToReimportClass * klass) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_raw_development_state_impl_dev_to_reimport_parent_class = g_type_class_peek_parent (klass);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateImplDevToReimportClass *) klass)->finalize = photo_reimport_raw_development_state_impl_dev_to_reimport_finalize;
#line 33432 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init (PhotoReimportRawDevelopmentStateImplDevToReimport * self) {
	BackingPhotoRow* _tmp0_ = NULL;
#line 1288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 1288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing = _tmp0_;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->ref_count = 1;
#line 33444 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_finalize (PhotoReimportRawDevelopmentStateImplDevToReimport* obj) {
	PhotoReimportRawDevelopmentStateImplDevToReimport * self;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, PhotoReimportRawDevelopmentStateImplDevToReimport);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_handlers_destroy (self);
#line 1288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing);
#line 1289 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 33458 "Photo.c"
}


GType photo_reimport_raw_development_state_impl_dev_to_reimport_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_reimport_raw_development_state_impl_value_dev_to_reimport_init, photo_reimport_raw_development_state_impl_value_dev_to_reimport_free_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_copy_value, photo_reimport_raw_development_state_impl_value_dev_to_reimport_peek_pointer, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_collect_value, "p", photo_reimport_raw_development_state_impl_value_dev_to_reimport_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplDevToReimportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImplDevToReimport), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_raw_development_state_impl_dev_to_reimport_type_id;
		photo_reimport_raw_development_state_impl_dev_to_reimport_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportRawDevelopmentStateImplDevToReimport", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile, photo_reimport_raw_development_state_impl_dev_to_reimport_type_id);
	}
	return photo_reimport_raw_development_state_impl_dev_to_reimport_type_id__volatile;
}


static gpointer photo_reimport_raw_development_state_impl_dev_to_reimport_ref (gpointer instance) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self;
	self = instance;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return instance;
#line 33483 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_dev_to_reimport_unref (gpointer instance) {
	PhotoReimportRawDevelopmentStateImplDevToReimport* self;
	self = instance;
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_DEV_TO_REIMPORT_GET_CLASS (self)->finalize (self);
#line 1287 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 33496 "Photo.c"
	}
}


static void photo_reimport_raw_development_state_impl_class_init (PhotoReimportRawDevelopmentStateImplClass * klass) {
#line 1286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_reimport_raw_development_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 1286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoReimportRawDevelopmentStateClass *) klass)->finalize = photo_reimport_raw_development_state_impl_finalize;
#line 33506 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_instance_init (PhotoReimportRawDevelopmentStateImpl * self) {
	GeeArrayList* _tmp0_ = NULL;
#line 1297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_array_list_new (PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL_TYPE_DEV_TO_REIMPORT, (GBoxedCopyFunc) photo_reimport_raw_development_state_impl_dev_to_reimport_ref, (GDestroyNotify) photo_reimport_raw_development_state_impl_dev_to_reimport_unref, NULL, NULL, NULL);
#line 1297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->list = (GeeCollection*) _tmp0_;
#line 1298 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->metadata_only = FALSE;
#line 33518 "Photo.c"
}


static void photo_reimport_raw_development_state_impl_finalize (PhotoReimportRawDevelopmentState* obj) {
	PhotoReimportRawDevelopmentStateImpl * self;
#line 1286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE_IMPL, PhotoReimportRawDevelopmentStateImpl);
#line 1297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->list);
#line 1286 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_REIMPORT_RAW_DEVELOPMENT_STATE_CLASS (photo_reimport_raw_development_state_impl_parent_class)->finalize (obj);
#line 33530 "Photo.c"
}


static GType photo_reimport_raw_development_state_impl_get_type (void) {
	static volatile gsize photo_reimport_raw_development_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_raw_development_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportRawDevelopmentStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_raw_development_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportRawDevelopmentStateImpl), 0, (GInstanceInitFunc) photo_reimport_raw_development_state_impl_instance_init, NULL };
		GType photo_reimport_raw_development_state_impl_type_id;
		photo_reimport_raw_development_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_RAW_DEVELOPMENT_STATE, "PhotoReimportRawDevelopmentStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_raw_development_state_impl_type_id__volatile, photo_reimport_raw_development_state_impl_type_id);
	}
	return photo_reimport_raw_development_state_impl_type_id__volatile;
}


static void photo_class_init (PhotoClass * klass) {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPrivate));
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_replaced = (void (*)(Photo*, GFile*, GFile*)) photo_real_notify_editable_replaced;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_raw_development_modified = (void (*)(Photo*)) photo_real_notify_raw_development_modified;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_replaced = (void (*)(Photo*)) photo_real_notify_baseline_replaced;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*)(Photo*, PhotoMetadata*)) photo_real_notify_master_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*)(Photo*, PhotoMetadata*)) photo_real_notify_editable_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*)(Photo*, PhotoMetadata*)) photo_real_notify_source_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*)(Photo*, PhotoMetadata*)) photo_real_notify_baseline_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*)(DataSource*, GError**)) photo_real_internal_delete_backing;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_backing_files_state = (BackingFileState** (*)(MediaSource*, int*)) photo_real_get_backing_files_state;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*)(Photo*, PhotoMetadata*)) photo_real_apply_user_metadata_for_reimport;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->get_typename = (gchar* (*)(DataSource*)) photo_real_get_typename;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->get_instance_id = (gint64 (*)(DataSource*)) photo_real_get_instance_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->get_source_id = (gchar* (*)(DataSource*)) photo_real_get_source_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_preferred_thumbnail_format = (PhotoFileFormat (*)(ThumbnailSource*)) photo_real_get_preferred_thumbnail_format;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->create_thumbnail = (GdkPixbuf* (*)(ThumbnailSource*, gint, GError**)) photo_real_create_thumbnail;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_file = (GFile* (*)(MediaSource*)) photo_real_get_file;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_file = (GFile* (*)(MediaSource*)) photo_real_get_master_file;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_timestamp = (time_t (*)(MediaSource*)) photo_real_get_timestamp;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_event_id = (void (*)(MediaSource*, EventID*)) photo_real_get_event_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_import_id = (void (*)(MediaSource*, ImportID*)) photo_real_get_import_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_md5 = (gchar* (*)(MediaSource*)) photo_real_get_master_md5;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->commit_backlinks = (void (*)(DataSource*, SourceCollection*, const gchar*)) photo_real_commit_backlinks;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->set_event_id = (gboolean (*)(MediaSource*, EventID*)) photo_real_set_event_id;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataObjectClass *) klass)->to_string = (gchar* (*)(DataObject*)) photo_real_to_string;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->equals = (gboolean (*)(DataSource*, DataSource*)) photo_real_equals;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_filesize = (guint64 (*)(MediaSource*)) photo_real_get_filesize;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_master_filesize = (guint64 (*)(MediaSource*)) photo_real_get_master_filesize;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_exposure_time = (time_t (*)(MediaSource*)) photo_real_get_exposure_time;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_basename = (gchar* (*)(MediaSource*)) photo_real_get_basename;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_title = (gchar* (*)(MediaSource*)) photo_real_get_title;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_comment = (gchar* (*)(MediaSource*)) photo_real_get_comment;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->set_title = (void (*)(MediaSource*, const gchar*)) photo_real_set_title;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->set_comment = (gboolean (*)(MediaSource*, const gchar*)) photo_real_set_comment;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_dimensions = (void (*)(MediaSource*, PhotoException, Dimensions*)) photo_real_get_dimensions;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoSourceClass *) klass)->get_metadata = (PhotoMetadata* (*)(PhotoSource*)) photo_real_get_metadata;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*)(Photo*, Rotation)) photo_real_rotate;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoSourceClass *) klass)->get_pixbuf = (GdkPixbuf* (*)(PhotoSource*, Scaling*, GError**)) photo_real_get_pixbuf;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*)(Photo*)) photo_real_has_user_generated_metadata;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*)(Photo*, PhotoMetadata*)) photo_real_set_user_metadata_for_export;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->editable_replaced = photo_real_editable_replaced;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->raw_development_modified = photo_real_raw_development_modified;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->baseline_replaced = photo_real_baseline_replaced;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->master_reimported = photo_real_master_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->editable_reimported = photo_real_editable_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->baseline_reimported = photo_real_baseline_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->source_reimported = photo_real_source_reimported;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_photo_get_property;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_photo_set_property;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("editable_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, g_file_get_type (), g_file_get_type ());
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("raw_development_modified", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, raw_development_modified), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("baseline_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 33663 "Photo.c"
}


static void photo_dateable_interface_init (DateableIface * iface) {
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->get_exposure_time = (time_t (*)(Dateable*)) photo_real_get_exposure_time;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->set_exposure_time = (void (*)(Dateable*, time_t)) photo_real_set_exposure_time;
#line 33674 "Photo.c"
}


static void photo_instance_init (Photo * self) {
	BackingPhotoRow* _tmp0_ = NULL;
	PhotoBackingReaders* _tmp1_ = NULL;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = PHOTO_GET_PRIVATE (self);
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_row);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backing_photo_row_new ();
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_readers);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_backing_readers_new ();
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->transformer = NULL;
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->adjustments = NULL;
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->file_title = NULL;
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->can_rotate_now = TRUE;
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_unmodified_precached);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->unmodified_precached = NULL;
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->secs_since_access = NULL;
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_init (&self->priv->__lock_developments);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->developments = NULL;
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->backing_photo_row = NULL;
#line 33723 "Photo.c"
}


static void photo_finalize (GObject* obj) {
	Photo * self;
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PHOTO, Photo);
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_row);
#line 245 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (self->row);
#line 246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->priv->editable);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_readers);
#line 247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_backing_readers_unref0 (self->priv->readers);
#line 248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 251 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 254 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 255 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_unmodified_precached);
#line 273 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->unmodified_precached);
#line 274 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_timer_destroy0 (self->priv->secs_since_access);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_rec_mutex_clear (&self->priv->__lock_developments);
#line 277 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->developments);
#line 288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (self->backing_photo_row);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 33769 "Photo.c"
}


GType photo_get_type (void) {
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


static void _vala_photo_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (property_id) {
#line 33792 "Photo.c"
		default:
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		break;
#line 33798 "Photo.c"
	}
}


static void _vala_photo_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Photo * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PHOTO, Photo);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	switch (property_id) {
#line 33808 "Photo.c"
		default:
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 97 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		break;
#line 33814 "Photo.c"
	}
}


GType library_photo_source_collection_state_get_type (void) {
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN", "unknown"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER", "developer"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static guint _file_hash_gee_hash_data_func (gconstpointer v, gpointer self) {
	guint result;
	result = file_hash ((GFile*) v);
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33836 "Photo.c"
}


static gboolean _file_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33845 "Photo.c"
}


static gint _int64_compare_gcompare_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gint result;
	result = int64_compare ((gint64*) a, (gint64*) b);
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33854 "Photo.c"
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return dup;
#line 33866 "Photo.c"
}


static gboolean _int64_equal_gee_equal_data_func (gconstpointer a, gconstpointer b, gpointer self) {
	gboolean result;
	result = int64_equal ((gint64*) a, (gint64*) b);
#line 4389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33875 "Photo.c"
}


static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self) {
	gint64 result;
	result = photo_get_photo_key (source);
#line 4409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33884 "Photo.c"
}


static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 33891 "Photo.c"
}


static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered ((LibraryPhotoSourceCollection*) self, added, removed);
#line 33898 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type) {
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_ = NULL;
#line 4409 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp1_, "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 4411 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_connect ((SourceHoldingTank*) _tmp3_, "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 4412 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4408 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 33928 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_new (void) {
#line 4408 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 33935 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33944 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_ = NULL;
#line 4415 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4416 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33960 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo ((LibraryPhotoSourceCollection*) self, source, alteration);
#line 4420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33969 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	LibraryPhotoSourceHoldingTank* _tmp0_ = NULL;
#line 4419 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_source_holding_tank_new (self, _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 4420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (MediaSourceHoldingTank*) _tmp0_;
#line 4420 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 33985 "Photo.c"
}


static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable) {
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	Workers* _tmp0_ = NULL;
	GCancellable* _tmp1_ = NULL;
	PhotoMonitor* _tmp2_ = NULL;
#line 4423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (workers != NULL, NULL);
#line 4423 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (cancellable != NULL, NULL);
#line 4424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = workers;
#line 4424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = cancellable;
#line 4424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_monitor_new (_tmp0_, _tmp1_);
#line 4424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (MediaMonitor*) _tmp2_;
#line 4424 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34011 "Photo.c"
}


static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	DataSource* _tmp0_ = NULL;
#line 4427 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4427 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = source;
#line 4428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO);
#line 4428 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34029 "Photo.c"
}


static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 4431 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 4432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 4432 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34045 "Photo.c"
}


static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 4435 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4435 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 4436 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 4436 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_file_format_is_file_supported (_tmp0_);
#line 4436 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 4436 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 34066 "Photo.c"
}


static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 4448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_on_editable_replaced ((LibraryPhotoSourceCollection*) self, _sender, old_file, new_file);
#line 34073 "Photo.c"
}


static void _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self) {
#line 4454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_on_raw_development_modified ((LibraryPhotoSourceCollection*) self, _sender);
#line 34080 "Photo.c"
}


static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed) {
	LibraryPhotoSourceCollection * self;
	GeeIterable* _tmp0_ = NULL;
	GeeIterable* _tmp75_ = NULL;
	GeeIterable* _tmp153_ = NULL;
	GeeIterable* _tmp154_ = NULL;
#line 4439 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = added;
#line 4441 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 34096 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterable* _tmp1_ = NULL;
			GeeIterator* _tmp2_ = NULL;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = added;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_object_it = _tmp2_;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 34109 "Photo.c"
				GeeIterator* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				DataObject* object = NULL;
				GeeIterator* _tmp5_ = NULL;
				gpointer _tmp6_ = NULL;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp7_ = NULL;
				LibraryPhoto* _tmp8_ = NULL;
				GFile* editable = NULL;
				LibraryPhoto* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
				GFile* _tmp11_ = NULL;
				LibraryPhoto* _tmp15_ = NULL;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp16_ = NULL;
				GeeCollection* _tmp17_ = NULL;
				GeeCollection* _tmp18_ = NULL;
				LibraryPhoto* _tmp28_ = NULL;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp29_ = NULL;
				BackingPhotoRow* _tmp30_ = NULL;
				BackingPhotoRow* _tmp31_ = NULL;
				gint64 _tmp32_ = 0LL;
				gint64 _tmp33_ = 0LL;
				gint64 _tmp34_ = 0LL;
				LibraryPhoto* _tmp35_ = NULL;
				BackingPhotoRow* _tmp36_ = NULL;
				BackingPhotoRow* _tmp37_ = NULL;
				gboolean _tmp38_ = FALSE;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp43_ = NULL;
				gint64 _tmp44_ = 0LL;
				LibraryPhoto* _tmp45_ = NULL;
				GeeHashMap* _tmp46_ = NULL;
				LibraryPhoto* _tmp47_ = NULL;
				gint64 _tmp48_ = 0LL;
				gint64 _tmp49_ = 0LL;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp56_ = NULL;
				GeeCollection* _tmp57_ = NULL;
				GeeCollection* _tmp58_ = NULL;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _object_it;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp4_) {
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 34159 "Photo.c"
				}
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _object_it;
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				object = (DataObject*) _tmp6_;
#line 4443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = object;
#line 4443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4443 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp8_;
#line 4445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = photo;
#line 4445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = photo_get_editable_file ((Photo*) _tmp9_);
#line 4445 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable = _tmp10_;
#line 4446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = editable;
#line 4446 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 34183 "Photo.c"
					GeeHashMap* _tmp12_ = NULL;
					GFile* _tmp13_ = NULL;
					LibraryPhoto* _tmp14_ = NULL;
#line 4447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = self->priv->by_editable_file;
#line 4447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = editable;
#line 4447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = photo;
#line 4447 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, _tmp13_, _tmp14_);
#line 34195 "Photo.c"
				}
#line 4448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = photo;
#line 4448 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp15_, "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = photo;
#line 4450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = photo_get_raw_developer_files ((Photo*) _tmp16_);
#line 4450 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_list = _tmp17_;
#line 4451 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = raw_list;
#line 4451 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp18_ != NULL) {
#line 34211 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp19_ = NULL;
						GeeIterator* _tmp20_ = NULL;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp19_ = raw_list;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_f_it = _tmp20_;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 34224 "Photo.c"
							GeeIterator* _tmp21_ = NULL;
							gboolean _tmp22_ = FALSE;
							GFile* f = NULL;
							GeeIterator* _tmp23_ = NULL;
							gpointer _tmp24_ = NULL;
							GeeHashMap* _tmp25_ = NULL;
							GFile* _tmp26_ = NULL;
							LibraryPhoto* _tmp27_ = NULL;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp21_ = _f_it;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp22_ = gee_iterator_next (_tmp21_);
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp22_) {
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 34241 "Photo.c"
							}
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp23_ = _f_it;
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp24_ = gee_iterator_get (_tmp23_);
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							f = (GFile*) _tmp24_;
#line 4453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp25_ = self->priv->by_raw_development_file;
#line 4453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp26_ = f;
#line 4453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp27_ = photo;
#line 4453 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, _tmp26_, _tmp27_);
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (f);
#line 34259 "Photo.c"
						}
#line 4452 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34263 "Photo.c"
					}
				}
#line 4454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = photo;
#line 4454 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp28_, "raw-development-modified", (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = photo;
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = photo_get_master_photo_row ((Photo*) _tmp29_);
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = _tmp30_;
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = _tmp31_->filesize;
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _tmp32_;
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp31_);
#line 4456 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				master_filesize = _tmp33_;
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = photo;
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = photo_get_editable_photo_row ((Photo*) _tmp35_);
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = _tmp36_;
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = _tmp37_ != NULL;
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp37_);
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp38_) {
#line 34296 "Photo.c"
					LibraryPhoto* _tmp39_ = NULL;
					BackingPhotoRow* _tmp40_ = NULL;
					BackingPhotoRow* _tmp41_ = NULL;
					gint64 _tmp42_ = 0LL;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp39_ = photo;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp40_ = photo_get_editable_photo_row ((Photo*) _tmp39_);
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp41_ = _tmp40_;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp42_ = _tmp41_->filesize;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp34_ = _tmp42_;
#line 4458 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp41_);
#line 34313 "Photo.c"
				} else {
#line 4459 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp34_ = (gint64) -1;
#line 34317 "Photo.c"
				}
#line 4457 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_filesize = _tmp34_;
#line 4460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = self->priv->filesize_to_photo;
#line 4460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = master_filesize;
#line 4460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp45_ = photo;
#line 4460 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_set (_tmp43_, &_tmp44_, _tmp45_);
#line 4461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp46_ = self->priv->photo_to_master_filesize;
#line 4461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp47_ = photo;
#line 4461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp48_ = master_filesize;
#line 4461 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp46_, _tmp47_, &_tmp48_);
#line 4462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp49_ = editable_filesize;
#line 4462 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp49_ >= ((gint64) 0)) {
#line 34341 "Photo.c"
					GeeMultiMap* _tmp50_ = NULL;
					gint64 _tmp51_ = 0LL;
					LibraryPhoto* _tmp52_ = NULL;
					GeeHashMap* _tmp53_ = NULL;
					LibraryPhoto* _tmp54_ = NULL;
					gint64 _tmp55_ = 0LL;
#line 4463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = self->priv->filesize_to_photo;
#line 4463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp51_ = editable_filesize;
#line 4463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp52_ = photo;
#line 4463 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp50_, &_tmp51_, _tmp52_);
#line 4464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp53_ = self->priv->photo_to_editable_filesize;
#line 4464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp54_ = photo;
#line 4464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp55_ = editable_filesize;
#line 4464 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp53_, _tmp54_, &_tmp55_);
#line 34364 "Photo.c"
				}
#line 4467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = photo;
#line 4467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = photo_get_raw_development_photo_rows ((Photo*) _tmp56_);
#line 4467 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_rows = _tmp57_;
#line 4468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = raw_rows;
#line 4468 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp58_ != NULL) {
#line 34376 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp59_ = NULL;
						GeeIterator* _tmp60_ = NULL;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp59_ = raw_rows;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp60_ = gee_iterable_iterator ((GeeIterable*) _tmp59_);
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_row_it = _tmp60_;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 34389 "Photo.c"
							GeeIterator* _tmp61_ = NULL;
							gboolean _tmp62_ = FALSE;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp63_ = NULL;
							gpointer _tmp64_ = NULL;
							BackingPhotoRow* _tmp65_ = NULL;
							gint64 _tmp66_ = 0LL;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp61_ = _row_it;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp62_ = gee_iterator_next (_tmp61_);
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp62_) {
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 34405 "Photo.c"
							}
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp63_ = _row_it;
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp64_ = gee_iterator_get (_tmp63_);
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp64_;
#line 4470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp65_ = row;
#line 4470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp66_ = _tmp65_->filesize;
#line 4470 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (_tmp66_ >= ((gint64) 0)) {
#line 34419 "Photo.c"
								GeeMultiMap* _tmp67_ = NULL;
								BackingPhotoRow* _tmp68_ = NULL;
								gint64 _tmp69_ = 0LL;
								LibraryPhoto* _tmp70_ = NULL;
								GeeMultiMap* _tmp71_ = NULL;
								LibraryPhoto* _tmp72_ = NULL;
								BackingPhotoRow* _tmp73_ = NULL;
								gint64 _tmp74_ = 0LL;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp67_ = self->priv->filesize_to_photo;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp68_ = row;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp69_ = _tmp68_->filesize;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp70_ = photo;
#line 4471 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								gee_multi_map_set (_tmp67_, &_tmp69_, _tmp70_);
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp71_ = self->priv->photo_to_raw_development_filesize;
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp72_ = photo;
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp73_ = row;
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp74_ = _tmp73_->filesize;
#line 4472 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								gee_multi_map_set (_tmp71_, _tmp72_, &_tmp74_);
#line 34448 "Photo.c"
							}
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34452 "Photo.c"
						}
#line 4469 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34456 "Photo.c"
					}
				}
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (object);
#line 34469 "Photo.c"
			}
#line 4442 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34473 "Photo.c"
		}
	}
#line 4479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp75_ = removed;
#line 4479 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp75_ != NULL) {
#line 34480 "Photo.c"
		{
			GeeIterator* _object_it = NULL;
			GeeIterable* _tmp76_ = NULL;
			GeeIterator* _tmp77_ = NULL;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp76_ = removed;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp77_ = gee_iterable_iterator (_tmp76_);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_object_it = _tmp77_;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 34493 "Photo.c"
				GeeIterator* _tmp78_ = NULL;
				gboolean _tmp79_ = FALSE;
				DataObject* object = NULL;
				GeeIterator* _tmp80_ = NULL;
				gpointer _tmp81_ = NULL;
				LibraryPhoto* photo = NULL;
				DataObject* _tmp82_ = NULL;
				LibraryPhoto* _tmp83_ = NULL;
				GFile* editable = NULL;
				LibraryPhoto* _tmp84_ = NULL;
				GFile* _tmp85_ = NULL;
				GFile* _tmp86_ = NULL;
				LibraryPhoto* _tmp94_ = NULL;
				guint _tmp95_ = 0U;
				GeeCollection* raw_list = NULL;
				LibraryPhoto* _tmp96_ = NULL;
				GeeCollection* _tmp97_ = NULL;
				GeeCollection* _tmp98_ = NULL;
				LibraryPhoto* _tmp107_ = NULL;
				guint _tmp108_ = 0U;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp109_ = NULL;
				BackingPhotoRow* _tmp110_ = NULL;
				BackingPhotoRow* _tmp111_ = NULL;
				gint64 _tmp112_ = 0LL;
				gint64 _tmp113_ = 0LL;
				gint64 _tmp114_ = 0LL;
				LibraryPhoto* _tmp115_ = NULL;
				BackingPhotoRow* _tmp116_ = NULL;
				BackingPhotoRow* _tmp117_ = NULL;
				gboolean _tmp118_ = FALSE;
				gint64 editable_filesize = 0LL;
				GeeMultiMap* _tmp123_ = NULL;
				gint64 _tmp124_ = 0LL;
				LibraryPhoto* _tmp125_ = NULL;
				GeeHashMap* _tmp126_ = NULL;
				LibraryPhoto* _tmp127_ = NULL;
				gint64 _tmp128_ = 0LL;
				GeeCollection* raw_rows = NULL;
				LibraryPhoto* _tmp134_ = NULL;
				GeeCollection* _tmp135_ = NULL;
				GeeCollection* _tmp136_ = NULL;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp78_ = _object_it;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp79_ = gee_iterator_next (_tmp78_);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp79_) {
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 34544 "Photo.c"
				}
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp80_ = _object_it;
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp81_ = gee_iterator_get (_tmp80_);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				object = (DataObject*) _tmp81_;
#line 4481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp82_ = object;
#line 4481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp83_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp82_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4481 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp83_;
#line 4483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp84_ = photo;
#line 4483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp85_ = photo_get_editable_file ((Photo*) _tmp84_);
#line 4483 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable = _tmp85_;
#line 4484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp86_ = editable;
#line 4484 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp86_ != NULL) {
#line 34568 "Photo.c"
					gboolean is_removed = FALSE;
					GeeHashMap* _tmp87_ = NULL;
					LibraryPhoto* _tmp88_ = NULL;
					GFile* _tmp89_ = NULL;
					GFile* _tmp90_ = NULL;
					gboolean _tmp91_ = FALSE;
					gboolean _tmp92_ = FALSE;
					gboolean _tmp93_ = FALSE;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp87_ = self->priv->by_editable_file;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp88_ = photo;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp89_ = photo_get_editable_file ((Photo*) _tmp88_);
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp90_ = _tmp89_;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp91_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp87_, _tmp90_, NULL);
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp92_ = _tmp91_;
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp90_);
#line 4485 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					is_removed = _tmp92_;
#line 4486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp93_ = is_removed;
#line 4486 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_vala_assert (_tmp93_, "is_removed");
#line 34597 "Photo.c"
				}
#line 4488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp94_ = photo;
#line 4488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp95_, NULL, FALSE);
#line 4488 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp94_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp95_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 4490 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp96_ = photo;
#line 4490 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp97_ = photo_get_raw_developer_files ((Photo*) _tmp96_);
#line 4490 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_list = _tmp97_;
#line 4491 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp98_ = raw_list;
#line 4491 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp98_ != NULL) {
#line 34615 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp99_ = NULL;
						GeeIterator* _tmp100_ = NULL;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp99_ = raw_list;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp100_ = gee_iterable_iterator ((GeeIterable*) _tmp99_);
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_f_it = _tmp100_;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 34628 "Photo.c"
							GeeIterator* _tmp101_ = NULL;
							gboolean _tmp102_ = FALSE;
							GFile* f = NULL;
							GeeIterator* _tmp103_ = NULL;
							gpointer _tmp104_ = NULL;
							GeeHashMap* _tmp105_ = NULL;
							GFile* _tmp106_ = NULL;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp101_ = _f_it;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp102_ = gee_iterator_next (_tmp101_);
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp102_) {
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 34644 "Photo.c"
							}
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp103_ = _f_it;
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp104_ = gee_iterator_get (_tmp103_);
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							f = (GFile*) _tmp104_;
#line 4493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp105_ = self->priv->by_raw_development_file;
#line 4493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp106_ = f;
#line 4493 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_abstract_map_unset ((GeeAbstractMap*) _tmp105_, _tmp106_, NULL);
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (f);
#line 34660 "Photo.c"
						}
#line 4492 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 34664 "Photo.c"
					}
				}
#line 4494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp107_ = photo;
#line 4494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp108_, NULL, FALSE);
#line 4494 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp107_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp108_, 0, NULL, (GCallback) _library_photo_source_collection_on_raw_development_modified_photo_raw_development_modified, self);
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp109_ = photo;
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp110_ = photo_get_master_photo_row ((Photo*) _tmp109_);
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp111_ = _tmp110_;
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp112_ = _tmp111_->filesize;
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp113_ = _tmp112_;
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp111_);
#line 4496 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				master_filesize = _tmp113_;
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp115_ = photo;
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp116_ = photo_get_editable_photo_row ((Photo*) _tmp115_);
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp117_ = _tmp116_;
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp118_ = _tmp117_ != NULL;
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp117_);
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp118_) {
#line 34699 "Photo.c"
					LibraryPhoto* _tmp119_ = NULL;
					BackingPhotoRow* _tmp120_ = NULL;
					BackingPhotoRow* _tmp121_ = NULL;
					gint64 _tmp122_ = 0LL;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp119_ = photo;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp120_ = photo_get_editable_photo_row ((Photo*) _tmp119_);
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp121_ = _tmp120_;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp122_ = _tmp121_->filesize;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp114_ = _tmp122_;
#line 4498 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp121_);
#line 34716 "Photo.c"
				} else {
#line 4499 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp114_ = (gint64) -1;
#line 34720 "Photo.c"
				}
#line 4497 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_filesize = _tmp114_;
#line 4500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp123_ = self->priv->filesize_to_photo;
#line 4500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp124_ = master_filesize;
#line 4500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp125_ = photo;
#line 4500 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove (_tmp123_, &_tmp124_, _tmp125_);
#line 4501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp126_ = self->priv->photo_to_master_filesize;
#line 4501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp127_ = photo;
#line 4501 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp126_, _tmp127_, NULL);
#line 4502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp128_ = editable_filesize;
#line 4502 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp128_ >= ((gint64) 0)) {
#line 34742 "Photo.c"
					GeeMultiMap* _tmp129_ = NULL;
					gint64 _tmp130_ = 0LL;
					LibraryPhoto* _tmp131_ = NULL;
					GeeHashMap* _tmp132_ = NULL;
					LibraryPhoto* _tmp133_ = NULL;
#line 4503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp129_ = self->priv->filesize_to_photo;
#line 4503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp130_ = editable_filesize;
#line 4503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp131_ = photo;
#line 4503 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_remove (_tmp129_, &_tmp130_, _tmp131_);
#line 4504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp132_ = self->priv->photo_to_editable_filesize;
#line 4504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp133_ = photo;
#line 4504 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp132_, _tmp133_, NULL);
#line 34762 "Photo.c"
				}
#line 4507 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp134_ = photo;
#line 4507 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp135_ = photo_get_raw_development_photo_rows ((Photo*) _tmp134_);
#line 4507 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_rows = _tmp135_;
#line 4508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp136_ = raw_rows;
#line 4508 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp136_ != NULL) {
#line 34774 "Photo.c"
					{
						GeeIterator* _row_it = NULL;
						GeeCollection* _tmp137_ = NULL;
						GeeIterator* _tmp138_ = NULL;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp137_ = raw_rows;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp138_ = gee_iterable_iterator ((GeeIterable*) _tmp137_);
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_row_it = _tmp138_;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 34787 "Photo.c"
							GeeIterator* _tmp139_ = NULL;
							gboolean _tmp140_ = FALSE;
							BackingPhotoRow* row = NULL;
							GeeIterator* _tmp141_ = NULL;
							gpointer _tmp142_ = NULL;
							BackingPhotoRow* _tmp143_ = NULL;
							gint64 _tmp144_ = 0LL;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp139_ = _row_it;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp140_ = gee_iterator_next (_tmp139_);
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp140_) {
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 34803 "Photo.c"
							}
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp141_ = _row_it;
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp142_ = gee_iterator_get (_tmp141_);
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							row = (BackingPhotoRow*) _tmp142_;
#line 4510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp143_ = row;
#line 4510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp144_ = _tmp143_->filesize;
#line 4510 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (_tmp144_ >= ((gint64) 0)) {
#line 34817 "Photo.c"
								GeeMultiMap* _tmp145_ = NULL;
								BackingPhotoRow* _tmp146_ = NULL;
								gint64 _tmp147_ = 0LL;
								LibraryPhoto* _tmp148_ = NULL;
								GeeMultiMap* _tmp149_ = NULL;
								LibraryPhoto* _tmp150_ = NULL;
								BackingPhotoRow* _tmp151_ = NULL;
								gint64 _tmp152_ = 0LL;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp145_ = self->priv->filesize_to_photo;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp146_ = row;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp147_ = _tmp146_->filesize;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp148_ = photo;
#line 4511 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								gee_multi_map_remove (_tmp145_, &_tmp147_, _tmp148_);
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp149_ = self->priv->photo_to_raw_development_filesize;
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp150_ = photo;
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp151_ = row;
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								_tmp152_ = _tmp151_->filesize;
#line 4512 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								gee_multi_map_remove (_tmp149_, _tmp150_, &_tmp152_);
#line 34846 "Photo.c"
							}
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_backing_photo_row_unref0 (row);
#line 34850 "Photo.c"
						}
#line 4509 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_row_it);
#line 34854 "Photo.c"
					}
				}
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_rows);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_list);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (editable);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (object);
#line 34867 "Photo.c"
			}
#line 4480 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 34871 "Photo.c"
		}
	}
#line 4519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp153_ = added;
#line 4519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp154_ = removed;
#line 4519 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp153_, _tmp154_);
#line 34880 "Photo.c"
}


static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp5_ = NULL;
#line 4522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4522 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = old_file;
#line 4523 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 34895 "Photo.c"
		gboolean is_removed = FALSE;
		GeeHashMap* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
#line 4524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 4524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = old_file;
#line 4524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, _tmp2_, NULL);
#line 4524 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		is_removed = _tmp3_;
#line 4525 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = is_removed;
#line 4525 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_assert (_tmp4_, "is_removed");
#line 34913 "Photo.c"
	}
#line 4528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = new_file;
#line 4528 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 34919 "Photo.c"
		GeeHashMap* _tmp6_ = NULL;
		GFile* _tmp7_ = NULL;
		Photo* _tmp8_ = NULL;
#line 4529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = self->priv->by_editable_file;
#line 4529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = new_file;
#line 4529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = photo;
#line 4529 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp7_, G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 34931 "Photo.c"
	}
}


static void library_photo_source_collection_on_raw_development_modified (LibraryPhotoSourceCollection* self, Photo* _photo) {
	LibraryPhoto* photo = NULL;
	Photo* _tmp0_ = NULL;
	LibraryPhoto* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GeeMultiMap* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp23_ = NULL;
	GeeCollection* _tmp24_ = NULL;
	GeeCollection* _tmp25_ = NULL;
	GeeCollection* raw_rows = NULL;
	LibraryPhoto* _tmp35_ = NULL;
	GeeCollection* _tmp36_ = NULL;
	GeeCollection* _tmp37_ = NULL;
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 4533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _photo;
#line 4533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 4533 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp1_;
#line 4534 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo;
#line 4534 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 4535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4535 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 34970 "Photo.c"
	}
#line 4538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = self->priv->photo_to_raw_development_filesize;
#line 4538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo;
#line 4538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = gee_multi_map_contains (_tmp3_, _tmp4_);
#line 4538 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_) {
#line 34980 "Photo.c"
		GeeMultiMap* _tmp21_ = NULL;
		LibraryPhoto* _tmp22_ = NULL;
		{
			GeeIterator* _s_it = NULL;
			GeeMultiMap* _tmp6_ = NULL;
			LibraryPhoto* _tmp7_ = NULL;
			GeeCollection* _tmp8_ = NULL;
			GeeCollection* _tmp9_ = NULL;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tmp11_ = NULL;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->photo_to_raw_development_filesize;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = photo;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_multi_map_get (_tmp6_, _tmp7_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp9_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_s_it = _tmp11_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 35009 "Photo.c"
				GeeIterator* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				gint64 s = 0LL;
				GeeIterator* _tmp14_ = NULL;
				gpointer _tmp15_ = NULL;
				gint64* _tmp16_ = NULL;
				gint64 _tmp17_ = 0LL;
				GeeMultiMap* _tmp18_ = NULL;
				gint64 _tmp19_ = 0LL;
				LibraryPhoto* _tmp20_ = NULL;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _s_it;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp13_) {
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 35028 "Photo.c"
				}
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = _s_it;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = (gint64*) _tmp15_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = *_tmp16_;
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp16_);
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				s = _tmp17_;
#line 4540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = self->priv->filesize_to_photo;
#line 4540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = s;
#line 4540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = photo;
#line 4540 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove (_tmp18_, &_tmp19_, _tmp20_);
#line 35050 "Photo.c"
			}
#line 4539 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_s_it);
#line 35054 "Photo.c"
		}
#line 4541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = self->priv->photo_to_raw_development_filesize;
#line 4541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp22_ = photo;
#line 4541 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_multi_map_remove_all (_tmp21_, _tmp22_);
#line 35062 "Photo.c"
	}
#line 4545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = photo;
#line 4545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = photo_get_raw_developer_files ((Photo*) _tmp23_);
#line 4545 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_list = _tmp24_;
#line 4546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = raw_list;
#line 4546 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 35074 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp26_ = NULL;
			GeeIterator* _tmp27_ = NULL;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = raw_list;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_f_it = _tmp27_;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 35087 "Photo.c"
				GeeIterator* _tmp28_ = NULL;
				gboolean _tmp29_ = FALSE;
				GFile* f = NULL;
				GeeIterator* _tmp30_ = NULL;
				gpointer _tmp31_ = NULL;
				GeeHashMap* _tmp32_ = NULL;
				GFile* _tmp33_ = NULL;
				LibraryPhoto* _tmp34_ = NULL;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = _f_it;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = gee_iterator_next (_tmp28_);
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp29_) {
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 35104 "Photo.c"
				}
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = _f_it;
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = gee_iterator_get (_tmp30_);
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				f = (GFile*) _tmp31_;
#line 4548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = self->priv->by_raw_development_file;
#line 4548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = f;
#line 4548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = photo;
#line 4548 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, _tmp33_, _tmp34_);
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (f);
#line 35122 "Photo.c"
			}
#line 4547 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 35126 "Photo.c"
		}
	}
#line 4550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = photo;
#line 4550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = photo_get_raw_development_photo_rows ((Photo*) _tmp35_);
#line 4550 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_rows = _tmp36_;
#line 4551 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = raw_rows;
#line 4551 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp37_ != NULL) {
#line 35139 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp38_ = NULL;
			GeeIterator* _tmp39_ = NULL;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp38_ = raw_rows;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp39_ = gee_iterable_iterator ((GeeIterable*) _tmp38_);
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_row_it = _tmp39_;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 35152 "Photo.c"
				GeeIterator* _tmp40_ = NULL;
				gboolean _tmp41_ = FALSE;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp42_ = NULL;
				gpointer _tmp43_ = NULL;
				BackingPhotoRow* _tmp44_ = NULL;
				gint64 _tmp45_ = 0LL;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = _row_it;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = gee_iterator_next (_tmp40_);
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp41_) {
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 35168 "Photo.c"
				}
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = _row_it;
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = gee_iterator_get (_tmp42_);
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp43_;
#line 4553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = row;
#line 4553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp45_ = _tmp44_->filesize;
#line 4553 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp45_ > ((gint64) 0)) {
#line 35182 "Photo.c"
					GeeMultiMap* _tmp46_ = NULL;
					BackingPhotoRow* _tmp47_ = NULL;
					gint64 _tmp48_ = 0LL;
					LibraryPhoto* _tmp49_ = NULL;
					GeeMultiMap* _tmp50_ = NULL;
					LibraryPhoto* _tmp51_ = NULL;
					BackingPhotoRow* _tmp52_ = NULL;
					gint64 _tmp53_ = 0LL;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp46_ = self->priv->filesize_to_photo;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp47_ = row;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp48_ = _tmp47_->filesize;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp49_ = photo;
#line 4554 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp46_, &_tmp48_, _tmp49_);
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = self->priv->photo_to_raw_development_filesize;
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp51_ = photo;
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp52_ = row;
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp53_ = _tmp52_->filesize;
#line 4555 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp50_, _tmp51_, &_tmp53_);
#line 35211 "Photo.c"
				}
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 35215 "Photo.c"
			}
#line 4552 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 35219 "Photo.c"
		}
	}
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (raw_rows);
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 4532 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 35228 "Photo.c"
}


static gpointer __int64_dup0 (gpointer self) {
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 35235 "Photo.c"
}


static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items) {
	LibraryPhotoSourceCollection * self;
	GeeMap* _tmp72_ = NULL;
#line 4561 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4561 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (items != NULL);
#line 35246 "Photo.c"
	{
		GeeIterator* _object_it = NULL;
		GeeMap* _tmp0_ = NULL;
		GeeSet* _tmp1_ = NULL;
		GeeSet* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = items;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_object_it = _tmp5_;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 35273 "Photo.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			DataObject* object = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			Alteration* alteration = NULL;
			GeeMap* _tmp10_ = NULL;
			DataObject* _tmp11_ = NULL;
			gpointer _tmp12_ = NULL;
			LibraryPhoto* photo = NULL;
			DataObject* _tmp13_ = NULL;
			LibraryPhoto* _tmp14_ = NULL;
			gboolean _tmp15_ = FALSE;
			Alteration* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _object_it;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp7_) {
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 35297 "Photo.c"
			}
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _object_it;
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			object = (DataObject*) _tmp9_;
#line 4563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = items;
#line 4563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = object;
#line 4563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 4563 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			alteration = (Alteration*) _tmp12_;
#line 4565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = object;
#line 4565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4565 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = _tmp14_;
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = alteration;
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = alteration_has_detail (_tmp16_, "image", "master");
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp17_) {
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = TRUE;
#line 35327 "Photo.c"
			} else {
				Alteration* _tmp18_ = NULL;
				gboolean _tmp19_ = FALSE;
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = alteration;
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = alteration_has_detail (_tmp18_, "image", "editable");
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = _tmp19_;
#line 35337 "Photo.c"
			}
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp15_) {
#line 35341 "Photo.c"
				gint64 old_master_filesize = 0LL;
				GeeHashMap* _tmp20_ = NULL;
				LibraryPhoto* _tmp21_ = NULL;
				gpointer _tmp22_ = NULL;
				gint64* _tmp23_ = NULL;
				gint64 _tmp24_ = 0LL;
				gint64* _tmp25_ = NULL;
				GeeHashMap* _tmp26_ = NULL;
				LibraryPhoto* _tmp27_ = NULL;
				gboolean _tmp28_ = FALSE;
				gint64 old_editable_filesize = 0LL;
				GeeHashMap* _tmp34_ = NULL;
				LibraryPhoto* _tmp35_ = NULL;
				GeeMultiMap* _tmp36_ = NULL;
				gint64 _tmp37_ = 0LL;
				LibraryPhoto* _tmp38_ = NULL;
				gint64 _tmp39_ = 0LL;
				gint64 master_filesize = 0LL;
				LibraryPhoto* _tmp45_ = NULL;
				BackingPhotoRow* _tmp46_ = NULL;
				BackingPhotoRow* _tmp47_ = NULL;
				gint64 _tmp48_ = 0LL;
				gint64 _tmp49_ = 0LL;
				gint64 _tmp50_ = 0LL;
				LibraryPhoto* _tmp51_ = NULL;
				BackingPhotoRow* _tmp52_ = NULL;
				BackingPhotoRow* _tmp53_ = NULL;
				gboolean _tmp54_ = FALSE;
				gint64 editable_filesize = 0LL;
				GeeHashMap* _tmp59_ = NULL;
				LibraryPhoto* _tmp60_ = NULL;
				gint64 _tmp61_ = 0LL;
				GeeMultiMap* _tmp62_ = NULL;
				gint64 _tmp63_ = 0LL;
				LibraryPhoto* _tmp64_ = NULL;
				gint64 _tmp65_ = 0LL;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = self->priv->photo_to_master_filesize;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = photo;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp20_, _tmp21_);
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = (gint64*) _tmp22_;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = *_tmp23_;
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp23_);
#line 4568 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				old_master_filesize = _tmp24_;
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = self->priv->photo_to_editable_filesize;
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = photo;
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp26_, _tmp27_);
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp28_) {
#line 35400 "Photo.c"
					GeeHashMap* _tmp29_ = NULL;
					LibraryPhoto* _tmp30_ = NULL;
					gpointer _tmp31_ = NULL;
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp29_ = self->priv->photo_to_editable_filesize;
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = photo;
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp29_, _tmp30_);
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (_tmp25_);
#line 4570 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = (gint64*) _tmp31_;
#line 35414 "Photo.c"
				} else {
					gint64 _tmp32_ = 0LL;
					gint64* _tmp33_ = NULL;
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp32_ = (gint64) -1;
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp33_ = __int64_dup0 (&_tmp32_);
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (_tmp25_);
#line 4571 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = _tmp33_;
#line 35426 "Photo.c"
				}
#line 4569 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				old_editable_filesize = *_tmp25_;
#line 4573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = self->priv->photo_to_master_filesize;
#line 4573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = photo;
#line 4573 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp34_, _tmp35_, NULL);
#line 4574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = self->priv->filesize_to_photo;
#line 4574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = old_master_filesize;
#line 4574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = photo;
#line 4574 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove (_tmp36_, &_tmp37_, _tmp38_);
#line 4575 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = old_editable_filesize;
#line 4575 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp39_ >= ((gint64) 0)) {
#line 35448 "Photo.c"
					GeeHashMap* _tmp40_ = NULL;
					LibraryPhoto* _tmp41_ = NULL;
					GeeMultiMap* _tmp42_ = NULL;
					gint64 _tmp43_ = 0LL;
					LibraryPhoto* _tmp44_ = NULL;
#line 4576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp40_ = self->priv->photo_to_editable_filesize;
#line 4576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp41_ = photo;
#line 4576 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_unset ((GeeAbstractMap*) _tmp40_, _tmp41_, NULL);
#line 4577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp42_ = self->priv->filesize_to_photo;
#line 4577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp43_ = old_editable_filesize;
#line 4577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp44_ = photo;
#line 4577 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_remove (_tmp42_, &_tmp43_, _tmp44_);
#line 35468 "Photo.c"
				}
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp45_ = photo;
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp46_ = photo_get_master_photo_row ((Photo*) _tmp45_);
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp47_ = _tmp46_;
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp48_ = _tmp47_->filesize;
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp49_ = _tmp48_;
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp47_);
#line 4580 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				master_filesize = _tmp49_;
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp51_ = photo;
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp52_ = photo_get_editable_photo_row ((Photo*) _tmp51_);
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp53_ = _tmp52_;
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp54_ = _tmp53_ != NULL;
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (_tmp53_);
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp54_) {
#line 35496 "Photo.c"
					LibraryPhoto* _tmp55_ = NULL;
					BackingPhotoRow* _tmp56_ = NULL;
					BackingPhotoRow* _tmp57_ = NULL;
					gint64 _tmp58_ = 0LL;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp55_ = photo;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp56_ = photo_get_editable_photo_row ((Photo*) _tmp55_);
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp57_ = _tmp56_;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp58_ = _tmp57_->filesize;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = _tmp58_;
#line 4582 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (_tmp57_);
#line 35513 "Photo.c"
				} else {
#line 4583 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = (gint64) -1;
#line 35517 "Photo.c"
				}
#line 4581 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				editable_filesize = _tmp50_;
#line 4584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp59_ = self->priv->photo_to_master_filesize;
#line 4584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp60_ = photo;
#line 4584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp61_ = master_filesize;
#line 4584 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp59_, _tmp60_, &_tmp61_);
#line 4585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp62_ = self->priv->filesize_to_photo;
#line 4585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp63_ = master_filesize;
#line 4585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp64_ = photo;
#line 4585 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_set (_tmp62_, &_tmp63_, _tmp64_);
#line 4586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp65_ = editable_filesize;
#line 4586 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp65_ >= ((gint64) 0)) {
#line 35541 "Photo.c"
					GeeHashMap* _tmp66_ = NULL;
					LibraryPhoto* _tmp67_ = NULL;
					gint64 _tmp68_ = 0LL;
					GeeMultiMap* _tmp69_ = NULL;
					gint64 _tmp70_ = 0LL;
					LibraryPhoto* _tmp71_ = NULL;
#line 4587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp66_ = self->priv->photo_to_editable_filesize;
#line 4587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp67_ = photo;
#line 4587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp68_ = editable_filesize;
#line 4587 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp66_, _tmp67_, &_tmp68_);
#line 4588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp69_ = self->priv->filesize_to_photo;
#line 4588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp70_ = editable_filesize;
#line 4588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp71_ = photo;
#line 4588 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp69_, &_tmp70_, _tmp71_);
#line 35564 "Photo.c"
				}
#line 4567 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp25_);
#line 35568 "Photo.c"
			}
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_alteration_unref0 (alteration);
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (object);
#line 35576 "Photo.c"
		}
#line 4562 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 35580 "Photo.c"
	}
#line 4593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp72_ = items;
#line 4593 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered ((DataCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp72_);
#line 35586 "Photo.c"
}


static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources) {
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* map = NULL;
	GeeHashMultiMap* _tmp0_ = NULL;
	GeeCollection* _tmp97_ = NULL;
#line 4597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (media_sources != NULL);
#line 4598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4598 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	map = _tmp0_;
#line 35603 "Photo.c"
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp1_ = NULL;
		GeeIterator* _tmp2_ = NULL;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = media_sources;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_it = _tmp2_;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 35616 "Photo.c"
			GeeIterator* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			MediaSource* media = NULL;
			GeeIterator* _tmp5_ = NULL;
			gpointer _tmp6_ = NULL;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp7_ = NULL;
			LibraryPhoto* _tmp8_ = NULL;
			PhotoMetadata* metadata = NULL;
			LibraryPhoto* _tmp9_ = NULL;
			PhotoMetadata* _tmp10_ = NULL;
			HierarchicalTagIndex* global_index = NULL;
			HierarchicalTagIndex* _tmp11_ = NULL;
			HierarchicalTagIndex* htag_index = NULL;
			PhotoMetadata* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			LibraryPhoto* _tmp18_ = NULL;
			GeeCollection* _tmp19_ = NULL;
			GeeCollection* _tmp20_ = NULL;
			gboolean _tmp21_ = FALSE;
			PhotoMetadata* _tmp55_ = NULL;
			gboolean _tmp56_ = FALSE;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp3_ = _media_it;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp4_) {
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 35647 "Photo.c"
			}
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _media_it;
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media = (MediaSource*) _tmp6_;
#line 4600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = media;
#line 4600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4600 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = _tmp8_;
#line 4601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = photo;
#line 4601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = photo_source_get_metadata ((PhotoSource*) _tmp9_);
#line 4601 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			metadata = _tmp10_;
#line 4604 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = hierarchical_tag_index_get_global_index ();
#line 4604 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			global_index = _tmp11_;
#line 4611 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			htag_index = NULL;
#line 4612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = metadata;
#line 4612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = photo_metadata_has_hierarchical_keywords (_tmp12_);
#line 4612 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp13_) {
#line 35679 "Photo.c"
				PhotoMetadata* _tmp14_ = NULL;
				GeeSet* _tmp15_ = NULL;
				GeeSet* _tmp16_ = NULL;
				HierarchicalTagIndex* _tmp17_ = NULL;
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = metadata;
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = photo_metadata_get_hierarchical_keywords (_tmp14_);
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = _tmp15_;
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp16_);
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_hierarchical_tag_index_unref0 (htag_index);
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				htag_index = _tmp17_;
#line 4613 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp16_);
#line 35698 "Photo.c"
			}
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = photo;
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = library_photo_get_import_keywords (_tmp18_);
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = _tmp20_ != NULL;
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp20_);
#line 4617 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp21_) {
#line 35712 "Photo.c"
				{
					GeeIterator* _keyword_it = NULL;
					LibraryPhoto* _tmp22_ = NULL;
					GeeCollection* _tmp23_ = NULL;
					GeeCollection* _tmp24_ = NULL;
					GeeIterator* _tmp25_ = NULL;
					GeeIterator* _tmp26_ = NULL;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = photo;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = library_photo_get_import_keywords (_tmp22_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp24_ = _tmp23_;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = gee_iterable_iterator ((GeeIterable*) _tmp24_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp26_ = _tmp25_;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp24_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_keyword_it = _tmp26_;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 35736 "Photo.c"
						GeeIterator* _tmp27_ = NULL;
						gboolean _tmp28_ = FALSE;
						gchar* keyword = NULL;
						GeeIterator* _tmp29_ = NULL;
						gpointer _tmp30_ = NULL;
						gboolean _tmp31_ = FALSE;
						HierarchicalTagIndex* _tmp32_ = NULL;
						gchar* name = NULL;
						const gchar* _tmp36_ = NULL;
						gchar* _tmp37_ = NULL;
						HierarchicalTagIndex* _tmp38_ = NULL;
						const gchar* _tmp39_ = NULL;
						gboolean _tmp40_ = FALSE;
						const gchar* _tmp49_ = NULL;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp27_ = _keyword_it;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp28_ = gee_iterator_next (_tmp27_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!_tmp28_) {
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 35759 "Photo.c"
						}
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp29_ = _keyword_it;
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp30_ = gee_iterator_get (_tmp29_);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						keyword = (gchar*) _tmp30_;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp32_ = htag_index;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp32_ != NULL) {
#line 35771 "Photo.c"
							HierarchicalTagIndex* _tmp33_ = NULL;
							const gchar* _tmp34_ = NULL;
							gboolean _tmp35_ = FALSE;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp33_ = htag_index;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp34_ = keyword;
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp35_ = hierarchical_tag_index_is_tag_in_index (_tmp33_, _tmp34_);
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp31_ = _tmp35_;
#line 35783 "Photo.c"
						} else {
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp31_ = FALSE;
#line 35787 "Photo.c"
						}
#line 4619 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp31_) {
#line 4620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (keyword);
#line 4620 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							continue;
#line 35795 "Photo.c"
						}
#line 4622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp36_ = keyword;
#line 4622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp37_ = tag_prep_tag_name (_tmp36_);
#line 4622 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						name = _tmp37_;
#line 4624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp38_ = global_index;
#line 4624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp39_ = name;
#line 4624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp40_ = hierarchical_tag_index_is_tag_in_index (_tmp38_, _tmp39_);
#line 4624 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp40_) {
#line 35811 "Photo.c"
							gchar* most_derived_path = NULL;
							HierarchicalTagIndex* _tmp41_ = NULL;
							const gchar* _tmp42_ = NULL;
							gchar* _tmp43_ = NULL;
							GeeHashMultiMap* _tmp44_ = NULL;
							const gchar* _tmp45_ = NULL;
							Tag* _tmp46_ = NULL;
							Tag* _tmp47_ = NULL;
							LibraryPhoto* _tmp48_ = NULL;
#line 4625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp41_ = global_index;
#line 4625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp42_ = name;
#line 4625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp43_ = hierarchical_tag_index_get_path_for_name (_tmp41_, _tmp42_);
#line 4625 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							most_derived_path = _tmp43_;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp44_ = map;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp45_ = most_derived_path;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp46_ = tag_for_path (_tmp45_);
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp47_ = _tmp46_;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp48_ = photo;
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp44_, _tmp47_, _tmp48_);
#line 4626 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp47_);
#line 4627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (most_derived_path);
#line 4627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (name);
#line 4627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_free0 (keyword);
#line 4627 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							continue;
#line 35851 "Photo.c"
						}
#line 4630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp49_ = name;
#line 4630 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp49_ != NULL) {
#line 35857 "Photo.c"
							GeeHashMultiMap* _tmp50_ = NULL;
							const gchar* _tmp51_ = NULL;
							Tag* _tmp52_ = NULL;
							Tag* _tmp53_ = NULL;
							LibraryPhoto* _tmp54_ = NULL;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp50_ = map;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp51_ = name;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp52_ = tag_for_path (_tmp51_);
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp53_ = _tmp52_;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp54_ = photo;
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp50_, _tmp53_, _tmp54_);
#line 4631 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp53_);
#line 35877 "Photo.c"
						}
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_free0 (name);
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_free0 (keyword);
#line 35883 "Photo.c"
					}
#line 4618 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 35887 "Photo.c"
				}
			}
#line 4635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp55_ = metadata;
#line 4635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp56_ = photo_metadata_has_hierarchical_keywords (_tmp55_);
#line 4635 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp56_) {
#line 35896 "Photo.c"
				{
					GeeIterator* _path_it = NULL;
					HierarchicalTagIndex* _tmp57_ = NULL;
					GeeCollection* _tmp58_ = NULL;
					GeeCollection* _tmp59_ = NULL;
					GeeIterator* _tmp60_ = NULL;
					GeeIterator* _tmp61_ = NULL;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp57_ = htag_index;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp58_ = hierarchical_tag_index_get_all_paths (_tmp57_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp59_ = _tmp58_;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp60_ = gee_iterable_iterator ((GeeIterable*) _tmp59_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp61_ = _tmp60_;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp59_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_path_it = _tmp61_;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 35920 "Photo.c"
						GeeIterator* _tmp62_ = NULL;
						gboolean _tmp63_ = FALSE;
						gchar* path = NULL;
						GeeIterator* _tmp64_ = NULL;
						gpointer _tmp65_ = NULL;
						gchar* name = NULL;
						const gchar* _tmp66_ = NULL;
						gchar* _tmp67_ = NULL;
						const gchar* _tmp68_ = NULL;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp62_ = _path_it;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp63_ = gee_iterator_next (_tmp62_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!_tmp63_) {
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 35938 "Photo.c"
						}
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp64_ = _path_it;
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp65_ = gee_iterator_get (_tmp64_);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						path = (gchar*) _tmp65_;
#line 4637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp66_ = path;
#line 4637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp67_ = tag_prep_tag_name (_tmp66_);
#line 4637 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						name = _tmp67_;
#line 4638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp68_ = name;
#line 4638 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (_tmp68_ != NULL) {
#line 35956 "Photo.c"
							GeeHashMultiMap* _tmp69_ = NULL;
							const gchar* _tmp70_ = NULL;
							Tag* _tmp71_ = NULL;
							Tag* _tmp72_ = NULL;
							LibraryPhoto* _tmp73_ = NULL;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp69_ = map;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp70_ = name;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp71_ = tag_for_path (_tmp70_);
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp72_ = _tmp71_;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp73_ = photo;
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_multi_map_set ((GeeMultiMap*) _tmp69_, _tmp72_, _tmp73_);
#line 4639 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (_tmp72_);
#line 35976 "Photo.c"
						}
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_free0 (name);
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_free0 (path);
#line 35982 "Photo.c"
					}
#line 4636 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_path_it);
#line 35986 "Photo.c"
				}
			}
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_hierarchical_tag_index_unref0 (htag_index);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_hierarchical_tag_index_unref0 (global_index);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (media);
#line 35999 "Photo.c"
		}
#line 4599 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36003 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp74_ = NULL;
		GeeIterator* _tmp75_ = NULL;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp74_ = media_sources;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp75_ = gee_iterable_iterator ((GeeIterable*) _tmp74_);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_it = _tmp75_;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 36017 "Photo.c"
			GeeIterator* _tmp76_ = NULL;
			gboolean _tmp77_ = FALSE;
			MediaSource* media = NULL;
			GeeIterator* _tmp78_ = NULL;
			gpointer _tmp79_ = NULL;
			LibraryPhoto* photo = NULL;
			MediaSource* _tmp80_ = NULL;
			LibraryPhoto* _tmp81_ = NULL;
			LibraryPhoto* _tmp82_ = NULL;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp76_ = _media_it;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp77_ = gee_iterator_next (_tmp76_);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp77_) {
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 36035 "Photo.c"
			}
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp78_ = _media_it;
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp79_ = gee_iterator_get (_tmp78_);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media = (MediaSource*) _tmp79_;
#line 4645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp80_ = media;
#line 4645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp81_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp80_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4645 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = _tmp81_;
#line 4646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp82_ = photo;
#line 4646 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			library_photo_clear_import_keywords (_tmp82_);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (media);
#line 36057 "Photo.c"
		}
#line 4644 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36061 "Photo.c"
	}
	{
		GeeIterator* _tag_it = NULL;
		GeeHashMultiMap* _tmp83_ = NULL;
		GeeSet* _tmp84_ = NULL;
		GeeSet* _tmp85_ = NULL;
		GeeIterator* _tmp86_ = NULL;
		GeeIterator* _tmp87_ = NULL;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp83_ = map;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp84_ = gee_multi_map_get_keys ((GeeMultiMap*) _tmp83_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp85_ = _tmp84_;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp86_ = gee_iterable_iterator ((GeeIterable*) _tmp85_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp87_ = _tmp86_;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp85_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tag_it = _tmp87_;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 36086 "Photo.c"
			GeeIterator* _tmp88_ = NULL;
			gboolean _tmp89_ = FALSE;
			Tag* tag = NULL;
			GeeIterator* _tmp90_ = NULL;
			gpointer _tmp91_ = NULL;
			Tag* _tmp92_ = NULL;
			GeeHashMultiMap* _tmp93_ = NULL;
			Tag* _tmp94_ = NULL;
			GeeCollection* _tmp95_ = NULL;
			GeeCollection* _tmp96_ = NULL;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp88_ = _tag_it;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp89_ = gee_iterator_next (_tmp88_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp89_) {
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 36105 "Photo.c"
			}
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp90_ = _tag_it;
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp91_ = gee_iterator_get (_tmp90_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			tag = (Tag*) _tmp91_;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp92_ = tag;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp93_ = map;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp94_ = tag;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp95_ = gee_multi_map_get ((GeeMultiMap*) _tmp93_, _tmp94_);
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp96_ = _tmp95_;
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			tag_attach_many (_tmp92_, _tmp96_);
#line 4650 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp96_);
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (tag);
#line 36129 "Photo.c"
		}
#line 4649 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 36133 "Photo.c"
	}
#line 4652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp97_ = media_sources;
#line 4652 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp97_);
#line 4597 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (map);
#line 36141 "Photo.c"
}


static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
#line 4656 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo;
#line 4657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = metadata;
#line 4657 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_, _tmp1_);
#line 36156 "Photo.c"
}


void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4656 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4656 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 36165 "Photo.c"
}


static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
#line 4661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo;
#line 4662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = metadata;
#line 4662 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_, _tmp1_);
#line 36180 "Photo.c"
}


void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4661 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 36189 "Photo.c"
}


static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
#line 4666 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo;
#line 4667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = metadata;
#line 4667 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_, _tmp1_);
#line 36204 "Photo.c"
}


void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4666 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4666 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 36213 "Photo.c"
}


static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_ = NULL;
	PhotoMetadata* _tmp1_ = NULL;
#line 4671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo;
#line 4672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = metadata;
#line 4672 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_, _tmp1_);
#line 36228 "Photo.c"
}


void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4671 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 36237 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gint64 _tmp0_ = 0LL;
	PhotoID _tmp1_ = {0};
	LibraryPhoto* _tmp2_ = NULL;
#line 4675 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = numeric_id;
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp1_, _tmp0_);
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch (self, &_tmp1_);
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (MediaSource*) _tmp2_;
#line 4676 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36259 "Photo.c"
}


static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 4679 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = added;
#line 4681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = removed;
#line 4681 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "trashcan-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 36274 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 4685 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4685 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4685 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4686 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = source;
#line 4686 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = media_source_is_trashed ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4686 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 4686 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36296 "Photo.c"
}


static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 4689 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = added;
#line 4691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = removed;
#line 4691 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_emit_by_name ((MediaSourceCollection*) self, "offline-contents-altered", G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 36311 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
#line 4695 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4695 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 4695 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (alteration != NULL, FALSE);
#line 4696 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = source;
#line 4696 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = media_source_is_offline ((MediaSource*) G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 4696 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 4696 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36333 "Photo.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1304 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1304 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 36356 "Photo.c"
		glong _tmp4_ = 0L;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 36364 "Photo.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 36376 "Photo.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1314 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 36400 "Photo.c"
		glong _tmp2_ = 0L;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 36406 "Photo.c"
	} else {
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 36410 "Photo.c"
	}
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 36414 "Photo.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 36426 "Photo.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 36436 "Photo.c"
	}
#line 1323 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1323 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 36442 "Photo.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 36456 "Photo.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 36466 "Photo.c"
	}
#line 1329 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1329 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 36472 "Photo.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 36481 "Photo.c"
	}
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 36501 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* numeric_only = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gchar* _tmp5_ = NULL;
	gint64 _tmp6_ = 0LL;
	MediaSource* _tmp7_ = NULL;
#line 4699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4699 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 4700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = source_id;
#line 4700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = g_str_has_prefix (_tmp0_, PHOTO_TYPENAME);
#line 4700 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp1_, "source_id.has_prefix (Photo.TYPENAME)");
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = source_id;
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = strlen (PHOTO_TYPENAME);
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = string_substring (_tmp2_, (glong) _tmp4_, (glong) -1);
#line 4701 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	numeric_only = _tmp5_;
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = parse_int64 (numeric_only, 16);
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = media_source_collection_fetch_by_numeric_id ((MediaSourceCollection*) self, _tmp6_);
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp7_;
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (numeric_only);
#line 4703 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36547 "Photo.c"
}


static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id) {
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_ = NULL;
	EventID _tmp2_ = {0};
	GeeArrayList* _tmp3_ = NULL;
	GeeCollection* _tmp4_ = NULL;
#line 4706 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4706 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = *event_id;
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = (GeeCollection*) _tmp3_;
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 4707 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36579 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id) {
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_ = 0LL;
	DataSource* _tmp2_ = NULL;
#line 4710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4710 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = *photo_id;
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = database_source_collection_fetch_by_key ((DatabaseSourceCollection*) self, _tmp1_);
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4711 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36602 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
#line 4714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4714 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file;
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 4715 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36625 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_raw_development_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
#line 4718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4718 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->by_raw_development_file;
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file;
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 4719 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 36648 "Photo.c"
}


static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matches_development) {
	LibraryPhoto* _tmp0_ = NULL;
	BackingPhotoRow* _tmp1_ = NULL;
	BackingPhotoRow* _tmp2_ = NULL;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	BackingPhotoRow* editable = NULL;
	LibraryPhoto* _tmp8_ = NULL;
	BackingPhotoRow* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	BackingPhotoRow* _tmp11_ = NULL;
	GeeCollection* development = NULL;
	LibraryPhoto* _tmp17_ = NULL;
	GeeCollection* _tmp18_ = NULL;
	GeeCollection* _tmp19_ = NULL;
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_development != NULL);
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo;
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_get_master_photo_row ((Photo*) _tmp0_);
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = info;
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = backing_photo_row_matches_file_info (_tmp2_, _tmp3_);
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp2_);
#line 4725 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_) {
#line 36696 "Photo.c"
		GeeCollection* _tmp6_ = NULL;
		LibraryPhoto* _tmp7_ = NULL;
#line 4726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = matches_master;
#line 4726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = photo;
#line 4726 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_collection_add (_tmp6_, _tmp7_);
#line 36705 "Photo.c"
	}
#line 4728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo;
#line 4728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = photo_get_editable_photo_row ((Photo*) _tmp8_);
#line 4728 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	editable = _tmp9_;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = editable;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 36717 "Photo.c"
		BackingPhotoRow* _tmp12_ = NULL;
		GFileInfo* _tmp13_ = NULL;
		gboolean _tmp14_ = FALSE;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = editable;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = info;
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = backing_photo_row_matches_file_info (_tmp12_, _tmp13_);
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = _tmp14_;
#line 36729 "Photo.c"
	} else {
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = FALSE;
#line 36733 "Photo.c"
	}
#line 4729 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp10_) {
#line 36737 "Photo.c"
		GeeCollection* _tmp15_ = NULL;
		LibraryPhoto* _tmp16_ = NULL;
#line 4730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = matches_editable;
#line 4730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = photo;
#line 4730 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_collection_add (_tmp15_, _tmp16_);
#line 36746 "Photo.c"
	}
#line 4732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = photo;
#line 4732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp18_ = photo_get_raw_development_photo_rows ((Photo*) _tmp17_);
#line 4732 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	development = _tmp18_;
#line 4733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = development;
#line 4733 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 36758 "Photo.c"
		{
			GeeIterator* _row_it = NULL;
			GeeCollection* _tmp20_ = NULL;
			GeeIterator* _tmp21_ = NULL;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = development;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = gee_iterable_iterator ((GeeIterable*) _tmp20_);
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_row_it = _tmp21_;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 36771 "Photo.c"
				GeeIterator* _tmp22_ = NULL;
				gboolean _tmp23_ = FALSE;
				BackingPhotoRow* row = NULL;
				GeeIterator* _tmp24_ = NULL;
				gpointer _tmp25_ = NULL;
				BackingPhotoRow* _tmp26_ = NULL;
				GFileInfo* _tmp27_ = NULL;
				gboolean _tmp28_ = FALSE;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = _row_it;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = gee_iterator_next (_tmp22_);
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp23_) {
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 36788 "Photo.c"
				}
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = _row_it;
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = gee_iterator_get (_tmp24_);
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				row = (BackingPhotoRow*) _tmp25_;
#line 4735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = row;
#line 4735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = info;
#line 4735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = backing_photo_row_matches_file_info (_tmp26_, _tmp27_);
#line 4735 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp28_) {
#line 36804 "Photo.c"
					GeeCollection* _tmp29_ = NULL;
					LibraryPhoto* _tmp30_ = NULL;
#line 4736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp29_ = matches_development;
#line 4736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp30_ = photo;
#line 4736 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_collection_add (_tmp29_, _tmp30_);
#line 4738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_backing_photo_row_unref0 (row);
#line 4738 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 36817 "Photo.c"
				}
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (row);
#line 36821 "Photo.c"
			}
#line 4734 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_row_it);
#line 36825 "Photo.c"
		}
	}
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (development);
#line 4722 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (editable);
#line 36832 "Photo.c"
}


void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable, GeeCollection* matched_development) {
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (info != NULL);
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_master != NULL);
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matches_editable != NULL);
#line 4746 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (matched_development != NULL);
#line 36847 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_ = NULL;
		GFileInfo* _tmp1_ = NULL;
		gint64 _tmp2_ = 0LL;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_ = NULL;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = info;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = g_file_info_get_size (_tmp1_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_multi_map_get (_tmp0_, &_tmp2_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_it = _tmp6_;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 36877 "Photo.c"
			GeeIterator* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp9_ = NULL;
			gpointer _tmp10_ = NULL;
			LibraryPhoto* _tmp11_ = NULL;
			GFileInfo* _tmp12_ = NULL;
			GeeCollection* _tmp13_ = NULL;
			GeeCollection* _tmp14_ = NULL;
			GeeCollection* _tmp15_ = NULL;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = _photo_it;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp8_) {
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 36896 "Photo.c"
			}
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _photo_it;
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp10_;
#line 4749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = photo;
#line 4749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = info;
#line 4749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = matches_master;
#line 4749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = matches_editable;
#line 4749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = matched_development;
#line 4749 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp11_, _tmp12_, _tmp13_, _tmp14_, _tmp15_);
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 36918 "Photo.c"
		}
#line 4748 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 36922 "Photo.c"
	}
	{
		GeeIterator* _media_it = NULL;
		GeeCollection* _tmp16_ = NULL;
		GeeCollection* _tmp17_ = NULL;
		GeeIterator* _tmp18_ = NULL;
		GeeIterator* _tmp19_ = NULL;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = media_source_collection_get_offline_bin_contents ((MediaSourceCollection*) self);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp17_);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_it = _tmp19_;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 36944 "Photo.c"
			GeeIterator* _tmp20_ = NULL;
			gboolean _tmp21_ = FALSE;
			MediaSource* media = NULL;
			GeeIterator* _tmp22_ = NULL;
			gpointer _tmp23_ = NULL;
			MediaSource* _tmp24_ = NULL;
			GFileInfo* _tmp25_ = NULL;
			GeeCollection* _tmp26_ = NULL;
			GeeCollection* _tmp27_ = NULL;
			GeeCollection* _tmp28_ = NULL;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp20_ = _media_it;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp21_ = gee_iterator_next (_tmp20_);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp21_) {
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 36963 "Photo.c"
			}
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp22_ = _media_it;
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = gee_iterator_get (_tmp22_);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			media = (MediaSource*) _tmp23_;
#line 4752 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = media;
#line 4752 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp25_ = info;
#line 4752 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = matches_master;
#line 4752 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = matches_editable;
#line 4752 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = matched_development;
#line 4752 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, TYPE_LIBRARY_PHOTO, LibraryPhoto), _tmp25_, _tmp26_, _tmp27_, _tmp28_);
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (media);
#line 36985 "Photo.c"
		}
#line 4751 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 36989 "Photo.c"
	}
}


void library_photo_source_collection_get_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize, PhotoID* result) {
	PhotoID _tmp19_ = {0};
#line 4755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 4755 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (basename != NULL);
#line 37000 "Photo.c"
	{
		GeeIterator* _photo_it = NULL;
		GeeMultiMap* _tmp0_ = NULL;
		gint64 _tmp1_ = 0LL;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_ = NULL;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = filesize;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_photo_it = _tmp5_;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		while (TRUE) {
#line 37027 "Photo.c"
			GeeIterator* _tmp6_ = NULL;
			gboolean _tmp7_ = FALSE;
			LibraryPhoto* photo = NULL;
			GeeIterator* _tmp8_ = NULL;
			gpointer _tmp9_ = NULL;
			LibraryPhoto* _tmp10_ = NULL;
			GFile* _tmp11_ = NULL;
			GFile* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gint _tmp15_ = 0;
			gboolean _tmp16_ = FALSE;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (!_tmp7_) {
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				break;
#line 37048 "Photo.c"
			}
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp9_;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = photo;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = media_source_get_master_file ((MediaSource*) _tmp10_);
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp13_ = g_file_get_basename (_tmp12_);
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp14_ = basename;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = utf8_ci_compare (_tmp13_, _tmp14_);
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = _tmp15_ == 0;
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp12_);
#line 4757 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_tmp16_) {
#line 37074 "Photo.c"
				LibraryPhoto* _tmp17_ = NULL;
				PhotoID _tmp18_ = {0};
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = photo;
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo_get_photo_id ((Photo*) _tmp17_, &_tmp18_);
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				*result = _tmp18_;
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 4758 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 37089 "Photo.c"
			}
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (photo);
#line 37093 "Photo.c"
		}
#line 4756 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 37097 "Photo.c"
	}
#line 4761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp19_, PHOTO_ID_INVALID);
#line 4761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp19_;
#line 4761 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 37105 "Photo.c"
}


gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	PhotoID _tmp2_ = {0};
	gboolean _tmp3_ = FALSE;
#line 4765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 4765 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = basename;
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = filesize;
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_get_basename_filesize_duplicate (self, _tmp0_, _tmp1_, &_tmp2_);
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_id_is_valid (&_tmp2_);
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 4766 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37131 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_ = NULL;
#line 4769 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4769 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = file;
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4770 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp4_;
#line 4771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo;
#line 4771 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 37166 "Photo.c"
		MediaSourceHoldingTank* _tmp6_ = NULL;
		LibraryPhotoSourceHoldingTank* _tmp7_ = NULL;
		GFile* _tmp8_ = NULL;
		LibraryPhoto* _tmp9_ = NULL;
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = file;
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp7_, _tmp8_);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4772 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp7_);
#line 37185 "Photo.c"
	}
#line 4775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo;
#line 4775 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37191 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
#line 4778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4778 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = md5;
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 4779 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37222 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_ = NULL;
#line 4782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4782 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = file;
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4783 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp4_;
#line 4784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo;
#line 4784 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_ == NULL) {
#line 37257 "Photo.c"
		MediaSourceHoldingTank* _tmp6_ = NULL;
		LibraryPhotoSourceHoldingTank* _tmp7_ = NULL;
		GFile* _tmp8_ = NULL;
		LibraryPhoto* _tmp9_ = NULL;
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = file;
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = library_photo_source_holding_tank_fetch_by_backing_file (_tmp7_, _tmp8_);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (photo);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4785 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_source_holding_tank_unref0 (_tmp7_);
#line 37276 "Photo.c"
	}
#line 4788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = photo;
#line 4788 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37282 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
#line 4791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4791 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = md5;
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp4_;
#line 4792 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37313 "Photo.c"
}


gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self) {
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 4795 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count ((SourceHoldingTank*) _tmp1_);
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 4796 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37339 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state) {
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	LibraryPhoto* photo = NULL;
	GFile* _tmp0_ = NULL;
	MediaSource* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_ = NULL;
	GFile* _tmp6_ = NULL;
	LibraryPhoto* _tmp7_ = NULL;
	LibraryPhoto* _tmp8_ = NULL;
	GFile* _tmp9_ = NULL;
	LibraryPhoto* _tmp10_ = NULL;
	LibraryPhoto* _tmp11_ = NULL;
	LibraryPhoto* _tmp12_ = NULL;
	GFile* _tmp13_ = NULL;
	LibraryPhoto* _tmp14_ = NULL;
	LibraryPhoto* _tmp15_ = NULL;
	LibraryPhoto* _tmp16_ = NULL;
#line 4799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4799 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 4800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 4800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = media_source_collection_fetch_by_master_file ((MediaSourceCollection*) self, _tmp0_);
#line 4800 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo;
#line 4801 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 4802 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 4804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37386 "Photo.c"
		}
#line 4804 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37390 "Photo.c"
	}
#line 4807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = file;
#line 4807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_editable_file (self, _tmp3_);
#line 4807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4807 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp4_;
#line 4808 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo;
#line 4808 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 4809 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 4811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37412 "Photo.c"
		}
#line 4811 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37416 "Photo.c"
	}
#line 4814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = file;
#line 4814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = library_photo_source_collection_fetch_by_raw_development_file (self, _tmp6_);
#line 4814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4814 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp7_;
#line 4815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo;
#line 4815 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 4816 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER;
#line 4818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37438 "Photo.c"
		}
#line 4818 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37442 "Photo.c"
	}
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = file;
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = library_photo_source_collection_get_trashed_by_file (self, _tmp9_);
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp10_) : NULL;
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_ == NULL) {
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp10_);
#line 37454 "Photo.c"
	}
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4821 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp11_;
#line 4822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = photo;
#line 4822 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_ != NULL) {
#line 4823 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 4825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37472 "Photo.c"
		}
#line 4825 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37476 "Photo.c"
	}
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = file;
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = library_photo_source_collection_get_offline_by_file (self, _tmp13_);
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp14_) : NULL;
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp15_ == NULL) {
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp14_);
#line 37488 "Photo.c"
	}
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4828 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp15_;
#line 4829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = photo;
#line 4829 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp16_ != NULL) {
#line 4830 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 4832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = photo;
#line 4832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (state) {
#line 4832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*state = _vala_state;
#line 37506 "Photo.c"
		}
#line 4832 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37510 "Photo.c"
	}
#line 4835 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN;
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = NULL;
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (state) {
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*state = _vala_state;
#line 37522 "Photo.c"
	}
#line 4837 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37526 "Photo.c"
}


static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	SourceBacklink* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_ = NULL;
	SourceBacklink* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	MediaSourceHoldingTank* _tmp7_ = NULL;
	MediaSourceHoldingTank* _tmp8_ = NULL;
	SourceBacklink* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
#line 4840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4840 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (backlink != NULL, FALSE);
#line 4841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = backlink;
#line 4841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp0_);
#line 4841 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 4842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 4842 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37559 "Photo.c"
	}
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = backlink;
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp3_, _tmp4_);
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 4844 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_) {
#line 4845 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 4845 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37579 "Photo.c"
	}
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = backlink;
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = source_holding_tank_has_backlink ((SourceHoldingTank*) _tmp8_, _tmp9_);
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp8_);
#line 4847 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp11_) {
#line 4848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 4848 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 37599 "Photo.c"
	}
#line 4850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = FALSE;
#line 4850 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37605 "Photo.c"
}


static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_ = NULL;
	SourceBacklink* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_ = NULL;
	MediaSourceHoldingTank* _tmp4_ = NULL;
	SourceBacklink* _tmp5_ = NULL;
	SourceBacklink* _tmp6_ = NULL;
#line 4853 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4853 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (backlink != NULL);
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan ((MediaSourceCollection*) self);
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = backlink;
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp1_, _tmp2_);
#line 4854 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin ((MediaSourceCollection*) self);
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = backlink;
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	source_holding_tank_remove_backlink ((SourceHoldingTank*) _tmp4_, _tmp5_);
#line 4855 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 4857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = backlink;
#line 4857 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink ((SourceCollection*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), _tmp6_);
#line 37646 "Photo.c"
}


static TransactionController* library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base) {
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_ = NULL;
	TransactionController* _tmp2_ = NULL;
#line 4374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) base;
#line 4375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 4375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 37661 "Photo.c"
		MediaSourceTransactionController* _tmp1_ = NULL;
#line 4376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new ((MediaSourceCollection*) self);
#line 4376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		self->priv->_transaction_controller = (TransactionController*) _tmp1_;
#line 37669 "Photo.c"
	}
#line 4378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 4378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp2_;
#line 4378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 37677 "Photo.c"
}


static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4396 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37684 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = closure->data;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 37703 "Photo.c"
	} else {
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data2 = closure->data;
#line 37709 "Photo.c"
	}
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 37715 "Photo.c"
}


static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4399 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37722 "Photo.c"
}


static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4402 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37729 "Photo.c"
}


static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 4405 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 37736 "Photo.c"
}


static void library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass) {
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataCollectionClass *) klass)->finalize = library_photo_source_collection_finalize;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceCollectionPrivate));
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_trashcan = (MediaSourceHoldingTank* (*)(MediaSourceCollection*)) library_photo_source_collection_real_create_trashcan;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_offline_bin = (MediaSourceHoldingTank* (*)(MediaSourceCollection*)) library_photo_source_collection_real_create_offline_bin;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->create_media_monitor = (MediaMonitor* (*)(MediaSourceCollection*, Workers*, GCancellable*)) library_photo_source_collection_real_create_media_monitor;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceCollectionClass *) klass)->holds_type_of_source = (gboolean (*)(SourceCollection*, DataSource*)) library_photo_source_collection_real_holds_type_of_source;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_typename = (gchar* (*)(MediaSourceCollection*)) library_photo_source_collection_real_get_typename;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->is_file_recognized = (gboolean (*)(MediaSourceCollection*, GFile*)) library_photo_source_collection_real_is_file_recognized;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataCollectionClass *) klass)->notify_contents_altered = (void (*)(DataCollection*, GeeIterable*, GeeIterable*)) library_photo_source_collection_real_notify_contents_altered;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*)(DataCollection*, GeeMap*)) library_photo_source_collection_real_items_altered;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->postprocess_imported_media = (void (*)(MediaSourceCollection*, GeeCollection*)) library_photo_source_collection_real_postprocess_imported_media;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_master_reimported = (void (*)(LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_master_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_editable_reimported = (void (*)(LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_editable_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_source_reimported = (void (*)(LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_source_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->notify_baseline_reimported = (void (*)(LibraryPhotoSourceCollection*, LibraryPhoto*, PhotoMetadata*)) library_photo_source_collection_real_notify_baseline_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_numeric_id = (MediaSource* (*)(MediaSourceCollection*, gint64)) library_photo_source_collection_real_fetch_by_numeric_id;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->fetch_by_source_id = (MediaSource* (*)(MediaSourceCollection*, const gchar*)) library_photo_source_collection_real_fetch_by_source_id;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceCollectionClass *) klass)->get_event_source_ids = (GeeCollection* (*)(MediaSourceCollection*, EventID*)) library_photo_source_collection_real_get_event_source_ids;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceCollectionClass *) klass)->has_backlink = (gboolean (*)(SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_has_backlink;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceCollectionClass *) klass)->remove_backlink = (void (*)(SourceCollection*, SourceBacklink*)) library_photo_source_collection_real_remove_backlink;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((LibraryPhotoSourceCollectionClass *) klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 37801 "Photo.c"
}


static void library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self) {
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
	GeeTreeMultiMap* _tmp2_ = NULL;
	GeeHashMap* _tmp3_ = NULL;
	GeeHashMap* _tmp4_ = NULL;
	GeeTreeMultiMap* _tmp5_ = NULL;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE (self);
#line 4382 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->by_editable_file = _tmp0_;
#line 4385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->by_raw_development_file = _tmp1_;
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _int64_compare_gcompare_data_func, NULL, NULL, NULL, NULL, NULL);
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->filesize_to_photo = (GeeMultiMap*) _tmp2_;
#line 4389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp3_;
#line 4391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, _int64_equal_gee_equal_data_func, NULL, NULL);
#line 4391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp4_;
#line 4393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = gee_tree_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 4393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->photo_to_raw_development_filesize = (GeeMultiMap*) _tmp5_;
#line 37840 "Photo.c"
}


static void library_photo_source_collection_finalize (DataCollection* obj) {
	LibraryPhotoSourceCollection * self;
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection);
#line 4382 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 4383 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 4385 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->by_raw_development_file);
#line 4387 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 4389 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 4391 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 4393 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_raw_development_filesize);
#line 4363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 37864 "Photo.c"
}


GType library_photo_source_collection_get_type (void) {
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self) {
#line 4885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_generate_thumbnails ((LibraryPhoto*) self);
#line 37883 "Photo.c"
}


static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row) {
	LibraryPhoto * self = NULL;
	PhotoRow* _tmp0_ = NULL;
	OneShotScheduler* _tmp1_ = NULL;
	PhotoRow* _tmp2_ = NULL;
	guint64 _tmp3_ = 0ULL;
#line 4880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 4881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = row;
#line 4881 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp0_);
#line 4883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4883 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 4885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4885 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp1_;
#line 4888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = row;
#line 4888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_->flags;
#line 4888 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((_tmp3_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 37915 "Photo.c"
		LibraryPhotoSourceCollection* _tmp4_ = NULL;
		PhotoRow* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 4889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = library_photo_global;
#line 4889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = row;
#line 4889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp5_->backlinks;
#line 4889 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp4_, _tmp6_);
#line 37927 "Photo.c"
	}
#line 4880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 37931 "Photo.c"
}


static LibraryPhoto* library_photo_new (PhotoRow* row) {
#line 4880 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row);
#line 37938 "Photo.c"
}


static LibraryPhoto* library_photo_construct_from_import_params (GType object_type, PhotoImportParams* import_params) {
	LibraryPhoto * self = NULL;
	PhotoImportParams* _tmp0_ = NULL;
	PhotoRow* _tmp1_ = NULL;
	PhotoImportParams* _tmp2_ = NULL;
	GeeCollection* _tmp3_ = NULL;
	GeeCollection* _tmp4_ = NULL;
	OneShotScheduler* _tmp5_ = NULL;
	PhotoImportParams* _tmp6_ = NULL;
	PhotoRow* _tmp7_ = NULL;
	guint64 _tmp8_ = 0ULL;
#line 4892 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (import_params != NULL, NULL);
#line 4893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = import_params;
#line 4893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_->row;
#line 4893 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, _tmp1_);
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = import_params;
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_->keywords;
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4895 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->import_keywords = _tmp4_;
#line 4896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 4896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4896 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp5_;
#line 4899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = import_params;
#line 4899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_->row;
#line 4899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = _tmp7_->flags;
#line 4899 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if ((_tmp8_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 37985 "Photo.c"
		LibraryPhotoSourceCollection* _tmp9_ = NULL;
		PhotoImportParams* _tmp10_ = NULL;
		PhotoRow* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = library_photo_global;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = import_params;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp10_->row;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = _tmp11_->backlinks;
#line 4900 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		data_source_rehydrate_backlinks ((DataSource*) self, (SourceCollection*) _tmp9_, _tmp12_);
#line 38000 "Photo.c"
	}
#line 4892 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 38004 "Photo.c"
}


static LibraryPhoto* library_photo_new_from_import_params (PhotoImportParams* import_params) {
#line 4892 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return library_photo_construct_from_import_params (TYPE_LIBRARY_PHOTO, import_params);
#line 38011 "Photo.c"
}


void library_photo_init (ProgressMonitor monitor, void* monitor_target) {
	LibraryPhotoSourceCollection* _tmp0_ = NULL;
	GeeArrayList* all = NULL;
	PhotoTable* _tmp1_ = NULL;
	PhotoTable* _tmp2_ = NULL;
	GeeArrayList* _tmp3_ = NULL;
	GeeArrayList* _tmp4_ = NULL;
	GeeArrayList* all_photos = NULL;
	GeeArrayList* _tmp5_ = NULL;
	GeeArrayList* trashed_photos = NULL;
	GeeArrayList* _tmp6_ = NULL;
	GeeArrayList* offline_photos = NULL;
	GeeArrayList* _tmp7_ = NULL;
	gint count = 0;
	GeeArrayList* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	LibraryPhotoSourceCollection* _tmp34_ = NULL;
	GeeArrayList* _tmp35_ = NULL;
	GeeCollection* _tmp36_ = NULL;
	GeeCollection* _tmp37_ = NULL;
	LibraryPhotoSourceCollection* _tmp38_ = NULL;
	GeeArrayList* _tmp39_ = NULL;
	LibraryPhotoSourceCollection* _tmp40_ = NULL;
	GeeArrayList* _tmp41_ = NULL;
#line 4904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 4904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 4904 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_global = _tmp0_;
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_table_get_instance ();
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = photo_table_get_all (_tmp2_);
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp2_);
#line 4908 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	all = _tmp4_;
#line 4909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 4909 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	all_photos = _tmp5_;
#line 4910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 4910 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	trashed_photos = _tmp6_;
#line 4911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 4911 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	offline_photos = _tmp7_;
#line 4912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = all;
#line 4912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 4912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 4912 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	count = _tmp10_;
#line 38078 "Photo.c"
	{
		gint ctr = 0;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		ctr = 0;
#line 38083 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = TRUE;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 38090 "Photo.c"
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				PhotoRow* row = NULL;
				GeeArrayList* _tmp15_ = NULL;
				gint _tmp16_ = 0;
				gpointer _tmp17_ = NULL;
				LibraryPhoto* photo = NULL;
				PhotoRow* _tmp18_ = NULL;
				LibraryPhoto* _tmp19_ = NULL;
				guint64 flags = 0ULL;
				PhotoRow* _tmp20_ = NULL;
				guint64 _tmp21_ = 0ULL;
				guint64 _tmp22_ = 0ULL;
				ProgressMonitor _tmp30_ = NULL;
				void* _tmp30__target = NULL;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp11_) {
#line 38108 "Photo.c"
					gint _tmp12_ = 0;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp12_ = ctr;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					ctr = _tmp12_ + 1;
#line 38114 "Photo.c"
				}
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = FALSE;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = ctr;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = count;
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 38126 "Photo.c"
				}
#line 4914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = all;
#line 4914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = ctr;
#line 4914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _tmp16_);
#line 4914 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				row = (PhotoRow*) _tmp17_;
#line 4915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = row;
#line 4915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp19_ = library_photo_new (_tmp18_);
#line 4915 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp19_;
#line 4916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = row;
#line 4916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = _tmp20_->flags;
#line 4916 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				flags = _tmp21_;
#line 4918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = flags;
#line 4918 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if ((_tmp22_ & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 38152 "Photo.c"
					GeeArrayList* _tmp23_ = NULL;
					LibraryPhoto* _tmp24_ = NULL;
#line 4919 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp23_ = trashed_photos;
#line 4919 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp24_ = photo;
#line 4919 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 38161 "Photo.c"
				} else {
					guint64 _tmp25_ = 0ULL;
#line 4920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp25_ = flags;
#line 4920 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					if ((_tmp25_ & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 38168 "Photo.c"
						GeeArrayList* _tmp26_ = NULL;
						LibraryPhoto* _tmp27_ = NULL;
#line 4921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp26_ = offline_photos;
#line 4921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp27_ = photo;
#line 4921 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 38177 "Photo.c"
					} else {
						GeeArrayList* _tmp28_ = NULL;
						LibraryPhoto* _tmp29_ = NULL;
#line 4923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp28_ = all_photos;
#line 4923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp29_ = photo;
#line 4923 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
#line 38187 "Photo.c"
					}
				}
#line 4925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = monitor;
#line 4925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30__target = monitor_target;
#line 4925 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp30_ != NULL) {
#line 38196 "Photo.c"
					ProgressMonitor _tmp31_ = NULL;
					void* _tmp31__target = NULL;
					gint _tmp32_ = 0;
					gint _tmp33_ = 0;
#line 4926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31_ = monitor;
#line 4926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31__target = monitor_target;
#line 4926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp32_ = ctr;
#line 4926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp33_ = count;
#line 4926 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp31_ ((guint64) _tmp32_, (guint64) _tmp33_, TRUE, _tmp31__target);
#line 38211 "Photo.c"
				}
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 4913 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_photo_row_unref0 (row);
#line 38217 "Photo.c"
			}
		}
	}
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = library_photo_global;
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = all_photos;
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = data_collection_add_many ((DataCollection*) _tmp34_, (GeeCollection*) _tmp35_, NULL, NULL);
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = _tmp36_;
#line 4929 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp37_);
#line 4930 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = library_photo_global;
#line 4930 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = trashed_photos;
#line 4930 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_collection_add_many_to_trash ((MediaSourceCollection*) _tmp38_, (GeeCollection*) _tmp39_);
#line 4931 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 4931 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = offline_photos;
#line 4931 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	media_source_collection_add_many_to_offline ((MediaSourceCollection*) _tmp40_, (GeeCollection*) _tmp41_);
#line 4903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 4903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 4903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 4903 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (all);
#line 38251 "Photo.c"
}


void library_photo_terminate (void) {
}


ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo) {
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoID photo_id = {0};
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_ = NULL;
	PhotoImportParams* _tmp2_ = NULL;
	PhotoRow* _tmp3_ = NULL;
	PhotoID _tmp4_ = {0};
	PhotoID _tmp5_ = {0};
	gboolean _tmp6_ = FALSE;
	PhotoImportParams* _tmp7_ = NULL;
	LibraryPhoto* _tmp8_ = NULL;
#line 4941 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = params;
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_->row;
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_table_add (_tmp1_, _tmp3_, &_tmp4_);
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 4943 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id = _tmp5_;
#line 4944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = photo_id_is_invalid (&photo_id);
#line 4944 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_) {
#line 4945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 4945 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_vala_photo = NULL;
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (photo) {
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			*photo = _vala_photo;
#line 38304 "Photo.c"
		} else {
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 38308 "Photo.c"
		}
#line 4947 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 38312 "Photo.c"
	}
#line 4951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = params;
#line 4951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = library_photo_new_from_import_params (_tmp7_);
#line 4951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 4951 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_photo = _tmp8_;
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (photo) {
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*photo = _vala_photo;
#line 38328 "Photo.c"
	} else {
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 38332 "Photo.c"
	}
#line 4953 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 38336 "Photo.c"
}


void library_photo_import_failed (LibraryPhoto* photo) {
	GError * _inner_error_ = NULL;
#line 4956 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (photo != NULL);
#line 38344 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_ = NULL;
		LibraryPhoto* _tmp2_ = NULL;
		PhotoID _tmp3_ = {0};
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = photo;
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_get_photo_id ((Photo*) _tmp2_, &_tmp3_);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp3_, &_inner_error_);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 38366 "Photo.c"
				goto __catch265_database_error;
			}
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4958 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 38375 "Photo.c"
		}
	}
	goto __finally265;
	__catch265_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_ = NULL;
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = err;
#line 4960 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 38393 "Photo.c"
	}
	__finally265:
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4957 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 38404 "Photo.c"
	}
}


static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_ = NULL;
	LibraryPhotoSourceCollection* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
#line 4964 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 4965 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = metadata;
#line 4967 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp1_, self, _tmp2_);
#line 38426 "Photo.c"
}


static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_ = NULL;
	LibraryPhotoSourceCollection* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
#line 4970 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 4971 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = metadata;
#line 4973 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp1_, self, _tmp2_);
#line 38447 "Photo.c"
}


static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_ = NULL;
	LibraryPhotoSourceCollection* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
#line 4976 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 4977 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = metadata;
#line 4979 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp1_, self, _tmp2_);
#line 38468 "Photo.c"
}


static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_ = NULL;
	LibraryPhotoSourceCollection* _tmp1_ = NULL;
	PhotoMetadata* _tmp2_ = NULL;
#line 4982 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 4983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 4983 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 4985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 4985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = metadata;
#line 4985 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp1_, self, _tmp2_);
#line 38489 "Photo.c"
}


static void library_photo_generate_thumbnails (LibraryPhoto* self) {
	GError * _inner_error_ = NULL;
#line 4988 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 38497 "Photo.c"
	{
#line 4990 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		thumbnail_cache_import_from_source ((ThumbnailSource*) self, TRUE, &_inner_error_);
#line 4990 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 38503 "Photo.c"
			goto __catch266_g_error;
		}
	}
	goto __finally266;
	__catch266_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = data_object_to_string ((DataObject*) self);
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = err;
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:4992: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 4992 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 38533 "Photo.c"
	}
	__finally266:
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4989 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 38544 "Photo.c"
	}
#line 4996 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 38548 "Photo.c"
}


GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp1_ = NULL;
#line 5000 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 5001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 5001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 5001 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 38566 "Photo.c"
}


void library_photo_clear_import_keywords (LibraryPhoto* self) {
#line 5004 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5005 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 5005 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 38577 "Photo.c"
}


static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration) {
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	Alteration* _tmp5_ = NULL;
#line 5008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5008 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (alteration != NULL);
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = self->priv->block_thumbnail_generation;
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp1_) {
#line 38594 "Photo.c"
		Alteration* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = alteration;
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = alteration_has_subject (_tmp2_, "image");
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 38603 "Photo.c"
	} else {
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = FALSE;
#line 38607 "Photo.c"
	}
#line 5010 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 38611 "Photo.c"
		OneShotScheduler* _tmp4_ = NULL;
#line 5011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = self->priv->thumbnail_scheduler;
#line 5011 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp4_, G_PRIORITY_LOW);
#line 38617 "Photo.c"
	}
#line 5013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = alteration;
#line 5013 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered ((DataObject*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp5_);
#line 38623 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 5016 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5016 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail ((ThumbnailSource*) self, (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error_);
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	pixbuf = _tmp0_;
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5017 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 38648 "Photo.c"
	}
#line 5019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 5019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp1_;
#line 5019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 5019 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 38658 "Photo.c"
}


static void library_photo_real_rotate (Photo* base, Rotation rotation) {
	LibraryPhoto * self;
	Rotation _tmp0_ = 0;
	GError * _inner_error_ = NULL;
#line 5022 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5024 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 5025 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = rotation;
#line 5025 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), _tmp0_);
#line 5026 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 38676 "Photo.c"
	{
		Rotation _tmp1_ = 0;
#line 5034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = rotation;
#line 5034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		thumbnail_cache_rotate ((ThumbnailSource*) self, _tmp1_, &_inner_error_);
#line 5034 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 38685 "Photo.c"
			goto __catch267_g_error;
		}
	}
	goto __finally267;
	__catch267_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = data_object_to_string ((DataObject*) self);
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = err;
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_warning ("Photo.vala:5037: Unable to update thumbnails for %s: %s", _tmp3_, _tmp5_);
#line 5037 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 38715 "Photo.c"
	}
	__finally267:
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 5033 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 38726 "Photo.c"
	}
#line 5040 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered ((ThumbnailSource*) self);
#line 38730 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 5044 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = scale;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = thumbnail_cache_fetch ((ThumbnailSource*) self, _tmp1_, &_inner_error_);
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp2_;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 38756 "Photo.c"
	}
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp0_;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = NULL;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp0_);
#line 5045 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 38768 "Photo.c"
}


static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self) {
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_on_duplicate_progress ((LibraryPhoto*) self, current_num_bytes, total_num_bytes);
#line 38775 "Photo.c"
}


static void library_photo_duplicate_backing_photo (LibraryPhoto* self, BackingPhotoRow* backing, BackingPhotoID* result, GError** error) {
	BackingPhotoID backing_id = {0};
	gboolean _tmp0_ = FALSE;
	BackingPhotoRow* _tmp1_ = NULL;
	GFile* file = NULL;
	BackingPhotoRow* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GFile* _tmp6_ = NULL;
	GFile* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	GError * _inner_error_ = NULL;
#line 5050 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5051 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	backing_photo_id_init (&backing_id, BACKING_PHOTO_ID_INVALID);
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = backing;
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = TRUE;
#line 38800 "Photo.c"
	} else {
		BackingPhotoRow* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = backing;
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = _tmp2_->filepath;
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 38810 "Photo.c"
	}
#line 5052 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_) {
#line 5053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result = backing_id;
#line 5053 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 38818 "Photo.c"
	}
#line 5055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = backing;
#line 5055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_->filepath;
#line 5055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = g_file_new_for_path (_tmp5_);
#line 5055 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	file = _tmp6_;
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = file;
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = g_file_query_exists (_tmp7_, NULL);
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_) {
#line 38834 "Photo.c"
		GFile* dupe_file = NULL;
		GFile* _tmp9_ = NULL;
		GFile* _tmp10_ = NULL;
		DetectedPhotoInformation* detected = NULL;
		BackingPhotoRow* state = NULL;
		GFile* _tmp11_ = NULL;
		DetectedPhotoInformation* _tmp12_ = NULL;
		BackingPhotoRow* _tmp13_ = NULL;
		BackingPhotoRow* _tmp14_ = NULL;
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp9_ = file;
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = library_files_duplicate (_tmp9_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		dupe_file = _tmp10_;
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 5057 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 38858 "Photo.c"
		}
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = dupe_file;
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = photo_query_backing_photo_row ((Photo*) self, _tmp11_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp12_, &_inner_error_);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		detected = _tmp12_;
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		state = _tmp13_;
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (file);
#line 5060 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 38882 "Photo.c"
		}
#line 5062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = state;
#line 5062 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp14_ != NULL) {
#line 38888 "Photo.c"
			BackingPhotoTable* _tmp15_ = NULL;
			BackingPhotoTable* _tmp16_ = NULL;
			BackingPhotoRow* _tmp17_ = NULL;
			BackingPhotoRow* _tmp18_ = NULL;
			BackingPhotoID _tmp19_ = {0};
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp15_ = backing_photo_table_get_instance ();
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp17_ = state;
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_photo_table_add (_tmp16_, _tmp17_, &_inner_error_);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_database_table_unref0 (_tmp16_);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_backing_photo_row_unref0 (state);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (file);
#line 5063 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				return;
#line 38918 "Photo.c"
			}
#line 5064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp18_ = state;
#line 5064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp19_ = _tmp18_->id;
#line 5064 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			backing_id = _tmp19_;
#line 38926 "Photo.c"
		}
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_backing_photo_row_unref0 (state);
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 5056 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 38934 "Photo.c"
	}
#line 5068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = backing_id;
#line 5068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (file);
#line 5068 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 38942 "Photo.c"
}


LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error) {
	LibraryPhoto* result = NULL;
	GFile* dupe_file = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	BackingPhotoID dupe_editable_id = {0};
	BackingPhotoRow* _tmp4_ = NULL;
	BackingPhotoRow* _tmp5_ = NULL;
	BackingPhotoID _tmp6_ = {0};
	BackingPhotoID _tmp7_ = {0};
	BackingPhotoID dupe_raw_shotwell_id = {0};
	BackingPhotoRow* _tmp8_ = NULL;
	BackingPhotoRow* _tmp9_ = NULL;
	BackingPhotoID _tmp10_ = {0};
	BackingPhotoID _tmp11_ = {0};
	BackingPhotoID dupe_raw_camera_id = {0};
	BackingPhotoRow* _tmp12_ = NULL;
	BackingPhotoRow* _tmp13_ = NULL;
	BackingPhotoID _tmp14_ = {0};
	BackingPhotoID _tmp15_ = {0};
	BackingPhotoID dupe_raw_embedded_id = {0};
	BackingPhotoRow* _tmp16_ = NULL;
	BackingPhotoRow* _tmp17_ = NULL;
	BackingPhotoID _tmp18_ = {0};
	BackingPhotoID _tmp19_ = {0};
	PhotoID dupe_id = {0};
	PhotoTable* _tmp20_ = NULL;
	PhotoTable* _tmp21_ = NULL;
	PhotoID _tmp22_ = {0};
	GFile* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	BackingPhotoID _tmp26_ = {0};
	BackingPhotoID _tmp27_ = {0};
	BackingPhotoID _tmp28_ = {0};
	BackingPhotoID _tmp29_ = {0};
	PhotoID _tmp30_ = {0};
	PhotoID _tmp31_ = {0};
	PhotoRow* dupe_row = NULL;
	PhotoTable* _tmp32_ = NULL;
	PhotoTable* _tmp33_ = NULL;
	PhotoID _tmp34_ = {0};
	PhotoRow* _tmp35_ = NULL;
	PhotoRow* _tmp36_ = NULL;
	LibraryPhoto* dupe = NULL;
	PhotoRow* _tmp37_ = NULL;
	LibraryPhoto* _tmp38_ = NULL;
	LibraryPhoto* _tmp39_ = NULL;
	LibraryPhotoSourceCollection* _tmp40_ = NULL;
	LibraryPhoto* _tmp41_ = NULL;
	LibraryPhoto* _tmp42_ = NULL;
	Event* _tmp43_ = NULL;
	Event* _tmp44_ = NULL;
	gboolean _tmp45_ = FALSE;
	GeeCollection* tags = NULL;
	TagSourceCollection* _tmp50_ = NULL;
	GeeList* _tmp51_ = NULL;
	GeeCollection* _tmp52_ = NULL;
	GError * _inner_error_ = NULL;
#line 5071 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = media_source_get_master_file ((MediaSource*) self);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_file = _tmp3_;
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5073 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39027 "Photo.c"
	}
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo_get_editable_photo_row ((Photo*) self);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp5_, &_tmp6_, &_inner_error_);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp5_);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_editable_id = _tmp7_;
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5076 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39049 "Photo.c"
	}
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_SHOTWELL);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp9_, &_tmp10_, &_inner_error_);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp9_);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_raw_shotwell_id = _tmp11_;
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5077 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39071 "Photo.c"
	}
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_CAMERA);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp13_, &_tmp14_, &_inner_error_);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp13_);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_raw_camera_id = _tmp15_;
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5079 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39093 "Photo.c"
	}
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp16_ = photo_get_raw_development_photo_row ((Photo*) self, RAW_DEVELOPER_EMBEDDED);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_duplicate_backing_photo (self, _tmp17_, &_tmp18_, &_inner_error_);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp19_ = _tmp18_;
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_backing_photo_row_unref0 (_tmp17_);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_raw_embedded_id = _tmp19_;
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (dupe_file);
#line 5081 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return NULL;
#line 39115 "Photo.c"
	}
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = photo_table_get_instance ();
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = _tmp20_;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp22_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp23_ = dupe_file;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = g_file_get_path (_tmp23_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp25_ = _tmp24_;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp26_ = dupe_editable_id;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp27_ = dupe_raw_shotwell_id;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp28_ = dupe_raw_camera_id;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp29_ = dupe_raw_embedded_id;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_table_duplicate (_tmp21_, &_tmp22_, _tmp25_, &_tmp26_, &_tmp27_, &_tmp28_, &_tmp29_, &_tmp30_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_free0 (_tmp25_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp21_);
#line 5085 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_id = _tmp31_;
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp32_ = photo_table_get_instance ();
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp33_ = _tmp32_;
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp34_ = dupe_id;
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp35_ = photo_table_get_row (_tmp33_, &_tmp34_);
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_database_table_unref0 (_tmp33_);
#line 5087 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe_row = _tmp36_;
#line 5090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp37_ = dupe_row;
#line 5090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp38_ = library_photo_new (_tmp37_);
#line 5090 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	dupe = _tmp38_;
#line 5093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = dupe;
#line 5093 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	thumbnail_cache_duplicate ((ThumbnailSource*) self, (ThumbnailSource*) _tmp39_);
#line 5096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = library_photo_global;
#line 5096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp41_ = dupe;
#line 5096 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	data_collection_add ((DataCollection*) _tmp40_, (DataObject*) _tmp41_);
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp42_ = dupe;
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp43_ = media_source_get_event ((MediaSource*) _tmp42_);
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp45_ = _tmp44_ != NULL;
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (_tmp44_);
#line 5099 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp45_) {
#line 39189 "Photo.c"
		LibraryPhoto* _tmp46_ = NULL;
		Event* _tmp47_ = NULL;
		Event* _tmp48_ = NULL;
		LibraryPhoto* _tmp49_ = NULL;
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp46_ = dupe;
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp47_ = media_source_get_event ((MediaSource*) _tmp46_);
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp48_ = _tmp47_;
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp49_ = dupe;
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		event_attach (_tmp48_, (MediaSource*) _tmp49_);
#line 5100 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp48_);
#line 39206 "Photo.c"
	}
#line 5103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp50_ = tag_global;
#line 5103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp51_ = tag_source_collection_fetch_for_source (_tmp50_, (MediaSource*) self);
#line 5103 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	tags = (GeeCollection*) _tmp51_;
#line 5104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp52_ = tags;
#line 5104 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp52_ != NULL) {
#line 39218 "Photo.c"
		{
			GeeIterator* _tag_it = NULL;
			GeeCollection* _tmp53_ = NULL;
			GeeIterator* _tmp54_ = NULL;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp53_ = tags;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp54_ = gee_iterable_iterator ((GeeIterable*) _tmp53_);
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_it = _tmp54_;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 39231 "Photo.c"
				GeeIterator* _tmp55_ = NULL;
				gboolean _tmp56_ = FALSE;
				Tag* tag = NULL;
				GeeIterator* _tmp57_ = NULL;
				gpointer _tmp58_ = NULL;
				Tag* _tmp59_ = NULL;
				LibraryPhoto* _tmp60_ = NULL;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp55_ = _tag_it;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp56_ = gee_iterator_next (_tmp55_);
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp56_) {
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 39247 "Photo.c"
				}
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp57_ = _tag_it;
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp58_ = gee_iterator_get (_tmp57_);
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag = (Tag*) _tmp58_;
#line 5106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp59_ = tag;
#line 5106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp60_ = dupe;
#line 5106 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag_attach (_tmp59_, (MediaSource*) _tmp60_);
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (tag);
#line 39263 "Photo.c"
			}
#line 5105 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 39267 "Photo.c"
		}
	}
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = dupe;
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_photo_row_unref0 (dupe_row);
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 5110 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39280 "Photo.c"
}


static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total) {
#line 5113 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5114 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	spin_event_loop ();
#line 39289 "Photo.c"
}


static gboolean library_photo_real_is_trashed (MediaSource* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5118 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH);
#line 5119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 5119 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39305 "Photo.c"
}


static void library_photo_real_trash (MediaSource* base) {
	LibraryPhoto * self;
#line 5122 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5123 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39315 "Photo.c"
}


static void library_photo_real_untrash (MediaSource* base) {
	LibraryPhoto * self;
#line 5126 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5127 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 39325 "Photo.c"
}


static gboolean library_photo_real_is_offline (Monitorable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5130 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE);
#line 5131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 5131 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39341 "Photo.c"
}


static void library_photo_real_mark_offline (Monitorable* base) {
	LibraryPhoto * self;
#line 5134 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5135 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39351 "Photo.c"
}


static void library_photo_real_mark_online (Monitorable* base) {
	LibraryPhoto * self;
#line 5138 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5139 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 39361 "Photo.c"
}


static gboolean library_photo_real_is_flagged (Flaggable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 5142 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = photo_is_flag_set ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED);
#line 5143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp0_;
#line 5143 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39377 "Photo.c"
}


static void library_photo_real_mark_flagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_ = NULL;
	Alteration* _tmp1_ = NULL;
#line 5146 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_add_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5147 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39395 "Photo.c"
}


static void library_photo_real_mark_unflagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_ = NULL;
	Alteration* _tmp1_ = NULL;
#line 5150 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 5151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 5151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_remove_flags ((Photo*) self, LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 5151 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 39413 "Photo.c"
}


static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GError * _inner_error_ = NULL;
#line 5154 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo), &_inner_error_);
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _tmp1_;
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 39432 "Photo.c"
		gboolean _tmp2_ = FALSE;
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return _tmp2_;
#line 39438 "Photo.c"
	}
#line 5157 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (!_tmp0_) {
#line 5158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = FALSE;
#line 5158 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 39446 "Photo.c"
	}
#line 5160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = media_source_delete_original_file ((MediaSource*) self);
#line 5160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp3_;
#line 5160 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39454 "Photo.c"
}


static void library_photo_real_destroy (DataSource* base) {
	LibraryPhoto * self;
	PhotoID photo_id = {0};
	PhotoID _tmp0_ = {0};
	GError * _inner_error_ = NULL;
#line 5163 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_get_photo_id ((Photo*) self, &_tmp0_);
#line 5164 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id = _tmp0_;
#line 5167 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	thumbnail_cache_remove ((ThumbnailSource*) self);
#line 39471 "Photo.c"
	{
		PhotoTable* _tmp1_ = NULL;
		PhotoTable* _tmp2_ = NULL;
		PhotoID _tmp3_ = {0};
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_id;
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error_);
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 39490 "Photo.c"
				goto __catch268_database_error;
			}
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 5173 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			return;
#line 39499 "Photo.c"
		}
	}
	goto __finally268;
	__catch268_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_ = NULL;
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		err = _inner_error_;
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_inner_error_ = NULL;
#line 5175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = err;
#line 5175 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_error_free0 (err);
#line 39517 "Photo.c"
	}
	__finally268:
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 5172 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 39528 "Photo.c"
	}
#line 5178 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy ((DataSource*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_PHOTO, Photo));
#line 39532 "Photo.c"
}


gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	PhotoID _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = thumbnail_md5;
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = full_md5;
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = file_format;
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_get_nontrash_duplicate (_tmp0_, _tmp1_, _tmp2_, _tmp3_, &_tmp4_);
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_id_is_valid (&_tmp4_);
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = _tmp5_;
#line 5183 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 39560 "Photo.c"
}


void library_photo_get_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, PhotoID* result) {
	PhotoID* ids = NULL;
	GFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	PhotoFileFormat _tmp3_ = 0;
	gint _tmp4_ = 0;
	PhotoID* _tmp5_ = NULL;
	gint ids_length1 = 0;
	gint _ids_size_ = 0;
	gboolean _tmp6_ = FALSE;
	PhotoID* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	PhotoID* _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	PhotoID _tmp18_ = {0};
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = file;
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = thumbnail_md5;
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = full_md5;
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = file_format;
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = photo_get_duplicate_ids (_tmp0_, _tmp1_, _tmp2_, _tmp3_, &_tmp4_);
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ids = _tmp5_;
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ids_length1 = _tmp4_;
#line 5188 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_ids_size_ = ids_length1;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = ids;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7__length1 = ids_length1;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = TRUE;
#line 39604 "Photo.c"
	} else {
		PhotoID* _tmp8_ = NULL;
		gint _tmp8__length1 = 0;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = ids;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8__length1 = ids_length1;
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = _tmp8__length1 == 0;
#line 39614 "Photo.c"
	}
#line 5190 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp6_) {
#line 39618 "Photo.c"
		PhotoID _tmp9_ = {0};
#line 5191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_id_init (&_tmp9_, PHOTO_ID_INVALID);
#line 5191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		*result = _tmp9_;
#line 5191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 5191 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return;
#line 39628 "Photo.c"
	}
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = ids;
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10__length1 = ids_length1;
#line 39634 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		id_collection = _tmp10_;
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		id_collection_length1 = _tmp10__length1;
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		for (id_it = 0; id_it < _tmp10__length1; id_it = id_it + 1) {
#line 39646 "Photo.c"
			PhotoID id = {0};
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			id = id_collection[id_it];
#line 39650 "Photo.c"
			{
				LibraryPhoto* photo = NULL;
				LibraryPhotoSourceCollection* _tmp11_ = NULL;
				PhotoID _tmp12_ = {0};
				LibraryPhoto* _tmp13_ = NULL;
				gboolean _tmp14_ = FALSE;
				LibraryPhoto* _tmp15_ = NULL;
#line 5194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = library_photo_global;
#line 5194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = id;
#line 5194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = library_photo_source_collection_fetch (_tmp11_, &_tmp12_);
#line 5194 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp13_;
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = photo;
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 39670 "Photo.c"
					LibraryPhoto* _tmp16_ = NULL;
					gboolean _tmp17_ = FALSE;
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = photo;
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = media_source_is_trashed ((MediaSource*) _tmp16_);
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = !_tmp17_;
#line 39679 "Photo.c"
				} else {
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = FALSE;
#line 39683 "Photo.c"
				}
#line 5195 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp14_) {
#line 5196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					*result = id;
#line 5196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (photo);
#line 5196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 5196 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return;
#line 39695 "Photo.c"
				}
#line 5193 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 39699 "Photo.c"
			}
		}
	}
#line 5199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_id_init (&_tmp18_, PHOTO_ID_INVALID);
#line 5199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	*result = _tmp18_;
#line 5199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 5199 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return;
#line 39711 "Photo.c"
}


static gboolean library_photo_real_has_user_generated_metadata (Photo* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	GeeList* tags = NULL;
	TagSourceCollection* _tmp0_ = NULL;
	GeeList* _tmp1_ = NULL;
	PhotoMetadata* metadata = NULL;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_ = NULL;
	GeeSet* keywords = NULL;
	PhotoMetadata* _tmp9_ = NULL;
	GeeSet* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	GeeList* _tmp12_ = NULL;
	gint tags_count = 0;
	gint _tmp16_ = 0;
	GeeSet* _tmp17_ = NULL;
	gint keywords_count = 0;
	gint _tmp21_ = 0;
	gint _tmp22_ = 0;
	gboolean _tmp23_ = FALSE;
	GeeList* _tmp24_ = NULL;
#line 5202 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5203 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	tags = _tmp1_;
#line 5205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_source_get_metadata ((PhotoSource*) self);
#line 5205 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	metadata = _tmp2_;
#line 5206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = metadata;
#line 5206 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 39753 "Photo.c"
		gboolean _tmp4_ = FALSE;
		GeeList* _tmp5_ = NULL;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = tags;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		if (_tmp5_ != NULL) {
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = TRUE;
#line 39762 "Photo.c"
		} else {
			GeeList* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = tags;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = _tmp8_ > 0;
#line 39775 "Photo.c"
		}
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = _tmp4_;
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5207 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 39785 "Photo.c"
	}
#line 5209 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = metadata;
#line 5209 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp10_ = photo_metadata_get_keywords (_tmp9_, NULL, NULL, NULL);
#line 5209 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	keywords = _tmp10_;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp12_ = tags;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp12_ != NULL) {
#line 39797 "Photo.c"
		GeeList* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp13_ = tags;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp14_ = gee_collection_get_size ((GeeCollection*) _tmp13_);
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = _tmp15_;
#line 39809 "Photo.c"
	} else {
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = 0;
#line 39813 "Photo.c"
	}
#line 5210 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	tags_count = _tmp11_;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp17_ = keywords;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp17_ != NULL) {
#line 39821 "Photo.c"
		GeeSet* _tmp18_ = NULL;
		gint _tmp19_ = 0;
		gint _tmp20_ = 0;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = keywords;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = gee_collection_get_size ((GeeCollection*) _tmp18_);
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = _tmp20_;
#line 39833 "Photo.c"
	} else {
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp16_ = 0;
#line 39837 "Photo.c"
	}
#line 5211 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	keywords_count = _tmp16_;
#line 5213 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = tags_count;
#line 5213 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = keywords_count;
#line 5213 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp21_ != _tmp22_) {
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = TRUE;
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (keywords);
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (tags);
#line 5214 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 39857 "Photo.c"
	}
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp24_ = tags;
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp24_ != NULL) {
#line 39863 "Photo.c"
		GeeSet* _tmp25_ = NULL;
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp25_ = keywords;
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = _tmp25_ != NULL;
#line 39869 "Photo.c"
	} else {
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp23_ = FALSE;
#line 39873 "Photo.c"
	}
#line 5216 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp23_) {
#line 39877 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp26_ = NULL;
			GeeList* _tmp27_ = NULL;
			gint _tag_size = 0;
			GeeList* _tmp28_ = NULL;
			gint _tmp29_ = 0;
			gint _tmp30_ = 0;
			gint _tag_index = 0;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp26_ = tags;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp27_ = _g_object_ref0 (_tmp26_);
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_list = _tmp27_;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp28_ = _tag_list;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp29_ = gee_collection_get_size ((GeeCollection*) _tmp28_);
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp30_ = _tmp29_;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_size = _tmp30_;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_index = -1;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 39905 "Photo.c"
				gint _tmp31_ = 0;
				gint _tmp32_ = 0;
				gint _tmp33_ = 0;
				Tag* tag = NULL;
				GeeList* _tmp34_ = NULL;
				gint _tmp35_ = 0;
				gpointer _tmp36_ = NULL;
				GeeSet* _tmp37_ = NULL;
				Tag* _tmp38_ = NULL;
				gchar* _tmp39_ = NULL;
				gchar* _tmp40_ = NULL;
				gchar* _tmp41_ = NULL;
				gchar* _tmp42_ = NULL;
				gboolean _tmp43_ = FALSE;
				gboolean _tmp44_ = FALSE;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = _tag_index;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tag_index = _tmp31_ + 1;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = _tag_index;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = _tag_size;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp32_ < _tmp33_)) {
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 39933 "Photo.c"
				}
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = _tag_list;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp35_ = _tag_index;
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = gee_list_get (_tmp34_, _tmp35_);
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag = (Tag*) _tmp36_;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = keywords;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = tag;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = data_object_get_name ((DataObject*) _tmp38_);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp40_ = _tmp39_;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp41_ = g_utf8_normalize (_tmp40_, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp42_ = _tmp41_;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = gee_collection_contains ((GeeCollection*) _tmp37_, _tmp42_);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = !_tmp43_;
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp42_);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp40_);
#line 5218 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp44_) {
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					result = TRUE;
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (tag);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (keywords);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (tags);
#line 5219 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					return result;
#line 39979 "Photo.c"
				}
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (tag);
#line 39983 "Photo.c"
			}
#line 5217 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 39987 "Photo.c"
		}
	}
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = FALSE;
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (tags);
#line 5223 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 40000 "Photo.c"
}


static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	GeeList* photo_tags = NULL;
	TagSourceCollection* _tmp0_ = NULL;
	GeeList* _tmp1_ = NULL;
	GeeList* _tmp2_ = NULL;
#line 5226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = tag_global;
#line 5227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, (MediaSource*) self);
#line 5227 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo_tags = _tmp1_;
#line 5228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo_tags;
#line 5228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 40024 "Photo.c"
		GeeCollection* string_tags = NULL;
		GeeArrayList* _tmp3_ = NULL;
		PhotoMetadata* _tmp19_ = NULL;
		GeeCollection* _tmp20_ = NULL;
#line 5229 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 5229 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		string_tags = (GeeCollection*) _tmp3_;
#line 40033 "Photo.c"
		{
			GeeList* _tag_list = NULL;
			GeeList* _tmp4_ = NULL;
			GeeList* _tmp5_ = NULL;
			gint _tag_size = 0;
			GeeList* _tmp6_ = NULL;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			gint _tag_index = 0;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp4_ = photo_tags;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_list = _tmp5_;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = _tag_list;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = gee_collection_get_size ((GeeCollection*) _tmp6_);
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_size = _tmp8_;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tag_index = -1;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40061 "Photo.c"
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				Tag* tag = NULL;
				GeeList* _tmp12_ = NULL;
				gint _tmp13_ = 0;
				gpointer _tmp14_ = NULL;
				GeeCollection* _tmp15_ = NULL;
				Tag* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_ = NULL;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = _tag_index;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tag_index = _tmp9_ + 1;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = _tag_index;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tag_size;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40085 "Photo.c"
				}
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tag_list;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _tag_index;
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag = (Tag*) _tmp14_;
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = string_tags;
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = tag;
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = data_object_get_name ((DataObject*) _tmp16_);
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_collection_add (_tmp15_, _tmp18_);
#line 5231 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (tag);
#line 40109 "Photo.c"
			}
#line 5230 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 40113 "Photo.c"
		}
#line 5233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = metadata;
#line 5233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp20_ = string_tags;
#line 5233 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_keywords (_tmp19_, _tmp20_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 5228 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 40123 "Photo.c"
	} else {
		PhotoMetadata* _tmp21_ = NULL;
#line 5235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp21_ = metadata;
#line 5235 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		photo_metadata_set_keywords (_tmp21_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 40130 "Photo.c"
	}
#line 5226 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 40134 "Photo.c"
}


static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	HierarchicalTagIndex* new_htag_index = NULL;
	PhotoMetadata* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GeeCollection* keywords = NULL;
	PhotoMetadata* _tmp6_ = NULL;
	GeeSet* _tmp7_ = NULL;
	GeeCollection* _tmp8_ = NULL;
	HierarchicalTagIndex* _tmp39_ = NULL;
#line 5238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhoto*) base;
#line 5238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (metadata != NULL);
#line 5239 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	new_htag_index = NULL;
#line 5241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = metadata;
#line 5241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = photo_metadata_has_hierarchical_keywords (_tmp0_);
#line 5241 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp1_) {
#line 40160 "Photo.c"
		PhotoMetadata* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_ = NULL;
		HierarchicalTagIndex* _tmp5_ = NULL;
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp2_ = metadata;
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp3_ = photo_metadata_get_hierarchical_keywords (_tmp2_);
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = hierarchical_tag_utilities_process_hierarchical_import_keywords ((GeeCollection*) _tmp4_);
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_hierarchical_tag_index_unref0 (new_htag_index);
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		new_htag_index = _tmp5_;
#line 5242 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 40179 "Photo.c"
	}
#line 5246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = metadata;
#line 5246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp7_ = photo_metadata_get_keywords (_tmp6_, NULL, NULL, NULL);
#line 5246 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	keywords = (GeeCollection*) _tmp7_;
#line 5247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp8_ = keywords;
#line 5247 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp8_ != NULL) {
#line 40191 "Photo.c"
		{
			GeeIterator* _keyword_it = NULL;
			GeeCollection* _tmp9_ = NULL;
			GeeIterator* _tmp10_ = NULL;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = keywords;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_keyword_it = _tmp10_;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40204 "Photo.c"
				GeeIterator* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				gchar* keyword = NULL;
				GeeIterator* _tmp13_ = NULL;
				gpointer _tmp14_ = NULL;
				gboolean _tmp15_ = FALSE;
				HierarchicalTagIndex* _tmp16_ = NULL;
				gchar* safe_keyword = NULL;
				const gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				gchar* promoted_keyword = NULL;
				const gchar* _tmp22_ = NULL;
				gchar* _tmp23_ = NULL;
				TagSourceCollection* _tmp24_ = NULL;
				const gchar* _tmp25_ = NULL;
				gboolean _tmp26_ = FALSE;
				TagSourceCollection* _tmp30_ = NULL;
				const gchar* _tmp31_ = NULL;
				gboolean _tmp32_ = FALSE;
				const gchar* _tmp36_ = NULL;
				Tag* _tmp37_ = NULL;
				Tag* _tmp38_ = NULL;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _keyword_it;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = gee_iterator_next (_tmp11_);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp12_) {
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40235 "Photo.c"
				}
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = _keyword_it;
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				keyword = (gchar*) _tmp14_;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = new_htag_index;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp16_ != NULL) {
#line 40247 "Photo.c"
					HierarchicalTagIndex* _tmp17_ = NULL;
					const gchar* _tmp18_ = NULL;
					gboolean _tmp19_ = FALSE;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = new_htag_index;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = keyword;
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = hierarchical_tag_index_is_tag_in_index (_tmp17_, _tmp18_);
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = _tmp19_;
#line 40259 "Photo.c"
				} else {
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = FALSE;
#line 40263 "Photo.c"
				}
#line 5249 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp15_) {
#line 5250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (keyword);
#line 5250 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					continue;
#line 40271 "Photo.c"
				}
#line 5252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp20_ = keyword;
#line 5252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp21_ = hierarchical_tag_utilities_make_flat_tag_safe (_tmp20_);
#line 5252 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				safe_keyword = _tmp21_;
#line 5253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp22_ = safe_keyword;
#line 5253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = hierarchical_tag_utilities_flat_to_hierarchical (_tmp22_);
#line 5253 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				promoted_keyword = _tmp23_;
#line 5256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = tag_global;
#line 5256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = safe_keyword;
#line 5256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = tag_source_collection_exists (_tmp24_, _tmp25_, FALSE);
#line 5256 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp26_) {
#line 40293 "Photo.c"
					const gchar* _tmp27_ = NULL;
					Tag* _tmp28_ = NULL;
					Tag* _tmp29_ = NULL;
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp27_ = safe_keyword;
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp28_ = tag_for_path (_tmp27_);
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp29_ = _tmp28_;
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					tag_attach (_tmp29_, (MediaSource*) self);
#line 5257 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp29_);
#line 5258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (keyword);
#line 5258 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					continue;
#line 40315 "Photo.c"
				}
#line 5261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = tag_global;
#line 5261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = promoted_keyword;
#line 5261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = tag_source_collection_exists (_tmp30_, _tmp31_, FALSE);
#line 5261 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp32_) {
#line 40325 "Photo.c"
					const gchar* _tmp33_ = NULL;
					Tag* _tmp34_ = NULL;
					Tag* _tmp35_ = NULL;
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp33_ = promoted_keyword;
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp34_ = tag_for_path (_tmp33_);
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp35_ = _tmp34_;
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					tag_attach (_tmp35_, (MediaSource*) self);
#line 5262 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp35_);
#line 5263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (promoted_keyword);
#line 5263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (safe_keyword);
#line 5263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_free0 (keyword);
#line 5263 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					continue;
#line 40347 "Photo.c"
				}
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp36_ = keyword;
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp37_ = tag_for_path (_tmp36_);
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag_attach (_tmp38_, (MediaSource*) self);
#line 5266 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp38_);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (promoted_keyword);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (safe_keyword);
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (keyword);
#line 40365 "Photo.c"
			}
#line 5248 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 40369 "Photo.c"
		}
	}
#line 5270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp39_ = new_htag_index;
#line 5270 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp39_ != NULL) {
#line 40376 "Photo.c"
		{
			GeeIterator* _path_it = NULL;
			HierarchicalTagIndex* _tmp40_ = NULL;
			GeeCollection* _tmp41_ = NULL;
			GeeCollection* _tmp42_ = NULL;
			GeeIterator* _tmp43_ = NULL;
			GeeIterator* _tmp44_ = NULL;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp40_ = new_htag_index;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = hierarchical_tag_index_get_all_paths (_tmp40_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = _tmp41_;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp43_ = gee_iterable_iterator ((GeeIterable*) _tmp42_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp44_ = _tmp43_;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp42_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_path_it = _tmp44_;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40400 "Photo.c"
				GeeIterator* _tmp45_ = NULL;
				gboolean _tmp46_ = FALSE;
				gchar* path = NULL;
				GeeIterator* _tmp47_ = NULL;
				gpointer _tmp48_ = NULL;
				const gchar* _tmp49_ = NULL;
				Tag* _tmp50_ = NULL;
				Tag* _tmp51_ = NULL;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp45_ = _path_it;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp46_ = gee_iterator_next (_tmp45_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp46_) {
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40417 "Photo.c"
				}
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp47_ = _path_it;
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp48_ = gee_iterator_get (_tmp47_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				path = (gchar*) _tmp48_;
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp49_ = path;
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp50_ = tag_for_path (_tmp49_);
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp51_ = _tmp50_;
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				tag_attach (_tmp51_, (MediaSource*) self);
#line 5272 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp51_);
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_free0 (path);
#line 40437 "Photo.c"
			}
#line 5271 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_path_it);
#line 40441 "Photo.c"
		}
	}
#line 5238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 5238 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_hierarchical_tag_index_unref0 (new_htag_index);
#line 40448 "Photo.c"
}


static void library_photo_class_init (LibraryPhotoClass * klass) {
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoPrivate));
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_master_reimported = (void (*)(Photo*, PhotoMetadata*)) library_photo_real_notify_master_reimported;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_editable_reimported = (void (*)(Photo*, PhotoMetadata*)) library_photo_real_notify_editable_reimported;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_source_reimported = (void (*)(Photo*, PhotoMetadata*)) library_photo_real_notify_source_reimported;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->notify_baseline_reimported = (void (*)(Photo*, PhotoMetadata*)) library_photo_real_notify_baseline_reimported;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataObjectClass *) klass)->notify_altered = (void (*)(DataObject*, Alteration*)) library_photo_real_notify_altered;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->get_preview_pixbuf = (GdkPixbuf* (*)(MediaSource*, Scaling*, GError**)) library_photo_real_get_preview_pixbuf;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->rotate = (void (*)(Photo*, Rotation)) library_photo_real_rotate;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((ThumbnailSourceClass *) klass)->get_thumbnail = (GdkPixbuf* (*)(ThumbnailSource*, gint, GError**)) library_photo_real_get_thumbnail;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->is_trashed = (gboolean (*)(MediaSource*)) library_photo_real_is_trashed;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->trash = (void (*)(MediaSource*)) library_photo_real_trash;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->untrash = (void (*)(MediaSource*)) library_photo_real_untrash;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->is_offline = (gboolean (*)(MediaSource*)) library_photo_real_is_offline;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->mark_offline = (void (*)(MediaSource*)) library_photo_real_mark_offline;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((MediaSourceClass *) klass)->mark_online = (void (*)(MediaSource*)) library_photo_real_mark_online;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->internal_delete_backing = (gboolean (*)(DataSource*, GError**)) library_photo_real_internal_delete_backing;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((DataSourceClass *) klass)->destroy = (void (*)(DataSource*)) library_photo_real_destroy;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->has_user_generated_metadata = (gboolean (*)(Photo*)) library_photo_real_has_user_generated_metadata;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->set_user_metadata_for_export = (void (*)(Photo*, PhotoMetadata*)) library_photo_real_set_user_metadata_for_export;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((PhotoClass *) klass)->apply_user_metadata_for_reimport = (void (*)(Photo*, PhotoMetadata*)) library_photo_real_apply_user_metadata_for_reimport;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 40497 "Photo.c"
}


static void library_photo_flaggable_interface_init (FlaggableIface * iface) {
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->is_flagged = (gboolean (*)(Flaggable*)) library_photo_real_is_flagged;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->mark_flagged = (void (*)(Flaggable*)) library_photo_real_mark_flagged;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->mark_unflagged = (void (*)(Flaggable*)) library_photo_real_mark_unflagged;
#line 40510 "Photo.c"
}


static void library_photo_monitorable_interface_init (MonitorableIface * iface) {
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->is_offline = (gboolean (*)(Monitorable*)) library_photo_real_is_offline;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->mark_offline = (void (*)(Monitorable*)) library_photo_real_mark_offline;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->mark_online = (void (*)(Monitorable*)) library_photo_real_mark_online;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->set_master_file = (void (*)(Monitorable*, GFile*)) photo_set_master_file;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	iface->set_master_timestamp = (void (*)(Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 40527 "Photo.c"
}


static void library_photo_instance_init (LibraryPhoto * self) {
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_GET_PRIVATE (self);
#line 4876 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 4877 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 40538 "Photo.c"
}


static void library_photo_finalize (GObject* obj) {
	LibraryPhoto * self;
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO, LibraryPhoto);
#line 4877 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 4878 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 4865 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 40552 "Photo.c"
}


GType library_photo_get_type (void) {
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_construct (GType object_type, LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
	LibraryPhotoSourceHoldingTank* self = NULL;
	LibraryPhotoSourceCollection* _tmp0_ = NULL;
	SourceHoldingTankCheckToKeep _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	GetSourceDatabaseKey _tmp2_ = NULL;
	void* _tmp2__target = NULL;
#line 5288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (sources != NULL, NULL);
#line 5290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = sources;
#line 5290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = check_to_keep;
#line 5290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1__target = check_to_keep_target;
#line 5290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = get_key;
#line 5290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2__target = get_key_target;
#line 5290 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) media_source_holding_tank_construct (object_type, (MediaSourceCollection*) _tmp0_, _tmp1_, _tmp1__target, _tmp2_, _tmp2__target);
#line 5288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return self;
#line 40595 "Photo.c"
}


LibraryPhotoSourceHoldingTank* library_photo_source_holding_tank_new (LibraryPhotoSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target) {
#line 5288 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return library_photo_source_holding_tank_construct (TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, sources, check_to_keep, check_to_keep_target, get_key, get_key_target);
#line 40602 "Photo.c"
}


LibraryPhoto* library_photo_source_holding_tank_fetch_by_backing_file (LibraryPhotoSourceHoldingTank* self, GFile* file) {
	LibraryPhoto* result = NULL;
	LibraryPhoto* ret = NULL;
	GeeHashMap* _tmp0_ = NULL;
	GFile* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
	LibraryPhoto* _tmp3_ = NULL;
	GeeHashMap* _tmp4_ = NULL;
	GFile* _tmp5_ = NULL;
	gpointer _tmp6_ = NULL;
#line 5293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 5293 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 5294 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = NULL;
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = self->priv->editable_file_map;
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = file;
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5295 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	ret = (LibraryPhoto*) _tmp2_;
#line 5296 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = ret;
#line 5296 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 5297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		result = ret;
#line 5297 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		return result;
#line 40640 "Photo.c"
	}
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = self->priv->development_file_map;
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = file;
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp4_, _tmp5_);
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	result = (LibraryPhoto*) _tmp6_;
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (ret);
#line 5299 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	return result;
#line 40654 "Photo.c"
}


static void _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 5323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_holding_tank_on_editable_replaced ((LibraryPhotoSourceHoldingTank*) self, _sender, old_file, new_file);
#line 40661 "Photo.c"
}


static void _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified (Photo* _sender, gpointer self) {
#line 5324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_holding_tank_on_raw_development_modified ((LibraryPhotoSourceHoldingTank*) self, _sender);
#line 40668 "Photo.c"
}


static void library_photo_source_holding_tank_real_notify_contents_altered (SourceHoldingTank* base, GeeCollection* added, GeeCollection* removed) {
	LibraryPhotoSourceHoldingTank * self;
	GeeCollection* _tmp0_ = NULL;
	GeeCollection* _tmp40_ = NULL;
	GeeCollection* _tmp81_ = NULL;
	GeeCollection* _tmp82_ = NULL;
#line 5302 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = (LibraryPhotoSourceHoldingTank*) base;
#line 5304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = added;
#line 5304 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 40684 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeCollection* _tmp1_ = NULL;
			GeeIterator* _tmp2_ = NULL;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp1_ = added;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator ((GeeIterable*) _tmp1_);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_source_it = _tmp2_;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40697 "Photo.c"
				GeeIterator* _tmp3_ = NULL;
				gboolean _tmp4_ = FALSE;
				DataSource* source = NULL;
				GeeIterator* _tmp5_ = NULL;
				gpointer _tmp6_ = NULL;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp7_ = NULL;
				LibraryPhoto* _tmp8_ = NULL;
				LibraryPhoto* _tmp9_ = NULL;
				GFile* _tmp10_ = NULL;
				GFile* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				GeeCollection* raw_files = NULL;
				LibraryPhoto* _tmp23_ = NULL;
				GeeCollection* _tmp24_ = NULL;
				GeeCollection* _tmp25_ = NULL;
				LibraryPhoto* _tmp38_ = NULL;
				LibraryPhoto* _tmp39_ = NULL;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp3_ = _source_it;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp4_) {
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40724 "Photo.c"
				}
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp5_ = _source_it;
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				source = (DataSource*) _tmp6_;
#line 5306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp7_ = source;
#line 5306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5306 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp8_;
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp9_ = photo;
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp10_ = photo_get_editable_file ((Photo*) _tmp9_);
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _tmp11_ != NULL;
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (_tmp11_);
#line 5309 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp12_) {
#line 40750 "Photo.c"
					GeeHashMap* _tmp13_ = NULL;
					LibraryPhoto* _tmp14_ = NULL;
					GFile* _tmp15_ = NULL;
					GFile* _tmp16_ = NULL;
					LibraryPhoto* _tmp17_ = NULL;
					GeeMultiMap* _tmp18_ = NULL;
					LibraryPhoto* _tmp19_ = NULL;
					LibraryPhoto* _tmp20_ = NULL;
					GFile* _tmp21_ = NULL;
					GFile* _tmp22_ = NULL;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp13_ = self->priv->editable_file_map;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp14_ = photo;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp15_ = photo_get_editable_file ((Photo*) _tmp14_);
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp16_ = _tmp15_;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp17_ = photo;
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, _tmp16_, _tmp17_);
#line 5310 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp16_);
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp18_ = self->priv->reverse_editable_file_map;
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp19_ = photo;
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp20_ = photo;
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp21_ = photo_get_editable_file ((Photo*) _tmp20_);
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp22_ = _tmp21_;
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					gee_multi_map_set (_tmp18_, _tmp19_, _tmp22_);
#line 5311 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp22_);
#line 40789 "Photo.c"
				}
#line 5315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp23_ = photo;
#line 5315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp24_ = photo_get_raw_developer_files ((Photo*) _tmp23_);
#line 5315 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				raw_files = _tmp24_;
#line 5316 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = raw_files;
#line 5316 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (_tmp25_ != NULL) {
#line 40801 "Photo.c"
					{
						GeeIterator* _f_it = NULL;
						GeeCollection* _tmp26_ = NULL;
						GeeIterator* _tmp27_ = NULL;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp26_ = raw_files;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp27_ = gee_iterable_iterator ((GeeIterable*) _tmp26_);
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_f_it = _tmp27_;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						while (TRUE) {
#line 40814 "Photo.c"
							GeeIterator* _tmp28_ = NULL;
							gboolean _tmp29_ = FALSE;
							GFile* f = NULL;
							GeeIterator* _tmp30_ = NULL;
							gpointer _tmp31_ = NULL;
							GeeHashMap* _tmp32_ = NULL;
							GFile* _tmp33_ = NULL;
							LibraryPhoto* _tmp34_ = NULL;
							GeeMultiMap* _tmp35_ = NULL;
							LibraryPhoto* _tmp36_ = NULL;
							GFile* _tmp37_ = NULL;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp28_ = _f_it;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp29_ = gee_iterator_next (_tmp28_);
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							if (!_tmp29_) {
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
								break;
#line 40834 "Photo.c"
							}
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp30_ = _f_it;
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp31_ = gee_iterator_get (_tmp30_);
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							f = (GFile*) _tmp31_;
#line 5318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp32_ = self->priv->development_file_map;
#line 5318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp33_ = f;
#line 5318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp34_ = photo;
#line 5318 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp32_, _tmp33_, _tmp34_);
#line 5319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp35_ = self->priv->reverse_development_file_map;
#line 5319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp36_ = photo;
#line 5319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_tmp37_ = f;
#line 5319 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							gee_multi_map_set (_tmp35_, _tmp36_, _tmp37_);
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							_g_object_unref0 (f);
#line 40860 "Photo.c"
						}
#line 5317 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (_f_it);
#line 40864 "Photo.c"
					}
				}
#line 5323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp38_ = photo;
#line 5323 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp38_, "editable-replaced", (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp39_ = photo;
#line 5324 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_connect ((Photo*) _tmp39_, "raw-development-modified", (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (raw_files);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (source);
#line 40881 "Photo.c"
			}
#line 5305 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 40885 "Photo.c"
		}
	}
#line 5328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp40_ = removed;
#line 5328 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp40_ != NULL) {
#line 40892 "Photo.c"
		{
			GeeIterator* _source_it = NULL;
			GeeCollection* _tmp41_ = NULL;
			GeeIterator* _tmp42_ = NULL;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp41_ = removed;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp42_ = gee_iterable_iterator ((GeeIterable*) _tmp41_);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_source_it = _tmp42_;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 40905 "Photo.c"
				GeeIterator* _tmp43_ = NULL;
				gboolean _tmp44_ = FALSE;
				DataSource* source = NULL;
				GeeIterator* _tmp45_ = NULL;
				gpointer _tmp46_ = NULL;
				LibraryPhoto* photo = NULL;
				DataSource* _tmp47_ = NULL;
				LibraryPhoto* _tmp48_ = NULL;
				GeeMultiMap* _tmp73_ = NULL;
				LibraryPhoto* _tmp74_ = NULL;
				GeeMultiMap* _tmp75_ = NULL;
				LibraryPhoto* _tmp76_ = NULL;
				LibraryPhoto* _tmp77_ = NULL;
				guint _tmp78_ = 0U;
				LibraryPhoto* _tmp79_ = NULL;
				guint _tmp80_ = 0U;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp43_ = _source_it;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp44_ = gee_iterator_next (_tmp43_);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp44_) {
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 40930 "Photo.c"
				}
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp45_ = _source_it;
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp46_ = gee_iterator_get (_tmp45_);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				source = (DataSource*) _tmp46_;
#line 5330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp47_ = source;
#line 5330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp48_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 5330 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				photo = _tmp48_;
#line 40944 "Photo.c"
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp49_ = NULL;
					LibraryPhoto* _tmp50_ = NULL;
					GeeCollection* _tmp51_ = NULL;
					GeeCollection* _tmp52_ = NULL;
					GeeIterator* _tmp53_ = NULL;
					GeeIterator* _tmp54_ = NULL;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp49_ = self->priv->reverse_editable_file_map;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp50_ = photo;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp51_ = gee_multi_map_get (_tmp49_, _tmp50_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp52_ = _tmp51_;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp53_ = gee_iterable_iterator ((GeeIterable*) _tmp52_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp54_ = _tmp53_;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp52_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_f_it = _tmp54_;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 40971 "Photo.c"
						GeeIterator* _tmp55_ = NULL;
						gboolean _tmp56_ = FALSE;
						GFile* f = NULL;
						GeeIterator* _tmp57_ = NULL;
						gpointer _tmp58_ = NULL;
						GeeHashMap* _tmp59_ = NULL;
						GFile* _tmp60_ = NULL;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp55_ = _f_it;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp56_ = gee_iterator_next (_tmp55_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!_tmp56_) {
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 40987 "Photo.c"
						}
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp57_ = _f_it;
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp58_ = gee_iterator_get (_tmp57_);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						f = (GFile*) _tmp58_;
#line 5332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp59_ = self->priv->editable_file_map;
#line 5332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp60_ = f;
#line 5332 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp59_, _tmp60_, NULL);
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (f);
#line 41003 "Photo.c"
					}
#line 5331 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 41007 "Photo.c"
				}
				{
					GeeIterator* _f_it = NULL;
					GeeMultiMap* _tmp61_ = NULL;
					LibraryPhoto* _tmp62_ = NULL;
					GeeCollection* _tmp63_ = NULL;
					GeeCollection* _tmp64_ = NULL;
					GeeIterator* _tmp65_ = NULL;
					GeeIterator* _tmp66_ = NULL;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp61_ = self->priv->reverse_development_file_map;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp62_ = photo;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp63_ = gee_multi_map_get (_tmp61_, _tmp62_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp64_ = _tmp63_;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp65_ = gee_iterable_iterator ((GeeIterable*) _tmp64_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_tmp66_ = _tmp65_;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_tmp64_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_f_it = _tmp66_;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					while (TRUE) {
#line 41035 "Photo.c"
						GeeIterator* _tmp67_ = NULL;
						gboolean _tmp68_ = FALSE;
						GFile* f = NULL;
						GeeIterator* _tmp69_ = NULL;
						gpointer _tmp70_ = NULL;
						GeeHashMap* _tmp71_ = NULL;
						GFile* _tmp72_ = NULL;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp67_ = _f_it;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp68_ = gee_iterator_next (_tmp67_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						if (!_tmp68_) {
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
							break;
#line 41051 "Photo.c"
						}
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp69_ = _f_it;
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp70_ = gee_iterator_get (_tmp69_);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						f = (GFile*) _tmp70_;
#line 5335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp71_ = self->priv->development_file_map;
#line 5335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_tmp72_ = f;
#line 5335 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						gee_abstract_map_unset ((GeeAbstractMap*) _tmp71_, _tmp72_, NULL);
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
						_g_object_unref0 (f);
#line 41067 "Photo.c"
					}
#line 5334 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					_g_object_unref0 (_f_it);
#line 41071 "Photo.c"
				}
#line 5337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp73_ = self->priv->reverse_editable_file_map;
#line 5337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp74_ = photo;
#line 5337 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove_all (_tmp73_, _tmp74_);
#line 5338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp75_ = self->priv->reverse_development_file_map;
#line 5338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp76_ = photo;
#line 5338 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_remove_all (_tmp75_, _tmp76_);
#line 5340 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp77_ = photo;
#line 5340 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp78_, NULL, FALSE);
#line 5340 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp77_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp78_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_editable_replaced_photo_editable_replaced, self);
#line 5341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp79_ = photo;
#line 5341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_parse_name ("raw-development-modified", TYPE_PHOTO, &_tmp80_, NULL, FALSE);
#line 5341 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				g_signal_handlers_disconnect_matched ((Photo*) _tmp79_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp80_, 0, NULL, (GCallback) _library_photo_source_holding_tank_on_raw_development_modified_photo_raw_development_modified, self);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (photo);
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (source);
#line 41101 "Photo.c"
			}
#line 5329 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_source_it);
#line 41105 "Photo.c"
		}
	}
#line 5345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp81_ = added;
#line 5345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp82_ = removed;
#line 5345 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->notify_contents_altered ((SourceHoldingTank*) G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank), _tmp81_, _tmp82_);
#line 41114 "Photo.c"
}


static void library_photo_source_holding_tank_on_editable_replaced (LibraryPhotoSourceHoldingTank* self, Photo* _photo, GFile* old_file, GFile* new_file) {
	LibraryPhoto* photo = NULL;
	Photo* _tmp0_ = NULL;
	LibraryPhoto* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GFile* _tmp3_ = NULL;
	GFile* _tmp9_ = NULL;
	GeeMultiMap* _tmp13_ = NULL;
	LibraryPhoto* _tmp14_ = NULL;
	GFile* _tmp15_ = NULL;
#line 5348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _photo;
#line 5349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 5349 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp1_;
#line 5350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo;
#line 5350 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp2_ != NULL, "photo != null");
#line 5352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = old_file;
#line 5352 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp3_ != NULL) {
#line 41146 "Photo.c"
		GeeHashMap* _tmp4_ = NULL;
		GFile* _tmp5_ = NULL;
		GeeMultiMap* _tmp6_ = NULL;
		LibraryPhoto* _tmp7_ = NULL;
		GFile* _tmp8_ = NULL;
#line 5353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp4_ = self->priv->editable_file_map;
#line 5353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp5_ = old_file;
#line 5353 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp4_, _tmp5_, NULL);
#line 5354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp6_ = self->priv->reverse_editable_file_map;
#line 5354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp7_ = photo;
#line 5354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp8_ = old_file;
#line 5354 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_multi_map_remove (_tmp6_, _tmp7_, _tmp8_);
#line 41166 "Photo.c"
	}
#line 5357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp9_ = new_file;
#line 5357 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp9_ != NULL) {
#line 41172 "Photo.c"
		GeeHashMap* _tmp10_ = NULL;
		GFile* _tmp11_ = NULL;
		LibraryPhoto* _tmp12_ = NULL;
#line 5358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp10_ = self->priv->editable_file_map;
#line 5358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp11_ = new_file;
#line 5358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp12_ = photo;
#line 5358 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, _tmp11_, _tmp12_);
#line 41184 "Photo.c"
	}
#line 5359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp13_ = self->priv->reverse_editable_file_map;
#line 5359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp14_ = photo;
#line 5359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp15_ = new_file;
#line 5359 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	gee_multi_map_set (_tmp13_, _tmp14_, _tmp15_);
#line 5348 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 41196 "Photo.c"
}


static void library_photo_source_holding_tank_on_raw_development_modified (LibraryPhotoSourceHoldingTank* self, Photo* _photo) {
	LibraryPhoto* photo = NULL;
	Photo* _tmp0_ = NULL;
	LibraryPhoto* _tmp1_ = NULL;
	LibraryPhoto* _tmp2_ = NULL;
	GeeMultiMap* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GeeCollection* raw_list = NULL;
	LibraryPhoto* _tmp20_ = NULL;
	GeeCollection* _tmp21_ = NULL;
	GeeCollection* _tmp22_ = NULL;
#line 5362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (self != NULL);
#line 5362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_return_if_fail (_photo != NULL);
#line 5363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = _photo;
#line 5363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, TYPE_LIBRARY_PHOTO) ? ((LibraryPhoto*) _tmp0_) : NULL);
#line 5363 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	photo = _tmp1_;
#line 5364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = photo;
#line 5364 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_vala_assert (_tmp2_ != NULL, "photo != null");
#line 5367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = self->priv->reverse_development_file_map;
#line 5367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp4_ = photo;
#line 5367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp5_ = gee_multi_map_contains (_tmp3_, _tmp4_);
#line 5367 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp5_) {
#line 41234 "Photo.c"
		GeeMultiMap* _tmp18_ = NULL;
		LibraryPhoto* _tmp19_ = NULL;
		{
			GeeIterator* _f_it = NULL;
			GeeMultiMap* _tmp6_ = NULL;
			LibraryPhoto* _tmp7_ = NULL;
			GeeCollection* _tmp8_ = NULL;
			GeeCollection* _tmp9_ = NULL;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tmp11_ = NULL;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp6_ = self->priv->reverse_development_file_map;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp7_ = photo;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp8_ = gee_multi_map_get (_tmp6_, _tmp7_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp10_ = gee_iterable_iterator ((GeeIterable*) _tmp9_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_tmp9_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_f_it = _tmp11_;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 41263 "Photo.c"
				GeeIterator* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				GFile* f = NULL;
				GeeIterator* _tmp14_ = NULL;
				gpointer _tmp15_ = NULL;
				GeeHashMap* _tmp16_ = NULL;
				GFile* _tmp17_ = NULL;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp12_ = _f_it;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp13_ = gee_iterator_next (_tmp12_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp13_) {
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 41279 "Photo.c"
				}
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp14_ = _f_it;
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp15_ = gee_iterator_get (_tmp14_);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				f = (GFile*) _tmp15_;
#line 5369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp16_ = self->priv->development_file_map;
#line 5369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp17_ = f;
#line 5369 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_unset ((GeeAbstractMap*) _tmp16_, _tmp17_, NULL);
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (f);
#line 41295 "Photo.c"
			}
#line 5368 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41299 "Photo.c"
		}
#line 5370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp18_ = self->priv->reverse_development_file_map;
#line 5370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		_tmp19_ = photo;
#line 5370 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
		gee_multi_map_remove_all (_tmp18_, _tmp19_);
#line 41307 "Photo.c"
	}
#line 5374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp20_ = photo;
#line 5374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp21_ = photo_get_raw_developer_files ((Photo*) _tmp20_);
#line 5374 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	raw_list = _tmp21_;
#line 5375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp22_ = raw_list;
#line 5375 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	if (_tmp22_ != NULL) {
#line 41319 "Photo.c"
		{
			GeeIterator* _f_it = NULL;
			GeeCollection* _tmp23_ = NULL;
			GeeIterator* _tmp24_ = NULL;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp23_ = raw_list;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_tmp24_ = gee_iterable_iterator ((GeeIterable*) _tmp23_);
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_f_it = _tmp24_;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			while (TRUE) {
#line 41332 "Photo.c"
				GeeIterator* _tmp25_ = NULL;
				gboolean _tmp26_ = FALSE;
				GFile* f = NULL;
				GeeIterator* _tmp27_ = NULL;
				gpointer _tmp28_ = NULL;
				GeeHashMap* _tmp29_ = NULL;
				GFile* _tmp30_ = NULL;
				LibraryPhoto* _tmp31_ = NULL;
				GeeMultiMap* _tmp32_ = NULL;
				LibraryPhoto* _tmp33_ = NULL;
				GFile* _tmp34_ = NULL;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp25_ = _f_it;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp26_ = gee_iterator_next (_tmp25_);
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				if (!_tmp26_) {
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
					break;
#line 41352 "Photo.c"
				}
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp27_ = _f_it;
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp28_ = gee_iterator_get (_tmp27_);
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				f = (GFile*) _tmp28_;
#line 5377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp29_ = self->priv->development_file_map;
#line 5377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp30_ = f;
#line 5377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp31_ = photo;
#line 5377 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp29_, _tmp30_, _tmp31_);
#line 5378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp32_ = self->priv->reverse_development_file_map;
#line 5378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp33_ = photo;
#line 5378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_tmp34_ = f;
#line 5378 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				gee_multi_map_set (_tmp32_, _tmp33_, _tmp34_);
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
				_g_object_unref0 (f);
#line 41378 "Photo.c"
			}
#line 5376 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
			_g_object_unref0 (_f_it);
#line 41382 "Photo.c"
		}
	}
#line 5362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (raw_list);
#line 5362 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (photo);
#line 41389 "Photo.c"
}


static void library_photo_source_holding_tank_class_init (LibraryPhotoSourceHoldingTankClass * klass) {
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	library_photo_source_holding_tank_parent_class = g_type_class_peek_parent (klass);
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceHoldingTankClass *) klass)->finalize = library_photo_source_holding_tank_finalize;
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceHoldingTankPrivate));
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	((SourceHoldingTankClass *) klass)->notify_contents_altered = (void (*)(SourceHoldingTank*, GeeCollection*, GeeCollection*)) library_photo_source_holding_tank_real_notify_contents_altered;
#line 41402 "Photo.c"
}


static void library_photo_source_holding_tank_instance_init (LibraryPhotoSourceHoldingTank * self) {
	GeeHashMap* _tmp0_ = NULL;
	GeeHashMap* _tmp1_ = NULL;
	GeeHashMultiMap* _tmp2_ = NULL;
	GeeHashMultiMap* _tmp3_ = NULL;
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_HOLDING_TANK_GET_PRIVATE (self);
#line 5279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp0_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->editable_file_map = _tmp0_;
#line 5281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL, NULL, NULL, NULL);
#line 5281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->development_file_map = _tmp1_;
#line 5283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp2_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->reverse_editable_file_map = (GeeMultiMap*) _tmp2_;
#line 5285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_tmp3_ = gee_hash_multi_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 5285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self->priv->reverse_development_file_map = (GeeMultiMap*) _tmp3_;
#line 41429 "Photo.c"
}


static void library_photo_source_holding_tank_finalize (SourceHoldingTank* obj) {
	LibraryPhotoSourceHoldingTank * self;
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBRARY_PHOTO_SOURCE_HOLDING_TANK, LibraryPhotoSourceHoldingTank);
#line 5279 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_file_map);
#line 5281 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->development_file_map);
#line 5283 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_editable_file_map);
#line 5285 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	_g_object_unref0 (self->priv->reverse_development_file_map);
#line 5278 "/builddir/build/BUILD/photos-0.2.4/src/Photo.vala"
	SOURCE_HOLDING_TANK_CLASS (library_photo_source_holding_tank_parent_class)->finalize (obj);
#line 41447 "Photo.c"
}


GType library_photo_source_holding_tank_get_type (void) {
	static volatile gsize library_photo_source_holding_tank_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_holding_tank_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceHoldingTankClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_holding_tank_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceHoldingTank), 0, (GInstanceInitFunc) library_photo_source_holding_tank_instance_init, NULL };
		GType library_photo_source_holding_tank_type_id;
		library_photo_source_holding_tank_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_HOLDING_TANK, "LibraryPhotoSourceHoldingTank", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_holding_tank_type_id__volatile, library_photo_source_holding_tank_type_id);
	}
	return library_photo_source_holding_tank_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



